// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(_) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function n(e) {
        return e.split("");
    }
    function pn(e, n) {
        return n.indexOf(e) >= 0;
    }
    function dn(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function t(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function r(e, n) {
        this.message = e;
        this.defs = n;
    }
    r.prototype = Object.create(Error.prototype);
    r.prototype.constructor = r;
    r.prototype.name = "DefaultsError";
    t(r);
    function be(e, n, t) {
        if (t) for (var i in e) {
            if (Sn(e, i) && !Sn(n, i)) throw new r("`" + i + "` is not a supported option", n);
        }
        for (var i in e) {
            if (Sn(e, i)) n[i] = e[i];
        }
        return n;
    }
    function vn() {}
    function hn() {
        return false;
    }
    function mn() {
        return true;
    }
    function _n() {
        return this;
    }
    function gn() {
        return null;
    }
    var bn = function() {
        function e(e, n) {
            var t = [];
            for (var i = 0; i < e.length; i++) {
                var r = n(e[i], i);
                if (r === a) continue;
                if (r instanceof o) {
                    t.push.apply(t, r.v);
                } else {
                    t.push(r);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function yn(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function wn(e, i) {
        return e.replace(/\{([^{}]+)\}/g, function(e, n) {
            var t = i[n];
            return t instanceof rn ? t.print_to_string() : t;
        });
    }
    function xn(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function kn(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function tn(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function En() {
        this.values = Object.create(null);
    }
    En.prototype = {
        set: function(e, n) {
            if (e == "__proto__") {
                this.proto_value = n;
            } else {
                this.values[e] = n;
            }
            return this;
        },
        add: function(e, n) {
            var t = this.get(e);
            if (t) {
                t.push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return e == "__proto__" ? this.proto_value : this.values[e];
        },
        del: function(e) {
            if (e == "__proto__") {
                delete this.proto_value;
            } else {
                delete this.values[e];
            }
            return this;
        },
        has: function(e) {
            return e == "__proto__" ? "proto_value" in this : e in this.values;
        },
        all: function(e) {
            for (var n in this.values) if (!e(this.values[n], n)) return false;
            if ("proto_value" in this && !e(this.proto_value, "__proto__")) return false;
            return true;
        },
        each: function(e) {
            for (var n in this.values) e(this.values[n], n);
            if ("proto_value" in this) e(this.proto_value, "__proto__");
        },
        size: function() {
            return Object.keys(this.values).length + ("proto_value" in this);
        },
        map: function(e) {
            var n = [];
            for (var t in this.values) n.push(e(this.values[t], t));
            if ("proto_value" in this) n.push(e(this.proto_value, "__proto__"));
            return n;
        },
        clone: function() {
            var t = new En();
            this.each(function(e, n) {
                t.set(n, e);
            });
            return t;
        },
        toObject: function() {
            var t = {};
            this.each(function(e, n) {
                t["$" + n] = e;
            });
            return t;
        }
    };
    En.fromObject = function(e) {
        var n = new En();
        for (var t in e) if (Sn(e, t)) n.set(t.slice(1), e[t]);
        return n;
    };
    function Sn(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function Tn(e, n, t) {
        var i = e.parent(-1);
        for (var r = 0, a; a = e.parent(r++); i = a) {
            if (Xn(a)) {
                return n && a.value === i;
            } else if (a instanceof un) {
                if (a.left === i) continue;
            } else if (a.TYPE == "Call") {
                if (a.expression === i) continue;
            } else if (a instanceof Kt) {
                if (a.condition === i) continue;
            } else if (a instanceof Nt) {
                return t;
            } else if (a instanceof Ut) {
                if (a.expression === i) continue;
            } else if (a instanceof sn) {
                if (a.expressions[0] === i) continue;
            } else if (a instanceof an) {
                return true;
            } else if (a instanceof Ai) {
                if (a.tag === i) continue;
            } else if (a instanceof Xt) {
                if (a.expression === i) continue;
            }
            return false;
        }
    }
    function i(i, e) {
        if (e.length > 31) throw new Error("Too many properties: " + e.length + "\n" + e.join(", "));
        e.forEach(function(e, n) {
            var t = 1 << n;
            Object.defineProperty(i.prototype, e, {
                get: function() {
                    return !!(this._bits & t);
                },
                set: function(e) {
                    if (e) this._bits |= t; else this._bits &= ~t;
                }
            });
        });
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e, n, t, i) {
        if (typeof i === "undefined") i = rn;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var a = [ "return function AST_", e, "(props){", "this._bits=0;", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        a.push("}");
        var o = Object.create(i && i.prototype);
        if (t.initialize || o.initialize) a.push("this.initialize();");
        a.push("};");
        var s = new Function(a.join(""))();
        s.prototype = o;
        s.prototype.CTOR = s;
        s.prototype.TYPE = s.TYPE = e;
        if (i) {
            s.BASE = i;
            i.SUBCLASSES.push(s);
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        s.PROPS = n;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        for (var f in t) if (Sn(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.DEFMETHOD(f, t[f]);
            }
        }
        if (typeof _ !== "undefined") _["AST_" + e] = s;
        return s;
    }
    var ne = e("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var rn = e("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Ri(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: function() {
            if (this.TYPE == "Node") throw new Error("should not instantiate AST_Node");
        },
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new Yi(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(wn("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    i(rn, [ "_optimized", "_squeezed", "call_only", "collapse_scanning", "defined", "evaluating", "falsy", "in_arg", "in_bool", "is_undefined", "inlined", "length_read", "nested", "new", "optional", "private", "pure", "redundant", "static", "terminal", "truthy", "uses_eval", "uses_with" ]);
    (rn.log_function = function(n, e) {
        if (typeof n != "function") {
            rn.info = rn.warn = vn;
            return;
        }
        var t = Object.create(null);
        rn.info = e ? function(e, n) {
            i("INFO: " + wn(e, n));
        } : vn;
        rn.warn = function(e, n) {
            i("WARN: " + wn(e, n));
        };
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var a = [];
    rn.enable_validation = function() {
        rn.disable_validation();
        (function e(n) {
            n.SUBCLASSES.forEach(e);
            if (!Sn(n.prototype, "transform")) return;
            var i = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = i.call(this, e, n);
                if (t instanceof rn) {
                    t.validate();
                } else if (!(t === null || n && bn.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            a.push(function() {
                n.prototype.transform = i;
            });
        })(this);
    };
    rn.disable_validation = function() {
        var e;
        while (e = a.pop()) e();
    };
    var An = e("Statement", null, {
        $documentation: "Base class of all statements",
        _validate: function() {
            if (this.TYPE == "Statement") throw new Error("should not instantiate AST_Statement");
        }
    });
    var Dn = e("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, An);
    var On = e("Directive", "quote value", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, An);
    var $n = e("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, An);
    function qn(e) {
        return e instanceof An && !(e instanceof dt) && !(e instanceof Jn);
    }
    function o(e, n, t, i, r) {
        t = t ? "contain" : "be";
        if (!(e instanceof rn)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof Yt) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof ni) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof Pi && !r) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof Gt && !i) throw new Error(n + " cannot " + t + " AST_Spread");
        if (qn(e)) throw new Error(n + " cannot " + t + " AST_Statement");
        if (e instanceof pi) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function s(e, n) {
        o(e[n], n);
    }
    var an = e("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "body");
        }
    }, An);
    var zn = e("BlockScope", "_var_names enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Dictionary/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Dictionary/S] a map of name ---\x3e SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.TYPE == "BlockScope") throw new Error("should not instantiate AST_BlockScope");
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof zn)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof Un)) throw new Error("must be contained within AST_Scope");
        }
    }, An);
    function Cn(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var Mn = e("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                Cn(n, e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Block") throw new Error("should not instantiate AST_Block");
            this.body.forEach(function(e) {
                if (!qn(e)) throw new Error("body must contain AST_Statement");
            });
        }
    }, zn);
    var on = e("BlockStatement", null, {
        $documentation: "A block statement"
    }, Mn);
    var j = e("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (this.TYPE == "StatementWithBody") throw new Error("should not instantiate AST_StatementWithBody");
            if (!qn(this.body)) throw new Error("body must be AST_Statement");
        }
    }, zn);
    var Fn = e("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new Yi(function(e) {
                    if (e instanceof wt) {
                        if (!e.label || e.label.thedef !== i) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof Un) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof Se)) throw new Error("label must be AST_Label");
        }
    }, j);
    var Pn = e("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it.",
        _validate: function() {
            if (this.TYPE == "IterationStatement") throw new Error("should not instantiate AST_IterationStatement");
        }
    }, j);
    var jn = e("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            if (this.TYPE == "DWLoop") throw new Error("should not instantiate AST_DWLoop");
            s(this, "condition");
        }
    }, Pn);
    var Nn = e("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, jn);
    var In = e("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, jn);
    var Hn = e("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof rn)) throw new Error("init must be AST_Node");
                if (qn(this.init) && !(this.init instanceof zt)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) s(this, "condition");
            if (this.step != null) s(this, "step");
        }
    }, Pn);
    var Yn = e("ForEnumeration", "init object", {
        $documentation: "Base class for enumeration loops, i.e. `for ... in`, `for ... of` & `for await ... of`",
        $propdoc: {
            init: "[AST_Node] the assignment target during iteration",
            object: "[AST_Node] the object to iterate over"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ForEnumeration") throw new Error("should not instantiate AST_ForEnumeration");
            if (this.init instanceof zt) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                u(this.init, function(e) {
                    if (!(e instanceof Ut || e instanceof ln)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            s(this, "object");
        }
    }, Pn);
    var Rn = e("ForIn", null, {
        $documentation: "A `for ... in` statement"
    }, Yn);
    var ye = e("ForOf", null, {
        $documentation: "A `for ... of` statement"
    }, Yn);
    var Ln = e("ForAwaitOf", null, {
        $documentation: "A `for await ... of` statement"
    }, ye);
    var Bn = e("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, j);
    var Un = e("Scope", "fn_defs may_call_this uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: _n,
        _validate: function() {
            if (this.TYPE == "Scope") throw new Error("should not instantiate AST_Scope");
        }
    }, Mn);
    var Vn = e("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Dictionary/S] a map of name ---\x3e SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return Gi([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Ri(function(e) {
                if (e instanceof On && e.value == "$ORIG") {
                    return bn.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return Gi([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Ri(function(e) {
                if (e instanceof On && e.value == "$ORIG") {
                    return bn.splice(t);
                }
            }));
        }
    }, Un);
    var Wn = e("Lambda", "argnames length_read rest safe_ids uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_DefaultValue|AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            length_read: "[boolean/S] whether length property of this function is accessed",
            rest: "[(AST_Destructured|AST_SymbolFunarg)?] rest parameter, or null if absent",
            uses_arguments: "[boolean|number/S] whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new Yi(function(e) {
                if (e instanceof Yt) {
                    e.name.walk(t);
                    return true;
                }
                if (e instanceof ii) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof _i) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
            if (this.rest) this.rest.walk(t);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                Cn(e, n);
            });
        },
        _validate: function() {
            if (this.TYPE == "Lambda") throw new Error("should not instantiate AST_Lambda");
            this.argnames.forEach(function(e) {
                u(e, function(e) {
                    if (!(e instanceof _i)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
            if (this.rest != null) u(this.rest, function(e) {
                if (!(e instanceof _i)) throw new Error("rest must be AST_SymbolFunarg");
            });
        }
    }, Un);
    var Gn = e("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, Wn);
    var Jn = e("LambdaExpression", "inlined", {
        $documentation: "Base class for function expressions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined"
        },
        _validate: function() {
            if (this.TYPE == "LambdaExpression") throw new Error("should not instantiate AST_LambdaExpression");
        }
    }, Wn);
    function Xn(e) {
        return e instanceof et || e instanceof nt;
    }
    function Kn(e) {
        return e instanceof nt || e instanceof st || e instanceof tt || e instanceof ft || e instanceof it;
    }
    function Qn(e) {
        return e instanceof ft || e instanceof it || e instanceof ct || e instanceof at;
    }
    function Zn(e, n) {
        if (Xn(e) && e.value) {
            e.value.walk(n);
        } else {
            Cn(e, n);
        }
    }
    var et = e("Arrow", "value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    Cn(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, Jn);
    var nt = e("AsyncArrow", "value", {
        $documentation: "An asynchronous arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    Cn(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, Jn);
    var tt = e("AsyncFunction", "name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof bi)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Jn);
    var it = e("AsyncGeneratorFunction", "name", {
        $documentation: "An asynchronous generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof bi)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Jn);
    var rt = e("Function", "name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof bi)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Jn);
    var at = e("GeneratorFunction", "name", {
        $documentation: "A generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof bi)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Jn);
    var ot = e("LambdaDefinition", "inlined name", {
        $documentation: "Base class for function definitions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined",
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (this.TYPE == "LambdaDefinition") throw new Error("should not instantiate AST_LambdaDefinition");
            if (!(this.name instanceof gi)) throw new Error("name must be AST_SymbolDefun");
        }
    }, Wn);
    var st = e("AsyncDefun", null, {
        $documentation: "An asynchronous function definition"
    }, ot);
    var ft = e("AsyncGeneratorDefun", null, {
        $documentation: "An asynchronous generator function definition"
    }, ot);
    var ut = e("Defun", null, {
        $documentation: "A function definition"
    }, ot);
    var ct = e("GeneratorDefun", null, {
        $documentation: "A generator function definition"
    }, ot);
    var lt = e("Class", "extends name properties", {
        $documentation: "Base class for class literals",
        $propdoc: {
            extends: "[AST_Node?] the super class, or null if not specified",
            properties: "[AST_ClassProperty*] array of class properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                if (e.extends) e.extends.walk(n);
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Class") throw new Error("should not instantiate AST_Class");
            if (this.extends != null) s(this, "extends");
            this.properties.forEach(function(e) {
                if (!(e instanceof vt)) throw new Error("properties must contain AST_ClassProperty");
            });
        }
    }, zn);
    var pt = e("DefClass", null, {
        $documentation: "A class definition",
        $propdoc: {
            name: "[AST_SymbolDefClass] the name of this class"
        },
        _validate: function() {
            if (!(this.name instanceof Ee)) throw new Error("name must be AST_SymbolDefClass");
        }
    }, lt);
    var dt = e("ClassExpression", null, {
        $documentation: "A class expression",
        $propdoc: {
            name: "[AST_SymbolClass?] the name of this class, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof yi)) throw new Error("name must be AST_SymbolClass");
            }
        }
    }, lt);
    var vt = e("ClassProperty", "key private static value", {
        $documentation: "Base class for `class` properties",
        $propdoc: {
            key: "[string|AST_Node] property name (AST_Node for computed property)",
            private: "[boolean] whether this is a private property",
            static: "[boolean] whether this is a static property",
            value: "[AST_Node?] property value (AST_Accessor for getters/setters, AST_LambdaExpression for methods, null if not specified for fields)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof rn) n.key.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ClassProperty") throw new Error("should not instantiate AST_ClassProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof rn)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (this.value != null) {
                if (!(this.value instanceof rn)) throw new Error("value must be AST_Node");
            }
        }
    });
    var ht = e("ClassField", null, {
        $documentation: "A `class` field",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, vt);
    var we = e("ClassGetter", null, {
        $documentation: "A `class` getter",
        _validate: function() {
            if (!(this.value instanceof Gn)) throw new Error("value must be AST_Accessor");
        }
    }, vt);
    var xe = e("ClassSetter", null, {
        $documentation: "A `class` setter",
        _validate: function() {
            if (!(this.value instanceof Gn)) throw new Error("value must be AST_Accessor");
        }
    }, vt);
    var mt = e("ClassMethod", null, {
        $documentation: "A `class` method",
        _validate: function() {
            if (!(this.value instanceof Jn)) throw new Error("value must be AST_LambdaExpression");
            if (Xn(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of class method's lambda must be null");
        }
    }, vt);
    var _t = e("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)",
        _validate: function() {
            if (this.TYPE == "Jump") throw new Error("should not instantiate AST_Jump");
        }
    }, An);
    var gt = e("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Exit") throw new Error("should not instantiate AST_Exit");
        }
    }, _t);
    var bt = e("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, gt);
    var yt = e("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            s(this, "value");
        }
    }, gt);
    var wt = e("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "LoopControl") throw new Error("should not instantiate AST_LoopControl");
            if (this.label != null) {
                if (!(this.label instanceof Te)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, _t);
    var xt = e("Break", null, {
        $documentation: "A `break` statement"
    }, wt);
    var kt = e("Continue", null, {
        $documentation: "A `continue` statement"
    }, wt);
    var Et = e("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            if (this.alternative != null) {
                if (!qn(this.alternative)) throw new Error("alternative must be AST_Statement");
            }
        }
    }, j);
    var St = e("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                Cn(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof Tt)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, Mn);
    var Tt = e("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches",
        _validate: function() {
            if (this.TYPE == "SwitchBranch") throw new Error("should not instantiate AST_SwitchBranch");
        }
    }, Mn);
    var At = e("Default", null, {
        $documentation: "A `default` switch branch"
    }, Tt);
    var Dt = e("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                Cn(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, Tt);
    var Ot = e("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                Cn(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof $t)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof qt)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, Mn);
    var $t = e("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                Cn(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) u(this.argname, function(e) {
                if (!(e instanceof wi)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, Mn);
    var qt = e("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, Mn);
    var zt = e("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Definitions") throw new Error("should not instantiate AST_Definitions");
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, An);
    var Ct = e("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Pt)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof di)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, zt);
    var Mt = e("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Pt)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof hi)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, zt);
    var Ft = e("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Pt)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof mi)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, zt);
    var Pt = e("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    });
    var jt = e("ExportDeclaration", "body", {
        $documentation: "An `export` statement",
        $propdoc: {
            body: "[AST_DefClass|AST_Definitions|AST_LambdaDefinition] the statement to export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof pt || this.body instanceof zt || this.body instanceof ot)) {
                throw new Error("body must be AST_DefClass, AST_Definitions or AST_LambdaDefinition");
            }
        }
    }, An);
    var Nt = e("ExportDefault", "body", {
        $documentation: "An `export default` statement",
        $propdoc: {
            body: "[AST_Node] the default export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof pt || this.body instanceof ot)) {
                s(this, "body");
            }
        }
    }, An);
    var ke = e("ExportForeign", "aliases keys path quote", {
        $documentation: "An `export ... from '...'` statement",
        $propdoc: {
            aliases: "[string*] array of aliases to export",
            keys: "[string*] array of keys to import",
            path: "[string] the path to import module",
            quote: "[string?] the original quote character"
        },
        _validate: function() {
            if (this.aliases.length != this.keys.length) {
                throw new Error("aliases:key length mismatch: " + this.aliases.length + " != " + this.keys.length);
            }
            this.aliases.forEach(function(e) {
                if (typeof e != "string") throw new Error("aliases must contain string");
            });
            this.keys.forEach(function(e) {
                if (typeof e != "string") throw new Error("keys must contain string");
            });
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, An);
    var It = e("ExportReferences", "properties", {
        $documentation: "An `export { ... }` statement",
        $propdoc: {
            properties: "[AST_SymbolExport*] array of aliases to export"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof xi)) throw new Error("properties must contain AST_SymbolExport");
            });
        }
    }, An);
    var Ht = e("Import", "all default path properties quote", {
        $documentation: "An `import` statement",
        $propdoc: {
            all: "[AST_SymbolImport?] the imported namespace, or null if not specified",
            default: "[AST_SymbolImport?] the alias for default `export`, or null if not specified",
            path: "[string] the path to import module",
            properties: "[(AST_SymbolImport*)?] array of aliases, or null if not specified",
            quote: "[string?] the original quote character"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.all) e.all.walk(n);
                if (e.default) e.default.walk(n);
                if (e.properties) e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.all != null) {
                if (!(this.all instanceof vi)) throw new Error("all must be AST_SymbolImport");
                if (this.properties != null) throw new Error("cannot import both * and {} in the same statement");
            }
            if (this.default != null) {
                if (!(this.default instanceof vi)) throw new Error("default must be AST_SymbolImport");
                if (this.default.key !== "") throw new Error("invalid default key: " + this.default.key);
            }
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.properties != null) this.properties.forEach(function(e) {
                if (!(e instanceof vi)) throw new Error("properties must contain AST_SymbolImport");
            });
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, An);
    var Yt = e("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            s(this, "value");
        }
    });
    function f(e, n, t, i) {
        e[n].forEach(function(e) {
            o(e, n, true, t, i);
        });
    }
    var Rt = e("Call", "args expression optional pure terminal", {
        $documentation: "A function call expression",
        $propdoc: {
            args: "[AST_Node*] array of arguments",
            expression: "[AST_Node] expression to invoke as function",
            optional: "[boolean] whether the expression is optional chaining",
            pure: "[boolean/S] marker for side-effect-free call expression",
            terminal: "[boolean] whether the chain has ended"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "expression");
            f(this, "args", true);
        }
    });
    var Lt = e("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties",
        _validate: function() {
            if (this.optional) throw new Error("optional must be false");
            if (this.terminal) throw new Error("terminal must be false");
        }
    }, Rt);
    var sn = e("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            f(this, "expressions");
        }
    });
    function Bt(e) {
        while (e instanceof Ut) e = e.expression;
        return e;
    }
    var Ut = e("PropAccess", "expression optional property terminal", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            optional: "[boolean] whether the expression is optional chaining",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node",
            terminal: "[boolean] whether the chain has ended"
        },
        get_property: function() {
            var e = this.property;
            if (e instanceof Di) return e.value;
            if (e instanceof fn && e.operator == "void" && e.expression instanceof Di) return;
            return e;
        },
        _validate: function() {
            if (this.TYPE == "PropAccess") throw new Error("should not instantiate AST_PropAccess");
            s(this, "expression");
        }
    });
    var Vt = e("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, Ut);
    var Wt = e("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            s(this, "property");
        }
    }, Ut);
    var Gt = e("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Jt = e("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Unary") throw new Error("should not instantiate AST_Unary");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "expression");
        }
    });
    var fn = e("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, Jt);
    var Xt = e("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, Jt);
    var un = e("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof cn)) s(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "right");
        }
    });
    var Kt = e("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            s(this, "consequent");
            s(this, "alternative");
        }
    });
    var cn = e("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof ni) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                u(this.left, function(e) {
                    if (!(e instanceof Ut || e instanceof ln)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            } else if (!(this.left instanceof ji || this.left instanceof Mi || this.left instanceof Ut && !this.left.optional || this.left instanceof ln || this.left instanceof Fi)) {
                throw new Error("left must be assignable");
            }
        }
    }, un);
    var Qt = e("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Zt = e("Yield", "expression nested", {
        $documentation: "A yield expression",
        $propdoc: {
            expression: "[AST_Node?] return value for iterator, or null if undefined",
            nested: "[boolean] whether to iterate over expression as generator"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.expression) n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.expression != null) {
                s(this, "expression");
            } else if (this.nested) {
                throw new Error("yield* must contain expression");
            }
        }
    });
    var ei = e("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            f(this, "elements", true, true);
        }
    });
    var ni = e("Destructured", "rest", {
        $documentation: "Base class for destructured literal",
        $propdoc: {
            rest: "[(AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)?] rest parameter, or null if absent"
        },
        _validate: function() {
            if (this.TYPE == "Destructured") throw new Error("should not instantiate AST_Destructured");
        }
    });
    function u(e, n, t) {
        if (e instanceof Yt && t) return u(e.name, n);
        if (e instanceof ni) {
            if (e.rest != null) u(e.rest, n);
            if (e instanceof ti) return e.elements.forEach(function(e) {
                if (!(e instanceof Pi)) u(e, n, true);
            });
            if (e instanceof ri) return e.properties.forEach(function(e) {
                u(e.value, n, true);
            });
        }
        n(e);
    }
    var ti = e("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[(AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        }
    }, ni);
    var ii = e("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof rn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof rn)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof rn)) throw new Error("value must be AST_Node");
        }
    });
    var ri = e("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof ii)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, ni);
    var ai = e("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof oi || e instanceof Gt)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var oi = e("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof rn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ObjectProperty") throw new Error("should not instantiate AST_ObjectProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof rn)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof rn)) throw new Error("value must be AST_Node");
        }
    });
    var si = e("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            s(this, "value");
        }
    }, oi);
    var fi = e("ObjectMethod", null, {
        $documentation: "A key(){} object property",
        _validate: function() {
            if (!(this.value instanceof Jn)) throw new Error("value must be AST_LambdaExpression");
            if (Xn(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of object method's lambda must be null");
        }
    }, si);
    var ui = e("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof Gn)) throw new Error("value must be AST_Accessor");
        }
    }, oi);
    var ci = e("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof Gn)) throw new Error("value must be AST_Accessor");
        }
    }, oi);
    var li = e("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (this.TYPE == "Symbol") throw new Error("should not instantiate AST_Symbol");
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var pi = e("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, li);
    var di = e("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, pi);
    var vi = e("SymbolImport", "key", {
        $documentation: "Symbol defined by an `import` statement",
        $propdoc: {
            key: "[string] the original `export` name"
        },
        _validate: function() {
            if (typeof this.key != "string") throw new Error("key must be string");
        }
    }, di);
    var hi = e("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, pi);
    var mi = e("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, pi);
    var _i = e("SymbolFunarg", "unused", {
        $documentation: "Symbol naming a function argument"
    }, mi);
    var gi = e("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, pi);
    var bi = e("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, pi);
    var Ee = e("SymbolDefClass", null, {
        $documentation: "Symbol defining a class"
    }, di);
    var yi = e("SymbolClass", null, {
        $documentation: "Symbol naming a class expression"
    }, di);
    var wi = e("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, pi);
    var Se = e("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, li);
    var ln = e("SymbolRef", "fixed in_arg redef", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, li);
    var xi = e("SymbolExport", "alias", {
        $documentation: "Reference in an `export` statement",
        $propdoc: {
            alias: "[string] the `export` alias"
        },
        _validate: function() {
            if (typeof this.alias != "string") throw new Error("alias must be string");
        }
    }, ln);
    var Te = e("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, li);
    var ki = e("ObjectIdentity", null, {
        $documentation: "Base class for `super` & `this`",
        _validate: function() {
            if (this.TYPE == "ObjectIdentity") throw new Error("should not instantiate AST_ObjectIdentity");
        }
    }, li);
    var Ei = e("Super", null, {
        $documentation: "The `super` symbol",
        _validate: function() {
            if (this.name !== "super") throw new Error('name must be "super"');
        }
    }, ki);
    var Si = e("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.TYPE == "This" && this.name !== "this") throw new Error('name must be "this"');
        }
    }, ki);
    var Ti = e("NewTarget", null, {
        $documentation: "The `new.target` symbol",
        initialize: function() {
            this.name = "new.target";
        },
        _validate: function() {
            if (this.name !== "new.target") throw new Error('name must be "new.target": ' + this.name);
        }
    }, Si);
    var Ai = e("Template", "expressions strings tag", {
        $documentation: "A template literal, i.e. tag`str1${expr1}...strN${exprN}strN+1`",
        $propdoc: {
            expressions: "[AST_Node*] the placeholder expressions",
            strings: "[string*] the raw text segments",
            tag: "[AST_Node] tag function, or null if absent"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.tag) e.tag.walk(n);
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length + 1 != this.strings.length) {
                throw new Error("malformed template with " + this.expressions.length + " placeholder(s) but " + this.strings.length + " text segment(s)");
            }
            f(this, "expressions");
            this.strings.forEach(function(e) {
                if (typeof e != "string") throw new Error("strings must contain string");
            });
            if (this.tag != null) s(this, "tag");
        }
    });
    var Di = e("Constant", null, {
        $documentation: "Base class for all constants",
        _validate: function() {
            if (this.TYPE == "Constant") throw new Error("should not instantiate AST_Constant");
        }
    });
    var Oi = e("String", "quote value", {
        $documentation: "A string literal",
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] the contents of this string"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Di);
    var $i = e("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
            if (!isFinite(this.value)) throw new Error("value must be finite");
            if (this.value < 0) throw new Error("value cannot be negative");
        }
    }, Di);
    var qi = e("BigInt", "value", {
        $documentation: "A BigInt literal",
        $propdoc: {
            value: "[string] the numeric representation"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
            if (this.value[0] == "-") throw new Error("value cannot be negative");
        }
    }, Di);
    var zi = e("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, Di);
    var g = e("Atom", null, {
        $documentation: "Base class for atoms",
        _validate: function() {
            if (this.TYPE == "Atom") throw new Error("should not instantiate AST_Atom");
        }
    }, Di);
    var Ci = e("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, g);
    var Mi = e("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, g);
    var Fi = e("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, g);
    var Pi = e("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, g);
    var ji = e("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, g);
    var Ni = e("Boolean", null, {
        $documentation: "Base class for booleans",
        _validate: function() {
            if (this.TYPE == "Boolean") throw new Error("should not instantiate AST_Boolean");
        }
    }, g);
    var Ii = e("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Ni);
    var Hi = e("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Ni);
    function Yi(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Yi.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || vn);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof Wn) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof On && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            var e = this.stack.pop();
            if (e instanceof Wn) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length - 1; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof Un) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof On)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Fn && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Pn || e instanceof xt && i instanceof St) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof Kt && t.condition === e || t instanceof jn && t.condition === e || t instanceof Hn && t.condition === e || t instanceof Et && t.condition === e || t instanceof bt && t.in_bool || t instanceof sn && t.tail_node() !== e || t instanceof an || t instanceof fn && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof un && (t.operator == "&&" || t.operator == "||") || t instanceof Kt || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof bt) {
                    for (var i, r = t; i = this.parent(++n); r = i) {
                        if (i.TYPE == "Call") {
                            if (!(r instanceof Wn) || r.name) return false;
                        } else if (r instanceof Wn) {
                            return false;
                        }
                    }
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Ri(e, n) {
        Yi.call(this);
        this.before = e;
        this.after = n;
    }
    Ri.prototype = new Yi();
    (function(e) {
        function t(e, n) {
            return bn(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(rn, vn);
        e(Fn, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(an, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(Mn, function(e, n) {
            e.body = t(e.body, n);
        });
        e(Nn, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(In, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(Hn, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(Yn, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(Bn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(gt, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(wt, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(Et, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(St, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Dt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Ot, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e($t, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(zt, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(Pt, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Yt, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(Wn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            e.body = t(e.body, n);
        });
        function n(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        }
        e(et, n);
        e(nt, n);
        e(lt, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            if (e.extends) e.extends = e.extends.transform(n);
            e.properties = t(e.properties, n);
        });
        e(vt, function(e, n) {
            if (e.key instanceof rn) e.key = e.key.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Rt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(sn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(Qt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Zt, function(e, n) {
            if (e.expression) e.expression = e.expression.transform(n);
        });
        e(Vt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Wt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(Gt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Jt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(un, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(Kt, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(ei, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(ti, function(e, n) {
            e.elements = t(e.elements, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(ii, function(e, n) {
            if (e.key instanceof rn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(ri, function(e, n) {
            e.properties = t(e.properties, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(ai, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(oi, function(e, n) {
            if (e.key instanceof rn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(jt, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(Nt, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(It, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Ht, function(e, n) {
            if (e.all) e.all = e.all.transform(n);
            if (e.default) e.default = e.default.transform(n);
            if (e.properties) e.properties = t(e.properties, n);
        });
        e(Ai, function(e, n) {
            if (e.tag) e.tag = e.tag.transform(n);
            e.expressions = t(e.expressions, n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var Ae = "break case catch class const continue debugger default delete do else extends finally for function if in instanceof new return switch throw try typeof var void while with";
    var C = "false null true";
    var N = [ "abstract async await boolean byte char double enum export final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield", C, Ae ].join(" ");
    var M = "return new delete throw else case";
    Ae = kn(Ae);
    N = kn(N);
    M = kn(M);
    C = kn(C);
    var c = /^0b([01]+)$/i;
    var l = /^0x([0-9a-f]+)$/i;
    var p = /^0o?([0-7]+)$/i;
    var F = kn([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", "**", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", "**=", ">>=", "<<=", ">>>=", "&=", "|=", "^=", "&&", "||", "??", "&&=", "||=", "??=" ]);
    var P = "\n\r\u2028\u2029";
    var I = "+-*&%=<>!?|~^";
    var d = "[{(";
    var v = ",;:";
    var h = ")}]";
    var De = v + h;
    var H = d + v;
    var Y = H + "`" + h;
    var R = P + "  \t\f\v​             　\ufeff";
    var L = kn(n("./'\"#" + I + Y + R));
    P = kn(n(P));
    I = kn(n(I));
    De = kn(n(De));
    H = kn(n(H));
    Y = kn(n(Y));
    R = kn(n(R));
    function te(e) {
        return e >= 55296 && e <= 56319;
    }
    function ie(e) {
        return e >= 56320 && e <= 57343;
    }
    function B(e) {
        return e >= 48 && e <= 57;
    }
    function re(e) {
        return !L[e];
    }
    function Li(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Bi(e) {
        switch (e[0]) {
          case "b":
            return "\b";

          case "f":
            return "\f";

          case "n":
            return "\n";

          case "r":
            return "\r";

          case "t":
            return "\t";

          case "u":
            var n;
            if (e[1] == "{" && e.slice(-1) == "}") {
                n = e.slice(2, -1);
            } else if (e.length == 5) {
                n = e.slice(1);
            } else {
                return;
            }
            var t = parseInt(n, 16);
            if (t < 0 || isNaN(t)) return;
            if (t < 65536) return String.fromCharCode(t);
            if (t > 1114111) return;
            return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

          case "v":
            return "\v";

          case "x":
            if (e.length != 3) return;
            var t = parseInt(e.slice(1), 16);
            if (t < 0 || isNaN(t)) return;
            return String.fromCharCode(t);

          case "\r":
          case "\n":
            return "";

          default:
            if (e == "0") return "\0";
            if (e[0] >= "0" && e[0] <= "9") return;
            return e;
        }
    }
    function U(e) {
        var n;
        if (n = c.exec(e)) return parseInt(n[1], 2);
        if (n = l.exec(e)) return parseInt(n[1], 16);
        if (n = p.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function Ui(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    Ui.prototype = Object.create(Error.prototype);
    Ui.prototype.constructor = Ui;
    Ui.prototype.name = "SyntaxError";
    t(Ui);
    function Oe(e, n, t, i, r) {
        throw new Ui(e, n, t, i, r);
    }
    function $e(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var V = {};
    function qe(d, v, h, m) {
        var r = {
            text: d,
            filename: v,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: [],
            read_template: e("Unterminated template literal", function(e) {
                var n = "";
                for (;;) {
                    var t = i();
                    switch (t) {
                      case "\\":
                        t += i();
                        break;

                      case "`":
                        e.push(n);
                        return;

                      case "$":
                        if (s() == "{") {
                            f();
                            e.push(n);
                            r.regex_allowed = true;
                            return true;
                        }
                    }
                    n += t;
                }
                function i() {
                    var e = f(true, true);
                    return e == "\r" ? "\n" : e;
                }
            })
        };
        var _ = false;
        function s() {
            return r.text.charAt(r.pos);
        }
        function f(e, n) {
            var t = r.text.charAt(r.pos++);
            if (e && !t) throw V;
            if (P[t]) {
                r.col = 0;
                r.line++;
                if (!n) r.newline_before = true;
                if (t == "\r" && s() == "\n") {
                    r.pos++;
                    t = "\n";
                }
            } else {
                r.col++;
            }
            return t;
        }
        function a(e) {
            while (e-- > 0) f();
        }
        function o(e) {
            return r.text.substr(r.pos, e.length) == e;
        }
        function g() {
            var e = r.text;
            for (var n = r.pos; n < r.text.length; ++n) {
                if (P[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = r.text.indexOf(e, r.pos);
            if (n && t == -1) throw V;
            return t;
        }
        function b() {
            r.tokline = r.line;
            r.tokcol = r.col;
            r.tokpos = r.pos;
        }
        function u(e, n, t) {
            r.regex_allowed = e == "operator" && !Vi[n] || e == "keyword" && M[n] || e == "punc" && H[n];
            if (e == "punc" && n == ".") _ = true; else if (!t) _ = false;
            var i = {
                type: e,
                value: n,
                line: r.tokline,
                col: r.tokcol,
                pos: r.tokpos,
                endline: r.line,
                endcol: r.col,
                endpos: r.pos,
                nlb: r.newline_before,
                file: v
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = d.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = r.comments_before;
                i.comments_after = r.comments_before = [];
            }
            r.newline_before = false;
            return new ne(i);
        }
        function y() {
            while (R[s()]) f();
        }
        function w(e) {
            var n = "", t;
            while ((t = s()) && e(t, n)) n += f();
            return n;
        }
        function c(e) {
            Oe(e, v, r.tokline, r.tokcol, r.tokpos);
        }
        function x(e) {
            return /^0[0-7_]+$/.test(e);
        }
        function k(e) {
            var t = false, i = false, r = false, a = e == ".";
            var n = w(function(e, n) {
                switch (e) {
                  case "x":
                  case "X":
                    return r ? false : r = true;

                  case "e":
                  case "E":
                    return r ? true : t ? false : t = i = true;

                  case "+":
                  case "-":
                    return i;

                  case i = false, ".":
                    return a || t || r || x(n) ? false : a = true;
                }
                return /[_0-9a-dfo]/i.test(e);
            });
            if (e) n = e + n;
            if (x(n)) {
                if (p.has_directive("use strict")) c("Legacy octal literals are not allowed in strict mode");
            } else {
                n = n.replace(r ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var o = U(n);
            if (isNaN(o)) c("Invalid syntax: " + n);
            if (a || t || s() != "n") return u("num", o);
            return u("bigint", n.toLowerCase() + f());
        }
        function E(e) {
            var n = f(true, e);
            if (n >= "0" && n <= "7") return S(n);
            if (n == "u") {
                var t = f(true, e);
                n += t;
                if (t != "{") {
                    n += f(true, e) + f(true, e) + f(true, e);
                } else do {
                    t = f(true, e);
                    n += t;
                } while (t != "}");
            } else if (n == "x") {
                n += f(true, e) + f(true, e);
            }
            var i = Bi(n);
            if (typeof i != "string") c("Invalid escape sequence: \\" + n);
            return i;
        }
        function S(e) {
            var n = s();
            if (n >= "0" && n <= "7") {
                e += f(true);
                if (e[0] <= "3" && (n = s()) >= "0" && n <= "7") e += f(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && p.has_directive("use strict")) c("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        var T = e("Unterminated string constant", function(e) {
            var n = f(), t = "";
            for (;;) {
                var i = f(true, true);
                if (i == "\\") i = E(true); else if (P[i]) c("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = u("string", t);
            r.quote = e;
            return r;
        });
        function l(e) {
            var n = r.regex_allowed;
            var t = g(), i;
            if (t == -1) {
                i = r.text.substr(r.pos);
                r.pos = r.text.length;
            } else {
                i = r.text.substring(r.pos, t);
                r.pos = t;
            }
            r.col = r.tokcol + (r.pos - r.tokpos);
            r.comments_before.push(u(e, i, true));
            r.regex_allowed = n;
            return p;
        }
        var n = e("Unterminated multiline comment", function() {
            var e = r.regex_allowed;
            var n = i("*/", true);
            var t = r.text.substring(r.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            a(t.length + 2);
            r.comments_before.push(u("comment2", t, true));
            r.regex_allowed = e;
            return p;
        });
        function A() {
            var e = false, n, t = false, i = s() == "#" ? f() : "";
            while (n = s()) {
                if (!e) {
                    if (n == "\\") t = e = true, f(); else if (re(n)) i += f(); else break;
                } else {
                    if (n != "u") c("Expecting UnicodeEscapeSequence -- uXXXX");
                    n = E();
                    if (!re(n)) c("Unicode char: " + n.charCodeAt(0) + " is not valid in identifier");
                    i += n;
                    e = false;
                }
            }
            if (Ae[i] && t) {
                var r = i.charCodeAt(0).toString(16).toUpperCase();
                i = "\\u" + "0000".substr(r.length) + r + i.slice(1);
            }
            return i;
        }
        var D = e("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = f(true)) if (P[t]) {
                c("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = A();
            try {
                var a = new RegExp(e, r);
                a.raw_source = e;
                return u("regexp", a);
            } catch (e) {
                c(e.message);
            }
        });
        function O(e) {
            function t(e) {
                if (!s()) return e;
                var n = e + s();
                if (F[n]) {
                    f();
                    return t(n);
                } else {
                    return e;
                }
            }
            return u("operator", t(e || f()));
        }
        function $() {
            f();
            switch (s()) {
              case "/":
                f();
                return l("comment1");

              case "*":
                f();
                return n();
            }
            return r.regex_allowed ? D("") : O("/");
        }
        function q() {
            f();
            var e = s();
            if (e == ".") {
                var n = ".";
                do {
                    n += ".";
                    f();
                } while (s() == ".");
                return u("operator", n);
            }
            return B(e.charCodeAt(0)) ? k(".") : u("punc", ".");
        }
        function z() {
            var e = A();
            if (_) return u("name", e);
            return C[e] ? u("atom", e) : !Ae[e] ? u("name", e) : F[e] ? u("operator", e) : u("keyword", e);
        }
        function e(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === V) c(n); else throw e;
                }
            };
        }
        function p(e) {
            if (e != null) return D(e);
            if (m && r.pos == 0 && o("#!")) {
                b();
                a(2);
                l("comment5");
            }
            for (;;) {
                y();
                b();
                if (h) {
                    if (o("\x3c!--")) {
                        a(4);
                        l("comment3");
                        continue;
                    }
                    if (o("--\x3e") && r.newline_before) {
                        a(3);
                        l("comment4");
                        continue;
                    }
                }
                var n = s();
                if (!n) return u("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return T(n);

                  case 46:
                    return q();

                  case 47:
                    var i = $();
                    if (i === p) continue;
                    return i;
                }
                if (B(t)) return k();
                if (Y[n]) return u("punc", f());
                if (o("=>")) return u("punc", f() + f());
                if (I[n]) return O();
                if (t == 35 || t == 92 || !L[n]) return z();
                break;
            }
            c("Unexpected character '" + n + "'");
        }
        p.context = function(e) {
            if (e) r = e;
            return r;
        };
        p.add_directive = function(e) {
            r.directive_stack[r.directive_stack.length - 1].push(e);
            if (r.directives[e]) r.directives[e]++; else r.directives[e] = 1;
        };
        p.push_directives_stack = function() {
            r.directive_stack.push([]);
        };
        p.pop_directives_stack = function() {
            var e = r.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                r.directives[e[n]]--;
            }
        };
        p.has_directive = function(e) {
            return r.directives[e] > 0;
        };
        return p;
    }
    var ze = kn("typeof void delete -- ++ ! ~ - +");
    var Vi = kn("-- ++");
    var Ce = kn("= += -= /= *= %= **= >>= <<= >>>= &= |= ^= &&= ||= ??=");
    var Wi = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var i = e[t++];
            for (var r = 0; r < i.length; r++) {
                n[i[r]] = t;
            }
        }
        return n;
    }([ [ "??" ], [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ], [ "**" ] ], {});
    var Me = kn("atom bigint num regexp string");
    function Gi(e, l) {
        l = be(l, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var _ = {
            input: typeof e == "string" ? qe(e, l.filename, l.html5_comments, l.shebang) : e,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_generator: false,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        _.token = b();
        function g(e, n) {
            return $e(_.token, e, n);
        }
        function p() {
            return _.peeked || (_.peeked = _.input());
        }
        function b() {
            _.prev = _.token;
            if (_.peeked) {
                _.token = _.peeked;
                _.peeked = null;
            } else {
                _.token = _.input();
            }
            _.in_directives = _.in_directives && (_.token.type == "string" || g("punc", ";"));
            return _.token;
        }
        function y() {
            return _.prev;
        }
        function s(e, n, t, i) {
            var r = _.input.context();
            Oe(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function f(e, n) {
            s(n, e.line, e.col);
        }
        function t(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function w(e) {
            if (e == null) e = _.token;
            f(e, "Unexpected token: " + t(e.type, e.value));
        }
        function u(e, n) {
            if (g(e, n)) return b();
            f(_.token, "Unexpected token: " + t(_.token.type, _.token.value) + ", expected: " + t(e, n));
        }
        function x(e) {
            return u("punc", e);
        }
        function o(e) {
            return e.nlb || !tn(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function c() {
            return !l.strict && (g("eof") || g("punc", "}") || o(_.token));
        }
        function k(e) {
            if (g("punc", ";")) b(); else if (!e && !c()) x(";");
        }
        function d() {
            x("(");
            var e = me();
            x(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = _.token;
                var n = i.apply(null, arguments);
                var t = y();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function T() {
            if (g("operator", "/") || g("operator", "/=")) {
                _.peeked = null;
                _.token = _.input(_.token.value.substr(1));
            }
        }
        var v = n(function() {
            T();
            switch (_.token.type) {
              case "string":
                var e = _.in_directives;
                var n = me();
                if (e) {
                    if (n instanceof Oi) {
                        var t = n.start.raw.slice(1, -1);
                        _.input.add_directive(t);
                        n.value = t;
                    } else {
                        _.in_directives = e = false;
                    }
                }
                k();
                return e ? new On(n) : new an({
                    body: n
                });

              case "num":
              case "bigint":
              case "regexp":
              case "operator":
              case "atom":
                return m();

              case "name":
                switch (_.token.value) {
                  case "async":
                    if ($e(p(), "keyword", "function")) {
                        b();
                        b();
                        if (!g("operator", "*")) return E(st);
                        b();
                        return E(ft);
                    }
                    break;

                  case "await":
                    if (_.in_async) return m();
                    break;

                  case "export":
                    b();
                    return F();

                  case "import":
                    var i = p();
                    if (!(i.type == "punc" && /^[(.]$/.test(i.value))) {
                        b();
                        return N();
                    }
                    break;

                  case "let":
                    if (L()) {
                        b();
                        var r = U();
                        k();
                        return r;
                    }
                    break;

                  case "yield":
                    if (_.in_generator) return m();
                    break;
                }
                return $e(p(), "punc", ":") ? h() : m();

              case "punc":
                switch (_.token.value) {
                  case "{":
                    return new on({
                        start: _.token,
                        body: I(),
                        end: y()
                    });

                  case "[":
                  case "(":
                  case "`":
                    return m();

                  case ";":
                    _.in_directives = false;
                    b();
                    return new $n();

                  default:
                    w();
                }

              case "keyword":
                switch (_.token.value) {
                  case "break":
                    b();
                    return A(xt);

                  case "class":
                    b();
                    return O(pt);

                  case "const":
                    b();
                    var r = B();
                    k();
                    return r;

                  case "continue":
                    b();
                    return A(kt);

                  case "debugger":
                    b();
                    k();
                    return new Dn();

                  case "do":
                    b();
                    var n = _e(v);
                    u("keyword", "while");
                    var a = d();
                    k(true);
                    return new Nn({
                        body: n,
                        condition: a
                    });

                  case "while":
                    b();
                    return new In({
                        condition: d(),
                        body: _e(v)
                    });

                  case "for":
                    b();
                    return $();

                  case "function":
                    b();
                    if (!g("operator", "*")) return E(ut);
                    b();
                    return E(ct);

                  case "if":
                    b();
                    return C();

                  case "return":
                    if (_.in_function == 0 && !l.bare_returns) s("'return' outside of function");
                    b();
                    var t = null;
                    if (g("punc", ";")) {
                        b();
                    } else if (!c()) {
                        t = me();
                        k();
                    }
                    return new bt({
                        value: t
                    });

                  case "switch":
                    b();
                    return new St({
                        expression: d(),
                        body: _e(H)
                    });

                  case "throw":
                    b();
                    if (o(_.token)) s("Illegal newline after 'throw'");
                    var t = me();
                    k();
                    return new yt({
                        value: t
                    });

                  case "try":
                    b();
                    return Y();

                  case "var":
                    b();
                    var r = V();
                    k();
                    return r;

                  case "with":
                    if (_.input.has_directive("use strict")) {
                        s("Strict mode may not include a with statement");
                    }
                    b();
                    return new Bn({
                        expression: d(),
                        body: v()
                    });
                }
            }
            w();
        });
        function h() {
            var n = re(Se);
            if (!tn(_.labels, function(e) {
                return e.name != n.name;
            })) {
                s("Label " + n.name + " defined twice");
            }
            x(":");
            _.labels.push(n);
            var e = v();
            _.labels.pop();
            if (!(e instanceof Pn)) {
                n.references.forEach(function(e) {
                    if (e instanceof kt) {
                        f(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new Fn({
                body: e,
                label: n
            });
        }
        function m() {
            var e = me();
            k();
            return new an({
                body: e
            });
        }
        function A(e) {
            var n = null, t;
            if (!c()) {
                n = re(Te, true);
            }
            if (n != null) {
                t = dn(function(e) {
                    return e.name == n.name;
                }, _.labels);
                if (!t) f(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (_.in_loop == 0) s(e.TYPE + " not inside a loop or switch");
            k();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function D(e) {
            if (!g("name", e)) return;
            var n = p();
            if (!n) return;
            if ($e(n, "operator", "=")) return;
            if (n.type == "punc" && /^[(;}]$/.test(n.value)) return;
            if (o(n)) return;
            return b();
        }
        function O(c) {
            var l = _.in_async;
            var p = _.in_generator;
            _.input.push_directives_stack();
            _.input.add_directive("use strict");
            var e;
            if (c === pt) {
                e = re(Ee);
            } else {
                e = re(yi, true);
            }
            var d = null;
            if (g("keyword", "extends")) {
                b();
                T();
                d = J(true);
            }
            x("{");
            var n = [];
            while (!g("punc", "}")) {
                if (g("punc", ";")) {
                    b();
                    continue;
                }
                var t = _.token;
                var i = !!D("static");
                var r = D("async");
                if (g("operator", "*")) {
                    b();
                    var a = g("name") && /^#/.test(_.token.value);
                    var o = ee();
                    var v = _.token;
                    var s = E(r ? it : at);
                    s.start = v;
                    s.end = y();
                    n.push(new mt({
                        start: t,
                        static: i,
                        private: a,
                        key: o,
                        value: s,
                        end: y()
                    }));
                    continue;
                }
                var a = g("name") && /^#/.test(_.token.value);
                var o = ee();
                if (g("punc", "(")) {
                    var h = _.token;
                    var f = E(r ? tt : rt);
                    f.start = h;
                    f.end = y();
                    n.push(new mt({
                        start: t,
                        static: i,
                        private: a,
                        key: o,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (r) w(r);
                var m = null;
                if (g("operator", "=")) {
                    b();
                    _.in_async = false;
                    _.in_generator = false;
                    m = S();
                    _.in_generator = p;
                    _.in_async = l;
                } else if (!(g("punc", ";") || g("punc", "}"))) {
                    var u = null;
                    switch (o) {
                      case "get":
                        u = we;
                        break;

                      case "set":
                        u = xe;
                        break;
                    }
                    if (u) {
                        n.push(new u({
                            start: t,
                            static: i,
                            private: g("name") && /^#/.test(_.token.value),
                            key: ee(),
                            value: Q(),
                            end: y()
                        }));
                        continue;
                    }
                }
                k();
                n.push(new ht({
                    start: t,
                    static: i,
                    private: a,
                    key: o,
                    value: m,
                    end: y()
                }));
            }
            b();
            _.input.pop_directives_stack();
            _.in_generator = p;
            _.in_async = l;
            return new c({
                extends: d,
                name: e,
                properties: n
            });
        }
        function $() {
            var e = g("name", "await") && b();
            x("(");
            var n = null;
            if (e || !g("punc", ";")) {
                n = g("keyword", "const") ? (b(), B(true)) : g("name", "let") && L() ? (b(), 
                U(true)) : g("keyword", "var") ? (b(), V(true)) : me(true);
                var t;
                if (e) {
                    u("name", "of");
                    t = Ln;
                } else if (g("operator", "in")) {
                    b();
                    t = Rn;
                } else if (g("name", "of")) {
                    b();
                    t = ye;
                }
                if (t) {
                    if (n instanceof zt) {
                        if (n.definitions.length > 1) {
                            f(n.start, "Only one variable declaration allowed in for..in/of loop");
                        }
                        if (t !== Rn && n.definitions[0].value) {
                            f(n.definitions[0].value.start, "No initializers allowed in for..of loop");
                        }
                    } else if (!(ve(n) || (n = he(n)) instanceof ni)) {
                        f(n.start, "Invalid left-hand side in for..in/of loop");
                    }
                    return r(t, n);
                }
            }
            return i(n);
        }
        function i(e) {
            x(";");
            var n = g("punc", ";") ? null : me();
            x(";");
            var t = g("punc", ")") ? null : me();
            x(")");
            return new Hn({
                init: e,
                condition: n,
                step: t,
                body: _e(v)
            });
        }
        function r(e, n) {
            T();
            var t = me();
            x(")");
            return new e({
                init: n,
                object: t,
                body: _e(v)
            });
        }
        function q(e) {
            if (e instanceof ei) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Gt) {
                    n = q(e.elements.pop().expression);
                }
                return new ti({
                    start: e.start,
                    elements: e.elements.map(q),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof cn) return new Yt({
                start: e.start,
                name: q(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof Yt) {
                e.name = q(e.name);
                return e;
            }
            if (e instanceof ti) {
                e.elements = e.elements.map(q);
                if (e.rest) e.rest = q(e.rest);
                return e;
            }
            if (e instanceof ri) {
                e.properties.forEach(function(e) {
                    e.value = q(e.value);
                });
                if (e.rest) e.rest = q(e.rest);
                return e;
            }
            if (e instanceof Pi) return e;
            if (e instanceof ai) {
                var n = null;
                if (e.properties[e.properties.length - 1] instanceof Gt) {
                    n = q(e.properties.pop().expression);
                }
                return new ri({
                    start: e.start,
                    properties: e.properties.map(function(e) {
                        if (!(e instanceof si)) f(e.start, "Invalid destructuring assignment");
                        return new ii({
                            start: e.start,
                            key: e.key,
                            value: q(e.value),
                            end: e.end
                        });
                    }),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof _i) return e;
            if (e instanceof ln) return new _i(e);
            if (e instanceof Zt) return new _i({
                start: e.start,
                name: "yield",
                end: e.end
            });
            f(e.start, "Invalid arrow parameter");
        }
        function z(e, n, t) {
            var i = _.in_async;
            var r = _.in_generator;
            _.in_async = t;
            _.in_generator = false;
            var a = _.in_funarg;
            _.in_funarg = _.in_function;
            var c = e.map(q);
            var o = e.rest || null;
            if (o) o = q(o);
            _.in_funarg = a;
            x("=>");
            var s, f;
            var l = _.in_loop;
            var p = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            if (g("punc", "{")) {
                s = I();
                f = null;
            } else {
                s = [];
                T();
                f = S();
            }
            var d = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = l;
            _.labels = p;
            _.in_generator = r;
            _.in_async = i;
            var u = new (t ? nt : et)({
                start: n,
                argnames: c,
                rest: o,
                body: s,
                value: f,
                end: y()
            });
            if (d) u.each_argname(ie);
            return u;
        }
        var E = function(e) {
            var n = _.in_async;
            var t = _.in_generator;
            var i;
            if (/Defun$/.test(e.TYPE)) {
                i = re(gi);
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
            } else {
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
                i = re(bi, true);
            }
            if (i && e !== Gn && !(i instanceof pi)) w(y());
            x("(");
            var r = _.in_funarg;
            _.in_funarg = _.in_function;
            var a = X(")", !l.strict, false, function() {
                return oe(_i);
            });
            _.in_funarg = r;
            var o = _.in_loop;
            var s = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            var f = I();
            var c = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = o;
            _.labels = s;
            _.in_generator = t;
            _.in_async = n;
            var u = new e({
                name: i,
                argnames: a,
                rest: a.rest || null,
                body: f
            });
            if (c) {
                if (i) ie(i);
                u.each_argname(ie);
            }
            return u;
        };
        function C() {
            var e = d(), n = v(), t = null;
            if (g("keyword", "else")) {
                b();
                t = v();
            }
            return new Et({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function M() {
            return g("name") || Li(_.token.value);
        }
        function F() {
            if (g("operator", "*")) {
                b();
                var e = "*";
                if (g("name", "as")) {
                    b();
                    if (!M()) u("name");
                    e = _.token.value;
                    b();
                }
                u("name", "from");
                var n = _.token;
                u("string");
                k();
                return new ke({
                    aliases: [ e ],
                    keys: [ "*" ],
                    path: n.value,
                    quote: n.quote
                });
            }
            if (g("punc", "{")) {
                b();
                var i = [];
                var t = [];
                while (M()) {
                    var r = _.token;
                    b();
                    t.push(r);
                    if (g("name", "as")) {
                        b();
                        if (!M()) u("name");
                        i.push(_.token.value);
                        b();
                    } else {
                        i.push(r.value);
                    }
                    if (!g("punc", "}")) x(",");
                }
                x("}");
                if (g("name", "from")) {
                    b();
                    var n = _.token;
                    u("string");
                    k();
                    return new ke({
                        aliases: i,
                        keys: t.map(function(e) {
                            return e.value;
                        }),
                        path: n.value,
                        quote: n.quote
                    });
                }
                k();
                return new It({
                    properties: t.map(function(e, n) {
                        if (!$e(e, "name")) f(e, "Name expected");
                        var t = te(xi, e);
                        t.alias = i[n];
                        return t;
                    })
                });
            }
            if (g("keyword", "default")) {
                b();
                var a = _.token;
                var o = P();
                if (o) {
                    o.start = a;
                    o.end = y();
                } else {
                    T();
                    o = me();
                    k();
                }
                return new Nt({
                    body: o
                });
            }
            return new jt({
                body: j()
            });
        }
        function a(e, n) {
            if (n.name) {
                n = new e(n);
                n.name = new (e === pt ? Ee : gi)(n.name);
            }
            return n;
        }
        function P() {
            if (g("name", "async")) {
                if (!$e(p(), "keyword", "function")) return;
                b();
                b();
                if (!g("operator", "*")) return a(st, E(tt));
                b();
                return a(ft, E(it));
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return a(pt, O(dt));

              case "function":
                b();
                if (!g("operator", "*")) return a(ut, E(rt));
                b();
                return a(ct, E(at));
            }
        }
        var j = n(function() {
            if (g("name")) switch (_.token.value) {
              case "async":
                b();
                u("keyword", "function");
                if (!g("operator", "*")) return E(st);
                b();
                return E(ft);

              case "let":
                b();
                var e = U();
                k();
                return e;
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return O(pt);

              case "const":
                b();
                var e = B();
                k();
                return e;

              case "function":
                b();
                if (!g("operator", "*")) return E(ut);
                b();
                return E(ct);

              case "var":
                b();
                var e = V();
                k();
                return e;
            }
            w();
        });
        function N() {
            var e = null;
            var n = re(vi, true);
            var t = null;
            if (n ? (n.key = "", g("punc", ",") && b()) : !g("string")) {
                if (g("operator", "*")) {
                    b();
                    u("name", "as");
                    e = re(vi);
                    e.key = "*";
                } else {
                    x("{");
                    t = [];
                    while (M()) {
                        var i;
                        if ($e(p(), "name", "as")) {
                            var r = _.token.value;
                            b();
                            b();
                            i = re(vi);
                            i.key = r;
                        } else {
                            i = re(vi);
                            i.key = i.name;
                        }
                        t.push(i);
                        if (!g("punc", "}")) x(",");
                    }
                    x("}");
                }
            }
            if (e || n || t) u("name", "from");
            var a = _.token;
            u("string");
            k();
            return new Ht({
                all: e,
                default: n,
                path: a.value,
                properties: t,
                quote: a.quote
            });
        }
        function I() {
            x("{");
            var e = [];
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                e.push(v());
            }
            b();
            return e;
        }
        function H() {
            x("{");
            var e = [], n, t, i, r;
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                if (g("keyword", "case")) {
                    if (n) n.end = y();
                    t = [];
                    n = new Dt({
                        start: (r = _.token, b(), r),
                        expression: me(),
                        body: t
                    });
                    e.push(n);
                    x(":");
                } else if (g("keyword", "default")) {
                    if (n) n.end = y();
                    if (i) s("More than one default clause in switch statement");
                    t = [];
                    n = new At({
                        start: (r = _.token, b(), x(":"), r),
                        body: t
                    });
                    e.push(n);
                    i = n;
                } else {
                    if (!t) w();
                    t.push(v());
                }
            }
            if (n) n.end = y();
            b();
            return e;
        }
        function Y() {
            var e = I(), n = null, t = null;
            if (g("keyword", "catch")) {
                var i = _.token;
                b();
                var r = null;
                if (g("punc", "(")) {
                    b();
                    r = ae(wi);
                    x(")");
                }
                n = new $t({
                    start: i,
                    argname: r,
                    body: I(),
                    end: y()
                });
            }
            if (g("keyword", "finally")) {
                var i = _.token;
                b();
                t = new qt({
                    start: i,
                    body: I(),
                    end: y()
                });
            }
            if (!n && !t) s("Missing catch/finally blocks");
            return new Ot({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function R(e, n) {
            var t = [];
            for (;;) {
                var i = _.token;
                var r = ae(e);
                var a = null;
                if (g("operator", "=")) {
                    b();
                    a = S(n);
                } else if (!n && (e === di || r instanceof ni)) {
                    s("Missing initializer in declaration");
                }
                t.push(new Pt({
                    start: i,
                    name: r,
                    value: a,
                    end: y()
                }));
                if (!g("punc", ",")) break;
                b();
            }
            return t;
        }
        function L() {
            var e = p();
            return $e(e, "name") || $e(e, "punc", "[") || $e(e, "punc", "{");
        }
        var B = function(e) {
            return new Ct({
                start: y(),
                definitions: R(di, e),
                end: y()
            });
        };
        var U = function(e) {
            return new Mt({
                start: y(),
                definitions: R(hi, e),
                end: y()
            });
        };
        var V = function(e) {
            return new Ft({
                start: y(),
                definitions: R(mi, e),
                end: y()
            });
        };
        var W = function(e) {
            var n = _.token;
            u("operator", "new");
            var t;
            if (g("punc", ".") && $e(p(), "name", "target")) {
                b();
                b();
                t = new Ti();
            } else {
                var i = J(false), r;
                if (g("punc", "(")) {
                    b();
                    r = X(")", !l.strict);
                } else {
                    r = [];
                }
                t = new Lt({
                    expression: i,
                    args: r
                });
            }
            t.start = n;
            t.end = y();
            return fe(t, e);
        };
        function G() {
            var e, n = _.token, t = n.value;
            switch (n.type) {
              case "num":
                if (isFinite(t)) {
                    e = new $i({
                        value: t
                    });
                } else {
                    e = new ji();
                    if (t < 0) e = new fn({
                        operator: "-",
                        expression: e
                    });
                }
                break;

              case "bigint":
                e = new qi({
                    value: t
                });
                break;

              case "string":
                e = new Oi({
                    value: t,
                    quote: n.quote
                });
                break;

              case "regexp":
                e = new zi({
                    value: t
                });
                break;

              case "atom":
                switch (t) {
                  case "false":
                    e = new Ii();
                    break;

                  case "true":
                    e = new Hi();
                    break;

                  case "null":
                    e = new Ci();
                    break;

                  default:
                    w();
                }
                break;

              default:
                w();
            }
            b();
            e.start = e.end = n;
            return e;
        }
        var J = function(e) {
            if (g("operator", "new")) {
                return W(e);
            }
            var n = _.token;
            if (g("punc")) {
                switch (n.value) {
                  case "`":
                    return fe(se(null), e);

                  case "(":
                    b();
                    if (g("punc", ")")) {
                        b();
                        return z([], n);
                    }
                    var t = me(false, true);
                    var i = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = i;
                    if (i == 0 && n.comments_before.length > 0) {
                        var r = n.comments_before[0];
                        if (!r.nlb) {
                            r.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    x(")");
                    var a = y();
                    a.comments_before = t.end.comments_before;
                    a.comments_after.forEach(function(e) {
                        t.end.comments_after.push(e);
                        if (e.nlb) _.token.nlb = true;
                    });
                    a.comments_after.length = 0;
                    a.comments_after = t.end.comments_after;
                    t.end = a;
                    if (g("punc", "=>")) return z(t instanceof sn ? t.expressions : [ t ], n);
                    return fe(t, e);

                  case "[":
                    return fe(K(), e);

                  case "{":
                    return fe(Z(), e);
                }
                w();
            }
            if (g("keyword")) switch (n.value) {
              case "class":
                b();
                var o = O(dt);
                o.start = n;
                o.end = y();
                return fe(o, e);

              case "function":
                b();
                var s;
                if (g("operator", "*")) {
                    b();
                    s = E(at);
                } else {
                    s = E(rt);
                }
                s.start = n;
                s.end = y();
                return fe(s, e);
            }
            if (g("name")) {
                var f = te(ln, n);
                b();
                if (f.name == "async") {
                    if (g("keyword", "function")) {
                        b();
                        var s;
                        if (g("operator", "*")) {
                            b();
                            s = E(it);
                        } else {
                            s = E(tt);
                        }
                        s.start = n;
                        s.end = y();
                        return fe(s, e);
                    }
                    if (g("name") && $e(p(), "punc", "=>")) {
                        n = _.token;
                        f = te(ln, n);
                        b();
                        return z([ f ], n, true);
                    }
                    if (g("punc", "(")) {
                        var c = fe(f, e);
                        if (!g("punc", "=>")) return c;
                        var u = c.args;
                        if (u[u.length - 1] instanceof Gt) {
                            u.rest = u.pop().expression;
                        }
                        return z(u, n, true);
                    }
                }
                return g("punc", "=>") ? z([ f ], n) : fe(f, e);
            }
            if (Me[_.token.type]) {
                return fe(G(), e);
            }
            w();
        };
        function X(e, n, t, i) {
            if (!i) i = S;
            var r = true, a = [];
            while (!g("punc", e)) {
                if (r) r = false; else x(",");
                if (n && g("punc", e)) break;
                if (t && g("punc", ",")) {
                    a.push(new Pi({
                        start: _.token,
                        end: _.token
                    }));
                } else if (!g("operator", "...")) {
                    a.push(i());
                } else if (i === S) {
                    a.push(new Gt({
                        start: _.token,
                        expression: (b(), i()),
                        end: y()
                    }));
                } else {
                    b();
                    a.rest = i();
                    if (a.rest instanceof Yt) f(a.rest.start, "Invalid rest parameter");
                    break;
                }
            }
            x(e);
            return a;
        }
        var K = n(function() {
            x("[");
            return new ei({
                elements: X("]", !l.strict, true)
            });
        });
        var Q = n(function() {
            return E(Gn);
        });
        var Z = n(function() {
            x("{");
            var e = true, n = [];
            while (!g("punc", "}")) {
                if (e) e = false; else x(",");
                if (!l.strict && g("punc", "}")) break;
                var t = _.token;
                if (g("operator", "*")) {
                    b();
                    var i = ee();
                    var r = _.token;
                    var a = E(at);
                    a.start = r;
                    a.end = y();
                    n.push(new fi({
                        start: t,
                        key: i,
                        value: a,
                        end: y()
                    }));
                    continue;
                }
                if (g("operator", "...")) {
                    b();
                    n.push(new Gt({
                        start: t,
                        expression: S(),
                        end: y()
                    }));
                    continue;
                }
                if ($e(p(), "operator", "=")) {
                    var o = re(ln);
                    b();
                    n.push(new si({
                        start: t,
                        key: t.value,
                        value: new cn({
                            start: t,
                            left: o,
                            operator: "=",
                            right: S(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                if ($e(p(), "punc", ",") || $e(p(), "punc", "}")) {
                    n.push(new si({
                        start: t,
                        key: t.value,
                        value: re(ln),
                        end: y()
                    }));
                    continue;
                }
                var i = ee();
                if (g("punc", "(")) {
                    var s = _.token;
                    var f = E(rt);
                    f.start = s;
                    f.end = y();
                    n.push(new fi({
                        start: t,
                        key: i,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (g("punc", ":")) {
                    b();
                    n.push(new si({
                        start: t,
                        key: i,
                        value: S(),
                        end: y()
                    }));
                    continue;
                }
                if (t.type == "name") switch (i) {
                  case "async":
                    var u = g("operator", "*") && b();
                    i = ee();
                    var s = _.token;
                    var f = E(u ? it : tt);
                    f.start = s;
                    f.end = y();
                    n.push(new fi({
                        start: t,
                        key: i,
                        value: f,
                        end: y()
                    }));
                    continue;

                  case "get":
                    n.push(new ci({
                        start: t,
                        key: ee(),
                        value: Q(),
                        end: y()
                    }));
                    continue;

                  case "set":
                    n.push(new ui({
                        start: t,
                        key: ee(),
                        value: Q(),
                        end: y()
                    }));
                    continue;
                }
                w();
            }
            b();
            return new ai({
                properties: n
            });
        });
        function ee() {
            var e = _.token;
            switch (e.type) {
              case "operator":
                if (!Ae[e.value]) w();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                b();
                return "" + e.value;

              case "punc":
                x("[");
                var n = S();
                x("]");
                return n;

              default:
                w();
            }
        }
        function ne() {
            var e = _.token.value;
            u("name");
            return e;
        }
        function te(e, n) {
            var t = n.value;
            switch (t) {
              case "await":
                if (_.in_async) w(n);
                break;

              case "super":
                e = Ei;
                break;

              case "this":
                e = Si;
                break;

              case "yield":
                if (_.in_generator) w(n);
                break;
            }
            return new e({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function ie(e) {
            if (e.name == "arguments" || e.name == "eval" || e.name == "let") f(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function re(e, n) {
            if (!g("name")) {
                if (!n) s("Name expected");
                return null;
            }
            var t = te(e, _.token);
            if (_.input.has_directive("use strict") && t instanceof pi) {
                ie(t);
            }
            b();
            return t;
        }
        function ae(e) {
            var n = _.token;
            if (g("punc", "[")) {
                b();
                var t = X("]", !l.strict, true, function() {
                    return oe(e);
                });
                return new ti({
                    start: n,
                    elements: t,
                    rest: t.rest || null,
                    end: y()
                });
            }
            if (g("punc", "{")) {
                b();
                var i = true, r = [], a = null;
                while (!g("punc", "}")) {
                    if (i) i = false; else x(",");
                    if (!l.strict && g("punc", "}")) break;
                    var o = _.token;
                    if (g("punc", "[") || $e(p(), "punc", ":")) {
                        var s = ee();
                        x(":");
                        r.push(new ii({
                            start: o,
                            key: s,
                            value: oe(e),
                            end: y()
                        }));
                        continue;
                    }
                    if (g("operator", "...")) {
                        b();
                        a = ae(e);
                        break;
                    }
                    var f = re(e);
                    if (g("operator", "=")) {
                        b();
                        f = new Yt({
                            start: f.start,
                            name: f,
                            value: S(),
                            end: y()
                        });
                    }
                    r.push(new ii({
                        start: o,
                        key: o.value,
                        value: f,
                        end: y()
                    }));
                }
                x("}");
                return new ri({
                    start: n,
                    properties: r,
                    rest: a,
                    end: y()
                });
            }
            return re(e);
        }
        function oe(e) {
            var n = _.token;
            var t = ae(e);
            if (!g("operator", "=")) return t;
            b();
            return new Yt({
                start: n,
                name: t,
                value: S(),
                end: y()
            });
        }
        function se(e) {
            var n = e ? e.start : _.token;
            var t = _.input.context().read_template;
            var i = [];
            var r = [];
            while (t(i)) {
                b();
                r.push(me());
                if (!g("punc", "}")) w();
            }
            b();
            return new Ai({
                start: n,
                expressions: r,
                strings: i,
                tag: e,
                end: y()
            });
        }
        function fe(e, n) {
            var t = e.start;
            var i = null;
            while (true) {
                if (g("operator", "?") && $e(p(), "punc", ".")) {
                    b();
                    b();
                    i = e;
                }
                if (g("punc", "[")) {
                    b();
                    var r = me();
                    x("]");
                    e = new Wt({
                        start: t,
                        optional: i === e,
                        expression: e,
                        property: r,
                        end: y()
                    });
                } else if (n && g("punc", "(")) {
                    b();
                    e = new Rt({
                        start: t,
                        optional: i === e,
                        expression: e,
                        args: X(")", !l.strict),
                        end: y()
                    });
                } else if (i === e || g("punc", ".")) {
                    if (i !== e) b();
                    e = new Vt({
                        start: t,
                        optional: i === e,
                        expression: e,
                        property: ne(),
                        end: y()
                    });
                } else if (g("punc", "`")) {
                    if (i) s("Invalid template on optional chain");
                    e = se(e);
                } else {
                    break;
                }
            }
            if (i) e.terminal = true;
            if (e instanceof Rt && !e.pure) {
                var t = e.start;
                var a = t.comments_before;
                var o = Sn(t, "comments_before_length") ? t.comments_before_length : a.length;
                while (--o >= 0) {
                    if (/[@#]__PURE__/.test(a[o].value)) {
                        e.pure = true;
                        break;
                    }
                }
            }
            return e;
        }
        function ue(e) {
            var n = _.token;
            if (_.in_async && g("name", "await")) {
                if (_.in_funarg === _.in_function) s("Invalid use of await in function argument");
                _.input.context().regex_allowed = true;
                b();
                return new Qt({
                    start: n,
                    expression: ue(e),
                    end: y()
                });
            }
            if (_.in_generator && g("name", "yield")) {
                if (_.in_funarg === _.in_function) s("Invalid use of yield in function argument");
                _.input.context().regex_allowed = true;
                b();
                var t = null;
                var i = false;
                if (g("operator", "*")) {
                    b();
                    t = S(e);
                    i = true;
                } else if (g("punc") ? !De[_.token.value] : !c()) {
                    t = S(e);
                }
                return new Zt({
                    start: n,
                    expression: t,
                    nested: i,
                    end: y()
                });
            }
            if (g("operator") && ze[n.value]) {
                b();
                T();
                var r = ce(fn, n, ue(e));
                r.start = n;
                r.end = y();
                return r;
            }
            var a = J(true);
            while (g("operator") && Vi[_.token.value] && !o(_.token)) {
                a = ce(Xt, _.token, a);
                a.start = n;
                a.end = _.token;
                b();
            }
            return a;
        }
        function ce(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!ve(t)) f(n, "Invalid use of " + i + " operator");
                break;

              case "delete":
                if (t instanceof ln && _.input.has_directive("use strict")) f(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        var le = function(e, n, t) {
            var i = g("operator") ? _.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? Wi[i] : null;
            if (r != null && r > n) {
                b();
                var a = le(ue(t), i == "**" ? r - 1 : r, t);
                return le(new un({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function pe(e) {
            return le(ue(e), 0, e);
        }
        var de = function(e) {
            var n = _.token;
            var t = pe(e);
            if (g("operator", "?")) {
                b();
                var i = S();
                x(":");
                return new Kt({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: S(e),
                    end: y()
                });
            }
            return t;
        };
        function ve(e) {
            return e instanceof Ut && !e.optional || e instanceof ln;
        }
        function he(e) {
            if (e instanceof ei) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Gt) {
                    n = he(e.elements.pop().expression);
                    if (!(n instanceof ni || ve(n))) return e;
                }
                var t = e.elements.map(he);
                return tn(t, function(e) {
                    return e instanceof Yt || e instanceof ni || e instanceof Pi || ve(e);
                }) ? new ti({
                    start: e.start,
                    elements: t,
                    rest: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof cn) {
                var i = he(e.left);
                return i instanceof ni || ve(i) ? new Yt({
                    start: e.start,
                    name: i,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof ai)) return e;
            var n = null;
            if (e.properties[e.properties.length - 1] instanceof Gt) {
                n = he(e.properties.pop().expression);
                if (!(n instanceof ni || ve(n))) return e;
            }
            var r = [];
            for (var a = 0; a < e.properties.length; a++) {
                var o = e.properties[a];
                if (!(o instanceof si)) return e;
                var s = he(o.value);
                if (!(s instanceof Yt || s instanceof ni || ve(s))) {
                    return e;
                }
                r.push(new ii({
                    start: o.start,
                    key: o.key,
                    value: s,
                    end: o.end
                }));
            }
            return new ri({
                start: e.start,
                properties: r,
                rest: n,
                end: e.end
            });
        }
        function S(e) {
            var n = _.token;
            var t = de(e), i = _.token.value;
            if (g("operator") && Ce[i]) {
                if (ve(t) || i == "=" && (t = he(t)) instanceof ni) {
                    b();
                    return new cn({
                        start: n,
                        left: t,
                        operator: i,
                        right: S(e),
                        end: y()
                    });
                }
                s("Invalid assignment");
            }
            return t;
        }
        function me(e, n) {
            var t = _.token;
            var i = [];
            while (true) {
                if (n && g("operator", "...")) {
                    b();
                    i.rest = ae(_i);
                    break;
                }
                i.push(S(e));
                if (!g("punc", ",")) break;
                b();
                if (n && g("punc", ")") && $e(p(), "punc", "=>")) break;
            }
            return i.length == 1 && !i.rest ? i[0] : new sn({
                start: t,
                expressions: i,
                end: y()
            });
        }
        function _e(e) {
            ++_.in_loop;
            var n = e();
            --_.in_loop;
            return n;
        }
        if (l.expression) {
            T();
            var ge = me();
            u("eof");
            return ge;
        }
        return function() {
            var e = _.token;
            var n = [];
            _.input.push_directives_stack();
            while (!g("eof")) n.push(v());
            _.input.pop_directives_stack();
            var t = y() || e;
            var i = l.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new Vn({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function m(e, n, t, i) {
        this._bits = 0;
        this.defun = undefined;
        this.eliminated = 0;
        this.id = e;
        this.init = i;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.safe_ids = undefined;
        this.scope = n;
    }
    m.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = x(this, e);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this;
            var n = e.defun;
            if (!n) return;
            var t = e.name;
            var i = n.variables.get(t) || n instanceof Vn && n.globals.get(t) || e.orig[0] instanceof di && dn(function(e) {
                return e.name == t;
            }, n.enclosed);
            if (i && i !== e) return i.redefined() || i;
        },
        unmangleable: function(e) {
            if (this.exported) return true;
            if (this.undeclared) return true;
            if (!e.eval && this.scope.pinned()) return true;
            if (e.keep_fargs && Ji(this)) return true;
            if (e.keep_fnames) {
                var n = this.orig[0];
                if (n instanceof yi) return true;
                if (n instanceof Ee) return true;
                if (n instanceof gi) return true;
                if (n instanceof bi) return true;
            }
            if (!e.toplevel && this.global) return true;
            return false;
        }
    };
    i(m, [ "const_redefs", "cross_loop", "direct_access", "exported", "global", "undeclared" ]);
    function Ji(e) {
        return e.orig[0] instanceof _i || e.orig[1] instanceof _i;
    }
    var Xi = kn("delete ++ --");
    function Ki(e, n) {
        if (n instanceof cn) return n.left === e && e;
        if (n instanceof Yt) return n.name === e && e;
        if (n instanceof ni) return e;
        if (n instanceof ii) return e;
        if (n instanceof Yn) return n.init === e && e;
        if (n instanceof Jt) return Xi[n.operator] && n.expression;
    }
    Vn.DEFMETHOD("figure_out_scope", function(c) {
        c = be(c, {
            cache: null,
            ie: false
        });
        var l = this;
        var o = null;
        var s = false;
        var t = 0;
        var f = l.parent_scope = null;
        var p = new Yi(function(i, e) {
            if (i instanceof pt) {
                var n = s;
                s = p.parent() instanceof jt;
                i.name.walk(p);
                s = n;
                a(function() {
                    if (i.extends) i.extends.walk(p);
                    i.properties.forEach(function(e) {
                        e.walk(p);
                    });
                });
                return true;
            }
            if (i instanceof zt) {
                var n = s;
                s = p.parent() instanceof jt;
                e();
                s = n;
                return true;
            }
            if (i instanceof ot) {
                var n = s;
                s = p.parent() instanceof jt;
                i.name.walk(p);
                s = n;
                a(function() {
                    i.argnames.forEach(function(e) {
                        e.walk(p);
                    });
                    if (i.rest) i.rest.walk(p);
                    Cn(i, p);
                });
                return true;
            }
            if (i instanceof Tt) {
                i.init_vars(f);
                e();
                return true;
            }
            if (i instanceof Ot) {
                a(function() {
                    Cn(i, p);
                });
                if (i.bcatch) i.bcatch.walk(p);
                if (i.bfinally) i.bfinally.walk(p);
                return true;
            }
            if (i instanceof Bn) {
                var t = f;
                do {
                    t = t.resolve();
                    if (t.uses_with) break;
                    t.uses_with = true;
                } while (t = t.parent_scope);
                a(e);
                return true;
            }
            if (i instanceof zn) {
                a(e);
                return true;
            }
            if (i instanceof li) {
                i.scope = f;
            }
            if (i instanceof Se) {
                i.thedef = i;
                i.references = [];
            }
            if (i instanceof wi) {
                f.def_variable(i).defun = o;
            } else if (i instanceof di) {
                var r = f.def_variable(i);
                r.defun = o;
                if (s) r.exported = true;
            } else if (i instanceof gi) {
                var r = o.def_function(i, p.parent());
                if (s) r.exported = true;
            } else if (i instanceof _i) {
                o.def_variable(i);
            } else if (i instanceof bi) {
                var r = o.def_function(i, i.name == "arguments" ? undefined : o);
                if (c.ie) r.defun = o.parent_scope.resolve();
            } else if (i instanceof hi) {
                var r = f.def_variable(i);
                if (s) r.exported = true;
            } else if (i instanceof mi) {
                var r = o.def_variable(i, i instanceof vi ? undefined : null);
                if (s) r.exported = true;
            }
            function a(e) {
                i.init_vars(f);
                var n = o;
                var t = f;
                if (i instanceof Un) o = i;
                f = i;
                e();
                f = t;
                o = n;
            }
        });
        l.make_def = function(e, n) {
            return new m(++t, this, e, n);
        };
        l.walk(p);
        l.globals = new En();
        var d = [];
        var p = new Yi(function(e) {
            if (e instanceof $t) {
                if (!(e.argname instanceof ni)) return;
                d.push(e);
                e.argname.walk(p);
                d.pop();
                Cn(e, p);
                return true;
            }
            if (e instanceof Wn) {
                d.push(e);
                if (e.name) e.name.walk(p);
                e.argnames.forEach(function(e) {
                    e.walk(p);
                });
                if (e.rest) e.rest.walk(p);
                d.pop();
                Zn(e, p);
                return true;
            }
            if (e instanceof wt) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof pi) {
                var n = e.definition();
                n.preinit = n.references.length;
                if (e instanceof wi) {
                    var t = n.redefined();
                    if (t) for (var i = e.scope; i; i = i.parent_scope) {
                        yn(i.enclosed, t);
                        if (i === t.scope) break;
                    }
                } else if (e instanceof di) {
                    var t = n.redefined();
                    if (t) t.const_redefs = true;
                } else if (n.scope !== e.scope && (e instanceof gi || e instanceof _i || e instanceof mi)) {
                    e.mark_enclosed(c);
                    var t = e.scope.find_variable(e.name);
                    if (e.thedef !== t) {
                        e.thedef = t;
                        t.orig.push(e);
                        e.mark_enclosed(c);
                    }
                }
                if (e.name != "arguments") return true;
                var r = e instanceof mi && p.parent();
                if (r instanceof Pt && !r.value) return true;
                var a = e.scope.resolve().find_variable("arguments");
                if (a && v(a)) a.scope.uses_arguments = 3;
                return true;
            }
            if (e instanceof ln) {
                var o = e.name;
                var a = e.scope.find_variable(o);
                for (var s = d.length; s > 0 && a; ) {
                    s = d.lastIndexOf(a.scope, s - 1);
                    if (s < 0) break;
                    var f = a.orig[0];
                    if (f instanceof wi || f instanceof _i || f instanceof bi) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(o);
                }
                if (!a) {
                    a = l.def_global(e);
                } else if (o == "arguments" && v(a)) {
                    var r = p.parent();
                    if (Ki(e, r)) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(r instanceof Ut && r.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (o == "eval") {
                    var r = p.parent();
                    if (r.TYPE == "Call" && r.expression === e) {
                        var i = e.scope;
                        do {
                            i = i.resolve();
                            if (i.uses_eval) break;
                            i.uses_eval = true;
                        } while (i = i.parent_scope);
                    } else if (a.undeclared) {
                        l.uses_eval = true;
                    }
                }
                if (a.init instanceof ot && a.scope !== a.init.name.scope) {
                    var u = e.scope;
                    do {
                        if (u === a.init.name.scope) break;
                    } while (u = u.parent_scope);
                    if (!u) a.init = undefined;
                }
                e.thedef = a;
                e.reference(c);
                return true;
            }
        });
        l.walk(p);
        if (c.ie) l.walk(new Yi(function(e) {
            if (e instanceof wi) {
                var n = e.thedef.defun;
                if (n.name instanceof bi && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof bi) {
                var t = e.thedef;
                if (!i(e, e.scope.parent_scope.resolve())) {
                    t.defun = undefined;
                } else if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function v(e) {
            return e.orig[0] instanceof _i && !(e.orig[1] instanceof _i || e.orig[2] instanceof _i) && !Xn(e.scope);
        }
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            if (!tn(i.orig, function(e) {
                return !(e instanceof di || e instanceof hi);
            })) return false;
            var r = n.find_variable(t);
            if (r) {
                var a = r.redefined();
                if (a) r = a;
            } else {
                r = l.globals.get(t);
            }
            if (r) {
                r.orig.push(e);
            } else {
                r = n.def_variable(e);
            }
            if (r.undeclared) l.variables.set(t, r);
            if (t == "arguments" && v(i) && e instanceof bi) return true;
            i.defun = r.scope;
            i.forEach(function(e) {
                e.redef = i;
                e.thedef = r;
                e.reference(c);
            });
            return true;
        }
    });
    Vn.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = this.make_def(e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    function b(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new En();
        e.variables = new En();
        if (n) e.make_def = n.make_def;
    }
    function y(e, n) {
        b(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    zn.DEFMETHOD("init_vars", function(e) {
        b(this, e);
    });
    Un.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    et.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        return this;
    });
    nt.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    Wn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        this.uses_arguments = false;
        this.def_variable(new _i({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    li.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            yn(t.enclosed, n);
            if (!e) {
                t._var_names = undefined;
            } else {
                if (e.keep_fargs && t instanceof Wn) t.each_argname(function(e) {
                    yn(n.scope.enclosed, e.definition());
                });
                if (e.keep_fnames) t.functions.each(function(e) {
                    yn(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    li.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    zn.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    zn.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof ot) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    zn.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof Jn) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function w(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = new En();
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t.set(e.name, true);
                if (e.global && i && i.has(e.name)) {
                    t.set(i.get(e.name), true);
                }
            });
        }
        return t;
    }
    function x(e, t) {
        var n = e.scope;
        var i = w(n, t);
        var r = n.cname_holes;
        var a = new En();
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (pn(n, o)) break;
                w(n, t).each(function(e, n) {
                    a.set(n, e);
                });
                o.push(n);
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < r.length; f++) {
            s = E(r[f]);
            if (a.has(s)) continue;
            r.splice(f, 1);
            i.set(s, true);
            return s;
        }
        while (true) {
            s = E(++n.cname);
            if (i.has(s) || N[s] || t.reserved.has[s]) continue;
            if (!a.has(s)) break;
            r.push(n.cname);
        }
        i.set(s, true);
        return s;
    }
    li.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    Se.DEFMETHOD("unmangleable", hn);
    li.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function k(e) {
        e = be(e, {
            eval: false,
            ie: false,
            keep_fargs: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        yn(e.reserved, "arguments");
        e.reserved.has = kn(e.reserved);
        return e;
    }
    Vn.DEFMETHOD("mangle_names", function(s) {
        s = k(s);
        if (s.cache && s.cache.props) {
            var n = w(this, s);
            s.cache.props.each(function(e) {
                n.set(e, true);
            });
        }
        var f = 10;
        var u = -1;
        var a = [];
        var c = new Yi(function(e, n) {
            if (e instanceof Fn) {
                var t = u;
                n();
                if (!s.v8 || !d(c)) u = t;
                return true;
            }
            if (e instanceof zn) {
                if (s.webkit && e instanceof Pn && e.init instanceof Mt) {
                    e.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof hi)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var i = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(i);
                            n.redefined = function() {
                                return i;
                            };
                        });
                    }, true);
                }
                var i = e.to_mangle = [];
                e.variables.each(function(e) {
                    if (!p(e)) i.push(e);
                });
                n();
                if (s.cache && e instanceof Vn) {
                    e.globals.each(l);
                }
                if (e instanceof ut && c.has_directive("use asm")) {
                    var r = new ln(e.name);
                    r.scope = e;
                    r.reference(s);
                }
                if (i.length > f) {
                    var a = i.map(function(e, n) {
                        return n;
                    }).sort(function(e, n) {
                        return i[n].references.length - i[e].references.length || e - n;
                    });
                    i = a.slice(0, f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return i[e];
                    }).concat(a.slice(f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return i[e];
                    }));
                }
                i.forEach(l);
                return true;
            }
            if (e instanceof Se) {
                var o;
                do {
                    o = E(++u);
                } while (N[o]);
                e.mangled_name = o;
                return true;
            }
        });
        this.walk(c);
        a.forEach(l);
        function l(e) {
            if (s.reserved.has[e.name]) return;
            e.mangle(s);
        }
        function p(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof di)) return false;
                var i = n.scope.resolve();
                if (n.scope === i) return false;
                if (n.scope.parent_scope.find_variable(e.name)) return false;
                t = i.def_variable(e);
                i.to_mangle.push(t);
            }
            a.push(n);
            n.references.forEach(r);
            if (e instanceof wi || e instanceof di) r(e);
            return true;
            function r(e) {
                e.thedef = t;
                e.reference(s);
                e.thedef = n;
            }
        }
        function d(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof Mn) return t instanceof Vn && !s.toplevel;
                if (t instanceof Fn) return true;
            }
        }
    });
    Vn.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(N);
        t.reserved.forEach(r);
        this.globals.each(a);
        this.walk(new Yi(function(e) {
            if (e instanceof zn) e.variables.each(a);
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    Vn.DEFMETHOD("expand_names", function(i) {
        E.reset();
        E.sort();
        i = k(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(a);
        this.walk(new Yi(function(e) {
            if (e instanceof zn) e.variables.each(a);
        }));
        function r() {
            var e;
            do {
                e = E(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && i.cache) return;
            if (n.unmangleable(i)) return;
            if (i.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : r();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    rn.DEFMETHOD("tail_node", _n);
    sn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    Vn.DEFMETHOD("compute_char_frequency", function(e) {
        e = k(e);
        E.reset();
        var n = li.prototype.add_source_map;
        try {
            li.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) E.consider(this.name, -1);
            };
            if (e.properties) {
                Vt.prototype.add_source_map = function() {
                    E.consider(this.property, -1);
                };
                Wt.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            E.consider(this.print_to_string(), 1);
        } finally {
            li.prototype.add_source_map = n;
            delete Vt.prototype.add_source_map;
            delete Wt.prototype.add_source_map;
        }
        E.sort();
        function t(e) {
            if (e instanceof Oi) {
                E.consider(e.value, -1);
            } else if (e instanceof Kt) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof sn) {
                t(e.tail_node());
            }
        }
    });
    var E = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, a;
        function o() {
            i = null;
            a = Object.create(r);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            i = t.sort(s).concat(n).sort(s);
        };
        f.reset = o;
        o();
        function f(e) {
            var n = t[e % 54];
            for (e = Math.floor(e / 54); --e >= 0; e >>= 6) {
                n += i[e & 63];
            }
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Qi(e, n) {
        if (!(this instanceof Qi)) return new Qi(e, n);
        Ri.call(this, this.before, this.after);
        this.options = be(e, {
            annotations: !n,
            arguments: !n,
            arrows: !n,
            assignments: !n,
            awaits: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_exports: !n,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie: false,
            if_return: !n,
            imports: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            optional_chains: !n,
            passes: 1,
            properties: !n,
            pure_funcs: null,
            pure_getters: !n && "strict",
            reduce_funcs: !n,
            reduce_vars: !n,
            rests: !n,
            sequences: !n,
            side_effects: !n,
            spreads: !n,
            strings: !n,
            switches: !n,
            templates: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n,
            webkit: false,
            yields: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var i = this.options["global_defs"];
        if (typeof i == "object") for (var r in i) {
            if (/^@/.test(r) && Sn(i, r)) {
                i[r.slice(1)] = Gi(i[r], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 4;
        this.drop_fargs = this.options["keep_fargs"] ? hn : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        };
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof Rt) {
                    n = e.expression;
                } else if (e instanceof Ai) {
                    n = e.tag;
                }
                return !(n && a === n.print_to_string());
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof Rt) {
                    n = e.expression;
                } else if (e instanceof Ai) {
                    n = e.tag;
                }
                return !(n && pn(n.print_to_string(), a));
            };
        } else {
            this.pure_funcs = mn;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return pn(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    Qi.prototype = new Ri(function(e, n, t) {
        if (e._squeezed) return e;
        var i = e instanceof Un;
        if (i) {
            e.hoist_properties(this);
            e.hoist_declarations(this);
            e.process_boolean_returns(this);
        }
        n(e, this);
        n(e, this);
        var r = e.optimize(this);
        if (i && r === e && !this.has_directive("use asm") && !r.pinned()) {
            r.drop_unused(this);
            if (r.merge_variables(this)) r.drop_unused(this);
            n(r, this);
        }
        if (r === e) r._squeezed = true;
        return r;
    });
    Qi.prototype.option = function(e) {
        return this.options[e];
    };
    Qi.prototype.exposed = function(e) {
        if (e.exported) return true;
        if (e.undeclared) return true;
        if (!(e.global || e.scope.resolve() instanceof Vn)) return false;
        var n = this.toplevel;
        return !tn(e.orig, function(e) {
            return n[e instanceof gi ? "funcs" : "vars"];
        });
    };
    Qi.prototype.compress = function(e) {
        e = e.resolve_defines(this);
        e.hoist_exports(this);
        if (this.option("expression")) {
            e.process_expression(true);
        }
        var n = this.options.merge_vars;
        var t = +this.options.passes || 1;
        var i = 1 / 0;
        var r = false;
        var a = {
            ie: this.option("ie")
        };
        for (var o = 0; o < t; o++) {
            e.figure_out_scope(a);
            if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
            this.options.merge_vars = n && (r || o == t - 1);
            e = e.transform(this);
            if (t > 1) {
                var s = 0;
                e.walk(new Yi(function() {
                    s++;
                }));
                rn.info("pass {pass}: last_count: {min_count}, count: {count}", {
                    pass: o,
                    min_count: i,
                    count: s
                });
                if (s < i) {
                    i = s;
                    r = false;
                } else if (r) {
                    break;
                } else {
                    r = true;
                }
            }
        }
        if (this.option("expression")) {
            e.process_expression(false);
        }
        return e;
    };
    (function(e) {
        e(rn, function(e, n) {
            return e;
        });
        rn.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        Vn.DEFMETHOD("hoist_exports", function(e) {
            if (!e.option("hoist_exports")) return;
            var n = this.body, t = [];
            for (var i = 0; i < n.length; i++) {
                var r = n[i];
                if (r instanceof jt) {
                    n[i] = r = r.body;
                    if (r instanceof zt) {
                        r.definitions.forEach(function(e) {
                            e.name.match_symbol(a, true);
                        });
                    } else {
                        a(r.name);
                    }
                } else if (r instanceof It) {
                    n.splice(i--, 1);
                    [].push.apply(t, r.properties);
                }
            }
            if (t.length) n.push(Oe(It, this, {
                properties: t
            }));
            function a(e) {
                if (!(e instanceof pi)) return;
                var n = Oe(xi, e, e);
                n.alias = n.name;
                t.push(n);
            }
        });
        Un.DEFMETHOD("process_expression", function(i, r) {
            var a = this;
            var o = new Ri(function(e) {
                if (i && e instanceof an) {
                    return r ? r(e) : Oe(bt, e, {
                        value: e.body
                    });
                }
                if (!i && e instanceof bt) {
                    return r ? r(e) : Oe(an, e, {
                        body: e.value || Oe(fn, e, {
                            operator: "void",
                            expression: Oe($i, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof Mn) {
                    if (e instanceof Wn) {
                        if (e !== a) return e;
                    } else if (i === "awaits" && e instanceof Ot) {
                        if (e.bfinally) return e;
                    }
                    for (var n = e.body.length; --n >= 0; ) {
                        var t = e.body[n];
                        if (!H(t, true)) {
                            e.body[n] = t.transform(o);
                            break;
                        }
                    }
                } else if (e instanceof Et) {
                    e.body = e.body.transform(o);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(o);
                    }
                } else if (e instanceof Bn) {
                    e.body = e.body.transform(o);
                }
                return e;
            });
            a.transform(o);
        });
        function D(e, n) {
            var t = n.get_property();
            if (t instanceof rn) return;
            var i;
            if (e instanceof ei) {
                var r = e.elements;
                if (t == "length") return ue(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof Wn) {
                if (t == "length") {
                    e.length_read = true;
                    return ue(e.argnames.length, e);
                }
            } else if (e instanceof ai) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!Qe(s)) return;
                    if (!i && a[o].key === t) i = a[o].value;
                }
            }
            return i instanceof ln && i.fixed_value() || i;
        }
        function l(e, n) {
            if (e instanceof Ni) return b.Boolean[n];
            if (e instanceof $i) return b.Number[n];
            if (e instanceof Oi) return b.String[n];
            if (n == "valueOf") return false;
            if (e instanceof ei) return b.Array[n];
            if (e instanceof Wn) return b.Function[n];
            if (e instanceof ai) return b.Object[n];
            if (e instanceof zi) return b.RegExp[n] && !e.value.global;
        }
        function Me(e, n, t, i, r, a, o) {
            var s = n.parent(r);
            if (e.option("unsafe") && s instanceof Vt && l(i, s.property)) {
                return;
            }
            var f = Ki(t, s);
            if (f) return f;
            if (r == 0 && i && i.is_constant()) return;
            if (s instanceof ei) return Me(e, n, s, s, r + 1);
            if (s instanceof cn) switch (s.operator) {
              case "=":
                return Me(e, n, s, i, r + 1, a, o);

              case "&&=":
              case "||=":
              case "??=":
                return Me(e, n, s, s, r + 1);

              default:
                return;
            }
            if (s instanceof un) {
                if (!Ce[s.operator]) return;
                return Me(e, n, s, s, r + 1);
            }
            if (s instanceof Rt) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!(i instanceof Jn) || !(s instanceof Lt) && i.contains_this());
            }
            if (s instanceof Kt) {
                if (s.condition === t) return;
                return Me(e, n, s, s, r + 1);
            }
            if (s instanceof Yn) return s.init === t;
            if (s instanceof si) {
                if (s.value !== t) return;
                var u = n.parent(r + 1);
                return Me(e, n, u, u, r + 2);
            }
            if (s instanceof Ut) {
                if (s.expression !== t) return;
                var c = D(i, s);
                return (!a || o) && Me(e, n, s, c, r + 1);
            }
            if (s instanceof sn) {
                if (s.tail_node() !== t) return;
                return Me(e, n, s, i, r + 1, a, o);
            }
        }
        function O(e) {
            return e instanceof lt || e instanceof Wn;
        }
        function h(e) {
            return e instanceof lt || e instanceof ut || e instanceof rt;
        }
        function Fe(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function Q(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof Un) return true;
            } while (n = n.parent_scope);
        }
        function De(e, n, t) {
            var i = e.redef || e.definition();
            if (e.in_arg && Ji(i)) return false;
            return tn(i.orig, function(e) {
                if (e instanceof di || e instanceof hi) {
                    if (e instanceof vi) return true;
                    return n && K(n, e);
                }
                return !(t && e instanceof bi);
            });
        }
        function Pe(e, n, t, i) {
            if (i instanceof cn) return i.operator == "=" && i.right === t;
            if (i instanceof Rt) return i.expression !== t || i instanceof Lt;
            if (i instanceof gt) return i.value === t && n.resolve() !== e.scope.resolve();
            if (i instanceof Pt) return i.value === t;
        }
        var $ = /^(0|[1-9][0-9]*)$/;
        (function(e) {
            e(rn, vn);
            function a(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof Jn && t.init !== t.scope) && t.init;
                t.reassigned = 0;
                t.recursive_refs = 0;
                t.references = [];
                t.single_use = undefined;
            }
            function s(n, t, e) {
                e.variables.each(function(e) {
                    a(n, t, e);
                });
            }
            function p(t, i, r) {
                r.fn_defs = [];
                r.variables.each(function(e) {
                    a(t, i, e);
                    var n = e.init;
                    if (n instanceof ot) {
                        r.fn_defs.push(n);
                        n.safe_ids = null;
                    }
                    if (e.fixed === null) {
                        e.safe_ids = t.safe_ids;
                        _(t, e);
                    } else if (e.fixed) {
                        t.loop_ids[e.id] = t.in_loop;
                        _(t, e);
                    }
                });
                r.may_call_this = function() {
                    r.may_call_this = r.contains_this() ? mn : hn;
                };
                if (r.uses_arguments) r.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (i.option("ie")) r.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function o(e, n) {
                var t = n.safe_ids;
                return t === undefined || t === e.safe_ids;
            }
            function f(e, n) {
                var t = e.fn_scanning;
                e.fn_scanning = n;
                n.walk(e);
                e.fn_scanning = t;
            }
            function u(t, i) {
                i.enclosed.forEach(function(e) {
                    if (i.variables.get(e.name) === e) return;
                    if (b(t, e)) return;
                    e.single_use = false;
                    var n = e.fixed;
                    if (typeof n == "function") n = n();
                    if (n instanceof Wn && n.safe_ids !== undefined) return;
                    e.fixed = false;
                });
            }
            function v(e, n, t) {
                var i = t.safe_ids;
                if (i === undefined) return;
                if (i === false) return;
                if (t.parent_scope.resolve().may_call_this === mn) {
                    if (pn(t, e.fn_visited)) u(e, t);
                } else if (i) {
                    var r = pn(t, e.fn_visited);
                    if (i === e.safe_ids) {
                        if (!r) f(e, t);
                    } else if (r) {
                        u(e, t);
                    } else {
                        t.safe_ids = false;
                    }
                } else if (e.fn_scanning && e.fn_scanning !== n.scope.resolve()) {
                    t.safe_ids = false;
                } else {
                    t.safe_ids = e.safe_ids;
                    f(e, t);
                }
            }
            function d(n, e) {
                var t = e.fn_defs;
                var i = e.may_call_this === mn ? t : t.filter(function(e) {
                    if (e.safe_ids === false) return true;
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                    return false;
                });
                m(n);
                i.forEach(function(e) {
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                });
                t.forEach(function(e) {
                    e.safe_ids = undefined;
                });
                e.fn_defs = undefined;
                e.may_call_this = undefined;
            }
            function h(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function m(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function _(e, n) {
                e.safe_ids[n.id] = {};
            }
            function g(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function b(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    var i = Sn(e.safe_ids, n.id);
                    if (!i) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (Fe(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = Oe(Fi, n.orig[0]);
                        if (i) n.safe_ids = undefined;
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof ot;
            }
            function y(e, n, t) {
                if (!t) {
                    if (Ji(n) && n.scope.uses_arguments && !e.has_directive("use strict")) return false;
                    if (!tn(n.orig, function(e) {
                        return !(e instanceof di);
                    })) return false;
                }
                if (n.fixed === undefined) return t || tn(n.orig, function(e) {
                    return !(e instanceof hi);
                });
                if (n.fixed === false || n.fixed === 0) return false;
                var i = e.safe_ids[n.id];
                if (n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    n.safe_ids = undefined;
                    return n.fixed === null || Sn(e.safe_ids, n.id) && !i.read;
                }
                if (!Sn(e.safe_ids, n.id)) {
                    if (!i) return false;
                    if (i.read) {
                        var r = e.find_parent(zn);
                        if (r instanceof lt) return false;
                        if (n.scope.resolve() !== r.resolve()) return false;
                    }
                    i.assign = i.assign && i.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && i.read) {
                    if (i.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return b(e, n) && tn(n.orig, function(e) {
                    return !(e instanceof bi);
                });
            }
            function x(e, n) {
                var t = Oe(ln, e, e);
                t.fixed = n || Oe(Fi, e);
                return t;
            }
            function k(t, i) {
                return function() {
                    var e = x(t, i);
                    var n = t.definition();
                    n.references.push(e);
                    n.replaced++;
                    return e;
                };
            }
            function c(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(Ji(n) && n.scope.uses_arguments);
            }
            function E(e) {
                if (!e) return false;
                if (e instanceof cn) {
                    var n = e.operator;
                    return n == "=" ? E(e.right) : !Ce[n.slice(0, -1)];
                }
                if (e instanceof sn) return E(e.tail_node());
                return e.is_constant() || O(e) || e instanceof ki;
            }
            function l(e, n) {
                if (n instanceof ei) return true;
                if (n instanceof un) return Ce[n.operator];
                if (n instanceof Kt) return n.condition !== e;
                if (n instanceof sn) return n.tail_node() === e;
                if (n instanceof Gt) return true;
            }
            function w(e, n, t, i, r, a, o) {
                var s = e.parent(a);
                if (r && r.is_constant()) return;
                if (Pe(n, t, i, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(r && r.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    if (n.scope.resolve() !== t.resolve()) n.escaped.cross_scope = true;
                    if (n.fixed) n.fixed.escaped = n.escaped;
                    return;
                } else if (l(i, s)) {
                    w(e, n, t, s, s, a + 1, o);
                } else if (s instanceof si && s.value === i) {
                    var f = e.parent(a + 1);
                    w(e, n, t, f, f, a + 2, o);
                } else if (s instanceof Ut && s.expression === i) {
                    r = D(r, s);
                    w(e, n, t, s, r, a + 1, o + 1);
                    if (r) return;
                }
                if (a > 0) return;
                if (s instanceof Rt && s.expression === i) return;
                if (s instanceof sn && s.tail_node() !== i) return;
                if (s instanceof an) return;
                if (s instanceof Jt && !Xi[s.operator]) return;
                n.direct_access = true;
                if (n.fixed) n.fixed.direct_access = true;
            }
            function S(e) {
                if (!(e instanceof Wt)) return;
                var n = e.expression;
                if (!(n instanceof ln)) return;
                var t = n.definition();
                if (!Fe(t)) return;
                var i = e.property;
                if (i.is_constant()) i = i.value;
                if (!(i instanceof rn) && !$.test(i)) return;
                t.reassigned++;
                (i instanceof rn ? t.scope.argnames : [ t.scope.argnames[i] ]).forEach(function(e) {
                    if (e instanceof _i) e.definition().fixed = false;
                });
            }
            function T(o, t, e, s, n) {
                var f = new Yi(function(i) {
                    if (i instanceof Yt) {
                        q(i);
                        h(o);
                        i.value.walk(o);
                        m(o);
                        var r = s;
                        if (r) s = function() {
                            var e = r();
                            var n;
                            if (ze(e, t) || (n = V(t, e, true)) === undefined) {
                                return $e(i, [ e, i.value ]);
                            }
                            return n instanceof rn ? i : e;
                        };
                        i.name.walk(f);
                        s = r;
                        return true;
                    }
                    if (i instanceof ti) {
                        q(i);
                        var r = s;
                        i.elements.forEach(function(e, n) {
                            if (e instanceof Pi) return q(e);
                            if (r) s = function() {
                                return Oe(Wt, e, {
                                    expression: r(),
                                    property: Oe($i, e, {
                                        value: n
                                    })
                                });
                            };
                            e.walk(f);
                        });
                        if (i.rest) {
                            var a;
                            if (r) s = t.option("rests") && function() {
                                var e = r();
                                if (!(e instanceof ei)) return i;
                                for (var n = 0, t = i.elements.length; n < t; n++) {
                                    if (e.elements[n] instanceof Gt) return i;
                                }
                                if (!a) a = Oe(ei, i);
                                a.elements = e.elements.slice(t);
                                return a;
                            };
                            i.rest.walk(f);
                        }
                        s = r;
                        return true;
                    }
                    if (i instanceof ri) {
                        q(i);
                        var r = s;
                        i.properties.forEach(function(t) {
                            q(t);
                            if (t.key instanceof rn) {
                                h(o);
                                t.key.walk(o);
                                m(o);
                            }
                            if (r) s = function() {
                                var e = t.key;
                                var n = Wt;
                                if (typeof e == "string") {
                                    if (Li(e)) {
                                        n = Vt;
                                    } else {
                                        e = ue(e, t);
                                    }
                                }
                                return Oe(n, t, {
                                    expression: r(),
                                    property: e
                                });
                            };
                            t.value.walk(f);
                        });
                        if (i.rest) {
                            s = false;
                            i.rest.walk(f);
                        }
                        s = r;
                        return true;
                    }
                    n(i, s, function() {
                        var e = o.stack.length;
                        for (var n = 0, t = f.stack.length - 1; n < t; n++) {
                            o.stack.push(f.stack[n]);
                        }
                        i.walk(o);
                        o.stack.length = e;
                    });
                    return true;
                });
                e.walk(f);
            }
            function A(r, c, n) {
                var a = this;
                a.inlined = false;
                var o = r.parent();
                var t = Kn(a) || Qn(a);
                var i = false;
                a.walk(new Yi(function(e) {
                    if (t) return i = true;
                    if (e instanceof bt) return t = true;
                    if (e instanceof Un && e !== a) return true;
                }));
                if (i) h(r);
                p(r, n, a);
                var s = !a.uses_arguments || r.has_directive("use strict");
                a.argnames.forEach(function(t, e) {
                    var i = o.args[e];
                    T(r, n, t, function() {
                        var e = a.argnames.indexOf(t);
                        var n = e < 0 ? i : o.args[e];
                        if (n instanceof sn && n.expressions.length < 2) n = n.expressions[0];
                        return n || Oe(Fi, o);
                    }, u);
                });
                var e = a.rest, f;
                if (e) T(r, n, e, n.option("rests") && function() {
                    if (a.rest !== e) return e;
                    if (!f) f = Oe(ei, a);
                    f.elements = o.args.slice(a.argnames.length);
                    return f;
                }, u);
                Zn(a, r);
                var l = r.safe_ids;
                d(r, a);
                if (!i) r.safe_ids = l;
                return true;
                function u(e, n) {
                    var t = e.definition();
                    if (n && s && t.fixed === undefined) {
                        _(r, t);
                        r.loop_ids[t.id] = r.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ e ];
                    } else {
                        t.fixed = false;
                    }
                }
            }
            e(cn, function(a, c, n) {
                var o = this;
                var s = o.left;
                var f = o.right;
                var t = s instanceof ln && s.definition();
                var e = t || s instanceof ni;
                switch (o.operator) {
                  case "=":
                    if (s.equivalent_to(f) && !s.has_side_effects(n)) {
                        f.walk(a);
                        u(s);
                        o.redundant = true;
                        return true;
                    }
                    if (t && f instanceof Jn) {
                        p();
                        f.parent_scope.resolve().fn_defs.push(f);
                        f.safe_ids = null;
                        if (!t.fixed || !o.write_only) v(a, t, f);
                        return true;
                    }
                    if (e) {
                        f.walk(a);
                        p();
                        return true;
                    }
                    S(s);
                    return;

                  case "&&=":
                  case "||=":
                  case "??=":
                    var i = true;

                  default:
                    if (!e) {
                        S(s);
                        return d();
                    }
                    t.assignments++;
                    var r = t.fixed;
                    if (Me(n, a, o, o, 0)) {
                        t.fixed = false;
                        return d();
                    }
                    var l = b(a, t);
                    if (i) h(a);
                    f.walk(a);
                    if (i) m(a);
                    if (l && !s.in_arg && y(a, t)) {
                        g(t, s);
                        _(a, t);
                        if (t.single_use) t.single_use = false;
                        s.fixed = t.fixed = function() {
                            return Oe(un, o, {
                                operator: o.operator.slice(0, -1),
                                left: x(s, r),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !r || !r.assigns ? [ t.orig[0] ] : r.assigns.slice();
                        s.fixed.assigns.push(o);
                        s.fixed.to_binary = k(s, r);
                    } else {
                        s.walk(a);
                        t.fixed = false;
                    }
                    return true;
                }
                function u(e) {
                    if (e instanceof Vt) {
                        u(e.expression);
                    } else if (e instanceof Wt) {
                        u(e.expression);
                        e.property.walk(a);
                    } else if (e instanceof ln) {
                        var n = e.definition();
                        g(n, e);
                        if (n.fixed) {
                            e.fixed = n.fixed;
                            if (e.fixed.assigns) {
                                e.fixed.assigns.push(o);
                            } else {
                                e.fixed.assigns = [ o ];
                            }
                        }
                    } else {
                        e.walk(a);
                    }
                }
                function p() {
                    var e = t && Ue(a, t);
                    var r = Me(n, a, o, f, 0, E(f), e);
                    T(a, n, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof ln)) {
                            S(e);
                            t();
                            return;
                        }
                        var i = e.definition();
                        i.assignments++;
                        if (!n || e.in_arg || !y(a, i)) {
                            t();
                            i.fixed = false;
                        } else if (r) {
                            t();
                            i.fixed = 0;
                        } else {
                            g(i, e);
                            _(a, i);
                            if (s instanceof ni || i.orig.length == 1 && i.orig[0] instanceof gi) {
                                i.single_use = false;
                            }
                            a.loop_ids[i.id] = a.in_loop;
                            e.fixed = i.fixed = n;
                            e.fixed.assigns = [ o ];
                            w(a, i, e.scope, o, f, 0, 1);
                        }
                    });
                }
                function d() {
                    if (!i) return;
                    s.walk(a);
                    h(a);
                    f.walk(a);
                    m(a);
                    return true;
                }
            });
            e(un, function(e) {
                if (!Ce[this.operator]) return;
                this.left.walk(e);
                h(e);
                this.right.walk(e);
                m(e);
                return true;
            });
            e(zn, function(e, n, t) {
                s(e, t, this);
            });
            e(Rt, function(n, e) {
                var t = this;
                var i = t.expression;
                if (i instanceof Jn) {
                    var r = He(t);
                    t.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof Gt) r = false;
                    });
                    if (r) i.reduce_vars = A;
                    i.walk(n);
                    if (r) delete i.reduce_vars;
                    return true;
                }
                if (t.TYPE == "Call" && n.in_boolean_context()) {
                    if (i instanceof ln) {
                        i.definition().bool_fn++;
                    } else if (i instanceof cn && i.operator == "=" && i.left instanceof ln) {
                        i.left.definition().bool_fn++;
                    }
                }
                i.walk(n);
                var a = t.optional;
                if (a) h(n);
                t.args.forEach(function(e) {
                    e.walk(n);
                });
                if (a) m(n);
                var o = i instanceof ln && i.fixed_value();
                if (o instanceof Wn) {
                    v(n, i.definition(), o);
                } else {
                    n.find_parent(Un).may_call_this();
                }
                return true;
            });
            e(lt, function(n, e, t) {
                var i = this;
                s(n, t, i);
                if (i.extends) i.extends.walk(n);
                var r = i.properties.filter(function(e) {
                    q(e);
                    if (e.key instanceof rn) e.key.walk(n);
                    return e.value;
                });
                if (i.name) {
                    var a = i.name.definition();
                    var o = n.parent();
                    if (o instanceof jt || o instanceof Nt) a.single_use = false;
                    if (y(n, a, true)) {
                        _(n, a);
                        n.loop_ids[a.id] = n.in_loop;
                        a.fixed = function() {
                            return i;
                        };
                        a.fixed.assigns = [ i ];
                        if (!ne(a)) a.single_use = false;
                    } else {
                        a.fixed = false;
                    }
                }
                r.forEach(function(e) {
                    if (!e.static || e instanceof ht && e.value.contains_this()) {
                        h(n);
                        e.value.walk(n);
                        m(n);
                    } else {
                        e.value.walk(n);
                    }
                });
                return true;
            });
            e(Kt, function(e) {
                this.condition.walk(e);
                h(e);
                this.consequent.walk(e);
                m(e);
                h(e);
                this.alternative.walk(e);
                m(e);
                return true;
            });
            e(Yt, function(e) {
                this.name.walk(e);
                h(e);
                this.value.walk(e);
                m(e);
                return true;
            });
            e(Nn, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                h(e);
                this.body.walk(e);
                if (L(this, e.parent())) {
                    m(e);
                    h(e);
                }
                this.condition.walk(e);
                m(e);
                e.in_loop = n;
                return true;
            });
            e(Hn, function(e, n, t) {
                var i = this;
                s(e, t, i);
                if (i.init) i.init.walk(e);
                var r = e.in_loop;
                e.in_loop = i;
                h(e);
                if (i.condition) i.condition.walk(e);
                i.body.walk(e);
                if (i.step) {
                    if (L(i, e.parent())) {
                        m(e);
                        h(e);
                    }
                    i.step.walk(e);
                }
                m(e);
                e.in_loop = r;
                return true;
            });
            e(Yn, function(e, n, t) {
                var i = this;
                s(e, t, i);
                i.object.walk(e);
                var r = e.in_loop;
                e.in_loop = i;
                h(e);
                var a = i.init;
                if (a instanceof zt) {
                    a.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof pi) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, e);
                } else if (a instanceof ni || a instanceof ln) {
                    a.mark_symbol(function(e) {
                        if (e instanceof ln) {
                            var n = e.definition();
                            g(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, e);
                } else {
                    a.walk(e);
                }
                i.body.walk(e);
                m(e);
                e.in_loop = r;
                return true;
            });
            e(Et, function(e) {
                this.condition.walk(e);
                h(e);
                this.body.walk(e);
                m(e);
                if (this.alternative) {
                    h(e);
                    this.alternative.walk(e);
                    m(e);
                }
                return true;
            });
            e(Fn, function(e) {
                h(e);
                this.body.walk(e);
                m(e);
                return true;
            });
            e(Wn, function(e, n, t) {
                var i = this;
                if (!o(e, i)) return true;
                if (!yn(e.fn_visited, i)) return true;
                i.inlined = false;
                h(e);
                p(e, t, i);
                n();
                d(e, i);
                if (i.name) w(e, i.name.definition(), i, i.name, i, 0, 1);
                return true;
            });
            e(ot, function(e, n, t) {
                var i = this;
                var r = i.name.definition();
                var a = e.parent();
                if (a instanceof jt || a instanceof Nt) r.single_use = false;
                if (!o(e, i)) return true;
                if (!yn(e.fn_visited, i)) return true;
                i.inlined = false;
                h(e);
                p(e, t, i);
                n();
                d(e, i);
                return true;
            });
            e(Wt, function(e) {
                if (!this.optional) return;
                this.expression.walk(e);
                h(e);
                this.property.walk(e);
                m(e);
                return true;
            });
            e(St, function(n, e, t) {
                var i = this;
                s(n, t, i);
                i.expression.walk(n);
                var r = true;
                i.body.forEach(function(e) {
                    if (e instanceof At) return;
                    e.expression.walk(n);
                    if (r) {
                        r = false;
                        h(n);
                    }
                });
                if (!r) m(n);
                Cn(i, n);
                return true;
            });
            e(Tt, function(e) {
                h(e);
                Cn(this, e);
                m(e);
                return true;
            });
            e(wi, function() {
                this.definition().fixed = false;
            });
            e(vi, function() {
                this.definition().fixed = false;
            });
            e(ln, function(i, e, n) {
                var r = this.definition();
                g(r, this);
                if (r.references.length == 1 && !r.fixed && r.orig[0] instanceof gi) {
                    i.loop_ids[r.id] = i.in_loop;
                }
                var a = Ue(i, r);
                if (a) a.enclosed.forEach(function(e) {
                    if (r === e) return;
                    if (e.scope.resolve() === a) return;
                    var n = e.fixed && e.fixed.assigns;
                    if (!n) return;
                    if (n[n.length - 1] instanceof Pt) return;
                    var t = i.safe_ids[e.id];
                    if (!t) return;
                    t.assign = true;
                });
                if (r.fixed === false || r.fixed === 0) {
                    var t = r.redefined();
                    if (t && Q(r.scope, this.scope)) t.single_use = false;
                } else if (r.fixed === undefined || !b(i, r)) {
                    r.fixed = false;
                } else if (r.fixed) {
                    if (this.in_arg && r.orig[0] instanceof bi) this.fixed = r.scope;
                    var o = this.fixed_value();
                    if (a) {
                        r.recursive_refs++;
                    } else if (o && c(n, r)) {
                        r.in_loop = i.loop_ids[r.id] !== i.in_loop;
                        r.single_use = O(o) && !o.pinned() && (!r.in_loop || i.parent() instanceof Rt) || !r.in_loop && r.scope === this.scope.resolve() && o.is_constant_expression();
                    } else {
                        r.single_use = false;
                    }
                    if (Me(n, i, this, o, 0, E(o), a)) {
                        if (r.single_use) {
                            r.single_use = "m";
                        } else {
                            r.fixed = 0;
                        }
                    }
                    if (r.fixed && i.loop_ids[r.id] !== i.in_loop) r.cross_loop = true;
                    w(i, r, this.scope, this, o, 0, 1);
                }
                if (!this.fixed) this.fixed = r.fixed;
                var s;
                if (o instanceof Wn && !((s = i.parent()) instanceof Rt && s.expression === this)) {
                    v(i, r, o);
                }
            });
            e(Ai, function(n, e) {
                var t = this;
                var i = t.tag;
                if (!i) return;
                if (i instanceof Jn) {
                    t.expressions.forEach(function(e) {
                        e.walk(n);
                    });
                    i.walk(n);
                    return true;
                }
                i.walk(n);
                t.expressions.forEach(function(e) {
                    e.walk(n);
                });
                var r = i instanceof ln && i.fixed_value();
                if (r instanceof Wn) {
                    v(n, i.definition(), r);
                } else {
                    n.find_parent(Un).may_call_this();
                }
                return true;
            });
            e(Vn, function(n, e, t) {
                var i = this;
                i.globals.each(function(e) {
                    a(n, t, e);
                });
                h(n);
                p(n, t, i);
                e();
                d(n, i);
                return true;
            });
            e(Ot, function(e, n, t) {
                var i = this;
                s(e, t, i);
                h(e);
                Cn(i, e);
                m(e);
                if (i.bcatch) {
                    h(e);
                    i.bcatch.walk(e);
                    m(e);
                }
                if (i.bfinally) i.bfinally.walk(e);
                return true;
            });
            e(Jt, function(e, n) {
                var t = this;
                if (!Vi[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof ln)) {
                    S(i);
                    return;
                }
                var r = i.definition();
                r.assignments++;
                var a = r.fixed;
                if (b(e, r) && !i.in_arg && y(e, r)) {
                    g(r, i);
                    _(e, r);
                    if (r.single_use) r.single_use = false;
                    r.fixed = function() {
                        return Oe(un, t, {
                            operator: t.operator.slice(0, -1),
                            left: Oe(fn, t, {
                                operator: "+",
                                expression: x(i, a)
                            }),
                            right: Oe($i, t, {
                                value: 1
                            })
                        });
                    };
                    r.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    r.fixed.assigns.push(t);
                    if (t instanceof fn) {
                        i.fixed = r.fixed;
                    } else {
                        i.fixed = function() {
                            return Oe(fn, t, {
                                operator: "+",
                                expression: x(i, a)
                            });
                        };
                        i.fixed.assigns = a && a.assigns;
                        i.fixed.to_prefix = k(i, r.fixed);
                    }
                } else {
                    i.walk(e);
                    r.fixed = false;
                }
                return true;
            });
            e(Pt, function(i, e, n) {
                var r = this;
                var t = r.value;
                if (t instanceof Jn && r.name instanceof pi) {
                    o();
                    t.parent_scope.resolve().fn_defs.push(t);
                    t.safe_ids = null;
                    var a = r.name.definition();
                    if (!a.fixed) v(i, a, t);
                } else if (t) {
                    t.walk(i);
                    o();
                } else if (i.parent() instanceof Mt) {
                    o();
                }
                return true;
                function o() {
                    T(i, n, r.name, function() {
                        return r.value || Oe(Fi, r);
                    }, function(e, n) {
                        var t = e.definition();
                        if (n && y(i, t, true)) {
                            _(i, t);
                            i.loop_ids[t.id] = i.in_loop;
                            t.fixed = n;
                            t.fixed.assigns = [ r ];
                            if (e instanceof di && t.redefined() || !(De(e) || ne(t))) {
                                t.single_use = false;
                            }
                        } else {
                            t.fixed = false;
                        }
                    });
                }
            });
            e(In, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                h(e);
                n();
                m(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function q(e) {
            e._squeezed = false;
            e._optimized = false;
            if (e instanceof zn) e._var_names = undefined;
            if (e instanceof ln) e.fixed = undefined;
        }
        Vn.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new Yi(t.option("reduce_vars") ? function(e, n) {
                q(e);
                return e.reduce_vars(i, n, t);
            } : q);
            i.fn_scanning = null;
            i.fn_visited = [];
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
        });
        li.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (e) {
                if (this.fixed) e = this.fixed;
                return (e instanceof rn ? e : e()).tail_node();
            }
            e = e === 0 && this.fixed;
            if (!e) return e;
            var n = (e instanceof rn ? e : e()).tail_node();
            return n.is_constant() && n;
        });
        ln.DEFMETHOD("is_immutable", function() {
            var e = this.redef || this.definition();
            return (this.in_arg || e.orig.length == 1) && e.orig[0] instanceof bi;
        });
        rn.DEFMETHOD("convert_symbol", vn);
        function n(t, i) {
            return this.transform(new Ri(function(e, n) {
                if (e instanceof Yt) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof ni) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof ii) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, i);
            }));
        }
        Yt.DEFMETHOD("convert_symbol", n);
        ni.DEFMETHOD("convert_symbol", n);
        function t(e, n) {
            var t = Oe(e, this, this);
            n(t, this);
            return t;
        }
        pi.DEFMETHOD("convert_symbol", t);
        ln.DEFMETHOD("convert_symbol", t);
        function P(e) {
            var n = e.definition();
            n.assignments++;
            n.references.push(e);
        }
        function i(n, t) {
            var i = new Yi(function(e) {
                if (e instanceof Yt) {
                    e.value.walk(t);
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof ii) {
                    if (e.key instanceof rn) e.key.walk(t);
                    e.value.walk(i);
                    return true;
                }
                return n(e);
            });
            this.walk(i);
        }
        Yt.DEFMETHOD("mark_symbol", i);
        ni.DEFMETHOD("mark_symbol", i);
        function r(e) {
            return e(this);
        }
        pi.DEFMETHOD("mark_symbol", r);
        ln.DEFMETHOD("mark_symbol", r);
        rn.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        function a(n, t) {
            var i = false;
            var r = new Yi(function(e) {
                if (i) return true;
                if (e instanceof Yt) {
                    if (!t) return i = true;
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof ii) {
                    if (!t && e.key instanceof rn) return i = true;
                    e.value.walk(r);
                    return true;
                }
                if (n(e)) return i = true;
            });
            this.walk(r);
            return i;
        }
        Yt.DEFMETHOD("match_symbol", a);
        ni.DEFMETHOD("match_symbol", a);
        function k(e) {
            return e instanceof ft || e instanceof it;
        }
        function je(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        var fe = kn("Infinity NaN undefined");
        function Ne(e, n) {
            if (e instanceof ki) return true;
            if (e instanceof Ut) {
                if (e.property === "__proto__") return true;
                e = e.expression;
                if (e instanceof ln) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.tail_node().is_constant()) return true;
                return Ne(e, n);
            }
            if (e instanceof ln) {
                if (e.is_immutable()) return true;
                var t = e.definition();
                return n.exposed(t) && fe[t.name];
            }
            return false;
        }
        function Oe(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function $e(e, n) {
            if (n.length == 1) return n[0];
            return Oe(sn, e, {
                expressions: n.reduce(E, [])
            });
        }
        function ue(e, n) {
            switch (typeof e) {
              case "string":
                return Oe(Oi, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return Oe(Mi, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? Oe(fn, n, {
                        operator: "-",
                        expression: Oe($i, n, {
                            value: -e
                        })
                    }) : Oe($i, n, {
                        value: e
                    });
                }
                return e < 0 ? Oe(fn, n, {
                    operator: "-",
                    expression: Oe(ji, n)
                }) : Oe(ji, n);

              case "boolean":
                return Oe(e ? Hi : Ii, n);

              case "undefined":
                return Oe(Fi, n);

              default:
                if (e === null) {
                    return Oe(Ci, n);
                }
                if (e instanceof RegExp) {
                    return Oe(zi, n, {
                        value: e
                    });
                }
                throw new Error(wn("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function ce(e, n) {
            return n instanceof Ut || qe(n) && n.name == "eval";
        }
        function Ie(e, n, t, i) {
            var r = false;
            if (n.TYPE == "Call") {
                r = n.expression === t && ce(e, i);
            } else if (n instanceof Ai) {
                r = n.tag === t && ce(e, i);
            } else if (n instanceof fn) {
                r = n.operator == "delete" || n.operator == "typeof" && qe(i);
            }
            return r ? $e(t, [ Oe($i, t, {
                value: 0
            }), i ]) : i;
        }
        function E(e, n) {
            if (n instanceof sn) {
                [].push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function j(e) {
            return e instanceof Ct || e instanceof pt || e instanceof Mt;
        }
        function S(e) {
            if (e instanceof ot) {
                var n = e.name.definition();
                var t = e.name.scope;
                return n.scope === t || tn(n.references, function(e) {
                    var n = e.scope;
                    do {
                        if (n === t) return true;
                    } while (n = n.parent_scope);
                });
            }
            return !j(e);
        }
        function N(e) {
            if (e === null) return [];
            if (e instanceof on) return tn(e.body, S) ? e.body : [ e ];
            if (e instanceof $n) return [];
            if (qn(e)) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function le(e) {
            if (e === null) return true;
            if (e instanceof $n) return true;
            if (e instanceof on) return e.body.length == 0;
            return false;
        }
        function T(e) {
            return tn(e.body, function(e) {
                return le(e) || e instanceof ut || e instanceof Ft && de(e);
            });
        }
        function I(e) {
            if (e instanceof Pn) {
                return e.body instanceof on ? e.body : e;
            }
            return e;
        }
        function pe(e) {
            if (e.TYPE != "Call") return false;
            do {
                e = e.expression;
            } while (e instanceof Ut);
            return e instanceof Jn ? !Xn(e) : pe(e);
        }
        function He(e) {
            var n = e.expression;
            if (n.name) return false;
            if (!(e instanceof Lt)) return true;
            var t = false;
            n.walk(new Yi(function(e) {
                if (t) return true;
                if (e instanceof Ti) return t = true;
                if (e instanceof Un && e !== n) return true;
            }));
            return !t;
        }
        function qe(e) {
            return e instanceof ln && e.definition().undeclared;
        }
        var Ye = kn("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Map Math Number parseFloat parseInt RangeError ReferenceError RegExp Object Set setInterval setTimeout String SyntaxError TypeError unescape URIError WeakMap WeakSet");
        ln.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && Ye[this.name];
        });
        function de(e) {
            return tn(e.definitions, function(e) {
                return !e.value;
            });
        }
        function H(e, n) {
            if (e instanceof pt) return n && !e.extends && tn(e.properties, function(e) {
                if (e.key instanceof rn) return false;
                if (e instanceof ht && e.static && e.value) return false;
                return true;
            });
            if (e instanceof zt) return (n || e instanceof Ft) && de(e);
            if (e instanceof jt) return H(e.body, n);
            if (e instanceof Nt) return H(e.body, n);
            return e instanceof ot;
        }
        function A(e, n) {
            var t = e.lastIndexOf(n);
            if (t < 0) return false;
            while (++t < e.length) {
                if (!H(e[t], true)) return false;
            }
            return true;
        }
        function Re(e, n) {
            var t;
            if (e.init instanceof on) {
                t = e.init;
                e.init = t.body.pop();
                t.body.push(e);
            }
            if (e.init instanceof ut) {
                if (!t) t = Oe(on, e, {
                    body: [ e ]
                });
                t.body.splice(-1, 0, e.init);
                e.init = null;
            } else if (e.init instanceof an) {
                e.init = e.init.body;
            } else if (le(e.init)) {
                e.init = null;
            }
            if (!t) return;
            return n ? bn.splice(t.body) : t;
        }
        function c(e, s) {
            var C = M(s, function(e) {
                return e instanceof Wn;
            });
            var Ee, Se, Te, Ae;
            r();
            var n, t, i = 10;
            do {
                t = n;
                n = 0;
                if (o(e)) n = 1;
                if (!n && t == 1) break;
                if (s.option("dead_code")) {
                    if (u(e, s)) n = 2;
                    if (!n && t == 2) break;
                }
                if (s.option("if_return")) {
                    if (f(e, s)) n = 3;
                    if (!n && t == 3) break;
                }
                if (s.option("awaits") && s.option("side_effects")) {
                    if (c(e, s)) n = 4;
                    if (!n && t == 4) break;
                }
                if (s.option("inline") >= 4) {
                    if (l(e, s)) n = 5;
                    if (!n && t == 5) break;
                }
                if (s.sequences_limit > 0) {
                    if (d(e, s)) n = 6;
                    if (!n && t == 6) break;
                    if (h(e, s)) n = 7;
                    if (!n && t == 7) break;
                }
                if (s.option("join_vars")) {
                    if (w(e)) n = 8;
                    if (!n && t == 8) break;
                }
                if (s.option("collapse_vars")) {
                    if (a(e, s)) n = 9;
                }
            } while (n && i-- > 0);
            return e;
            function M(e, n) {
                var t = e.self(), i, r = 0;
                do {
                    do {
                        if (n(t)) return true;
                        t = e.parent(r++);
                    } while (t instanceof Et && (i = t));
                } while ((t instanceof on || t instanceof Un) && A(t.body, i));
            }
            function r() {
                var e = s.self(), n = 0;
                do {
                    if (!Ee && e.variables) Ee = e;
                    if (e instanceof $t) {
                        if (s.parent(n).bfinally) {
                            if (!Te) Te = {};
                            Te.bfinally = true;
                        }
                        n++;
                    } else if (e instanceof qt) {
                        n++;
                    } else if (e instanceof Pn) {
                        Se = true;
                    } else if (e instanceof Un) {
                        Ae = e;
                        break;
                    } else if (e instanceof Ot) {
                        if (!Te) Te = {};
                        if (e.bcatch) Te.bcatch = true;
                        if (e.bfinally) Te.bfinally = true;
                    }
                } while (e = s.parent(n++));
            }
            function a(m, d) {
                if (Ae.pinned()) return;
                var _;
                var g = new En();
                var b = [];
                var y = false;
                var w = new En();
                var a;
                var x = m.length;
                var l = new Ri(function(e, n) {
                    if (p) return e;
                    if (!U) {
                        if (e !== f[k]) return e;
                        k++;
                        if (k < f.length) return G(e, l);
                        U = true;
                        D = (A ? c : te)(e, 0);
                        if (D === e) p = true;
                        return e;
                    }
                    var t = l.parent();
                    if (!O && Q(e, t)) {
                        O = t;
                    }
                    if (C && q && h && !O && e instanceof cn && e.operator != "=" && e.left.equivalent_to(v)) {
                        V++;
                        y = true;
                        rn.info("Cascading {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        h = false;
                        I = he(v);
                        e.right.transform(l);
                        pe(u);
                        var i;
                        if (p) {
                            i = u;
                        } else {
                            p = true;
                            i = Oe(un, u, {
                                operator: C,
                                left: v.fixed && v.definition().fixed ? v.fixed.to_binary() : v,
                                right: R
                            });
                        }
                        return Oe(cn, e, {
                            operator: "=",
                            left: e.left,
                            right: Oe(un, e, {
                                operator: e.operator.slice(0, -1),
                                left: i,
                                right: e.right
                            })
                        });
                    }
                    if (X(e, t)) {
                        p = true;
                        return e;
                    }
                    if (e.single_use && t instanceof Pt && t.value === e) return e;
                    var r;
                    if (!(e instanceof pi) && (q && v.equivalent_to(e) || z && (r = z(e, this)))) {
                        if (!h || O && (r || !H || !B)) {
                            if (!r && !A) p = true;
                            return e;
                        }
                        if (Ki(e, t)) {
                            if (A && !r) S = true;
                            return e;
                        } else if (A) {
                            if (O && E == 0) E = T - V;
                            if (!r) V++;
                            return e;
                        } else {
                            V++;
                        }
                        y = p = true;
                        rn.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (u.TYPE == "Binary") {
                            de(u, e);
                            return Oe(cn, u, {
                                operator: "=",
                                left: u.right.left,
                                right: u.operator == "&&" ? Oe(Kt, u, {
                                    condition: u.left,
                                    consequent: u.right.right,
                                    alternative: e
                                }) : Oe(Kt, u, {
                                    condition: u.left,
                                    consequent: e,
                                    alternative: u.right.right
                                })
                            });
                        }
                        if (u instanceof Xt) return Oe(fn, u, {
                            operator: u.operator,
                            expression: v.fixed && v.definition().fixed ? v.fixed.to_prefix() : v
                        });
                        if (u instanceof fn) {
                            pe(u);
                            return u;
                        }
                        de(R, e);
                        if (u instanceof Pt) {
                            var a = u.name.definition();
                            if (a.references.length - a.replaced == 1 && !d.exposed(a)) {
                                a.replaced++;
                                return Ie(d, t, e, R);
                            }
                            return Oe(cn, u, {
                                operator: "=",
                                left: e,
                                right: R
                            });
                        }
                        pe(R);
                        var o = u.clone();
                        o.right = R;
                        return o;
                    }
                    if (K(e, t)) {
                        p = true;
                        return e;
                    }
                    if (Z(e, t) || M(e)) {
                        D = e;
                        if (e instanceof Un) p = true;
                    }
                    if (e instanceof Gn) {
                        var s = h;
                        h = false;
                        n(e, l);
                        h = s;
                        return W(e);
                    }
                    if (e instanceof ni) {
                        var s = h;
                        h = false;
                        n(e, l);
                        h = s;
                        return W(e);
                    }
                    if (e instanceof Yt) {
                        e.name = e.name.transform(l);
                        var s = h;
                        h = false;
                        e.value = e.value.transform(l);
                        h = s;
                        return W(e);
                    }
                    if (e instanceof zn && !(e instanceof Un) && !(e.variables && e.variables.all(function(e) {
                        return !j.has(e.name) && !I.has(e.name);
                    }))) {
                        var s = h;
                        h = false;
                        if (!G(e, l)) n(e, l);
                        h = s;
                        return W(e);
                    }
                    return G(e, l);
                }, W);
                var i = new Ri(function(e) {
                    if (p) return e;
                    if (!U) {
                        if (e !== f[k]) return e;
                        k++;
                        switch (f.length - k) {
                          case 0:
                            U = true;
                            if (S) return e;
                            if (e !== u) return e;
                            if (e instanceof Pt) return e;
                            r.replaced++;
                            var n = i.parent();
                            if (n instanceof sn && n.tail_node() !== e) {
                                A.replaced++;
                                if (R === Y) return bn.skip;
                                return $e(Y, Y.expressions.slice(0, -1));
                            }
                            return R;

                          case 1:
                            if (!S && e.body === u) {
                                U = true;
                                r.replaced++;
                                A.replaced++;
                                return null;
                            }

                          default:
                            return G(e, i);
                        }
                    }
                    if (e instanceof ln && e.definition() === r) {
                        if (Ki(e, i.parent())) return e;
                        if (!--V) p = true;
                        rn.info("Replacing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        var t = R.clone();
                        t.scope = e.scope;
                        t.reference();
                        if (V == E) {
                            p = true;
                            return Oe(cn, u, {
                                operator: "=",
                                left: e,
                                right: t
                            });
                        }
                        r.replaced++;
                        return t;
                    }
                    if (e instanceof At || e instanceof Un) return e;
                }, function(e) {
                    return _e(e, i);
                });
                while (--x >= 0) {
                    if (x == 0 && d.option("unused")) ne();
                    var f = [];
                    o(m[x]);
                    while (b.length > 0) {
                        f = b.pop();
                        var k = 0;
                        var u = f[f.length - 1];
                        var E = -1;
                        var S = false;
                        var T;
                        var A = null;
                        var D = null;
                        var O = null;
                        var v = se(u);
                        var $ = v && v.has_side_effects(d);
                        var q = v && (!$ || v instanceof ln) && !Ne(v, d);
                        var z = ce(u);
                        if (!q && !z) continue;
                        var C = u instanceof cn && u.operator.slice(0, -1);
                        var t = u.name instanceof _i;
                        var M = hn;
                        if (u.may_throw(d)) {
                            if (t && Kn(Ae)) continue;
                            M = Te ? function(e) {
                                return e.has_side_effects(d);
                            } : ke;
                        }
                        var F = false;
                        var P = false;
                        var j = new En();
                        var N = true;
                        var I = he(u);
                        var H = ge(v);
                        var Y = fe(u);
                        var R = !C && Y instanceof sn ? Y.tail_node() : Y;
                        if (!$) $ = be();
                        var L = Te || !H ? function(e) {
                            return e instanceof ni;
                        } : hn;
                        var B = ye(u);
                        var U = t;
                        var p = false;
                        var V = 0;
                        var h = !_ || !U;
                        if (!h) {
                            for (var e = u.arg_index + 1; !p && e < _.length; e++) {
                                if (_[e]) _[e].transform(l);
                            }
                            h = true;
                        }
                        for (var n = x; !p && n < m.length; n++) {
                            m[n].transform(l);
                        }
                        if (A) {
                            if (!V || T > V + S) {
                                b.push(f);
                                a = true;
                                continue;
                            }
                            if (V == E) S = true;
                            var r = v.definition();
                            p = false;
                            k = 0;
                            U = t;
                            for (var n = x; !p && n < m.length; n++) {
                                if (!m[n].transform(i)) m.splice(n--, 1);
                            }
                            V = u instanceof Pt && u === f[f.length - 1] && r.references.length == r.replaced && !d.exposed(r);
                            A.last_ref = false;
                            A.single_use = false;
                            y = true;
                        }
                        if (V) me(u);
                    }
                }
                return y;
                function W(e) {
                    if (p) return e;
                    if (D === e) p = true;
                    if (O === e) O = null;
                    return e;
                }
                function G(e, n) {
                    if (!(e instanceof zn)) {
                        if (!(e instanceof vt && !e.static)) return;
                        if (e.key instanceof rn) e.key = e.key.transform(n);
                        return e;
                    }
                    if (e instanceof Un) return e;
                    if (e instanceof Yn) {
                        e.object = e.object.transform(n);
                        p = true;
                        return e;
                    }
                    if (e instanceof St) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !p && t < e.body.length; t++) {
                            var i = e.body[t];
                            if (i instanceof Dt) {
                                if (!U) {
                                    if (i !== f[k]) continue;
                                    k++;
                                }
                                i.expression = i.expression.transform(n);
                                if (!B) break;
                                z = false;
                            }
                        }
                        p = true;
                        return e;
                    }
                }
                function J(e, n) {
                    if (n instanceof cn) return n.operator == "=" && n.left === e;
                    if (n instanceof Yt) return n.name === e;
                    if (n instanceof ti) return true;
                    if (n instanceof ii) return n.value === e;
                }
                function X(e, n) {
                    if (e === R) return true;
                    if (n instanceof Hn) {
                        if (e !== n.init) return true;
                    }
                    if (e instanceof cn) {
                        return e.operator != "=" && v.equivalent_to(e.left);
                    }
                    if (e instanceof Rt) {
                        if (!(v instanceof Ut)) return false;
                        if (!v.equivalent_to(e.expression)) return false;
                        return !(R instanceof Jn && !R.contains_this());
                    }
                    if (e instanceof lt) return !d.has_directive("use strict");
                    if (e instanceof Dn) return true;
                    if (e instanceof ut) return t && v.name === e.name.name;
                    if (e instanceof ii) return e.key instanceof rn;
                    if (e instanceof jn) return true;
                    if (e instanceof wt) return true;
                    if (e instanceof Ot) return true;
                    if (e instanceof Bn) return true;
                    return false;
                }
                function K(e, n) {
                    if (!(e instanceof ln)) return false;
                    if (e.is_declared(d)) {
                        if (e.fixed_value()) return false;
                        if (De(e)) {
                            return !(n instanceof Ut && n.expression === e) && Fe(e.definition());
                        }
                    } else if (J(e, n)) {
                        return false;
                    }
                    if (!B) return true;
                    z = false;
                    return false;
                }
                function Q(e, n) {
                    if (n instanceof cn) return n.left !== e && Ce[n.operator.slice(0, -1)];
                    if (n instanceof un) return n.left !== e && Ce[n.operator];
                    if (n instanceof Rt) return n.optional && n.expression !== e;
                    if (n instanceof Dt) return n.expression !== e;
                    if (n instanceof Kt) return n.condition !== e;
                    if (n instanceof Et) return n.condition !== e;
                    if (n instanceof Wt) return n.optional && n.expression !== e;
                }
                function Z(e, n) {
                    if (e instanceof Qt) return true;
                    if (e.TYPE == "Binary") return e.operator == "in" && !Be(e.right);
                    if (e instanceof Rt) {
                        var t, i = e.expression;
                        if (i instanceof ln) {
                            t = i.definition();
                            i = i.fixed_value();
                        }
                        if (!(i instanceof Wn)) return !e.is_expr_pure(d);
                        if (t && Ue(d, t, i)) return true;
                        if (i.collapse_scanning) return false;
                        i.collapse_scanning = true;
                        var r = h;
                        h = false;
                        var a = D;
                        var c = O;
                        if (!tn(i.argnames, function(e) {
                            if (e instanceof Yt) {
                                e.value.transform(l);
                                if (p) return false;
                                e = e.name;
                            }
                            return !(e instanceof ni);
                        })) {
                            p = true;
                        } else if (Xn(i) && i.value) {
                            i.value.transform(l);
                        } else for (var o = 0; !p && o < i.body.length; o++) {
                            var s = i.body[o];
                            if (s instanceof bt) {
                                if (s.value) s.value.transform(l);
                                break;
                            }
                            s.transform(l);
                        }
                        O = c;
                        D = a;
                        h = r;
                        i.collapse_scanning = false;
                        if (!p) return false;
                        p = false;
                        return true;
                    }
                    if (e instanceof gt) {
                        if (Te) {
                            if (Te.bfinally) return true;
                            if (Te.bcatch && e instanceof yt) return true;
                        }
                        return $ || v instanceof Ut || xe(v);
                    }
                    if (e instanceof rt) {
                        return d.option("ie") && e.name && I.has(e.name.name);
                    }
                    if (e instanceof ki) return we(e, n);
                    if (e instanceof Ut) {
                        if ($) return true;
                        var f = e.expression;
                        if (f instanceof ln && Fe(f.definition())) return true;
                        if (d.option("unsafe")) {
                            if (qe(f) && Ye[f.name]) return false;
                            if (Le(f)) return false;
                        }
                        if (!N) return true;
                        if (A) return false;
                        if (!Te && H) return false;
                        if (e.optional) return false;
                        return f.may_throw_on_access(d);
                    }
                    if (e instanceof Gt) return true;
                    if (e instanceof ln) {
                        if (we(e, n)) return !J(e, n);
                        if ($ && xe(e)) return true;
                        var t = e.definition();
                        return (Te || t.scope.resolve() !== Ae) && !De(e);
                    }
                    if (e instanceof Ai) return !e.is_expr_pure(d);
                    if (e instanceof Pt) {
                        if (L(e.name)) return true;
                        return (e.value || n instanceof Mt) && e.name.match_symbol(function(e) {
                            return e instanceof pi && (I.has(e.name) || $ && xe(e));
                        }, true);
                    }
                    if (e instanceof Zt) return true;
                    var u = Ki(e.left, e);
                    if (!u) return false;
                    if (u instanceof Ut) return true;
                    if (L(u)) return true;
                    return u.match_symbol(function(e) {
                        return e instanceof ln && (I.has(e.name) || F && d.exposed(e.definition()));
                    }, true);
                }
                function ee(e, n) {
                    if (!n) return !(e instanceof li);
                    if (e instanceof Yt) {
                        return n.has_side_effects(d) || e.value.has_side_effects(d) || ee(e.name, ze(n) && e.value);
                    }
                    if (e instanceof ni) {
                        if (e.rest && ee(e.rest)) return true;
                        if (e instanceof ti) {
                            if (!(n instanceof ei || n.is_string(d))) return true;
                            return !tn(e.elements, function(e) {
                                return !ee(e);
                            });
                        }
                        if (e instanceof ri) {
                            if (!n.is_defined(d)) return true;
                            return !tn(e.properties, function(e) {
                                if (e instanceof rn && e.has_side_effects(d)) return false;
                                return !ee(e.value);
                            });
                        }
                    }
                }
                function ne() {
                    var e, r = d.self();
                    if (r instanceof Jn && !Qn(r) && !r.uses_arguments && !r.pinned() && (e = d.parent()) instanceof Rt && e.expression === r && He(e) && tn(e.args, function(e) {
                        return !(e instanceof Gt);
                    })) {
                        var a = d.has_directive("use strict");
                        if (a && !pn(a, r.body)) a = false;
                        var c = Kn(r) ? function(e) {
                            return e instanceof li && e.name == "await";
                        } : function(e) {
                            return e instanceof Qt && !n.find_parent(Un);
                        };
                        var o = null;
                        var n = new Yi(function(e, n) {
                            if (!s) return true;
                            if (c(e) || e instanceof Zt) {
                                s = null;
                                return true;
                            }
                            if (e instanceof ki && (a || !o)) {
                                s = null;
                                return true;
                            }
                            if (e instanceof ln && r.variables.has(e.name)) {
                                var t = e.definition().scope;
                                if (t !== Ae) while (t = t.parent_scope) {
                                    if (t === Ae) return true;
                                }
                                s = null;
                            }
                            if (e instanceof Un && !Xn(e)) {
                                var i = o;
                                o = e;
                                n();
                                o = i;
                                return true;
                            }
                        });
                        _ = e.args.slice();
                        var l = _.length;
                        var p = new En();
                        for (var t = r.argnames.length; --t >= 0; ) {
                            var i = r.argnames[t];
                            var s = _[t];
                            var f;
                            if (i instanceof Yt) {
                                f = i.value;
                                i = i.name;
                                _[l + t] = f;
                            }
                            if (i instanceof ni) {
                                if (!ee(i, s)) continue;
                                b.length = 0;
                                break;
                            }
                            if (p.has(i.name)) continue;
                            p.set(i.name, true);
                            if (f) s = ze(s) ? f : null;
                            if (!s && !f) {
                                s = Oe(Fi, i).transform(d);
                            } else if (s instanceof Wn && s.pinned()) {
                                s = null;
                            } else if (s) {
                                s.walk(n);
                            }
                            if (!s) continue;
                            var u = Oe(Pt, i, {
                                name: i,
                                value: s
                            });
                            u.name_index = t;
                            u.arg_index = f ? l + t : t;
                            b.unshift([ u ]);
                        }
                    }
                }
                function o(e, n) {
                    f.push(e);
                    if (e instanceof ei) {
                        e.elements.forEach(function(e) {
                            o(e, n);
                        });
                    } else if (e instanceof cn) {
                        var t = e.left;
                        if (!(t instanceof ni)) b.push(f.slice());
                        o(t);
                        o(e.right);
                        if (t instanceof ln && e.operator == "=") {
                            g.set(t.name, (g.get(t.name) || 0) + 1);
                        }
                    } else if (e instanceof Qt) {
                        o(e.expression, n);
                    } else if (e instanceof un) {
                        var i = Ce[e.operator];
                        if (n && i && e.operator != "??" && e.right instanceof cn && e.right.operator == "=" && !(e.right.left instanceof ni)) {
                            b.push(f.slice());
                        }
                        o(e.left, !i && n);
                        o(e.right, n);
                    } else if (e instanceof Rt) {
                        o(e.expression);
                        e.args.forEach(o);
                    } else if (e instanceof Dt) {
                        o(e.expression);
                    } else if (e instanceof Kt) {
                        o(e.condition);
                        o(e.consequent, n);
                        o(e.alternative, n);
                    } else if (e instanceof zt) {
                        e.definitions.forEach(o);
                    } else if (e instanceof Vt) {
                        o(e.expression);
                    } else if (e instanceof jn) {
                        o(e.condition);
                        if (!(e.body instanceof Mn)) {
                            o(e.body);
                        }
                    } else if (e instanceof gt) {
                        if (e.value) o(e.value);
                    } else if (e instanceof Hn) {
                        if (e.init) o(e.init, true);
                        if (e.condition) o(e.condition);
                        if (e.step) o(e.step, true);
                        if (!(e.body instanceof Mn)) {
                            o(e.body);
                        }
                    } else if (e instanceof Yn) {
                        o(e.object);
                        if (!(e.body instanceof Mn)) {
                            o(e.body);
                        }
                    } else if (e instanceof Et) {
                        o(e.condition);
                        if (!(e.body instanceof Mn)) {
                            o(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof Mn)) {
                            o(e.alternative);
                        }
                    } else if (e instanceof ai) {
                        e.properties.forEach(function(e) {
                            f.push(e);
                            if (e.key instanceof rn) o(e.key);
                            if (e instanceof si) o(e.value, n);
                            f.pop();
                        });
                    } else if (e instanceof sn) {
                        var r = e.expressions.length - (n ? 0 : 1);
                        e.expressions.forEach(function(e, n) {
                            o(e, n < r);
                        });
                    } else if (e instanceof an) {
                        o(e.body, true);
                    } else if (e instanceof Gt) {
                        o(e.expression);
                    } else if (e instanceof Wt) {
                        o(e.expression);
                        o(e.property);
                    } else if (e instanceof St) {
                        o(e.expression);
                        e.body.forEach(o);
                    } else if (e instanceof Jt) {
                        if (Vi[e.operator]) {
                            b.push(f.slice());
                        } else {
                            o(e.expression);
                        }
                    } else if (e instanceof Pt) {
                        if (e.name instanceof mi) {
                            if (e.value) {
                                var a = e.name.definition();
                                if (a.references.length > a.replaced) {
                                    b.push(f.slice());
                                }
                            } else {
                                w.set(e.name.name, (w.get(e.name.name) || 0) + 1);
                            }
                        }
                        if (e.value) o(e.value);
                    } else if (e instanceof Zt) {
                        if (e.expression) o(e.expression);
                    }
                    f.pop();
                }
                function te(e, n) {
                    var t = l.parent(n);
                    if (t instanceof ei) return e;
                    if (t instanceof cn) return e;
                    if (t instanceof Qt) return e;
                    if (t instanceof un) return e;
                    if (t instanceof Rt) return e;
                    if (t instanceof Dt) return e;
                    if (t instanceof Kt) return e;
                    if (t instanceof zt) return s(t, n + 1);
                    if (t instanceof gt) return e;
                    if (t instanceof Et) return e;
                    if (t instanceof Pn) return e;
                    if (t instanceof oi) return e;
                    if (t instanceof Ut) return e;
                    if (t instanceof sn) {
                        return (t.tail_node() === e ? te : s)(t, n + 1);
                    }
                    if (t instanceof an) return s(t, n + 1);
                    if (t instanceof Gt) return e;
                    if (t instanceof St) return e;
                    if (t instanceof Jt) return e;
                    if (t instanceof Pt) return e;
                    if (t instanceof Zt) return e;
                    return null;
                }
                function ie(e, n, t) {
                    var i;
                    do {
                        i = e;
                        e = l.parent(++t);
                    } while (e instanceof cn && e.operator.slice(0, -1) == n || e instanceof un && e.operator == n);
                    return i;
                }
                function re(e, n, t, i, r) {
                    var a = h;
                    h = false;
                    var o = D;
                    var s = O;
                    var f = l.stack;
                    l.stack = [ i ];
                    e.transform(l);
                    l.stack = f;
                    O = s;
                    D = o;
                    h = a;
                    if (p) {
                        p = false;
                        return t;
                    }
                    return n(i, r + 1);
                }
                function c(e, n) {
                    var t = l.parent(n);
                    if (t instanceof ei) return c(t, n + 1);
                    if (t instanceof cn) {
                        if (M(t)) return e;
                        if (t.left.match_symbol(function(e) {
                            return e instanceof ln && (v.name == e.name || A.name == e.name);
                        })) return e;
                        var i;
                        if (t.left === e || !Ce[i = t.operator.slice(0, -1)]) {
                            return c(t, n + 1);
                        }
                        return ie(t, i, n);
                    }
                    if (t instanceof un) {
                        var i;
                        if (t.left === e || !Ce[i = t.operator]) {
                            return c(t, n + 1);
                        }
                        return ie(t, i, n);
                    }
                    if (t instanceof Rt) return t;
                    if (t instanceof Dt) {
                        if (t.expression !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Kt) {
                        if (t.condition !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof zt) return s(t, n + 1);
                    if (t instanceof Nn) return e;
                    if (t instanceof gt) return s(t, n + 1);
                    if (t instanceof Hn) {
                        if (t.init !== e && t.condition !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Yn) {
                        if (t.init !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Et) {
                        if (t.condition !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof oi) {
                        var r = l.parent(n + 1);
                        return tn(r.properties, function(e) {
                            return e instanceof si;
                        }) ? c(r, n + 2) : r;
                    }
                    if (t instanceof Ut) {
                        var a = t.expression;
                        return a === e ? c(t, n + 1) : e;
                    }
                    if (t instanceof sn) {
                        return (t.tail_node() === e ? c : s)(t, n + 1);
                    }
                    if (t instanceof an) return s(t, n + 1);
                    if (t instanceof Gt) return c(t, n + 1);
                    if (t instanceof St) {
                        if (t.expression !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Jt) {
                        if (t.operator == "delete") return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Pt) return t.name.match_symbol(function(e) {
                        return e instanceof pi && (v.name == e.name || A.name == e.name);
                    }) ? e : c(t, n + 1);
                    if (t instanceof In) {
                        if (t.condition !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Zt) return c(t, n + 1);
                    return null;
                }
                function s(n, t) {
                    var i = l.parent(t);
                    if (Z(n, i)) return n;
                    if (Q(n, i)) return n;
                    if (i instanceof ei) return s(i, t + 1);
                    if (i instanceof cn) return a(i.left);
                    if (i instanceof Qt) return n;
                    if (i instanceof un) return s(i, t + 1);
                    if (i instanceof Rt) return s(i, t + 1);
                    if (i instanceof Dt) return s(i, t + 1);
                    if (i instanceof Kt) return s(i, t + 1);
                    if (i instanceof zt) return s(i, t + 1);
                    if (i instanceof gt) return s(i, t + 1);
                    if (i instanceof Et) return s(i, t + 1);
                    if (i instanceof Pn) return n;
                    if (i instanceof oi) {
                        var e = l.parent(t + 1);
                        return tn(e.properties, function(e) {
                            return e instanceof si;
                        }) ? s(e, t + 2) : e;
                    }
                    if (i instanceof Ut) {
                        var r = i.expression;
                        if (r === n) return s(i, t + 1);
                        return re(r, s, n, i, t);
                    }
                    if (i instanceof sn) return s(i, t + 1);
                    if (i instanceof an) return s(i, t + 1);
                    if (i instanceof Gt) return n;
                    if (i instanceof St) return s(i, t + 1);
                    if (i instanceof Jt) return s(i, t + 1);
                    if (i instanceof Pt) return a(i.name);
                    if (i instanceof Zt) return n;
                    return null;
                    function a(e) {
                        if (M(i)) return n;
                        if (e !== n && e instanceof ni) {
                            return re(e, s, n, i, t);
                        }
                        return s(i, t + 1);
                    }
                }
                function ae(e) {
                    if (a) {
                        a = false;
                        return;
                    }
                    if (T < 1) return;
                    e = e.tail_node();
                    var n = e instanceof cn && e.operator == "=" ? e.left : e;
                    if (!(n instanceof ln)) return;
                    var t = n.definition();
                    if (t.undeclared) return;
                    if (Fe(t)) return;
                    if (n !== e) {
                        if (Ne(n, d)) return;
                        var i = t.references.length - t.replaced;
                        if (i < 2) return;
                        var r = u.clone();
                        r[r instanceof cn ? "right" : "value"] = n;
                        if (u.name_index >= 0) {
                            r.name_index = u.name_index;
                            r.arg_index = u.arg_index;
                        }
                        u = r;
                    }
                    return A = t;
                }
                function oe(e) {
                    return e.references.length - e.replaced - (g.get(e.name) || 0);
                }
                function se(t) {
                    if (t instanceof cn) {
                        var i = t.left;
                        if (!(i instanceof ln)) return i;
                        var e = i.definition();
                        if (Ae.uses_arguments && Ji(e)) return i;
                        if (d.exposed(e)) return i;
                        T = oe(e);
                        if (e.fixed && i.fixed) {
                            var n = e.references.filter(function(e) {
                                return e.fixed === i.fixed;
                            }).length - 1;
                            if (n < T) {
                                T = n;
                                E = 0;
                            }
                        }
                        if (t.operator == "=") ae(t.right);
                        return i;
                    }
                    if (t instanceof un) return t.right.left;
                    if (t instanceof Jt) return t.expression;
                    if (t instanceof Pt) {
                        var i = t.name;
                        var e = i.definition();
                        if (e.const_redefs) return;
                        if (!pn(i, e.orig)) return;
                        if (Ae.uses_arguments && Ji(e)) return;
                        var r = e.orig.length - e.eliminated - (w.get(e.name) || 0);
                        T = oe(e);
                        if (e.fixed) T = Math.min(T, e.references.filter(function(e) {
                            if (!e.fixed) return true;
                            if (!e.fixed.assigns) return true;
                            var n = e.fixed.assigns[0];
                            return n === i || fe(n) === t.value;
                        }).length);
                        if (r > 1 && !(i instanceof _i)) {
                            ae(t.value);
                            return Oe(ln, i, i);
                        }
                        if (ae(t.value) || T == 1 && !d.exposed(e)) {
                            return Oe(ln, i, i);
                        }
                        return;
                    }
                }
                function fe(e) {
                    if (e instanceof cn) return e.right;
                    if (e instanceof un) {
                        var n = e.clone();
                        n.right = e.right.right;
                        return n;
                    }
                    if (e instanceof Pt) return e.value;
                }
                function ue(e) {
                    if (e instanceof ei) return false;
                    if (e instanceof un && Ce[e.operator]) {
                        return ue(e.left) && ue(e.right);
                    }
                    if (e instanceof Rt) return false;
                    if (e instanceof Kt) {
                        return ue(e.consequent) && ue(e.alternative);
                    }
                    if (e instanceof ai) return false;
                    return !e.has_side_effects(d);
                }
                function ce(n) {
                    if (n instanceof cn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new Yi(function(e) {
                        if (e instanceof ln) t[e.definition().id] = true;
                    });
                    while (n instanceof cn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof ki) return o;
                    if (n instanceof ln) {
                        var i = n.evaluate(d);
                        if (i === n) return o;
                        return le(i, o);
                    }
                    if (n.is_truthy()) return le(true, hn);
                    if (n.is_constant()) {
                        var r = n.evaluate(d);
                        if (!(r instanceof rn)) return le(r, o);
                    }
                    if (!(v instanceof ln)) return false;
                    if (!ue(n)) return false;
                    var a;
                    n.walk(new Yi(function(e) {
                        if (a) return true;
                        if (e instanceof ln && t[e.definition().id]) a = true;
                    }));
                    return !a && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function le(i, r) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (i && e.is_truthy() && !e.has_side_effects(d)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                var t = e.evaluate(d);
                                if (!(t instanceof rn)) return !t == !i;
                            }
                        }
                        return r(e);
                    };
                }
                function pe(e) {
                    while (e.write_only) {
                        e.write_only = false;
                        if (!(e instanceof cn)) break;
                        e = e.right;
                    }
                }
                function de(e, n) {
                    var t = n.scope || je(l) || Ee;
                    e.walk(new Yi(function(e) {
                        if (e instanceof zn) return true;
                        if (e instanceof li) e.scope = t;
                    }));
                }
                function ve(e) {
                    if (e instanceof ln) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof cn) return e.operator == "=" && ve(e.right);
                    return e instanceof Ut || e instanceof ki;
                }
                function he(f) {
                    var u = new En();
                    if (f instanceof Pt) {
                        if (!f.name.definition().fixed) N = false;
                        u.add(f.name.name, v);
                    }
                    var c = Ae.uses_arguments && !d.has_directive("use strict");
                    var l = Ae instanceof Vn;
                    var p = new Yi(function(n) {
                        var e;
                        if (n instanceof ln) {
                            e = n.fixed_value();
                            if (!e) {
                                e = n;
                                var t = n.definition();
                                var i = n.fixed && n.fixed.escaped || t.escaped;
                                if (!t.undeclared && (t.assignments || !i || i.cross_scope) && (Pe(t, n.scope, n, p.parent()) || !Ve(t))) {
                                    N = false;
                                }
                            }
                        } else if (n instanceof ki) {
                            e = n;
                        }
                        if (e) {
                            u.add(n.name, Me(d, p, n, e, 0));
                        } else if (n instanceof Wn) {
                            for (var r = 0, a, o = n; a = p.parent(r++); o = a) {
                                if (a instanceof cn) {
                                    if (a.left === o) break;
                                    if (a.operator == "=") continue;
                                    if (Ce[a.operator.slice(0, -1)]) continue;
                                    break;
                                }
                                if (a instanceof un) {
                                    if (Ce[a.operator]) continue;
                                    break;
                                }
                                if (a instanceof Rt) return;
                                if (a instanceof Un) return;
                                if (a instanceof sn) {
                                    if (a.tail_node() === o) continue;
                                    break;
                                }
                                if (a instanceof Ai) {
                                    if (a.tag) return;
                                    break;
                                }
                            }
                            n.enclosed.forEach(function(e) {
                                if (e.scope !== n) j.set(e.name, true);
                            });
                            return true;
                        } else if (c && n instanceof Wt) {
                            Ae.each_argname(function(e) {
                                if (!d.option("reduce_vars") || e.definition().assignments) {
                                    if (!e.definition().fixed) N = false;
                                    u.add(e.name, true);
                                }
                            });
                            c = false;
                        }
                        if (!l) return;
                        if (n.TYPE == "Call") {
                            if (P) return;
                            var s = n.expression;
                            if (s instanceof Ut) return;
                            if (s instanceof Jn && !s.contains_this()) return;
                            P = true;
                        } else if (n instanceof Ut && ve(n.expression)) {
                            if (n === v && !(f instanceof Jt)) {
                                P = true;
                            } else {
                                F = true;
                            }
                        }
                    });
                    f.walk(p);
                    return u;
                }
                function me(e) {
                    var i = R === Y ? null : $e(Y, Y.expressions.slice(0, -1));
                    var n = e.name_index;
                    if (n >= 0) {
                        var t, r = Ae.argnames[n];
                        if (r instanceof Yt) {
                            Ae.argnames[n] = r = r.clone();
                            r.value = i || Oe($i, r, {
                                value: 0
                            });
                        } else if ((t = d.parent().args)[n]) {
                            Ae.argnames[n] = r.clone();
                            t[n] = i || Oe($i, t[n], {
                                value: 0
                            });
                        }
                        return;
                    }
                    var a = f.length - 1;
                    if (f[a - 1].body === f[a]) a--;
                    var o = new Ri(function(e, n, t) {
                        if (U) return e;
                        if (e !== f[k]) return e;
                        k++;
                        if (k <= a) return G(e, o);
                        U = true;
                        if (e instanceof Pt) {
                            w.set(e.name.name, (w.get(e.name.name) || 0) + 1);
                            if (A) A.replaced++;
                            e = e.clone();
                            e.value = null;
                            return i ? bn.splice([ i, e ]) : e;
                        }
                        if (!i) return t ? bn.skip : null;
                        return qn(e) ? Oe(an, i, {
                            body: i
                        }) : i;
                    }, function(n, e) {
                        if (n instanceof zt) {
                            var t = [], i = n.definitions;
                            for (var r = 0, a = 0; r < i.length; r++) {
                                var o = i[r];
                                if (o instanceof Pt) continue;
                                s();
                                a = r + 1;
                                t.push(Oe(an, o, {
                                    body: o
                                }));
                            }
                            if (a == 0) return;
                            s();
                            if (t.length == 1) return t[0];
                            return e ? bn.splice(t) : Oe(on, n, {
                                body: t
                            });
                        }
                        if (n instanceof Hn) return Re(n, e);
                        return _e(n, this);
                        function s() {
                            if (a < r) {
                                var e = n.clone();
                                e.definitions = i.slice(a, r);
                                t.push(e);
                            }
                        }
                    });
                    p = false;
                    U = false;
                    k = 0;
                    if (!(m[x] = m[x].transform(o))) m.splice(x, 1);
                }
                function _e(e, n) {
                    if (e instanceof sn) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return Ie(d, n.parent(), e, e.expressions[0]);
                    }
                }
                function ge(e) {
                    var n = Bt(e);
                    if (!(n instanceof ln)) return false;
                    if (n.definition().scope.resolve() !== Ae) return false;
                    if (!Se) return true;
                    if (C) return false;
                    if (u instanceof Jt) return false;
                    var t = I.get(n.name);
                    return !t || t[0] === e;
                }
                function be() {
                    if (u instanceof Jt) return false;
                    return R.has_side_effects(d);
                }
                function ye(e) {
                    if (e instanceof Jt) return false;
                    if ($) return false;
                    if (A) return true;
                    if (!(v instanceof ln)) return false;
                    var n;
                    if (e instanceof Pt) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = v.definition();
                    if (t.references.length - t.replaced == n) return true;
                    return t.fixed && v.fixed && t.references.filter(function(e) {
                        return e.fixed === v.fixed;
                    }).length == n;
                }
                function we(e, n) {
                    var t = I.get(e.name);
                    if (!t || tn(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== v) return true;
                    z = false;
                }
                function xe(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof gi) return false;
                    if (n.scope.resolve() !== Ae) return true;
                    if (P && d.exposed(n)) return true;
                    return !tn(n.references, function(e) {
                        return e.scope.resolve() === Ae;
                    });
                }
                function ke(e, n) {
                    if (e instanceof cn) return ke(e.left, true);
                    if (e instanceof Jt) return ke(e.expression, true);
                    if (e instanceof Pt) return e.value && ke(e.value);
                    if (n) {
                        if (e instanceof Vt) return ke(e.expression, true);
                        if (e instanceof Wt) return ke(e.expression, true);
                        if (e instanceof ln) return e.definition().scope.resolve() !== Ae;
                    }
                    return false;
                }
            }
            function o(e) {
                var n = false, t = [];
                for (var i = 0; i < e.length; ) {
                    var r = e[i];
                    if (r instanceof on) {
                        if (tn(r.body, S)) {
                            n = true;
                            o(r.body);
                            [].splice.apply(e, [ i, 1 ].concat(r.body));
                            i += r.body.length;
                            continue;
                        }
                    }
                    if (r instanceof On) {
                        if (pn(r.value, t)) {
                            n = true;
                            e.splice(i, 1);
                            continue;
                        }
                        t.push(r.value);
                    }
                    if (r instanceof $n) {
                        n = true;
                        e.splice(i, 1);
                        continue;
                    }
                    i++;
                }
                return n;
            }
            function f(a, o) {
                var e = false;
                var c = o.parent();
                var l = o.self();
                var p = C && c && c.TYPE == "Call" && c.expression === l;
                var d = C && o.option("conditionals") && o.option("sequences");
                var v = E(a);
                for (var s = a.length; --s >= 0; ) {
                    var n = a[s];
                    var t = $(s);
                    var i = a[t];
                    if (C && !i && n instanceof bt) {
                        if (!n.value) {
                            e = true;
                            a.splice(s, 1);
                            continue;
                        }
                        var h = n.value.tail_node();
                        if (h instanceof fn && h.operator == "void") {
                            e = true;
                            var r;
                            if (h === n.value) {
                                r = h.expression;
                            } else {
                                r = n.value.clone();
                                r.expressions[r.length - 1] = h.expression;
                            }
                            a[s] = Oe(an, n, {
                                body: r
                            });
                            continue;
                        }
                    }
                    if (n instanceof Et) {
                        var f = F(n.body);
                        if (A(f)) {
                            if (f.label) xn(f.label.thedef.references, f);
                            e = true;
                            n = n.clone();
                            n.condition = n.condition.negate(o);
                            var r = O(n.body, f);
                            n.body = Oe(on, n, {
                                body: N(n.alternative).concat(D())
                            });
                            n.alternative = Oe(on, n, {
                                body: r
                            });
                            a[s] = n;
                            a[s] = n.transform(o);
                            continue;
                        }
                        if (f && !n.alternative && n.body instanceof on && i instanceof _t) {
                            var m = n.condition.negate(o);
                            if (m.print_to_string().length <= n.condition.print_to_string().length) {
                                e = true;
                                n = n.clone();
                                n.condition = m;
                                a[t] = n.body;
                                n.body = i;
                                a[s] = n;
                                a[s] = n.transform(o);
                                continue;
                            }
                        }
                        var u = F(n.alternative);
                        if (A(u)) {
                            if (u.label) xn(u.label.thedef.references, u);
                            e = true;
                            n = n.clone();
                            n.body = Oe(on, n.body, {
                                body: N(n.body).concat(D())
                            });
                            var r = O(n.alternative, u);
                            n.alternative = Oe(on, n.alternative, {
                                body: r
                            });
                            a[s] = n;
                            a[s] = n.transform(o);
                            continue;
                        }
                        if (o.option("typeofs")) {
                            if (f && !u) {
                                var _ = Oe(on, l, {
                                    body: a.slice(s + 1)
                                });
                                U(n.condition, null, _);
                            }
                            if (!f && u) {
                                var _ = Oe(on, l, {
                                    body: a.slice(s + 1)
                                });
                                U(n.condition, _);
                            }
                        }
                    }
                    if (n instanceof Et && n.body instanceof bt) {
                        var g = n.body.value;
                        var b = n.body.in_bool || i instanceof bt && i.in_bool;
                        if (!g && !n.alternative && (C && !i || i instanceof bt && !i.value)) {
                            e = true;
                            a[s] = Oe(an, n.condition, {
                                body: n.condition
                            });
                            continue;
                        }
                        if (!n.alternative && i instanceof bt) {
                            e = true;
                            n = n.clone();
                            n.alternative = i;
                            a.splice(s, 1, n.transform(o));
                            a.splice(t, 1);
                            continue;
                        }
                        if (!n.alternative && !i && C && (b || g && v)) {
                            e = true;
                            n = n.clone();
                            n.alternative = Oe(bt, n, {
                                value: null
                            });
                            a.splice(s, 1, n.transform(o));
                            continue;
                        }
                        var y, w;
                        if (d && !n.alternative && (!(w = a[y = q(s)]) && p || w instanceof Et && w.body instanceof bt) && $(t) == a.length && i instanceof an) {
                            e = true;
                            var x = [];
                            var k = w ? z(y, x) : [ s, 1 ];
                            n = n.clone();
                            x.push(n.condition);
                            n.condition = $e(n, x);
                            n.alternative = Oe(on, i, {
                                body: [ i, Oe(bt, i, {
                                    value: null
                                }) ]
                            });
                            k.push(n.transform(o));
                            a.splice(t, 1);
                            [].splice.apply(a, k);
                            s = y + 1;
                            continue;
                        }
                    }
                }
                return e;
                function E(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof Et && i.body instanceof bt) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function S(n) {
                    return M(o, function(e) {
                        return e === n;
                    });
                }
                function T(e) {
                    if (e instanceof bt) return C && ze(e.value);
                    if (!(e instanceof wt)) return false;
                    var n = o.loopcontrol_target(e);
                    if (e instanceof kt) return S(I(n));
                    if (n instanceof Pn) return false;
                    return S(n);
                }
                function A(e) {
                    if (!T(e)) return false;
                    for (var n = a.length; --n > s; ) {
                        var t = a[n];
                        if (t instanceof pt) {
                            if (t.name.definition().preinit) return false;
                        } else if (t instanceof Ct || t instanceof Mt) {
                            if (!tn(t.definitions, function(e) {
                                return !e.name.match_symbol(function(e) {
                                    return e instanceof pi && e.definition().preinit;
                                });
                            })) return false;
                        }
                    }
                    return true;
                }
                function D() {
                    var n = [];
                    var t = false;
                    var e = a.splice(s + 1).filter(function(e) {
                        if (e instanceof ot) {
                            n.push(e);
                            return false;
                        }
                        if (j(e)) t = true;
                        return true;
                    });
                    [].push.apply(t ? e : a, n);
                    return e;
                }
                function O(e, n) {
                    var t = N(e);
                    var i = t, r;
                    while ((r = i[i.length - 1]) !== n) {
                        i = r.body;
                    }
                    i.pop();
                    if (n.value) i.push(Oe(an, n.value, {
                        body: n.value
                    }));
                    return t;
                }
                function $(e) {
                    for (var n = e + 1; n < a.length; n++) {
                        if (!H(a[n])) break;
                    }
                    return n;
                }
                function q(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!(a[n] instanceof Ft)) break;
                    }
                    return n;
                }
                function z(e, n) {
                    var t = [ e + 1, s - e ];
                    var i = [];
                    while (++e < s) {
                        var r = a[e];
                        r.remove_initializers(o, i);
                        r.definitions.forEach(function(e) {
                            if (!e.value) return;
                            n.push(Oe(cn, e, {
                                operator: "=",
                                left: e.name.convert_symbol(ln, P),
                                right: e.value
                            }));
                        });
                    }
                    if (i.length > 0) t.push(Oe(Ft, r, {
                        definitions: i
                    }));
                    return t;
                }
            }
            function u(n, t) {
                var e;
                var i = t.self();
                for (var r = 0, a = 0, o = n.length; r < o; r++) {
                    var s = n[r];
                    if (s instanceof wt) {
                        var f = t.loopcontrol_target(s);
                        if (I(f) !== i || s instanceof xt && f instanceof Pn) {
                            n[a++] = s;
                        } else if (s.label) {
                            xn(s.label.thedef.references, s);
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (F(s)) {
                        e = n.slice(r + 1);
                        break;
                    }
                }
                n.length = a;
                if (e) e.forEach(function(e) {
                    z(t, e, n);
                });
                return n.length != o;
            }
            function c(e, n) {
                if (!C || Te && Te.bfinally) return;
                var t = false;
                for (var i = e.length; --i >= 0; ) {
                    var r = e[i];
                    if (!(r instanceof an)) break;
                    var a = r.body;
                    if (!(a instanceof Qt)) break;
                    var o = a.expression;
                    if (!x(n, o)) break;
                    t = true;
                    o = o.drop_side_effect_free(n, true);
                    if (o) {
                        r.body = o;
                        break;
                    }
                }
                e.length = i + 1;
                return t;
            }
            function l(e, n) {
                var t = false;
                var i = e.length - 1;
                if (C && i >= 0) {
                    var r = e[i].try_inline(n, Ee);
                    if (r) {
                        e[i--] = r;
                        t = true;
                    }
                }
                var a = Se && Te && Te.bfinally ? "try" : Se;
                for (;i >= 0; i--) {
                    var r = e[i].try_inline(n, Ee, true, a);
                    if (!r) continue;
                    e[i] = r;
                    t = true;
                }
                return t;
            }
            function d(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = $e(t[0], t);
                    n[i++] = Oe(an, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof an) {
                        if (t.length >= e.sequences_limit) r();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) E(t, f);
                    } else if (H(s)) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                return i != o;
            }
            function v(e, n) {
                if (!(e instanceof on)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof Ft && de(r)) {
                        n.push(r);
                    } else if (t || j(r)) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function h(e, n) {
                var t = false, i = 0, r;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (r) {
                        if (o instanceof gt) {
                            if (o.value || !k(Ae)) {
                                o.value = u(o.value || Oe(Fi, o)).optimize(n);
                            }
                        } else if (o instanceof Hn) {
                            if (!(o.init instanceof zt)) {
                                var s = false;
                                r.body.walk(new Yi(function(e) {
                                    if (s || e instanceof Un) return true;
                                    if (e instanceof un && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = u(o.init); else {
                                        o.init = r.body;
                                        i--;
                                        t = true;
                                    }
                                }
                            }
                        } else if (o instanceof Rn) {
                            if (!j(o.init)) o.object = u(o.object);
                        } else if (o instanceof Et) {
                            o.condition = u(o.condition);
                        } else if (o instanceof St) {
                            o.expression = u(o.expression);
                        } else if (o instanceof Bn) {
                            o.expression = u(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof Et) {
                        var f = [];
                        var c = v(o.body, f);
                        var l = v(o.alternative, f);
                        if (c !== false && l !== false && f.length > 0) {
                            var p = f.length;
                            f.push(Oe(Et, o, {
                                condition: o.condition,
                                body: c || Oe($n, o.body),
                                alternative: l
                            }));
                            f.unshift(i, 1);
                            [].splice.apply(e, f);
                            a += p;
                            i += p + 1;
                            r = null;
                            t = true;
                            continue;
                        }
                    }
                    e[i++] = o;
                    r = o instanceof an ? o : null;
                }
                e.length = i;
                return t;
                function u(e) {
                    i--;
                    t = true;
                    var n = r.body;
                    return $e(n, [ n, e ]);
                }
            }
            function m(e) {
                if (e instanceof cn) return [ e ];
                if (e instanceof sn) return e.expressions.slice();
            }
            function p(e, c, n) {
                var t = m(c);
                if (!t) return;
                var i = false;
                for (var r = t.length - (n || 0); --r >= 0; ) {
                    var a = t[r];
                    if (!u(a)) continue;
                    var o;
                    if (a.left instanceof ln) {
                        o = t.slice(r + 1);
                    } else if (a.left instanceof Ut && u(a.left.expression)) {
                        o = t.slice(r + 1);
                        var s = a.clone();
                        a = a.left.expression;
                        s.left = s.left.clone();
                        s.left.expression = a.left.clone();
                        o.unshift(s);
                    } else {
                        continue;
                    }
                    if (o.length == 0) continue;
                    if (!y(a.left, a.right, o)) continue;
                    i = true;
                    t = t.slice(0, r).concat(a, o);
                }
                if (e instanceof zt) {
                    n = n || 0;
                    for (var r = e.definitions.length; --r >= 0; ) {
                        var f = e.definitions[r];
                        if (!f.value) continue;
                        if (y(f.name, f.value, t)) i = true;
                        if (g(f, t, n)) i = true;
                        break;
                    }
                    if (e instanceof Ft && b(e.definitions, t, n)) i = true;
                }
                return i && t;
                function u(e) {
                    return e instanceof cn && e.operator == "=";
                }
            }
            function _(e, n) {
                if (!(e instanceof an)) return;
                if (de(n)) return;
                var t = m(e.body);
                if (!t) return;
                var i = [];
                if (!b(i, t.reverse(), 0)) return;
                n.definitions = i.reverse().concat(n.definitions);
                return t.reverse();
            }
            function g(e, n, t) {
                if (!s.option("conditionals")) return;
                if (e.name instanceof ni) return;
                var i = false;
                var r = e.name.definition();
                while (n.length > t) {
                    var a = ie(s, r, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function b(e, n, t) {
                var i = false;
                while (n.length > t) {
                    var r = n[0];
                    if (!(r instanceof cn)) break;
                    if (r.operator != "=") break;
                    var a = r.left;
                    if (!(a instanceof ln)) break;
                    if (qe(a)) break;
                    if (a.scope.resolve() !== Ae) break;
                    var o = a.definition();
                    if (o.scope !== Ae) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = Oe(mi, a, a);
                    e.push(Oe(Pt, r, {
                        name: s,
                        value: r.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function y(e, r, n) {
                var a = new En();
                a.set(e.name, true);
                while (r instanceof cn && r.operator == "=") {
                    if (r.left instanceof ln) a.set(r.left.name, true);
                    r = r.right;
                }
                if (!(r instanceof ai)) return;
                var t = false;
                do {
                    if (!o(n[0])) break;
                    n.shift();
                    t = true;
                } while (n.length);
                return t;
                function o(e) {
                    if (!(e instanceof cn)) return;
                    if (e.operator != "=") return;
                    if (!(e.left instanceof Ut)) return;
                    var n = e.left.expression;
                    if (!(n instanceof ln)) return;
                    if (!a.has(n.name)) return;
                    if (!e.right.is_constant_expression(Ae)) return;
                    var t = e.left.property;
                    if (t instanceof rn) {
                        if (o(t)) t = e.left.property = t.right.clone();
                        t = t.evaluate(s);
                    }
                    if (t instanceof rn) return;
                    t = "" + t;
                    var i = t == "__proto__" || s.has_directive("use strict") ? function(e) {
                        var n = e.key;
                        return typeof n == "string" && n != t && n != "__proto__";
                    } : function(e) {
                        var n = e.key;
                        if (e instanceof ci || e instanceof ui) {
                            return typeof n == "string" && n != t;
                        }
                        return n !== "__proto__";
                    };
                    if (!tn(r.properties, i)) return;
                    r.properties.push(Oe(si, e, {
                        key: t,
                        value: e.right
                    }));
                    return true;
                }
            }
            function w(e) {
                var r = false, a;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var i = e[n];
                    var o = e[t];
                    if (i instanceof zt) {
                        if (o && o.TYPE == i.TYPE) {
                            o.definitions = o.definitions.concat(i.definitions);
                            r = true;
                        } else if (a && a.TYPE == i.TYPE && de(i)) {
                            a.definitions = a.definitions.concat(i.definitions);
                            r = true;
                        } else if (i instanceof Ft) {
                            var s = _(o, i);
                            if (s) {
                                if (s.length) {
                                    o.body = $e(o, s);
                                    t++;
                                }
                                r = true;
                            } else {
                                t++;
                            }
                            e[t] = a = i;
                        } else {
                            e[++t] = i;
                        }
                        continue;
                    } else if (i instanceof gt) {
                        i.value = u(i.value);
                    } else if (i instanceof Hn) {
                        var s = p(o, i.init);
                        if (s) {
                            r = true;
                            i.init = s.length ? $e(i.init, s) : null;
                        } else if (o instanceof Ft && (!i.init || i.init.TYPE == o.TYPE)) {
                            if (i.init) {
                                o.definitions = o.definitions.concat(i.init.definitions);
                            }
                            i = i.clone();
                            a = i.init = o;
                            e[t] = l(i);
                            r = true;
                            continue;
                        } else if (a && i.init && a.TYPE == i.init.TYPE && de(i.init)) {
                            a.definitions = a.definitions.concat(i.init.definitions);
                            i.init = null;
                            r = true;
                        } else if (i.init instanceof Ft) {
                            a = i.init;
                            s = _(o, i.init);
                            if (s) {
                                r = true;
                                if (s.length == 0) {
                                    e[t] = l(i);
                                    continue;
                                }
                                o.body = $e(o, s);
                            }
                        }
                    } else if (i instanceof Yn) {
                        if (a && a.TYPE == i.init.TYPE) {
                            var c = a.definitions.slice();
                            i.init = i.init.definitions[0].name.convert_symbol(ln, function(e, n) {
                                c.push(Oe(Pt, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            a.definitions = c;
                            r = true;
                        }
                        i.object = u(i.object);
                    } else if (i instanceof Et) {
                        i.condition = u(i.condition);
                    } else if (i instanceof an) {
                        var s = p(o, i.body), f;
                        if (s) {
                            r = true;
                            if (!s.length) continue;
                            i.body = $e(i.body, s);
                        } else if (o instanceof zt && (f = e[n + 1]) && o.TYPE == f.TYPE && (f = f.definitions[0]).value) {
                            r = true;
                            f.value = $e(i, [ i.body, f.value ]);
                            continue;
                        }
                    } else if (i instanceof St) {
                        i.expression = u(i.expression);
                    } else if (i instanceof Bn) {
                        i.expression = u(i.expression);
                    }
                    e[++t] = a ? l(i) : i;
                }
                e.length = t + 1;
                return r;
                function u(e) {
                    var n = p(o, e, 1);
                    if (!n) return e;
                    r = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return $e(e, n);
                }
                function l(e) {
                    return e.transform(new Ri(function(e, n, t) {
                        if (e instanceof zt) {
                            if (a === e) return e;
                            if (a.TYPE != e.TYPE) return e;
                            var i = this.parent();
                            if (i instanceof Yn && i.init === e) return e;
                            if (!de(e)) return e;
                            a.definitions = a.definitions.concat(e.definitions);
                            r = true;
                            if (i instanceof Hn && i.init === e) return null;
                            return t ? bn.skip : Oe($n, e);
                        }
                        if (e instanceof jt) return e;
                        if (e instanceof Un) return e;
                        if (!qn(e)) return e;
                    }));
                }
            }
        }
        function z(r, a, o) {
            var s;
            var f = false;
            a.walk(new Yi(function(e, n) {
                if (e instanceof pt) {
                    e.extends = null;
                    e.properties = [];
                    u(e);
                    return true;
                }
                if (e instanceof zt) {
                    var t = [];
                    if (e.remove_initializers(r, t)) {
                        rn.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        u(e);
                    }
                    return true;
                }
                if (e instanceof ot) {
                    u(e);
                    return true;
                }
                if (e instanceof Un) return true;
                if (e instanceof zn) {
                    var i = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(Oe(on, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = i;
                    return true;
                }
                if (!(e instanceof wt)) f = true;
            }));
            if (f) rn.warn("Dropping unreachable code [{file}:{line},{col}]", a.start);
            function u(e) {
                if (s) {
                    s.push(e);
                    if (!S(e)) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function ze(e, n) {
            return e == null || e.is_undefined || e instanceof Fi || e instanceof fn && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(rn, hn);
            e(ei, mn);
            e(cn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(Wn, mn);
            e(ai, mn);
            e(zi, mn);
            e(sn, function() {
                return this.tail_node().is_truthy();
            });
            e(ln, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = hn;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(rn, mn);
            e(ei, hn);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof Di) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                  case "**":
                    return true;

                  default:
                    return false;
                }
            }
            e(cn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(un, function() {
                return n(this.operator, this.left, this.right);
            });
            e(Di, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(Wn, hn);
            e(ai, hn);
            e(zi, hn);
            e(sn, function() {
                return this.tail_node().is_negative_zero();
            });
            e(ln, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = mn;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(fn, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            rn.DEFMETHOD("may_throw_on_access", function(e, n) {
                return !e.option("pure_getters") || this._dot_throw(e, n);
            });
            function r(e, n) {
                return n || /strict/.test(e.option("pure_getters"));
            }
            e(rn, r);
            e(ei, hn);
            e(cn, function(e) {
                var n = this.operator;
                var t = this.left;
                var i = this.right;
                if (n != "=") {
                    return Ce[n.slice(0, -1)] && (t._dot_throw(e) || i._dot_throw(e));
                }
                if (!i._dot_throw(e)) return false;
                if (!(t instanceof ln)) return true;
                if (i instanceof un && i.operator == "||" && t.name == i.left.name) {
                    return i.right._dot_throw(e);
                }
                return true;
            });
            e(un, function(e) {
                return Ce[this.operator] && (this.left._dot_throw(e) || this.right._dot_throw(e));
            });
            e(lt, hn);
            e(Kt, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(Di, hn);
            e(Vt, function(e, n) {
                if (!r(e, n)) return false;
                var t = this.expression;
                if (t instanceof ln) t = t.fixed_value();
                return !(this.property == "prototype" && O(t));
            });
            e(Wn, hn);
            e(Ci, mn);
            e(ai, function(n, t) {
                return r(n, t) && !tn(this.properties, function(e) {
                    if (!(e instanceof si)) return false;
                    return !(e.key === "__proto__" && e.value._dot_throw(n, t));
                });
            });
            e(ki, function(e, n) {
                return r(e, n) && !this.scope.resolve().new;
            });
            e(sn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(ln, function(e, n) {
                if (this.is_undefined) return true;
                if (!r(e, n)) return false;
                if (qe(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var t = this.definition();
                if (Fe(t) && !t.scope.rest && tn(t.scope.argnames, function(e) {
                    return e instanceof _i;
                })) return t.scope.uses_arguments > 2;
                var i = this.fixed_value();
                if (!i) return true;
                this._dot_throw = mn;
                if (i._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = hn;
                return false;
            });
            e(fn, function() {
                return this.operator == "void";
            });
            e(Xt, hn);
            e(Fi, mn);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(rn, hn);
            e(ei, mn);
            function t(e, n, t) {
                switch (n) {
                  case "&&":
                    return t.left.is_defined(e) && t.right.is_defined(e);

                  case "||":
                    return t.left.is_truthy() || t.right.is_defined(e);

                  case "??":
                    return t.left.is_defined(e) || t.right.is_defined(e);

                  default:
                    return true;
                }
            }
            e(cn, function(e) {
                var n = this.operator;
                if (n == "=") return this.right.is_defined(e);
                return t(e, n.slice(0, -1), this);
            });
            e(un, function(e) {
                return t(e, this.operator, this);
            });
            e(Kt, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(Di, mn);
            e(Pi, hn);
            e(Wn, mn);
            e(ai, mn);
            e(sn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(ln, function(e) {
                if (this.is_undefined) return false;
                if (qe(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = hn;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(fn, function() {
                return this.operator != "void";
            });
            e(Xt, mn);
            e(Fi, hn);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(rn, hn);
            e(cn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = kn("in instanceof == != === !== < <= >= >");
            e(un, function(e) {
                return n[this.operator] || Ce[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Ni, mn);
            var t = kn("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(Rt, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Vt && (t[n.property] || n.property == "test" && n.expression instanceof zi);
            });
            e(Kt, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(Lt, hn);
            e(sn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(ln, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = hn;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = kn("! delete");
            e(fn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(rn, hn);
            var n = kn("- * / % ** & | ^ << >> >>>");
            e(cn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(un, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = kn([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(Rt, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Vt && (t[n.property] || qe(n.expression) && n.expression.name == "Math");
            });
            e(Kt, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(Lt, hn);
            e($i, mn);
            e(sn, function(e) {
                return this.tail_node().is_number(e);
            });
            e(ln, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = hn;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = kn("+ - ~ ++ --");
            e(Jt, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(rn, hn);
            e(cn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(un, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = kn([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(Rt, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Vt && t[n.property];
            });
            e(Kt, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(sn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(Oi, mn);
            e(ln, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = hn;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(Ai, function(e) {
                return !this.tag || Te(e, this.tag);
            });
            e(fn, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var Ce = kn("&& || ??");
        (function(e) {
            function r(e, n) {
                if (e instanceof rn) return e.clone(true);
                if (Array.isArray(e)) return Oe(ei, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (Sn(e, i)) {
                        t.push(Oe(si, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return Oe(ai, n, {
                        properties: t
                    });
                }
                return ue(e, n);
            }
            function o(e) {
                rn.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            Vn.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie: a.option("ie")
                });
                return this.transform(new Ri(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof Ut)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (Ki(i, r)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(rn, vn);
            e(Vt, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(pi, function(e) {
                if (!this.definition().global) return;
                if (Sn(e.option("global_defs"), this.name)) o(this);
            });
            e(ln, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (Sn(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function ve(e, n, t) {
            var i = n.print_to_string().length - e.print_to_string().length;
            return i < (t || 0) ? n : e;
        }
        function u(e, n, t) {
            return ve(Oe(an, e, {
                body: e
            }), Oe(an, n, {
                body: n
            }), t).body;
        }
        function he(e, n, t, i) {
            return (Tn(e) ? u : ve)(n, t, i);
        }
        function s(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = kn(n[e]);
            });
            return t;
        }
        function o(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof On)) return t;
            }
        }
        function f() {
            if (this.value) return Oe(bt, this.value, {
                value: this.value
            });
            return o(this.body);
        }
        et.DEFMETHOD("first_statement", f);
        nt.DEFMETHOD("first_statement", f);
        Wn.DEFMETHOD("first_statement", function() {
            return o(this.body);
        });
        Wn.DEFMETHOD("length", function() {
            var e = this.argnames;
            for (var n = 0; n < e.length; n++) {
                if (e[n] instanceof Yt) break;
            }
            return n;
        });
        function me(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = ue(t, n).optimize(e);
            return he(e, n, t, e.eval_threshold);
        }
        var p = [ "constructor", "toString", "valueOf" ];
        var b = s({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(p),
            Boolean: p,
            Function: p,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(p),
            Object: p,
            RegExp: [ "exec", "test" ].concat(p),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(p)
        });
        var y = s({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode", "raw" ]
        });
        function Le(e) {
            if (!(e instanceof Vt)) return false;
            var n = e.expression;
            if (!qe(n)) return false;
            var t = y[n.name];
            return t && (t[e.property] || n.name == "Math" && e.property == "random");
        }
        (function(e) {
            e(rn, hn);
            e(Di, mn);
            e(zi, hn);
            var n = kn("! ~ - + void");
            e(fn, function() {
                return n[this.operator] && this.expression instanceof Di;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            rn.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var i = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return i;
                if (!i || i instanceof RegExp) return i;
                if (typeof i == "function" || typeof i == "object") return this;
                return i;
            });
            var m = new Yi(function(e) {
                if (e instanceof cn) u(e.left);
                if (e instanceof Jt && Vi[e.operator]) u(e.expression);
            });
            function u(e) {
                if (e instanceof ti) {
                    e.elements.forEach(u);
                } else if (e instanceof ri) {
                    e.properties.forEach(function(e) {
                        u(e.value);
                    });
                } else if (e instanceof Ut) {
                    u(e.expression);
                } else if (e instanceof ln) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(An, function() {
                throw new Error(wn("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(Gn, _n);
            e(qi, _n);
            e(lt, _n);
            e(rn, _n);
            e(Di, function() {
                return this.value;
            });
            e(cn, function(e, n, t, i) {
                var r = this.left;
                if (!n) {
                    if (!(r instanceof ln)) return this;
                    if (!Sn(r, "_eval")) {
                        if (!r.fixed) return this;
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                        if (a.single_use == "m") return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!Sn(r, "_eval") && r instanceof ln && r.fixed && r.definition().fixed) {
                    s = r;
                } else if (o == "=") {
                    s = this.right;
                } else {
                    s = Oe(un, this, {
                        operator: o.slice(0, -1),
                        left: r,
                        right: this.right
                    });
                }
                r.walk(m);
                var f = s._eval(e, n, t, i);
                if (typeof f == "object") return this;
                u(r);
                return f;
            });
            e(sn, function(e, n, t, i) {
                if (!n) return this;
                var r = this.expressions;
                for (var a = 0, o = r.length - 1; a < o; a++) {
                    r[a].walk(m);
                }
                var s = r[o];
                var f = s._eval(e, n, t, i);
                return f === s ? this : f;
            });
            e(Wn, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(ei, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof Pi) return this;
                        var s = o._eval(e, n, t, i);
                        if (o === s) return this;
                        r.push(s);
                    }
                    return r;
                }
                return this;
            });
            e(ai, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof si)) return this;
                        var s = o.key;
                        if (s instanceof rn) {
                            s = s._eval(e, n, t, i);
                            if (s === o.key) return this;
                        }
                        switch (s) {
                          case "__proto__":
                          case "toString":
                          case "valueOf":
                            return this;
                        }
                        r[s] = o.value._eval(e, n, t, i);
                        if (r[s] === o.value) return this;
                    }
                    return r;
                }
                return this;
            });
            var f = kn("! typeof void");
            e(fn, function(e, n, t, i) {
                var r = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (r instanceof Wn || r instanceof ln && r.fixed_value() instanceof Wn)) {
                    return typeof function() {};
                }
                var o = r instanceof ln && r.definition();
                if (!f[a] && !(o && o.fixed)) i++;
                r.walk(m);
                var s = r._eval(e, n, t, i);
                if (s === r) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                    }
                    if (Sn(r, "_eval")) s = +(a[0] + 1) + +s;
                    u(r);
                    return s;
                }
                return this;
            });
            e(Xt, function(e, n, t, i) {
                var r = this.expression;
                if (!(r instanceof ln)) {
                    if (!n) return this;
                } else if (!Sn(r, "_eval")) {
                    if (!r.fixed) return this;
                    if (!n) {
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                    }
                }
                if (!(r instanceof ln && r.definition().fixed)) i++;
                r.walk(m);
                var o = r._eval(e, n, t, i);
                if (o === r) return this;
                u(r);
                return +o;
            });
            var c = kn("&& || === !==");
            e(un, function(e, n, t, i) {
                if (!c[this.operator]) i++;
                var r = this.left._eval(e, n, t, i);
                if (r === this.left) return this;
                if (this.operator == (r ? "||" : "&&")) return r;
                var a = n && !(r && typeof r == "object");
                var o = this.right._eval(e, a, t, i);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = r && o;
                    break;

                  case "||":
                    s = r || o;
                    break;

                  case "??":
                    s = r == null ? o : r;
                    break;

                  case "|":
                    s = r | o;
                    break;

                  case "&":
                    s = r & o;
                    break;

                  case "^":
                    s = r ^ o;
                    break;

                  case "+":
                    s = r + o;
                    break;

                  case "-":
                    s = r - o;
                    break;

                  case "*":
                    s = r * o;
                    break;

                  case "/":
                    s = r / o;
                    break;

                  case "%":
                    s = r % o;
                    break;

                  case "<<":
                    s = r << o;
                    break;

                  case ">>":
                    s = r >> o;
                    break;

                  case ">>>":
                    s = r >>> o;
                    break;

                  case "==":
                    s = r == o;
                    break;

                  case "===":
                    s = r === o;
                    break;

                  case "!=":
                    s = r != o;
                    break;

                  case "!==":
                    s = r !== o;
                    break;

                  case "<":
                    s = r < o;
                    break;

                  case "<=":
                    s = r <= o;
                    break;

                  case ">":
                    s = r > o;
                    break;

                  case ">=":
                    s = r >= o;
                    break;

                  case "**":
                    s = Math.pow(r, o);
                    break;

                  case "in":
                    if (o && typeof o == "object" && Sn(o, r)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(Bn) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(r), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e[^e]+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(Kt, function(e, n, t, i) {
                var r = this.condition._eval(e, n, t, i);
                if (r === this.condition) return this;
                var a = r ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, i);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var i = false;
                    t[0].walk(new Yi(function(e) {
                        if (i) return true;
                        if (e === n) return i = true;
                        if (e instanceof Un) return true;
                    }));
                    return i;

                  default:
                    return e <= t.depth;
                }
            }
            e(ln, function(e, n, t, i) {
                var r = this.fixed_value();
                if (!r) return this;
                var a;
                if (Sn(r, "_eval")) {
                    a = r._eval();
                } else {
                    this._eval = _n;
                    a = r._eval(e, n, t, i);
                    delete this._eval;
                    if (a === r) return this;
                    r._eval = function() {
                        return a;
                    };
                    t.push(r);
                }
                return a && typeof a == "object" && !o(this, i) ? this : a;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var l = s({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var p = kn("global ignoreCase multiline source");
            e(Ut, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r;
                    var a = this.expression;
                    if (!qe(a)) {
                        r = a._eval(e, n, t, i + 1);
                        if (r == null || r === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof rn) {
                        o = o._eval(e, n, t, i);
                        if (o === this.property) return this;
                    }
                    if (r === undefined) {
                        var s = l[a.name];
                        if (!s || !s[o]) return this;
                        r = _[a.name];
                    } else if (r instanceof RegExp) {
                        if (!p[o]) return this;
                    } else if (typeof r == "object") {
                        if (!Sn(r, o)) return this;
                    } else if (typeof r == "function") switch (o) {
                      case "name":
                        return r.node.name ? r.node.name.name : "";

                      case "length":
                        return r.node.length();

                      default:
                        return this;
                    }
                    return r[o];
                }
                return this;
            });
            function g(e, n, t, i, r) {
                var a = [];
                for (var o = 0; o < e.length; o++) {
                    var s = e[o];
                    var f = s._eval(n, t, i, r);
                    if (s === f) return;
                    a.push(f);
                }
                return a;
            }
            e(Rt, function(i, r, a, o) {
                var e = this.expression;
                var n = e instanceof ln ? e.fixed_value() : e;
                if (n instanceof et || n instanceof ut || n instanceof rt) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(i)) return this;
                    var s = g(this.args, i, r, a, o);
                    if (!tn(n.argnames, function(e, n) {
                        if (e instanceof Yt) {
                            if (!s) return false;
                            if (s[n] === undefined) {
                                var t = e.value._eval(i, r, a, o);
                                if (t === e.value) return false;
                                s[n] = t;
                            }
                            e = e.name;
                        }
                        return !(e instanceof ni);
                    })) return this;
                    if (n.rest instanceof ni) return this;
                    if (!s && !r) return this;
                    var c = n.first_statement();
                    if (!(c instanceof bt)) {
                        if (r) {
                            n.walk(m);
                            var l = false;
                            n.evaluating = true;
                            Cn(n, new Yi(function(e) {
                                if (l) return true;
                                if (e instanceof bt) {
                                    if (e.value && e.value._eval(i, true, a, o) !== undefined) {
                                        l = true;
                                    }
                                    return true;
                                }
                                if (e instanceof Un && e !== n) return true;
                            }));
                            n.evaluating = false;
                            if (!l) return;
                        }
                        return this;
                    }
                    var t = c.value;
                    if (!t) return;
                    var p = [];
                    if (!s || tn(n.argnames, function(e, n) {
                        return h(e, s[n]);
                    }) && !(n.rest && !h(n.rest, s.slice(n.argnames.length))) || r) {
                        if (r) n.argnames.forEach(function(e) {
                            if (e instanceof Yt) e.value.walk(m);
                        });
                        n.evaluating = true;
                        t = t._eval(i, r, a, o);
                        n.evaluating = false;
                    }
                    p.forEach(function(e) {
                        delete e._eval;
                    });
                    return t === c.value ? this : t;
                } else if (i.option("unsafe") && e instanceof Ut) {
                    var f = e.property;
                    if (f instanceof rn) {
                        f = f._eval(i, r, a, o);
                        if (f === e.property) return this;
                    }
                    var t;
                    var u = e.expression;
                    if (qe(u)) {
                        var d = y[u.name];
                        if (!d || !d[f]) return this;
                        t = _[u.name];
                    } else {
                        t = u._eval(i, r, a, o + 1);
                        if (t == null || t === u) return this;
                        var v = b[t.constructor.name];
                        if (!v || !v[f]) return this;
                        if (t instanceof RegExp && t.global && !(u instanceof zi)) return this;
                    }
                    var s = g(this.args, i, r, a, o);
                    if (!s) return this;
                    if (f == "replace" && typeof s[1] == "function") return this;
                    try {
                        return t[f].apply(t, s);
                    } catch (e) {
                        rn.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (t instanceof RegExp) t.lastIndex = 0;
                    }
                }
                return this;
                function h(e, n) {
                    if (e instanceof Yt) e = e.name;
                    var t = e.definition();
                    if (t.orig[t.orig.length - 1] !== e) return false;
                    var i = n;
                    t.references.forEach(function(e) {
                        e._eval = function() {
                            return i;
                        };
                        p.push(e);
                    });
                    return true;
                }
            });
            e(Lt, _n);
            e(Ai, function(e, n, t, i) {
                if (!e.option("templates")) return this;
                if (this.tag) {
                    if (!Te(e, this.tag)) return this;
                    f = function(e) {
                        return e;
                    };
                }
                var r = g(this.expressions, e, n, t, i);
                if (!r) return this;
                var a = false;
                var o = f(this.strings[0]);
                for (var s = 0; s < r.length; s++) {
                    o += r[s] + f(this.strings[s + 1]);
                }
                if (!a) return o;
                this._eval = _n;
                return this;
                function f(e) {
                    e = Ae(e);
                    if (typeof e != "string") a = true;
                    return e;
                }
            });
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function a(e) {
                return Oe(fn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = a(e);
                if (t) {
                    var r = Oe(an, n, {
                        body: n
                    });
                    return ve(i, r) === r ? n : i;
                }
                return ve(i, n);
            }
            e(rn, function() {
                return a(this);
            });
            e(An, function() {
                throw new Error("Cannot negate a statement");
            });
            e(un, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return a(this);
            });
            e(dt, function() {
                return a(this);
            });
            e(Kt, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(Jn, function() {
                return a(this);
            });
            e(sn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return $e(this, n);
            });
            e(fn, function() {
                if (this.operator == "!") return this.expression;
                return a(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var d = kn("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        var v = kn("Map Set WeakMap WeakSet");
        Rt.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (qe(n)) {
                    if (d[n.name]) return true;
                    if (this instanceof Lt && v[n.name]) return true;
                }
                if (Le(n)) return true;
            }
            return e.option("annotations") && this.pure || !e.pure_funcs(this);
        });
        Ai.DEFMETHOD("is_expr_pure", function(e) {
            var n = this.tag;
            if (!n) return true;
            if (e.option("unsafe")) {
                if (qe(n) && d[n.name]) return true;
                if (n instanceof Vt && qe(n.expression)) {
                    var t = y[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return !e.pure_funcs(this);
        });
        rn.DEFMETHOD("is_call_pure", hn);
        Rt.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof Vt)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof ei) {
                i = b.Array;
            } else if (t.is_boolean(e)) {
                i = b.Boolean;
            } else if (t.is_number(e)) {
                i = b.Number;
            } else if (t instanceof zi) {
                i = b.RegExp;
            } else if (t.is_string(e)) {
                i = b.String;
                if (r == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = b.Object;
            }
            return i && i[r];
        });
        (function(e) {
            e(rn, hn);
            e(ei, mn);
            e(cn, function() {
                switch (this.operator) {
                  case "=":
                    return this.right.safe_to_spread();

                  case "&&=":
                  case "||=":
                  case "??=":
                    return this.left.safe_to_spread() && this.right.safe_to_spread();
                }
                return true;
            });
            e(un, function() {
                return !Ce[this.operator] || this.left.safe_to_spread() && this.right.safe_to_spread();
            });
            e(Di, mn);
            e(Wn, mn);
            e(ai, function() {
                return tn(this.properties, function(e) {
                    return !(e instanceof ci || e instanceof Gt);
                });
            });
            e(ki, mn);
            e(sn, function() {
                return this.tail_node().safe_to_spread();
            });
            e(ln, function() {
                var e = this.fixed_value();
                return e && e.safe_to_spread();
            });
            e(Jt, mn);
        })(function(e, n) {
            e.DEFMETHOD("safe_to_spread", n);
        });
        (function(e) {
            function t(e, n, t) {
                return !tn(e, t ? function(e) {
                    return e instanceof Gt ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function n(e, n) {
                var t = e.expression;
                return !t.is_string(n) || t.has_side_effects(n);
            }
            e(rn, mn);
            e(ei, function(e) {
                return t(this.elements, e, n);
            });
            e(cn, function(e) {
                var n = this.left;
                if (!(n instanceof Ut)) return true;
                var t = n.expression;
                return !(t instanceof ki) || !t.scope.resolve().new || n instanceof Wt && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(un, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !Be(this.right);
            });
            e(Mn, function(e) {
                return t(this.body, e);
            });
            e(Rt, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return t(this.args, e, n);
            });
            e(Dt, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(lt, function(e) {
                var n = this.extends;
                if (n) {
                    if (n instanceof ln) n = n.fixed_value();
                    if (!h(n)) return true;
                }
                return t(this.properties, e);
            });
            e(vt, function(e) {
                return this.key instanceof rn && this.key.has_side_effects(e) || this.static && this.value && this.value.has_side_effects(e);
            });
            e(Kt, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(Di, hn);
            e(zt, function(e) {
                return t(this.definitions, e);
            });
            e(ti, function(e) {
                return t(this.elements, e);
            });
            e(ii, function(e) {
                return this.key instanceof rn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(ri, function(e) {
                return t(this.properties, e);
            });
            e(Vt, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e($n, hn);
            e(Et, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(Fn, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Wn, hn);
            e(ai, function(e) {
                return t(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return !t.safe_to_spread() || t.has_side_effects(n);
                });
            });
            e(ki, hn);
            e(oi, function(e) {
                return this.key instanceof rn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(sn, function(e) {
                return t(this.expressions, e);
            });
            e(an, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Wt, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(St, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(pi, hn);
            e(ln, function(e) {
                return !this.is_declared(e) || !De(this, e);
            });
            e(Ai, function(e) {
                return !this.is_expr_pure(e) || t(this.expressions, e);
            });
            e(Ot, function(e) {
                return t(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(Jt, function(e) {
                return Xi[this.operator] || this.expression.has_side_effects(e);
            });
            e(Pt, function() {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(rn, mn);
            e(Di, hn);
            e($n, hn);
            e(Wn, hn);
            e(ki, hn);
            e(pi, hn);
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            function i(e, n) {
                if (e.may_throw(n)) return true;
                if (e instanceof ln) e = e.fixed_value();
                if (!(e instanceof Wn)) return true;
                if (t(e.argnames, n)) return true;
                if (t(e.body, n)) return true;
                return Xn(e) && e.value && e.value.may_throw(n);
            }
            e(ei, function(e) {
                return t(this.elements, e);
            });
            e(cn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof ln) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(Qt, function(e) {
                return this.expression.may_throw(e);
            });
            e(un, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !Be(this.right);
            });
            e(Mn, function(e) {
                return t(this.body, e);
            });
            e(Rt, function(e) {
                if (t(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                this.may_throw = mn;
                var n = i(this.expression, e);
                delete this.may_throw;
                return n;
            });
            e(Dt, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(Kt, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(Yt, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
            e(zt, function(e) {
                return t(this.definitions, e);
            });
            e(Vt, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(Yn, function(e) {
                if (this.init.may_throw(e)) return true;
                var n = this.object;
                if (n.may_throw(e)) return true;
                n = n.tail_node();
                if (!(n instanceof ei || n.is_string(e))) return true;
                return this.body.may_throw(e);
            });
            e(Et, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(Fn, function(e) {
                return this.body.may_throw(e);
            });
            e(ai, function(e) {
                return t(this.properties, e);
            });
            e(oi, function(e) {
                return this.value.may_throw(e) || this.key instanceof rn && this.key.may_throw(e);
            });
            e(bt, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(sn, function(e) {
                return t(this.expressions, e);
            });
            e(an, function(e) {
                return this.body.may_throw(e);
            });
            e(Wt, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(St, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(ln, function(e) {
                return !this.is_declared(e) || !De(this, e);
            });
            e(Ai, function(e) {
                if (t(this.expressions, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (!this.tag) return false;
                this.may_throw = mn;
                var n = i(this.tag, e);
                delete this.may_throw;
                return n;
            });
            e(Ot, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : t(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(Jt, function(e) {
                return this.expression.may_throw(e) && !(this.operator == "typeof" && this.expression instanceof ln);
            });
            e(Pt, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (!e[t].is_constant_expression(n)) return false;
                return true;
            }
            e(rn, hn);
            e(ei, function(e) {
                return t(this.elements, e);
            });
            e(un, function(e) {
                return this.left.is_constant_expression(e) && this.right.is_constant_expression(e) && (this.operator != "in" || Be(this.right));
            });
            e(lt, function(e) {
                var n = this.extends;
                if (n && !h(n)) return false;
                return t(this.properties, e);
            });
            e(vt, function(e) {
                return typeof this.key == "string" && (!this.value || this.value.is_constant_expression(e));
            });
            e(Di, mn);
            e(Wn, function(r) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new Yi(function(e, n) {
                    if (!o) return true;
                    if (e instanceof zn) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof ln) {
                        if (a.inlined || e.redef) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (pn(t.scope, s)) return true;
                        if (r && !t.redefined()) {
                            var i = r.find_variable(e.name);
                            if (i ? i === t : t.undeclared) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof ki) {
                        if (Xn(a) && tn(s, function(e) {
                            return !(e instanceof Un) || Xn(e);
                        })) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(ai, function(e) {
                return t(this.properties, e);
            });
            e(oi, function(e) {
                return typeof this.key == "string" && this.value.is_constant_expression(e);
            });
            e(Jt, function(e) {
                return this.expression.is_constant_expression(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function F(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(An, gn);
            e(_t, _n);
            function n() {
                var e = this.body.length;
                return e > 0 && F(this.body[e - 1]);
            }
            e(on, n);
            e(Tt, n);
            e(Et, function() {
                return this.alternative && F(this.body) && F(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var m = kn([ "use asm", "use strict" ]);
        e(On, function(e, n) {
            if (n.option("directives") && (!m[e.value] || n.has_directive(e.value) !== e)) {
                return Oe($n, e);
            }
            return e;
        });
        e(Dn, function(e, n) {
            if (n.option("drop_debugger")) return Oe($n, e);
            return e;
        });
        e(Fn, function(e, n) {
            if (n.option("dead_code") && e.body instanceof xt && n.loopcontrol_target(e.body) === e.body) {
                return Oe($n, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(wt, function(e, n) {
            if (!n.option("dead_code")) return e;
            var t = e.label;
            if (t) {
                var i = n.loopcontrol_target(e);
                e.label = null;
                if (n.loopcontrol_target(e) === i) {
                    xn(t.thedef.references, e);
                } else {
                    e.label = t;
                }
            }
            return e;
        });
        e(Mn, function(e, n) {
            e.body = c(e.body, n);
            return e;
        });
        function Z(e, n, t) {
            switch (e.body.length) {
              case 0:
                return t ? bn.skip : Oe($n, e);

              case 1:
                var i = e.body[0];
                if (!S(i)) return e;
                if (n instanceof Pn && i instanceof ot) return e;
                return i;
            }
            return e;
        }
        e(on, function(e, n) {
            e.body = c(e.body, n);
            return Z(e, n.parent());
        });
        function _(e, n) {
            if (!n.option("rests")) return;
            if (e.uses_arguments) return;
            if (!(e.rest instanceof ti)) return;
            if (!n.drop_fargs(e, n.parent())) return;
            e.argnames = e.argnames.concat(e.rest.elements);
            e.rest = e.rest.rest;
        }
        e(Wn, function(e, n) {
            _(e, n);
            e.body = c(e.body, n);
            return e;
        });
        function g(e, n) {
            if (!n.option("arrows")) return e;
            _(e, n);
            var t = c(e.value ? [ e.first_statement() ] : e.body, n);
            switch (t.length) {
              case 1:
                var i = t[0];
                if (i instanceof bt) {
                    e.body.length = 0;
                    e.value = i.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        }
        e(et, g);
        e(nt, g);
        e(rt, function(n, e) {
            _(n, e);
            n.body = c(n.body, e);
            var t = e.parent();
            if (e.option("inline")) for (var i = 0; i < n.body.length; i++) {
                var r = n.body[i];
                if (r instanceof On) continue;
                if (r instanceof bt) {
                    if (i != n.body.length - 1) break;
                    var a = r.value;
                    if (!a || a.TYPE != "Call") break;
                    if (a.is_expr_pure(e)) break;
                    var o = a.expression;
                    if (o instanceof ln) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof ut || o instanceof rt)) break;
                    if (o.rest) break;
                    if (o.uses_arguments) break;
                    if (o === a.expression) {
                        if (o.parent_scope !== n) break;
                        if (!tn(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.name && (t instanceof mt || t instanceof fi) && t.value === e.self()) break;
                    if (o.contains_this()) break;
                    var s = o.argnames.length;
                    if (s > 0 && e.option("inline") < 2) break;
                    if (s > n.argnames.length) break;
                    if (!tn(n.argnames, function(e) {
                        return e instanceof _i;
                    })) break;
                    if (!tn(a.args, function(e) {
                        return !(e instanceof Gt);
                    })) break;
                    for (var f = 0; f < s; f++) {
                        var u = a.args[f];
                        if (!(u instanceof ln)) break;
                        if (u.definition() !== n.argnames[f].definition()) break;
                    }
                    if (f < s) break;
                    for (;f < a.args.length; f++) {
                        if (a.args[f].has_side_effects(e)) break;
                    }
                    if (f < a.args.length) break;
                    if (s < n.argnames.length && !e.drop_fargs(n, t)) {
                        if (!e.drop_fargs(o, a)) break;
                        do {
                            o.argnames.push(o.make_var(_i, o, "argument_" + s));
                        } while (++s < n.argnames.length);
                    }
                    return a.expression;
                }
                break;
            }
            return n;
        });
        var C = kn("arguments await yield");
        Un.DEFMETHOD("merge_variables", function(y) {
            if (!y.option("merge_vars")) return;
            var w, x, v = {}, k = this;
            var o = [], s = [], f = 0;
            var E = new En();
            var h = Object.create(null);
            var u = Object.create(null);
            var m = new Yi(function(r, e) {
                if (r instanceof cn) {
                    var n = r.left;
                    var t = r.right;
                    if (n instanceof ni) {
                        t.walk(m);
                        var i = new Yi(function(e) {
                            if (e instanceof ni) return;
                            if (e instanceof Yt) {
                                _();
                                e.value.walk(m);
                                g();
                                e.name.walk(i);
                            } else if (e instanceof ii) {
                                if (e.key instanceof rn) {
                                    _();
                                    v.block = e;
                                    e.key.walk(m);
                                    e.value.walk(i);
                                    g();
                                } else {
                                    e.value.walk(i);
                                }
                            } else if (e instanceof ln) {
                                b(e);
                            } else {
                                e.walk(m);
                            }
                            return true;
                        });
                        n.walk(i);
                        return true;
                    }
                    if (Ce[r.operator.slice(0, -1)]) {
                        n.walk(m);
                        _();
                        t.walk(m);
                        if (n instanceof ln) b(n);
                        g();
                        return true;
                    }
                    if (n instanceof ln) {
                        if (r.operator != "=") b(n, true);
                        t.walk(m);
                        b(n);
                        return true;
                    }
                    return;
                }
                if (r instanceof un) {
                    if (!Ce[r.operator]) return;
                    r.left.walk(m);
                    _();
                    r.right.walk(m);
                    g();
                    return true;
                }
                if (r instanceof xt) {
                    var a = m.loopcontrol_target(r);
                    if (!(a instanceof Pn)) S(a);
                    return true;
                }
                if (r instanceof Rt) {
                    var o = r.expression;
                    var s = o.tail_node();
                    if (!O(s)) {
                        e();
                        return d(o);
                    }
                    if (o !== s) o.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(m);
                    });
                    r.args.forEach(function(e) {
                        e.walk(m);
                    });
                    s.walk(m);
                    return true;
                }
                if (r instanceof Kt) {
                    r.condition.walk(m);
                    _();
                    r.consequent.walk(m);
                    g();
                    _();
                    r.alternative.walk(m);
                    g();
                    return true;
                }
                if (r instanceof kt) {
                    var a = m.loopcontrol_target(r);
                    if (a instanceof Nn) S(a);
                    return true;
                }
                if (r instanceof Nn) {
                    _();
                    v.block = r;
                    v.loop = true;
                    var f = v;
                    r.body.walk(m);
                    if (v.inserted === r) v = f;
                    r.condition.walk(m);
                    g();
                    return true;
                }
                if (r instanceof Hn) {
                    if (r.init) r.init.walk(m);
                    _();
                    v.block = r;
                    v.loop = true;
                    if (r.condition) r.condition.walk(m);
                    r.body.walk(m);
                    if (r.step) r.step.walk(m);
                    g();
                    return true;
                }
                if (r instanceof Yn) {
                    r.object.walk(m);
                    _();
                    v.block = r;
                    v.loop = true;
                    r.init.walk(m);
                    r.body.walk(m);
                    g();
                    return true;
                }
                if (r instanceof Et) {
                    r.condition.walk(m);
                    _();
                    r.body.walk(m);
                    g();
                    if (r.alternative) {
                        _();
                        r.alternative.walk(m);
                        g();
                    }
                    return true;
                }
                if (r instanceof Fn) {
                    _();
                    v.block = r;
                    var f = v;
                    r.body.walk(m);
                    if (v.inserted === r) v = f;
                    g();
                    return true;
                }
                if (r instanceof Un) {
                    _();
                    v.block = r;
                    if (r === k) x = v;
                    if (r instanceof Wn) {
                        if (r.name) h[r.name.definition().id] = false;
                        var i = r.uses_arguments && !m.has_directive("use strict") ? function(e) {
                            if (e instanceof _i) h[e.definition().id] = false;
                        } : function(e) {
                            if (e instanceof _i) b(e);
                        };
                        var c = new Yi(function(e) {
                            if (e instanceof pi) h[e.definition().id] = false;
                            if (!(e instanceof ln)) return;
                            var n = e.definition();
                            var t = r.variables.get(e.name);
                            if (t && (t === n || n.undeclared || r.parent_scope.find_variable(e.name) === n)) {
                                h[n.id] = false;
                                h[t.id] = false;
                            } else {
                                var i = v;
                                g();
                                b(e, true);
                                v = i;
                            }
                            return true;
                        });
                        r.argnames.forEach(function(e) {
                            e.mark_symbol(i, c);
                        });
                        if (r.rest) r.rest.mark_symbol(i, c);
                    }
                    Zn(r, m);
                    g();
                    return true;
                }
                if (r instanceof Wt) {
                    var o = r.expression;
                    if (r.optional) {
                        o.walk(m);
                        _();
                        r.property.walk(m);
                        g();
                    } else {
                        e();
                    }
                    return d(o);
                }
                if (r instanceof St) {
                    r.expression.walk(m);
                    var f = v;
                    r.body.forEach(function(e) {
                        if (e instanceof At) return;
                        e.expression.walk(m);
                        if (f === v) _();
                    });
                    v = f;
                    r.body.forEach(function(e) {
                        _();
                        v.block = r;
                        var n = v;
                        Cn(e, m);
                        if (v.inserted === r) v = n;
                        g();
                    });
                    return true;
                }
                if (r instanceof di || r instanceof hi) {
                    h[r.definition().id] = false;
                    return true;
                }
                if (r instanceof ln) {
                    b(r, true);
                    return true;
                }
                if (r instanceof Ot) {
                    var l = w;
                    w = r;
                    var f = v;
                    Cn(r, m);
                    v = f;
                    if (r.bcatch) {
                        if (r.bcatch.argname) r.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof wi) {
                                var n = e.definition();
                                h[n.id] = false;
                                if (n = n.redefined()) h[n.id] = false;
                            }
                        }, m);
                        if (r.bfinally || (w = l)) {
                            Cn(r.bcatch, m);
                        } else {
                            _();
                            Cn(r.bcatch, m);
                            g();
                        }
                    }
                    w = l;
                    v = f;
                    if (r.bfinally) r.bfinally.walk(m);
                    return true;
                }
                if (r instanceof Jt) {
                    if (!Vi[r.operator]) return;
                    var p = r.expression;
                    if (!(p instanceof ln)) return;
                    b(p, true);
                    return true;
                }
                if (r instanceof Pt) {
                    var u = r.value;
                    if (u) {
                        u.walk(m);
                    } else {
                        u = v.block instanceof Yn && v.block.init === m.parent();
                    }
                    r.name.mark_symbol(u ? function(e) {
                        if (!(e instanceof pi)) return;
                        if (e instanceof mi) {
                            b(e);
                        } else {
                            h[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof pi)) return;
                        var n = e.definition().id;
                        if (!(e instanceof mi)) {
                            h[n] = false;
                        } else if (!(n in h)) {
                            E.add(n, e);
                        } else if (h[n]) {
                            h[n].push(e);
                        }
                        return true;
                    }, m);
                    return true;
                }
                if (r instanceof In) {
                    _();
                    v.block = r;
                    v.loop = true;
                    e();
                    g();
                    return true;
                }
                function d(e) {
                    if (y.option("ie")) {
                        var n = Bt(e);
                        if (n instanceof ln) n.walk(m);
                    }
                    return true;
                }
            });
            m.directives = Object.create(y.directives);
            k.walk(m);
            var i = false;
            var r = Object.create(null);
            while (o.length && s.length) {
                var a = s.shift();
                if (!a) continue;
                var n = a.definition;
                var e = h[n.id];
                if (!e) continue;
                e = {
                    end: e.end
                };
                while (n.id in r) n = r[n.id];
                e.start = h[n.id].start;
                var c = [];
                do {
                    var l = o.shift();
                    if (a.index > l.index) continue;
                    var p = l.definition.id;
                    if (!(p in u)) continue;
                    var t = h[p];
                    if (!t) continue;
                    if (t.start.block !== e.start.block || !T(t, e) || (t.start.loop || !Ve(n)) && !T(e, t) || y.option("webkit") && Ji(n) !== Ji(l.definition) || l.definition.const_redefs || !tn(t, function(e) {
                        return e.scope.find_variable(n.name) === n;
                    })) {
                        c.push(l);
                        continue;
                    }
                    t.forEach(function(e) {
                        e.thedef = n;
                        e.name = n.name;
                        if (e instanceof ln) {
                            n.references.push(e);
                        } else {
                            n.orig.push(e);
                        }
                    });
                    if (!l.definition.fixed) n.fixed = false;
                    r[p] = n;
                    i = true;
                    break;
                } while (o.length);
                if (c.length) o = c.concat(o);
            }
            return i;
            function _() {
                v = Object.create(v);
            }
            function g() {
                v = Object.getPrototypeOf(v);
            }
            function b(e, n) {
                var t = e.definition(), i, r = v;
                if (w) {
                    _();
                    r = v;
                    g();
                }
                if (t.id in h) {
                    var a = h[t.id];
                    if (!a) return;
                    if (a.start.block !== r.block) return h[t.id] = false;
                    a.push(e);
                    a.end = r;
                    if (t.id in u) {
                        s[u[t.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if ((i = k.variables.get(t.name)) !== t) {
                    if (i && x === r) h[i.id] = false;
                    return h[t.id] = false;
                } else if (y.exposed(t) || C[e.name]) {
                    return h[t.id] = false;
                } else {
                    var a = E.get(t.id) || [];
                    a.push(e);
                    h[t.id] = a;
                    if (!n) {
                        a.start = r;
                        return o.push({
                            index: f++,
                            definition: t
                        });
                    }
                    if (r.block !== k) return h[t.id] = false;
                    a.start = x;
                }
                u[t.id] = s.length;
                s.push({
                    index: f++,
                    definition: t
                });
            }
            function S(e) {
                var n = [];
                while (true) {
                    if (Sn(v, "block")) {
                        var t = v.block;
                        if (t instanceof Fn) t = t.body;
                        if (t === e) break;
                    }
                    n.push(v);
                    g();
                }
                v.inserted = v.block;
                _();
                while (n.length) {
                    var i = n.pop();
                    _();
                    if (Sn(i, "block")) v.block = i.block;
                    if (Sn(i, "loop")) v.loop = i.loop;
                }
            }
            function d(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function T(e, n) {
                return d(e.start, e.end) || d(e.start, n.start);
            }
        });
        function _e(e, n) {
            for (var t = n.length; --t >= 0; ) {
                if (!n[t]) n[t] = Oe(Pi, e);
            }
        }
        function ee(e, n) {
            var t = Oe(dt, e, e);
            if (t.name) t.name = n ? null : Oe(yi, t.name, t.name);
            return t;
        }
        function ge(e, n) {
            var t;
            switch (e.CTOR) {
              case st:
                t = tt;
                break;

              case ft:
                t = it;
                break;

              case ut:
                t = rt;
                break;

              case ct:
                t = at;
                break;
            }
            var i = Oe(t, e, e);
            i.name = n ? null : Oe(bi, e.name, e.name);
            return i;
        }
        Un.DEFMETHOD("drop_unused", function(D) {
            if (!D.option("unused")) return;
            var O = this;
            var P = !(O instanceof Vn) || D.toplevel.funcs;
            var $ = !(O instanceof Vn) || D.toplevel.vars;
            var j = /keep_assign/.test(D.option("unused")) ? hn : function(e, n) {
                var t, r = false;
                if (e instanceof cn) {
                    if (e.write_only || e.operator == "=") t = a(e.left, n);
                } else if (e instanceof Jt) {
                    if (e.write_only) t = a(e.expression, n);
                }
                if (!(t instanceof ln)) return;
                var i = t.definition();
                if (o[i.id]) return;
                if (D.exposed(i)) return;
                if (!De(t, D, r)) return;
                return t;
                function a(e, n) {
                    if (e instanceof Ut) {
                        var t = e.expression;
                        if (!t.may_throw_on_access(D, true)) {
                            r = true;
                            if (n && e instanceof Wt) n.unshift(e.property);
                            return a(t, n);
                        }
                    } else if (e instanceof cn && e.operator == "=") {
                        e.write_only = "p";
                        var i = a(e.right);
                        if (!n) return i;
                        n.assign = e;
                        return i instanceof ln ? i : e.left;
                    }
                    return e;
                }
            };
            var q = Object.create(null);
            var o = Object.create(null);
            var _ = function(e) {
                _ = a(O, 0, vn);
                return _(e);
                function a(e, n, i) {
                    var r = D.parent(n);
                    if (!r) return i;
                    var t = r instanceof Wn && pn(e, r.argnames);
                    return a(r, n + 1, t ? function(e) {
                        var n = i(e);
                        if (n) return n;
                        n = r.variables.get(e);
                        if (n) {
                            var t = n.orig[0];
                            if (t instanceof _i || t instanceof bi) return n;
                        }
                    } : r.variables ? function(e) {
                        return i(e) || r.variables.get(e);
                    } : i);
                }
            };
            var N = Object.create(null);
            var h = [];
            var z = Object.create(null);
            var g = Object.create(null);
            var b = Object.create(null);
            var C = Object.create(null);
            if (O instanceof Vn && D.top_retain) {
                O.variables.each(function(e) {
                    if (D.top_retain(e) && !(e.id in z)) {
                        z[e.id] = true;
                        h.push(e);
                    }
                });
            }
            var y = new En();
            var w = new En();
            var M = this;
            var m = new Yi(function(s, e) {
                if (s instanceof Wn && s.uses_arguments && !m.has_directive("use strict")) {
                    s.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in z)) {
                            z[n.id] = true;
                            h.push(n);
                        }
                    });
                }
                if (s === O) return;
                if (M === O) {
                    if (s instanceof pt) {
                        var n = s.name.definition();
                        var t = P && !n.exported;
                        if (!t && !(n.id in z)) {
                            z[n.id] = true;
                            h.push(n);
                        }
                        if (s.extends) s.extends.walk(m);
                        var i = m.parent() instanceof Nt;
                        if (i) o[n.id] = true;
                        var r = [];
                        s.properties.forEach(function(e) {
                            if (e.key instanceof rn) e.key.walk(m);
                            var n = e.value;
                            if (!n) return;
                            if (e instanceof ht && e.static) {
                                if (!i && n.contains_this()) i = true;
                                a(n);
                            } else {
                                r.push(n);
                            }
                        });
                        r.forEach(t && i ? a : function(e) {
                            w.add(n.id, e);
                        });
                        return true;
                    }
                    if (s instanceof ot) {
                        var n = s.name.definition();
                        if ((!P || n.exported) && !(n.id in z)) {
                            z[n.id] = true;
                            h.push(n);
                        }
                        w.add(n.id, s);
                        if (m.parent() instanceof Nt) {
                            o[n.id] = true;
                        } else {
                            return true;
                        }
                    }
                    if (s instanceof zt) {
                        s.definitions.forEach(function(i) {
                            var r = i.value;
                            var a = r && (i.name instanceof ni || r.has_side_effects(D));
                            var o = a && r.tail_node().operator == "=";
                            i.name.mark_symbol(function(e) {
                                if (!(e instanceof pi)) return;
                                var n = e.definition();
                                C[n.id] = (C[n.id] || 0) + 1;
                                if (s instanceof Ft && n.orig[0] instanceof wi) {
                                    var t = n.redefined();
                                    if (t) C[t.id] = (C[t.id] || 0) + 1;
                                }
                                if (!(n.id in z) && (!$ || n.exported || (s instanceof Ct ? n.redefined() : n.const_redefs) || !(s instanceof Ft || ne(n)))) {
                                    z[n.id] = true;
                                    h.push(n);
                                }
                                if (r) {
                                    if (!a) {
                                        w.add(n.id, r);
                                    } else if (o) {
                                        E(n, e, b[n.id]);
                                    }
                                    y.add(n.id, i);
                                }
                                return true;
                            }, m);
                            if (a) r.walk(m);
                        });
                        return true;
                    }
                    if (s instanceof _i) {
                        var n = s.definition();
                        C[n.id] = (C[n.id] || 0) + 1;
                        y.add(n.id, s);
                        return true;
                    }
                    if (s instanceof vi) {
                        var n = s.definition();
                        if (!(n.id in z) && (!$ || !ne(n))) {
                            z[n.id] = true;
                            h.push(n);
                        }
                        return true;
                    }
                }
                return f(s, e, true);
                function a(e) {
                    var n = M;
                    M = s;
                    e.walk(m);
                    M = n;
                }
            });
            m.directives = Object.create(D.directives);
            O.walk(m);
            var I = D.option("keep_fnames") ? hn : D.option("ie") ? function(e) {
                return !D.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in z)) return true;
                if (e.orig.length - e.eliminated < 2) return false;
                if (e.orig[1] instanceof _i) return true;
                return tn(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            if (D.option("ie")) w.each(function(e, n) {
                if (n in z) return;
                e.forEach(function(e) {
                    e.walk(new Yi(function(e) {
                        if (e instanceof rt && e.name && !I(e.name.definition())) {
                            e.walk(m);
                            return true;
                        }
                        if (e instanceof Un) return true;
                    }));
                });
            });
            m = new Yi(f);
            for (var e = 0; e < h.length; e++) {
                var n = w.get(h[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(m);
                });
            }
            Object.keys(q).forEach(function(e) {
                var t = q[e];
                if (!t) {
                    delete q[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        yn(n, e);
                    });
                    return n;
                }, []);
                var n = (y.get(e) || []).filter(function(n) {
                    return dn(n instanceof Jt ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof Jt) return false;
                        return i(e) === i(n);
                    }, t);
                });
                if (t.length == n.length) {
                    q[e] = n;
                } else {
                    delete q[e];
                }
            });
            var H = [];
            var Y = [];
            var R = [];
            var L = new Ri(function(i) {
                if (i instanceof Yt) return T(L, i);
                if (i instanceof ni && i.rest) i.rest = i.rest.transform(L);
                if (i instanceof ti) {
                    var e = !i.rest;
                    for (var n = i.elements.length; --n >= 0; ) {
                        var t = i.elements[n].transform(L);
                        if (t) {
                            i.elements[n] = t;
                            e = false;
                        } else if (e) {
                            i.elements.pop();
                        } else {
                            i.elements[n] = Oe(Pi, i.elements[n]);
                        }
                    }
                    return i;
                }
                if (i instanceof ri) {
                    var r = [];
                    i.properties.forEach(function(e) {
                        var n = false;
                        if (e.key instanceof rn) {
                            e.key = e.key.transform(F);
                            n = e.key.has_side_effects(D);
                        }
                        if ((n || i.rest) && a(e.value)) {
                            e.value = e.value.transform(F);
                            r.push(e);
                        } else {
                            var t = e.value.transform(L);
                            if (!t && i.rest) {
                                if (e.value instanceof ti) {
                                    t = Oe(ti, e.value, {
                                        elements: []
                                    });
                                } else {
                                    t = Oe(ri, e.value, {
                                        properties: []
                                    });
                                }
                            }
                            if (t) {
                                e.value = t;
                                r.push(e);
                            }
                        }
                    });
                    i.properties = r;
                    return i;
                }
                if (i instanceof pi) return i.definition().id in z ? i : null;
            });
            var F = new Ri(function(_, o, s) {
                var g = F.parent();
                if ($) {
                    var e = [], n = j(_, e);
                    if (n) {
                        var t;
                        if (J(n, _)) {
                            if (_ instanceof cn) {
                                t = X(_);
                                if (_.write_only === true) t = t.drop_side_effect_free(D);
                            }
                            if (!t) t = Oe($i, _, {
                                value: 0
                            });
                        }
                        if (t) {
                            if (e.assign) {
                                var f = e.assign.drop_side_effect_free(D);
                                if (f) {
                                    f.write_only = true;
                                    e.unshift(f);
                                }
                            }
                            if (!(g instanceof sn) || g.tail_node() === _ || t.has_side_effects(D)) {
                                e.push(t);
                            }
                            switch (e.length) {
                              case 0:
                                return bn.skip;

                              case 1:
                                return Ie(D, g, _, e[0].transform(F));

                              default:
                                return $e(_, e.map(function(e) {
                                    return e.transform(F);
                                }));
                            }
                        }
                    } else if (_ instanceof Xt && _.expression instanceof ln && G(_.expression.definition(), _) < 0) {
                        return Oe(fn, _, {
                            operator: "+",
                            expression: _.expression
                        });
                    }
                }
                if (_ instanceof Rt) Y.push(_);
                if (M !== O) return;
                if (P && _ !== O && _ instanceof pt) {
                    var u = _.name.definition();
                    if (!(u.id in z)) {
                        B(_.name, "Dropping unused class {name}");
                        u.eliminated++;
                        o(_, F);
                        var i = ee(_, true);
                        if (g instanceof Nt) return i;
                        i = i.drop_side_effect_free(D, true);
                        if (i) return Oe(an, _, {
                            body: i
                        });
                        return s ? bn.skip : Oe($n, _);
                    }
                }
                if (_ instanceof dt && _.name && I(_.name.definition())) {
                    H.push(_);
                }
                if (_ instanceof Wn) {
                    if (P && _ !== O && _ instanceof ot) {
                        var u = _.name.definition();
                        if (!(u.id in z)) {
                            B(_.name, "Dropping unused function {name}");
                            u.eliminated++;
                            if (g instanceof Nt) {
                                A();
                                return ge(_, true);
                            }
                            return s ? bn.skip : Oe($n, _);
                        }
                    }
                    if (_ instanceof Jn && _.name && I(_.name.definition())) {
                        H.push(_);
                    }
                    if (!(_ instanceof Gn)) {
                        var r, c, l = D.drop_fargs(_, g);
                        if (l && g instanceof Rt && g.expression === _) {
                            r = g.args;
                            for (c = 0; c < r.length; c++) {
                                if (r[c] instanceof Gt) break;
                            }
                        }
                        var p = _.argnames;
                        var a = _.rest;
                        if (a) {
                            if (!r || c < p.length || a instanceof _i) {
                                a = a.transform(L);
                            } else {
                                var i = K(a, Oe(ei, g, {
                                    elements: r.slice(p.length)
                                }), function(e) {
                                    return e.definition().id in z ? e : null;
                                }, !_.uses_arguments, a);
                                a = i.name;
                                r.length = p.length;
                                if (i.value.elements.length) [].push.apply(r, i.value.elements);
                            }
                            if (a instanceof ni && !a.rest && (!_.uses_arguments || F.has_directive("use strict"))) {
                                if (a instanceof ti) {
                                    if (a.elements.length == 0) a = null;
                                } else if (a.properties.length == 0) {
                                    a = null;
                                }
                            }
                            _.rest = a;
                            if (a) l = false;
                        }
                        var d = l ? -1 : _.length();
                        for (var v = p.length; --v >= 0; ) {
                            var n = p[v];
                            if (n instanceof _i) {
                                var u = n.definition();
                                if (u.id in z) {
                                    l = false;
                                    if (G(u, n) < 0) n.unused = null;
                                } else if (l) {
                                    B(n, "Dropping unused function argument {name}");
                                    p.pop();
                                } else {
                                    n.unused = true;
                                }
                            } else {
                                var h;
                                if (!r || c < v) {
                                    h = n.transform(L);
                                } else {
                                    h = K(n, r[v], function(e) {
                                        return e.definition().id in z ? e : null;
                                    }, !_.uses_arguments, n).name;
                                }
                                if (h) {
                                    l = false;
                                } else if (l) {
                                    U(n, "Dropping unused default argument {name}");
                                    p.pop();
                                } else if (v > d) {
                                    U(n, "Dropping unused default argument assignment {name}");
                                    if (n.name instanceof _i) n.name.unused = true;
                                    p[v] = n.name;
                                } else {
                                    U(n, "Dropping unused default argument value {name}");
                                    n.value = Oe($i, n, {
                                        value: 0
                                    });
                                }
                            }
                        }
                        R.push(_);
                    }
                }
                if (_ instanceof $t && _.argname instanceof ni) {
                    _.argname.transform(L);
                }
                if (_ instanceof zt && !(g instanceof Yn && g.init === _)) {
                    var w = [], x = [], b = [];
                    var y = [];
                    var k = 0;
                    var E = _ instanceof Ft;
                    _.definitions.forEach(function(t) {
                        if (t.value) t.value = t.value.transform(F);
                        var e = t.value;
                        if (t.name instanceof ni) {
                            var n = K(t.name, e, function(e) {
                                if (!$) return e;
                                if (e.definition().id in z) return e;
                                if (h(e)) return e;
                                if (E && !De(e)) return e;
                                return null;
                            }, true);
                            if (n.name) {
                                t = Oe(Pt, t, {
                                    name: n.name,
                                    value: e = n.value
                                });
                                m();
                            } else if (n.value) {
                                y.push(n.value);
                            }
                            return;
                        }
                        var a = t.name.definition();
                        var i = E ? De(t.name) : ne(a);
                        if (!i || !$ || a.id in z) {
                            var r;
                            if (e && ((r = G(a, t)) < 0 || l(e.tail_node()))) {
                                t = t.clone();
                                e = e.drop_side_effect_free(D);
                                if (e) rn.warn("Side effects in definition of variable {name} [{file}:{line},{col}]", V(t.name));
                                if (_ instanceof Ct) {
                                    t.value = e || Oe($i, t, {
                                        value: 0
                                    });
                                } else {
                                    t.value = null;
                                    if (e) y.push(e);
                                }
                                e = null;
                                if (r >= 0) q[a.id][r] = t;
                            }
                            var o, s;
                            if (!e && !(_ instanceof Mt)) {
                                if (g instanceof jt) {
                                    m();
                                } else if (i && C[a.id] > 1) {
                                    rn.info("Dropping declaration of variable {name} [{file}:{line},{col}]", V(t.name));
                                    C[a.id]--;
                                    a.eliminated++;
                                } else {
                                    x.push(t);
                                }
                            } else if (D.option("functions") && !D.option("ie") && i && e && C[a.id] == 1 && a.assignments == 0 && (s = e.tail_node()) instanceof Jn && !Fe(a) && !Xn(s) && p(s, a.references) && d(s) && (o = v(s, t.name.name)) !== false) {
                                rn.warn("Declaring {name} as function [{file}:{line},{col}]", V(t.name));
                                var f;
                                switch (s.CTOR) {
                                  case tt:
                                    f = st;
                                    break;

                                  case it:
                                    f = ft;
                                    break;

                                  case rt:
                                    f = ut;
                                    break;

                                  case at:
                                    f = ct;
                                    break;
                                }
                                var u = Oe(f, t, s);
                                u.name = Oe(gi, t.name, t.name);
                                var c = t.name.scope.resolve().def_function(u.name);
                                if (o) o.forEach(function(e) {
                                    e.name = c.name;
                                    e.thedef = c;
                                    e.reference();
                                });
                                w.push(u);
                                if (e !== s) [].push.apply(y, e.expressions.slice(0, -1));
                            } else {
                                if (i && C[a.id] > 1 && !(g instanceof jt) && a.orig.indexOf(t.name) > a.eliminated) {
                                    C[a.id]--;
                                    k++;
                                }
                                m();
                            }
                        } else if (h(t.name)) {
                            e = e && e.drop_side_effect_free(D);
                            if (e) y.push(e);
                            if (C[a.id] > 1) {
                                rn.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", V(t.name));
                                C[a.id]--;
                                a.eliminated++;
                            } else {
                                t.value = null;
                                x.push(t);
                            }
                        } else {
                            e = e && e.drop_side_effect_free(D);
                            if (e) {
                                rn.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", V(t.name));
                                y.push(e);
                            } else {
                                B(t.name, "Dropping unused variable {name}");
                            }
                            a.eliminated++;
                        }
                        function l(e) {
                            return e instanceof ln && e.definition() === a;
                        }
                        function p(n, e) {
                            if (e.length == 0) return n === t.name.fixed_value();
                            return tn(e, function(e) {
                                return n === e.fixed_value();
                            });
                        }
                        function d(e) {
                            if (!E || D.has_directive("use strict") || !(e instanceof rt)) {
                                return g instanceof Un;
                            }
                            return g instanceof Mn || g instanceof Hn && g.init === _ || g instanceof Et;
                        }
                        function v(t, i) {
                            if (!t.name) return null;
                            var e = t.name.definition();
                            if (e.orig.length > 1) return null;
                            if (e.assignments > 0) return false;
                            if (e.name == i) return e;
                            var r;
                            switch (i) {
                              case "await":
                                r = Kn;
                                break;

                              case "yield":
                                r = Qn;
                                break;
                            }
                            return tn(e.references, function(e) {
                                var n = e.scope;
                                if (n.find_variable(i) !== a) return false;
                                if (r) do {
                                    n = n.resolve();
                                    if (r(n)) return false;
                                } while (n !== t && (n = n.parent_scope));
                                return true;
                            }) && e;
                        }
                        function h(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof wi && n.scope.resolve() === e.scope.resolve();
                        }
                        function m() {
                            if (y.length > 0) {
                                if (b.length == 0) {
                                    w.push(Oe(an, _, {
                                        body: $e(_, y)
                                    }));
                                } else if (e) {
                                    y.push(e);
                                    t.value = $e(e, y);
                                } else {
                                    t.value = Oe(fn, t, {
                                        operator: "void",
                                        expression: $e(t, y)
                                    });
                                }
                                y = [];
                            }
                            b.push(t);
                        }
                    });
                    switch (x.length) {
                      case 0:
                        if (b.length == 0) break;
                        if (b.length == k) {
                            [].unshift.apply(y, b.map(function(e) {
                                rn.info("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", V(e.name));
                                var n = e.name.definition();
                                var t = Oe(ln, e.name, e.name);
                                n.references.push(t);
                                var i = Oe(cn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var r = G(n, e);
                                if (r >= 0) q[n.id][r] = i;
                                n.eliminated++;
                                return i;
                            }));
                            break;
                        }

                      case 1:
                        if (b.length == 0) {
                            var m = x[0].name.definition().id;
                            if (m in N) {
                                _.definitions = x;
                                N[m].init = _;
                                break;
                            }
                        }

                      default:
                        var S;
                        if (b.length > 0 && (S = b[0].value) instanceof sn) {
                            b[0].value = S.tail_node();
                            w.push(Oe(an, _, {
                                body: $e(S, S.expressions.slice(0, -1))
                            }));
                        }
                        _.definitions = x.concat(b);
                        w.push(_);
                    }
                    if (y.length > 0) {
                        w.push(Oe(an, _, {
                            body: $e(_, y)
                        }));
                    }
                    return W(w, _, s);
                }
                if (_ instanceof cn) {
                    o(_, F);
                    if (!(_.left instanceof ni)) return _;
                    var i = K(_.left, _.right, function(e) {
                        return e;
                    }, _.write_only === true);
                    if (i.name) return Oe(cn, _, {
                        operator: _.operator,
                        left: i.name,
                        right: i.value
                    });
                    if (i.value) return i.value;
                    if (g instanceof sn && g.tail_node() !== _) return bn.skip;
                    return Oe($i, _, {
                        value: 0
                    });
                }
                if (_ instanceof Fn && _.body instanceof Hn) {
                    o(_, F);
                    if (_.body instanceof on) {
                        var T = _.body;
                        _.body = T.body.pop();
                        T.body.push(_);
                        return s ? bn.splice(T.body) : T;
                    }
                    return _;
                }
                if (_ instanceof Un) {
                    A();
                    return _;
                }
                if (_ instanceof vi) {
                    if (!D.option("imports") || _.definition().id in z) return _;
                    return s ? bn.skip : null;
                }
                function A() {
                    var e = M;
                    M = _;
                    o(_, F);
                    M = e;
                }
            }, function(e, n) {
                if (e instanceof on) return Z(e, F.parent(), n);
                if (e instanceof Hn) return Re(e, n);
                if (e instanceof Rn) {
                    if (!$ || !D.option("loops")) return;
                    if (!le(e.body)) return;
                    var t = S(e);
                    if (!t) return;
                    var i = t.definition();
                    if (i.id in z) return;
                    B(t, "Dropping unused loop variable {name}");
                    if (N[i.id] === e) delete N[i.id];
                    var r = [];
                    var a = e.object.drop_side_effect_free(D);
                    if (a) {
                        rn.warn("Side effects in object of for-in loop [{file}:{line},{col}]", a.start);
                        r.push(Oe(an, e, {
                            body: a
                        }));
                    }
                    if (e.init instanceof zt && i.orig[0] instanceof wi) {
                        r.push(e.init);
                    }
                    return W(r, e, n);
                }
                if (e instanceof Ht) {
                    if (e.properties && e.properties.length == 0) e.properties = null;
                    return e;
                }
                if (e instanceof sn) {
                    if (e.expressions.length > 1) return;
                    return Ie(D, F.parent(), e, e.expressions[0]);
                }
            });
            F.push(D.parent());
            O.transform(F);
            if (O instanceof Wn && O.body.length == 1 && O.body[0] instanceof On && O.body[0].value == "use strict") {
                O.body.length = 0;
            }
            H.forEach(function(e) {
                e.name = null;
            });
            Y.forEach(function(e) {
                xe(e, D, R);
            });
            function B(e, n) {
                rn[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", V(e));
            }
            function U(e, n) {
                if (e.name instanceof _i) {
                    B(e.name, n);
                } else {
                    rn.info(n + " [{file}:{line},{col}]", {
                        name: e,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    });
                }
            }
            function V(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function i(e) {
                return e[e instanceof cn ? "right" : "value"];
            }
            function W(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? bn.skip : Oe($n, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? bn.splice(e) : Oe(on, n, {
                        body: e
                    });
                }
            }
            function x(e, n) {
                if (e.scope.resolve() !== O) return false;
                if (!e.fixed || !n.fixed) q[e.id] = false;
                return q[e.id] !== false;
            }
            function k(e, n) {
                if (!q[e.id]) q[e.id] = [];
                if (n.fixed.assigns) yn(q[e.id], n.fixed.assigns);
            }
            function G(e, n) {
                var t = q[e.id];
                return t && t.indexOf(n);
            }
            function E(e, n, t) {
                if (e.id in z) return;
                if (n && t) {
                    z[e.id] = n;
                    h.push(e);
                } else {
                    g[e.id] = n;
                    b[e.id] = t;
                }
            }
            function J(e, n) {
                var t = e.definition();
                var i = z[t.id];
                if (!i) return true;
                if (n[n instanceof cn ? "left" : "expression"] !== e) return false;
                return i === e && t.references.length - t.replaced == 1 || G(t, n) < 0;
            }
            function X(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof un && Ce[n.operator])) return n;
                if (!(n.left instanceof ln)) return n;
                if (!(e.left instanceof ln)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(D)) return n;
                if (x(t, n.left)) k(t, n.left);
                return n.right;
            }
            function S(e) {
                var n = e.init;
                if (n instanceof zt) {
                    n = n.definitions[0].name;
                    return n instanceof pi && n;
                }
                while (n instanceof Ut) n = n.expression.tail_node();
                if (n instanceof ln) return n;
            }
            function f(e, c, l) {
                if (e instanceof cn && e.left instanceof ln) {
                    var n = e.left.definition();
                    if (n.scope.resolve() === O) y.add(n.id, e);
                }
                if (e instanceof Jt && e.expression instanceof ln) {
                    var n = e.expression.definition();
                    if (n.scope.resolve() === O) y.add(n.id, e);
                }
                var t, i = [], r = j(e, i);
                if (r && ((t = r.definition()).scope.resolve() === O || O.variables.get(r.name) === t) && !(Fe(t) && !tn(O.argnames, function(e) {
                    return !e.match_symbol(function(e) {
                        if (e instanceof _i) {
                            var n = e.definition();
                            return n.references.length > n.replaced;
                        }
                    }, true);
                }))) {
                    if (e.write_only === "p" && e.right.may_throw_on_access(D, true)) return;
                    var a = i.assign;
                    if (a) {
                        a.write_only = true;
                        a.walk(m);
                    }
                    i.forEach(function(e) {
                        e.walk(m);
                    });
                    if (e instanceof cn) {
                        var o = X(e), s = false;
                        if (l && e.write_only === true && !o.has_side_effects(D)) {
                            w.add(t.id, o);
                        } else {
                            o.walk(m);
                            s = o.tail_node().operator == "=";
                        }
                        if (e.left === r) {
                            if (!e.write_only || s) {
                                E(t, r, b[t.id]);
                            }
                        } else {
                            var p = r.fixed_value();
                            if (!p || !p.is_constant()) {
                                E(t, g[t.id], true);
                            }
                        }
                    }
                    if (x(t, r) && Ki(r, e) !== r) k(t, r);
                    return true;
                }
                if (e instanceof Rn) {
                    if (e.init instanceof ln && M === O) {
                        var d = e.init.definition().id;
                        if (!(d in N)) N[d] = e;
                    }
                    if (!$ || !D.option("loops")) return;
                    if (!le(e.body)) return;
                    if (e.init.has_side_effects(D)) return;
                    var r = S(e);
                    if (!r) return;
                    var n = r.definition();
                    if (n.scope.resolve() !== O) {
                        var f = _(r.name);
                        if (f === n || f && f.redefined() === n) return;
                    }
                    e.object.walk(m);
                    return true;
                }
                if (e instanceof ln) {
                    t = e.definition();
                    if (!(t.id in z)) {
                        z[t.id] = true;
                        h.push(t);
                    }
                    if (Q(t.scope, e.scope)) {
                        var u = t.redefined();
                        if (u && !(u.id in z)) {
                            z[u.id] = true;
                            h.push(u);
                        }
                    }
                    if (x(t, e)) k(t, e);
                    return true;
                }
                if (e instanceof Un) {
                    var v = M;
                    M = e;
                    c();
                    M = v;
                    return true;
                }
            }
            function a(e) {
                return (e instanceof Yt ? e.name : e) instanceof pi;
            }
            function T(e, n) {
                n.value = n.value.transform(F);
                var t = n.name.transform(e);
                if (!t) {
                    if (n.name instanceof ni) return null;
                    var i = n.value.drop_side_effect_free(D);
                    if (!i) return null;
                    B(n.name, "Side effects in default value of unused variable {name}");
                    n.name.unused = null;
                    n.value = i;
                }
                return n;
            }
            function K(e, m, _, g, b) {
                var y = new Ri(function(a) {
                    if (a instanceof Yt) {
                        if (!(D.option("default_values") && m && m.is_defined(D))) {
                            var n = g;
                            g = false;
                            var l = T(y, a);
                            g = n;
                            if (!l && g && m) m = m.drop_side_effect_free(D);
                            return l;
                        } else if (a === b) {
                            b = a = a.name;
                        } else {
                            a = a.name;
                        }
                    }
                    if (a instanceof ti) {
                        var n = g;
                        var t = m;
                        if (m instanceof ln) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var i = m instanceof ei && m.elements;
                        var r = [], o = g && [], s = 0;
                        a.elements.forEach(function(e, n) {
                            m = i && i[n];
                            if (m instanceof Pi) {
                                m = null;
                            } else if (m instanceof Gt) {
                                if (g) {
                                    o.length = s;
                                    _e(t, o);
                                    [].push.apply(o, i.slice(n));
                                    t.elements = o;
                                }
                                m = i = false;
                            }
                            e = e.transform(y);
                            if (e) r[s] = e;
                            if (g && m) o[s] = m;
                            if (e || m || !g || !i) s++;
                        });
                        m = i && Oe(ei, t, {
                            elements: i.slice(a.elements.length)
                        });
                        if (a.rest) {
                            var p = g;
                            g = false;
                            a.rest = a.rest.transform(D.option("rests") ? y : F);
                            g = p;
                            if (a.rest) r.length = s;
                        }
                        if (g) {
                            if (m && !a.rest) m = m.drop_side_effect_free(D);
                            if (m instanceof ei) {
                                m = m.elements;
                            } else if (m instanceof sn) {
                                m = m.expressions;
                            } else if (m) {
                                m = [ m ];
                            }
                            if (m && m.length) {
                                o.length = s;
                                [].push.apply(o, m);
                            }
                        }
                        m = t;
                        g = n;
                        if (i && o) {
                            _e(m, o);
                            m.elements = o;
                        }
                        if (!a.rest && (m instanceof ei || m && m.is_string(D))) switch (r.length) {
                          case 0:
                            if (a === b) break;
                            if (g) m = m.drop_side_effect_free(D);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var d = r[0];
                            if (d.has_side_effects(D)) break;
                            if (m.has_side_effects(D) && d.match_symbol(function(e) {
                                return e instanceof Ut;
                            })) break;
                            m = Oe(Wt, a, {
                                expression: m,
                                property: Oe($i, a, {
                                    value: 0
                                })
                            });
                            return d;
                        }
                        _e(a, r);
                        a.elements = r;
                        return a;
                    }
                    if (a instanceof ri) {
                        var n = g;
                        var t = m;
                        if (m instanceof ln) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var f, u;
                        if (m instanceof ai) {
                            f = [];
                            u = new En();
                            m.properties.forEach(function(e, n) {
                                if (e instanceof Gt) return u = false;
                                var t = e.key;
                                if (t instanceof rn) t = t.evaluate(D, true);
                                if (t instanceof rn) {
                                    u = false;
                                } else if (u && !(e instanceof ui)) {
                                    u.set(t, e);
                                }
                                f[n] = t;
                            });
                        }
                        if (a.rest) {
                            m = false;
                            a.rest = a.rest.transform(D.option("rests") ? y : F);
                        }
                        var v = new En();
                        var c = g && new En();
                        var h = [];
                        a.properties.map(function(e) {
                            var n = e.key;
                            if (n instanceof rn) {
                                e.key = n = n.transform(F);
                                n = n.evaluate(D, true);
                            }
                            if (n instanceof rn) {
                                c = false;
                            } else {
                                v.set(n, !v.has(n));
                            }
                            return n;
                        }).forEach(function(e, n) {
                            var t = a.properties[n], i;
                            if (e instanceof rn) {
                                g = false;
                                m = false;
                                i = t.value.transform(y) || x(t.value);
                            } else {
                                g = c && v.get(e);
                                var r = u && u.get(e);
                                if (r) {
                                    m = r.value;
                                    if (m instanceof Gn) m = false;
                                } else {
                                    m = false;
                                }
                                i = t.value.transform(y);
                                if (!i) {
                                    if (a.rest || w(t)) i = x(t.value);
                                    if (c && !c.has(e)) {
                                        if (r) {
                                            c.set(e, r);
                                            if (m === null) {
                                                u.set(e, w(r) && Oe(si, r, {
                                                    key: r.key,
                                                    value: Oe($i, r, {
                                                        value: 0
                                                    })
                                                }));
                                            }
                                        } else {
                                            c.set(e, true);
                                        }
                                    }
                                } else if (c) {
                                    c.set(e, false);
                                }
                                if (m) r.value = m;
                            }
                            if (i) {
                                t.value = i;
                                h.push(t);
                            }
                        });
                        m = t;
                        g = n;
                        if (c && f) m.properties = bn(m.properties, function(e, n) {
                            if (e instanceof Gt) return e;
                            var t = f[n];
                            if (t instanceof rn) return e;
                            if (c.has(t)) {
                                var i = c.get(t);
                                if (!i) return e;
                                if (i === e) return u.get(t) || bn.skip;
                            } else if (a.rest) {
                                return e;
                            }
                            var r = e.value.drop_side_effect_free(D);
                            if (r) {
                                e.value = r;
                                return e;
                            }
                            return w(e) ? Oe(si, e, {
                                key: e.key,
                                value: Oe($i, e, {
                                    value: 0
                                })
                            }) : bn.skip;
                        });
                        if (m && !a.rest) switch (h.length) {
                          case 0:
                            if (a === b) break;
                            if (m.may_throw_on_access(D, true)) break;
                            if (g) m = m.drop_side_effect_free(D);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var e = h[0];
                            if (e.key instanceof rn) break;
                            if (e.value.has_side_effects(D)) break;
                            if (m.has_side_effects(D) && e.value.match_symbol(function(e) {
                                return e instanceof Ut;
                            })) break;
                            m = Oe(Wt, a, {
                                expression: m,
                                property: ue(e.key, e)
                            });
                            return e.value;
                        }
                        a.properties = h;
                        return a;
                    }
                    if (a instanceof Pi) {
                        a = null;
                    } else {
                        a = _(a);
                    }
                    if (!a && g && m) m = m.drop_side_effect_free(D);
                    return a;
                });
                return {
                    name: e.transform(y),
                    value: m
                };
                function w(e) {
                    return e.key instanceof rn && e.key.has_side_effects(D);
                }
                function x(e) {
                    if (e instanceof Yt) return x(e.name);
                    if (e instanceof ni) {
                        if (m === null) {
                            m = Oe($i, e, {
                                value: 0
                            });
                        } else if (m && (m.tail_node().write_only === true || m.may_throw_on_access(D, true))) {
                            m = Oe(ei, e, {
                                elements: m instanceof sn ? m.expressions : [ m ]
                            });
                        }
                        return Oe(ri, e, {
                            properties: []
                        });
                    }
                    e.unused = null;
                    return e;
                }
            }
        });
        Un.DEFMETHOD("hoist_declarations", function(o) {
            if (o.has_directive("use asm")) return;
            var s = o.option("hoist_funs");
            var f = o.option("hoist_vars");
            var u = this;
            if (f) {
                var n = 0;
                u.walk(new Yi(function(e) {
                    if (n > 1) return true;
                    if (e instanceof jt) return true;
                    if (e instanceof Un && e !== u) return true;
                    if (e instanceof Ft) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) f = false;
            }
            if (!s && !f) return;
            var c = new En();
            var h = [];
            var l = [];
            var p = new En(), m = 0;
            var d = new Ri(function(e, n, t) {
                if (e === u) return;
                if (e instanceof On) {
                    h.push(e);
                    return t ? bn.skip : Oe($n, e);
                }
                if (e instanceof ot) {
                    if (!s) return e;
                    var i = d.parent();
                    if (i instanceof jt) return e;
                    if (i instanceof Nt) return e;
                    if (i !== u && o.has_directive("use strict")) return e;
                    l.push(e);
                    return t ? bn.skip : Oe($n, e);
                }
                if (e instanceof Ft) {
                    if (!f) return e;
                    var i = d.parent();
                    if (i instanceof jt) return e;
                    if (!tn(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof mi && !c.has(n.name) && u.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        p.set(e.name.name, e);
                        ++m;
                    });
                    var r = e.to_assignments();
                    if (i instanceof Yn && i.init === e) {
                        if (r) return r;
                        var a = e.definitions[0].name;
                        return Oe(ln, a, a);
                    }
                    if (i instanceof Hn && i.init === e) return r;
                    if (!r) return t ? bn.skip : Oe($n, e);
                    return Oe(an, e, {
                        body: r
                    });
                }
                if (e instanceof Un) return e;
                if (e instanceof di) {
                    c.set(e.name, true);
                    return e;
                }
            });
            u.transform(d);
            if (m > 0) {
                var v = [];
                if (u instanceof Wn) u.each_argname(function(e) {
                    p.del(e.name);
                });
                p.each(function(e, n) {
                    e = e.clone();
                    e.value = null;
                    v.push(e);
                    p.set(n, e);
                });
                if (v.length > 0) {
                    _(u.body);
                    v = Oe(Ft, u, {
                        definitions: v
                    });
                    l.push(v);
                }
            }
            u.body = h.concat(l, u.body);
            function _(e) {
                while (e.length) {
                    var n = e[0];
                    if (n instanceof an) {
                        var t = n.body, i, r;
                        if (t instanceof cn && t.operator == "=" && (i = t.left) instanceof li && p.has(i.name)) {
                            var a = p.get(i.name);
                            if (a.value) break;
                            var o = t.right;
                            if (o instanceof sn) o = o.clone();
                            a.value = o;
                            xn(v, a);
                            v.push(a);
                            e.shift();
                            continue;
                        }
                        if (t instanceof sn && (r = t.expressions[0]) instanceof cn && r.operator == "=" && (i = r.left) instanceof li && p.has(i.name)) {
                            var a = p.get(i.name);
                            if (a.value) break;
                            a.value = r.right;
                            xn(v, a);
                            v.push(a);
                            n.body = $e(t, t.expressions.slice(1));
                            continue;
                        }
                    }
                    if (n instanceof $n) {
                        e.shift();
                        continue;
                    }
                    if (n instanceof on && !_(n.body)) {
                        e.shift();
                        continue;
                    }
                    break;
                }
                return e.length;
            }
        });
        function w(n, t) {
            n.walk(new Yi(function(e) {
                if (e instanceof bt) {
                    t(e);
                    return true;
                }
                if (e instanceof Un && e !== n) return true;
            }));
        }
        function M(e) {
            var i = Object.create(null);
            w(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof ln) {
                    var t = n.definition().id;
                    i[t] = (i[t] || 0) + 1;
                }
            });
            return i;
        }
        function Y(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function R(e, i) {
            w(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = V(i, n);
                    if (!t) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? $e(e.value, [ n, Oe($i, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (!(t instanceof rn)) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? $e(e.value, [ n, Oe($i, e.value, {
                            value: 1
                        }) ]) : Oe($i, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        Un.DEFMETHOD("process_boolean_returns", vn);
        ut.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = M(this);
            if (!Y(this.name.definition(), n, e)) return;
            if (e.parent() instanceof Nt) return;
            R(this, e);
        });
        rt.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = M(this);
            if (this.name && !Y(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof cn) {
                if (t.operator != "=") return;
                var i = t.left;
                if (!(i instanceof ln)) return;
                if (!Y(i.definition(), n, e)) return;
            } else if (t instanceof Rt && t.expression !== this) {
                var r = t.expression;
                if (r instanceof ln) r = r.fixed_value();
                if (!(r instanceof Wn)) return;
                if (r.uses_arguments || r.pinned()) return;
                var i = r.argnames[t.args.indexOf(this)];
                if (i instanceof Yt) i = i.name;
                if (i instanceof _i && !Y(i.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var a = e.in_boolean_context();
                e.push(this);
                if (!a) return;
            } else return;
            R(this, e);
        });
        zn.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = new En();
                this.enclosed.forEach(function(e) {
                    t.set(e.name, true);
                });
                this.variables.each(function(e, n) {
                    t.set(n, true);
                });
            }
            return t;
        });
        Un.DEFMETHOD("make_var", function(e, n, t) {
            var i = [ this ];
            if (n instanceof pi) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (pn(n, i)) return;
                do {
                    yn(i, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/^[^a-z_$]|[^a-z0-9_$]/gi, "_");
            var r = t;
            for (var a = 0; !tn(i, function(e) {
                return !e.var_names().has(r);
            }); a++) r = t + "$" + a;
            var o = Oe(e, n, {
                name: r,
                scope: this
            });
            var s = this.def_variable(o);
            i.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names().set(r, true);
            });
            return o;
        });
        Un.DEFMETHOD("hoist_properties", function(a) {
            if (!a.option("hoist_props") || a.has_directive("use asm")) return;
            var f = this;
            var o = f instanceof Vn && a.top_retain || hn;
            var u = Object.create(null);
            f.transform(new Ri(function(i, e) {
                if (i instanceof cn) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (!c(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new En();
                    var a = [];
                    var o = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(mi, i.left, e.key);
                        o.push(Oe(Pt, i, {
                            name: n,
                            value: null
                        }));
                        var t = Oe(ln, i, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference();
                        a.push(Oe(cn, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    r.value = i.right;
                    u[i.left.definition().id] = r;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, Oe(Ft, i, {
                        definitions: o
                    }));
                    return $e(i, a);
                }
                if (i instanceof Un) return i === f ? undefined : i;
                if (i instanceof Pt) {
                    if (!c(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new En();
                    var n = [];
                    var t = i.clone();
                    t.value = i.name instanceof di ? Oe($i, i, {
                        value: 0
                    }) : null;
                    n.push(t);
                    i.value.properties.forEach(function(e) {
                        n.push(Oe(Pt, i, {
                            name: s(i.name.CTOR, i.name, e.key),
                            value: e.value
                        }));
                    });
                    r.value = i.value;
                    u[i.name.definition().id] = r;
                    return bn.splice(n);
                }
                function s(e, n, t) {
                    var i = f.make_var(e, n, n.name + "_" + t);
                    r.set(t, i.definition());
                    return i;
                }
            }));
            f.transform(new Ri(function(e, n) {
                if (e instanceof Ut) {
                    if (!(e.expression instanceof ln)) return;
                    var t = u[e.expression.definition().id];
                    if (!t) return;
                    if (e.expression.fixed_value() !== t.value) return;
                    var i = t.get(e.get_property());
                    var r = Oe(ln, e, {
                        name: i.name,
                        scope: e.expression.scope,
                        thedef: i
                    });
                    r.reference();
                    return r;
                }
                if (e instanceof ln) {
                    var t = u[e.definition().id];
                    if (!t) return;
                    if (e.fixed_value() !== t.value) return;
                    return Oe(ai, e, {
                        properties: []
                    });
                }
            }));
            function c(e, n, t) {
                if (!(e instanceof li)) return;
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.references.length - i.replaced == t) return;
                if (i.single_use) return;
                if (o(i)) return;
                if (e.fixed_value() !== n) return;
                var r = e.fixed || i.fixed;
                if (r.direct_access) return;
                if (r.escaped && r.escaped.depth == 1) return;
                return n instanceof ai && n.properties.length > 0 && tn(n.properties, Qe) && De(e, a);
            }
        });
        function be(e, n) {
            if (!e.name || !n.option("ie")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return tn(t.references, function(e) {
                return !(e instanceof ln);
            });
        }
        (function(e) {
            function c(e, n, t, i) {
                var r = e.length;
                var a = [], o = false;
                for (var s = 0; s < r; s++) {
                    var f = e[s];
                    var u;
                    if (i && f instanceof Gt) {
                        u = i(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return a.length ? o ? a : e : null;
            }
            function l(e, n, t) {
                var i = e.expression;
                if (!i.is_string(n)) return e;
                return i.drop_side_effect_free(n, t);
            }
            function p(e) {
                return e instanceof Gt ? Oe(ei, e, {
                    elements: [ e ]
                }) : e;
            }
            e(rn, _n);
            e(Gn, gn);
            e(ei, function(e, n) {
                var t = c(this.elements, e, n, l);
                if (!t) return null;
                if (t === this.elements && tn(t, function(e) {
                    return e instanceof Gt;
                })) return this;
                return $e(this, t.map(p));
            });
            e(cn, function(e) {
                var n = this.left;
                if (n instanceof Ut) {
                    var t = n.expression;
                    if (t.may_throw_on_access(e, true)) return this;
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                if (Ce[this.operator.slice(0, -1)]) return this;
                this.write_only = true;
                if (!Bt(n).is_constant_expression(e.find_parent(Un))) return this;
                return this.right.drop_side_effect_free(e);
            });
            e(Qt, function(e) {
                if (!e.option("awaits")) return this;
                var n = this.expression;
                if (!x(e, n)) return this;
                if (n instanceof fn && n.operator == "!") n = n.expression;
                var t = n.drop_side_effect_free(e);
                if (t === n) return this;
                if (!t) {
                    t = Oe($i, n, {
                        value: 0
                    });
                } else if (!x(e, t)) {
                    t = t.negate(e);
                }
                var i = this.clone();
                i.expression = t;
                return i;
            });
            e(un, function(e, n) {
                var t = this.left;
                var i = this.right;
                var r = this.operator;
                if (r == "in" && !Be(i)) {
                    var a = t.drop_side_effect_free(e, n);
                    if (a === t) return this;
                    var o = this.clone();
                    o.left = a || Oe($i, t, {
                        value: 0
                    });
                    return o;
                }
                var s = i.drop_side_effect_free(e, n);
                if (!s) return t.drop_side_effect_free(e, n);
                if (Ce[r] && s.has_side_effects(e)) {
                    var o = this;
                    if (s !== i) {
                        o = o.clone();
                        o.right = s.drop_side_effect_free(e);
                    }
                    if (r == "??") return o;
                    var f = Oe(un, this, {
                        operator: r == "&&" ? "||" : "&&",
                        left: t.negate(e, n),
                        right: o.right
                    });
                    return n ? u(o, f) : ve(o, f);
                }
                var a = t.drop_side_effect_free(e, n);
                if (!a) return s;
                s = s.drop_side_effect_free(e);
                if (!s) return a;
                return $e(this, [ a, s ]);
            });
            function d(o, n) {
                var e = Xn(n);
                var i = Kn(n);
                var s = false;
                var t = false;
                if (e && o.option("arrows")) {
                    if (!n.value) {
                        t = true;
                    } else if (!i || x(o, n.value)) {
                        var r = n.value.drop_side_effect_free(o);
                        if (r !== n.value) {
                            s = true;
                            n.value = r;
                        }
                    }
                } else if (n instanceof tt || n instanceof rt) {
                    if (n.name) {
                        var a = n.name.definition();
                        t = a.references.length == a.replaced;
                    } else {
                        t = true;
                    }
                }
                if (t) {
                    n.process_expression(false, function(e) {
                        var n = e.value;
                        if (n) {
                            if (i && !x(o, n)) return e;
                            n = n.drop_side_effect_free(o, true);
                        }
                        s = true;
                        if (!n) return Oe($n, e);
                        return Oe(an, e, {
                            body: n
                        });
                    });
                    w(n, function(e) {
                        var n = e.value;
                        if (n) {
                            if (i && !x(o, n)) return;
                            var t = n.drop_side_effect_free(o);
                            if (t !== n) {
                                s = true;
                                e.value = t;
                            }
                        }
                    });
                }
                if (i && o.option("awaits")) {
                    if (t) n.process_expression("awaits", function(e) {
                        var n = e.body;
                        if (n instanceof Qt) {
                            if (x(o, n.expression)) {
                                s = true;
                                n = n.expression.drop_side_effect_free(o, true);
                                if (!n) return Oe($n, e);
                                e.body = n;
                            }
                        } else if (n instanceof sn) {
                            var t = n.expressions;
                            for (var i = t.length; --i >= 0; ) {
                                var r = t[i];
                                if (!(r instanceof Qt)) break;
                                var a = r.expression;
                                if (!x(o, a)) break;
                                s = true;
                                if (t[i] = a.drop_side_effect_free(o)) break;
                            }
                            switch (i) {
                              case -1:
                                return Oe($n, e);

                              case 0:
                                e.body = t[0];
                                break;

                              default:
                                t.length = i + 1;
                                break;
                            }
                        }
                        return e;
                    });
                    var f = !t && n.name || e && n.value && !x(o, n.value);
                    var c = new Yi(function(e) {
                        if (f) return true;
                        if (c.parent() === n && e.may_throw(o)) return f = true;
                        if (e instanceof Qt) return f = true;
                        if (e instanceof Ln) return f = true;
                        if (e instanceof bt) {
                            if (e.value && !x(o, e.value)) return f = true;
                            return;
                        }
                        if (e instanceof Un && e !== n) return true;
                    });
                    n.walk(c);
                    if (!f) {
                        var u;
                        switch (n.CTOR) {
                          case nt:
                            u = et;
                            break;

                          case tt:
                            u = rt;
                            break;

                          case it:
                            u = at;
                            break;
                        }
                        return Oe(u, n, n);
                    }
                }
                return s && n.clone();
            }
            function v(e, n) {
                e.new = true;
                var t = tn(e.body, function(e) {
                    return !e.has_side_effects(n);
                }) && tn(e.argnames, function(e) {
                    return !e.match_symbol(hn);
                }) && !(e.rest && e.rest.match_symbol(hn));
                e.new = false;
                return t;
            }
            e(Rt, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    if (t.pure) rn.warn("Dropping __PURE__ call [{file}:{line},{col}]", t.start);
                    var i = c(t.args, e, n, l);
                    return i && $e(t, i.map(p));
                }
                var r = t.expression;
                if (t.is_call_pure(e)) {
                    var a = t.args.slice();
                    a.unshift(r.expression);
                    a = c(a, e, n, l);
                    return a && $e(t, a.map(p));
                }
                if (e.option("yields") && Qn(r)) {
                    var o = t.clone();
                    o.expression = Oe(rt, r, r);
                    o.expression.body = [];
                    var s = o.transform(e);
                    if (s !== o) return s.drop_side_effect_free(e, n);
                }
                var f = d(e, r);
                if (f) {
                    t = t.clone();
                    t.expression = f;
                    if (r._squeezed) t.expression._squeezed = true;
                }
                if (t instanceof Lt) {
                    var u = r;
                    if (u instanceof ln) u = u.fixed_value();
                    if (u instanceof Wn) {
                        if (v(u, e)) {
                            var a = t.args.slice();
                            a.unshift(r);
                            a = c(a, e, n, l);
                            return a && $e(t, a.map(p));
                        }
                        if (!u.contains_this()) {
                            t = Oe(Rt, t, t);
                            t.expression = t.expression.clone();
                            t.args = t.args.slice();
                        }
                    }
                }
                t.call_only = true;
                return t;
            });
            e(dt, function(e, n) {
                var t = this;
                var i = [], r = [];
                var a = t.properties;
                for (var o = 0; o < a.length; o++) {
                    var s = a[o];
                    if (s.key instanceof rn) i.push(s.key);
                    if (s.static && s.value && s instanceof ht && s.value.has_side_effects(e)) {
                        if (s.value.contains_this()) return t;
                        r.push(s.value);
                    }
                }
                var f = t.extends;
                if (f) {
                    if (f instanceof ln) f = f.fixed_value();
                    f = !h(f);
                    if (!f) i.unshift(t.extends);
                }
                i = c(i, e, n);
                if (i) n = false;
                r = c(r, e, n);
                if (!i) {
                    if (!f && !r && !t.name) return null;
                    i = [];
                }
                if (f || t.name || !e.has_directive("use strict")) {
                    var u = ee(t);
                    if (!f) u.extends = null;
                    u.properties = [];
                    if (r) {
                        u.properties.push(Oe(ht, t, {
                            static: true,
                            key: i.length ? $e(t, i) : "c",
                            value: $e(t, r)
                        }));
                    } else if (i.length) {
                        u.properties.push(Oe(mt, t, {
                            key: $e(t, i),
                            value: Oe(rt, t, {
                                argnames: [],
                                body: []
                            }).init_vars(u)
                        }));
                    }
                    return u;
                }
                if (r) i.push(Oe(Rt, t, {
                    expression: Oe(et, t, {
                        argnames: [],
                        body: [],
                        value: $e(t, r)
                    }).init_vars(t.parent_scope),
                    args: []
                }));
                return $e(t, i);
            });
            e(Kt, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var i;
                if (e.option("ie")) {
                    i = [];
                    if (n instanceof rt) {
                        i.push(n);
                        n = null;
                    }
                    if (t instanceof rt) {
                        i.push(t);
                        t = null;
                    }
                }
                var r;
                if (!n) {
                    r = t ? Oe(un, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    r = Oe(un, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    r = this.clone();
                    r.consequent = n;
                    r.alternative = t;
                }
                if (!i) return r;
                if (r) i.push(r);
                return i.length == 0 ? null : $e(this, i);
            });
            e(Di, gn);
            e(Vt, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(rt, function(e) {
                return be(this, e) ? null : this;
            });
            e(Jn, gn);
            e(ai, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof Gt) {
                        t.push(e);
                    } else {
                        if (e.key instanceof rn) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var i = c(t, e, n, function(e, n, t) {
                    var i = e.expression;
                    return i.safe_to_spread() ? i.drop_side_effect_free(n, t) : e;
                });
                if (!i) return null;
                if (i === t && !tn(i, function(e) {
                    return !(e instanceof Gt);
                })) return this;
                return $e(this, i.map(function(e) {
                    return e instanceof Gt ? Oe(ai, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(ki, gn);
            e(sn, function(e, n) {
                var t = c(this.expressions, e, n);
                if (!t) return null;
                var i = t.length - 1;
                var r = t[i];
                if (e.option("awaits") && i > 0 && r instanceof Qt && r.expression.is_constant()) {
                    t = t.slice(0, -1);
                    i--;
                    var a = t[i];
                    r.expression = x(e, a) ? a : a.negate(e);
                    t[i] = r;
                }
                var o, s, f;
                if (e.option("conditionals") && i > 0 && (o = t[i - 1]) instanceof cn && o.operator == "=" && (f = o.left) instanceof ln && (s = ie(e, f.definition(), o.right, r))) {
                    o = o.clone();
                    o.right = s;
                    t = t.slice(0, -2);
                    t.push(o.drop_side_effect_free(e, n));
                }
                return t === this.expressions ? this : $e(this, t);
            });
            e(Wt, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                var i = this.property;
                t = t.drop_side_effect_free(e, n);
                if (!t) return i.drop_side_effect_free(e, n);
                i = i.drop_side_effect_free(e);
                if (!i) return t;
                return $e(this, [ t, i ]);
            });
            e(ln, function(e) {
                return this.is_declared(e) && De(this, e) ? null : this;
            });
            e(Ai, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    var i = t.expressions;
                    if (i.length == 0) return null;
                    return $e(t, i).drop_side_effect_free(e, n);
                }
                var r = t.tag;
                var a = d(e, r);
                if (a) {
                    t = t.clone();
                    t.tag = a;
                    if (r._squeezed) t.tag._squeezed = true;
                }
                return t;
            });
            e(Jt, function(e, n) {
                var t = this.expression;
                if (Xi[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof ln && De(t, e)) {
                    return null;
                }
                var i = t.drop_side_effect_free(e, n);
                if (n && i && pe(i)) {
                    if (i === t && this.operator == "!") return this;
                    return i.negate(e, n);
                }
                return i;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(an, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    rn.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return Oe($n, e);
                }
                if (i !== t) {
                    return Oe(an, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(In, function(e, n) {
            return n.option("loops") ? Oe(Hn, e, e).optimize(n) : e;
        });
        function L(n, e, t) {
            if (!t) t = wt;
            var i = false;
            var r = new Yi(function(e) {
                if (i || e instanceof Un) return true;
                if (e instanceof t && r.loopcontrol_target(e) === n) {
                    return i = true;
                }
            });
            if (e instanceof Fn) r.push(e);
            r.push(n);
            n.body.walk(r);
            return i;
        }
        e(Nn, function(t, e) {
            if (!e.option("loops")) return t;
            var n = V(e, t.condition);
            if (!(n instanceof rn)) {
                if (n && !L(t, e.parent(), kt)) return Oe(Hn, t, {
                    body: Oe(on, t.body, {
                        body: [ t.body, Oe(an, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!L(t, e.parent())) return Oe(on, t.body, {
                    body: [ t.body, Oe(an, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof on && !L(t, e.parent(), kt)) {
                var i = t.body.body;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a instanceof Et && !a.alternative && a.body instanceof xt && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = Oe(un, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        i.splice(r, 1);
                    } else if (a instanceof an) {
                        if (o(a.body)) break;
                        t.condition = $e(t, [ a.body, t.condition ]);
                        i.splice(r, 1);
                    } else if (!H(a, true)) {
                        break;
                    }
                }
                t.body = Z(t.body, e.parent());
            }
            if (t.body instanceof $n) return Oe(Hn, t, t).optimize(e);
            if (t.body instanceof an) return Oe(Hn, t, {
                condition: $e(t.condition, [ t.body.body, t.condition ]),
                body: Oe($n, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new Yi(function(e) {
                    if (n) return true;
                    if (e instanceof ln) {
                        if (!pn(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function B(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof xt || e instanceof kt && s(e) || e instanceof gt)) {
                var i = [];
                if (qn(n.init)) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(Oe(an, n.init, {
                        body: n.init
                    }));
                }
                var r = s(e) || e instanceof gt;
                if (n.condition && r) {
                    i.push(Oe(Et, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    i.push(Oe(an, n.condition, {
                        body: n.condition
                    }));
                } else if (r) {
                    i.push(e);
                }
                z(t, n.body, i);
                return Oe(on, n, {
                    body: i
                });
            }
            if (e instanceof Et) {
                var a = o(e.body);
                if (a instanceof xt && !s(a)) {
                    if (n.condition) {
                        n.condition = Oe(un, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var i = N(e.alternative);
                    z(t, e.body, i);
                    return f(i);
                }
                a = o(e.alternative);
                if (a instanceof xt && !s(a)) {
                    if (n.condition) {
                        n.condition = Oe(un, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var i = N(e.body);
                    z(t, e.alternative, i);
                    return f(i);
                }
            }
            return n;
            function o(e) {
                return e instanceof on ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof on) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = Oe(on, n.body, {
                        body: e
                    }).transform(t);
                }
                return B(n, t);
            }
        }
        e(Hn, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = V(n, e.condition);
                if (!t) {
                    if (n.option("dead_code")) {
                        var i = [];
                        if (qn(e.init)) {
                            i.push(e.init);
                        } else if (e.init) {
                            i.push(Oe(an, e.init, {
                                body: e.init
                            }));
                        }
                        i.push(Oe(an, e.condition, {
                            body: e.condition
                        }));
                        z(n, e.body, i);
                        return Oe(on, e, {
                            body: i
                        }).optimize(n);
                    }
                } else if (!(t instanceof rn)) {
                    e.body = Oe(on, e.body, {
                        body: [ Oe(an, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return B(e, n);
        });
        e(Yn, function(e, t) {
            if (t.option("varify") && j(e.init)) {
                var n = e.init.definitions[0].name;
                if ((n instanceof ni || n instanceof hi) && !n.match_symbol(function(e) {
                    if (e instanceof pi) {
                        var n = e.definition();
                        return !Ve(n) || J(t, n);
                    }
                }, true)) {
                    e.init = X(e.init);
                }
            }
            return e;
        });
        function U(e, n, t) {
            if (e instanceof sn) e = e.tail_node();
            if (!(e instanceof un)) return;
            if (!(e.left instanceof Oi)) {
                switch (e.operator) {
                  case "&&":
                    U(e.left, n);
                    U(e.right, n);
                    break;

                  case "||":
                    U(p(e.left), t);
                    U(p(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof fn)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!qe(i)) return;
            var r;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                r = a ? t : n;
                break;

              case "!=":
                r = a ? n : t;
                break;

              default:
                return;
            }
            if (!r) return;
            var o = false;
            var c = i.definition();
            var s;
            var f = [];
            var l = [];
            var u = new Yi(function(e, n) {
                if (o) return true;
                if (e instanceof cn) {
                    var t = e.left;
                    if (!(t instanceof ln && t.definition() === c)) return;
                    e.right.walk(u);
                    switch (e.operator) {
                      case "=":
                      case "&&=":
                        o = true;
                    }
                    return true;
                }
                if (e instanceof Rt) {
                    n();
                    s = e.expression.tail_node();
                    var i;
                    if (s instanceof ln) {
                        s = s.fixed_value();
                        i = f.length;
                    }
                    if (!(s instanceof Wn)) {
                        o = true;
                    } else if (yn(l, s)) {
                        s.walk(u);
                    }
                    if (i >= 0) f.length = i;
                    return true;
                }
                if (e instanceof jn) {
                    var i = f.length;
                    n();
                    if (o) f.length = i;
                    return true;
                }
                if (e instanceof Hn) {
                    if (e.init) e.init.walk(u);
                    var i = f.length;
                    if (e.condition) e.condition.walk(u);
                    e.body.walk(u);
                    if (e.step) e.step.walk(u);
                    if (o) f.length = i;
                    return true;
                }
                if (e instanceof Yn) {
                    e.object.walk(u);
                    var i = f.length;
                    e.init.walk(u);
                    e.body.walk(u);
                    if (o) f.length = i;
                    return true;
                }
                if (e instanceof Un) {
                    if (e === s) return;
                    return true;
                }
                if (e instanceof ln) {
                    if (e.definition() === c) f.push(e);
                    return true;
                }
            });
            r.walk(u);
            f.forEach(function(e) {
                e.defined = true;
            });
            function p(e) {
                if (!(e instanceof un)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        function V(e, n, t) {
            if (n.truthy) return true;
            if (n.falsy && !t) return false;
            if (n.is_truthy()) return true;
            return n.evaluate(e, true);
        }
        function W(e, n) {
            var t;
            var i = 0;
            var r = false;
            var a = e.self();
            if (!qn(a)) while (true) {
                t = a;
                a = e.parent(i++);
                if (a instanceof un) {
                    var o = a.operator;
                    if (!Ce[o]) return;
                    var s = a.left;
                    if (s === t) continue;
                    if (u(s)) switch (o) {
                      case "&&":
                        n[r ? "falsy" : "truthy"] = true;
                        break;

                      case "||":
                      case "??":
                        n[r ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof Kt) {
                    var f = a.condition;
                    if (f === t) continue;
                    if (u(f)) switch (t) {
                      case a.consequent:
                        n[r ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[r ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof gt) {
                    break;
                } else if (a instanceof Et) {
                    break;
                } else if (a instanceof sn) {
                    if (a.expressions[0] === t) continue;
                } else if (a instanceof an) {
                    break;
                }
                return;
            }
            while (true) {
                t = a;
                a = e.parent(i++);
                if (a instanceof on) {
                    if (a.body[0] === t) continue;
                } else if (a instanceof Et) {
                    if (u(a.condition)) switch (t) {
                      case a.body:
                        n[r ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[r ? "truthy" : "falsy"] = true;
                        break;
                    }
                }
                return;
            }
            function u(e) {
                if (n.equivalent_to(e)) return true;
                if (!(e instanceof fn)) return false;
                if (e.operator != "!") return false;
                if (!n.equivalent_to(e.expression)) return false;
                r = true;
                return true;
            }
        }
        e(Et, function(e, u) {
            if (le(e.alternative)) e.alternative = null;
            if (!u.option("conditionals")) return e;
            if (u.option("booleans") && !e.condition.has_side_effects(u)) {
                W(u, e.condition);
            }
            if (u.option("dead_code")) {
                var c = V(u, e.condition);
                if (!c) {
                    rn.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var n = [ Oe(an, e.condition, {
                        body: e.condition
                    }) ];
                    z(u, e.body, n);
                    if (e.alternative) n.push(e.alternative);
                    return Oe(on, e, {
                        body: n
                    }).optimize(u);
                } else if (!(c instanceof rn)) {
                    rn.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var n = [ Oe(an, e.condition, {
                        body: e.condition
                    }), e.body ];
                    if (e.alternative) z(u, e.alternative, n);
                    return Oe(on, e, {
                        body: n
                    }).optimize(u);
                }
            }
            var t = e.condition.negate(u);
            var l = e.condition.print_to_string().length;
            var p = t.print_to_string().length;
            var i = p < l;
            if (e.alternative && i) {
                i = false;
                e.condition = t;
                var d = e.body;
                e.body = e.alternative || Oe($n, e);
                e.alternative = d;
            }
            var v = [];
            var r = [];
            var h = [];
            var a = y(e.body, v, r, h);
            var m = [];
            var o = [];
            var _ = [];
            var s = y(e.alternative, m, o, _);
            if (a instanceof on || s instanceof on) {
                var n = [], f = [];
                if (a) {
                    [].push.apply(n, v);
                    [].push.apply(f, r);
                    if (a instanceof on) {
                        e.body = a;
                    } else if (a.length == 0) {
                        e.body = Oe($n, e.body);
                    } else {
                        e.body = Oe(an, e.body, {
                            body: $e(e.body, a)
                        });
                    }
                    h.forEach(P);
                }
                if (s) {
                    [].push.apply(n, m);
                    [].push.apply(f, o);
                    if (s instanceof on) {
                        e.alternative = s;
                    } else if (s.length == 0) {
                        e.alternative = null;
                    } else {
                        e.alternative = Oe(an, e.alternative, {
                            body: $e(e.alternative, s)
                        });
                    }
                    _.forEach(P);
                }
                if (f.length > 0) n.push(Oe(Ft, e, {
                    definitions: f
                }));
                if (n.length > 0) {
                    n.push(e);
                    return Oe(on, e, {
                        body: n
                    }).optimize(u);
                }
            } else if (a && s) {
                var n = v.concat(m);
                if (r.length > 0 || o.length > 0) n.push(Oe(Ft, e, {
                    definitions: r.concat(o)
                }));
                if (a.length == 0) {
                    n.push(Oe(an, e.condition, {
                        body: s.length > 0 ? Oe(un, e, {
                            operator: "||",
                            left: e.condition,
                            right: $e(e.alternative, s)
                        }).transform(u) : e.condition.clone()
                    }).optimize(u));
                } else if (s.length == 0) {
                    if (l === p && !i && e.condition instanceof un && e.condition.operator == "||") {
                        i = true;
                    }
                    n.push(Oe(an, e, {
                        body: Oe(un, e, {
                            operator: i ? "||" : "&&",
                            left: i ? t : e.condition,
                            right: $e(e.body, a)
                        }).transform(u)
                    }).optimize(u));
                } else {
                    n.push(Oe(an, e, {
                        body: Oe(Kt, e, {
                            condition: e.condition,
                            consequent: $e(e.body, a),
                            alternative: $e(e.alternative, s)
                        })
                    }).optimize(u));
                }
                h.forEach(P);
                _.forEach(P);
                return Oe(on, e, {
                    body: n
                }).optimize(u);
            }
            if (le(e.body)) e = Oe(Et, e, {
                condition: t,
                body: e.alternative,
                alternative: null
            });
            if (e.alternative instanceof gt && e.body.TYPE == e.alternative.TYPE) {
                var g = Oe(e.body.CTOR, e, {
                    value: Oe(Kt, e, {
                        condition: e.condition,
                        consequent: e.body.value || Oe(Fi, e.body).transform(u),
                        alternative: e.alternative.value || Oe(Fi, e.alternative).transform(u)
                    })
                });
                if (g instanceof bt) g.in_bool = e.body.in_bool || e.alternative.in_bool;
                return g;
            }
            if (e.body instanceof Et && !e.body.alternative && !e.alternative) {
                e = Oe(Et, e, {
                    condition: Oe(un, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (F(e.body) && e.alternative) {
                var b = e.alternative;
                e.alternative = null;
                return Oe(on, e, {
                    body: [ e, b ]
                }).optimize(u);
            }
            if (F(e.alternative)) {
                var n = e.body;
                e.body = e.alternative;
                e.condition = i ? t : e.condition.negate(u);
                e.alternative = null;
                return Oe(on, e, {
                    body: [ e, n ]
                }).optimize(u);
            }
            if (u.option("typeofs")) U(e.condition, e.body, e.alternative);
            return e;
            function y(e, n, t, i) {
                if (e == null) return [];
                if (e instanceof on) {
                    var r = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof $n) continue;
                        if (o instanceof gt) {
                            if (r.length == 0) return;
                            o = o.clone();
                            r.push(o.value || Oe(Fi, o).transform(u));
                            o.value = $e(e, r);
                            var s = e.clone();
                            s.body = s.body.slice(a + 1);
                            s.body.unshift(o);
                            return s;
                        }
                        if (o instanceof ot) {
                            n.push(o);
                        } else if (o instanceof an) {
                            if (!u.option("sequences") && r.length > 0) return;
                            r.push(o.body);
                        } else if (o instanceof Ft) {
                            if (!u.option("sequences") && r.length > 0) return;
                            o.remove_initializers(u, t);
                            o.definitions.forEach(f);
                        } else {
                            return;
                        }
                    }
                    return r;
                }
                if (e instanceof ot) {
                    n.push(e);
                    return [];
                }
                if (e instanceof $n) return [];
                if (e instanceof an) return [ e.body ];
                if (e instanceof Ft) {
                    var r = [];
                    e.remove_initializers(u, t);
                    e.definitions.forEach(f);
                    return r;
                }
                function f(e) {
                    if (!e.value) return;
                    r.push(Oe(cn, e, {
                        operator: "=",
                        left: e.name.convert_symbol(ln, function(e) {
                            i.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(St, function(i, t) {
            if (!t.option("switches")) return i;
            if (!t.option("dead_code")) return i;
            var e = [];
            var n;
            var c = [];
            var r;
            var l;
            var a = [];
            for (var o = 0, p = i.body.length; o < p; o++) {
                n = i.body[o];
                if (n instanceof At) {
                    var s = e[e.length - 1];
                    if (r || w(n.body[0], t) && (!s || F(s))) {
                        k(n, s);
                        continue;
                    } else {
                        r = n;
                    }
                } else {
                    var f = n.expression;
                    var d = Oe(un, i, {
                        operator: "===",
                        left: i.expression,
                        right: f
                    }).evaluate(t, true);
                    if (!d) {
                        if (f.has_side_effects(t)) a.push(f);
                        k(n, e[e.length - 1]);
                        continue;
                    }
                    if (!(d instanceof rn)) {
                        if (r) {
                            var v = e.indexOf(r);
                            e.splice(v, 1);
                            k(r, e[v - 1]);
                            r = null;
                        }
                        if (f.has_side_effects(t)) {
                            l = n;
                        } else {
                            r = n = Oe(At, n, n);
                        }
                        while (++o < p) k(i.body[o], n);
                    }
                }
                if (o + 1 >= p || F(n)) {
                    var s = e[e.length - 1];
                    var u = n.body;
                    if (F(s)) switch (s.body.length - u.length) {
                      case 1:
                        var h = s.body[s.body.length - 1];
                        if (!w(h, t)) break;
                        u = u.concat(h);

                      case 0:
                        var m = Oe(on, s, s);
                        var _ = Oe(on, n, {
                            body: u
                        });
                        if (m.equivalent_to(_)) s.body = [];
                    }
                }
                if (a.length) {
                    if (n instanceof At) {
                        e.push(Oe(Dt, i, {
                            expression: $e(i, a),
                            body: []
                        }));
                    } else {
                        a.push(n.expression);
                        n.expression = $e(i, a);
                    }
                    a = [];
                }
                e.push(n);
            }
            if (a.length && !l) {
                e.push(Oe(Dt, i, {
                    expression: $e(i, a),
                    body: []
                }));
            }
            while (n = e[e.length - 1]) {
                var h = n.body[n.body.length - 1];
                if (w(h, t)) n.body.pop();
                if (n === r) {
                    if (!T(n)) break;
                } else if (n.expression.has_side_effects(t)) {
                    break;
                } else if (r) {
                    if (!T(r)) break;
                    if (e[e.length - 2] !== r) break;
                    r.body = r.body.concat(n.body);
                    n.body = [];
                } else if (!T(n)) break;
                k(n);
                if (e.pop() === r) r = null;
            }
            if (!n) {
                c.push(Oe(an, i.expression, {
                    body: i.expression
                }));
                if (a.length) c.push(Oe(an, i, {
                    body: $e(i, a)
                }));
                return Oe(on, i, {
                    body: c
                }).optimize(t);
            }
            if (n === r) while (n = e[e.length - 2]) {
                if (n instanceof At) break;
                if (!T(n)) break;
                var f = n.expression;
                if (f.has_side_effects(t)) {
                    var s = e[e.length - 3];
                    if (s && !F(s)) break;
                    r.body.unshift(Oe(an, i, {
                        body: f
                    }));
                }
                k(n);
                e.splice(-2, 1);
            }
            e[0].body = c.concat(e[0].body);
            i.body = e;
            if (t.option("conditionals")) switch (e.length) {
              case 1:
                if (!x(e[0])) break;
                var f = e[0].expression;
                var u = e[0].body.slice();
                if (e[0] !== r && e[0] !== l) return Oe(Et, i, {
                    condition: Oe(un, i, {
                        operator: "===",
                        left: i.expression,
                        right: f
                    }),
                    body: Oe(on, i, {
                        body: u
                    }),
                    alternative: null
                }).optimize(t);
                if (f) u.unshift(Oe(an, f, {
                    body: f
                }));
                u.unshift(Oe(an, i.expression, {
                    body: i.expression
                }));
                return Oe(on, i, {
                    body: u
                }).optimize(t);

              case 2:
                if (!pn(r, e) || !x(e[1])) break;
                var u = e[0].body.slice();
                var g = u.length && w(u[u.length - 1], t);
                if (g) u.pop();
                if (!tn(u, x)) break;
                var b = e[1].body.length && Oe(on, e[1], e[1]);
                var y = Oe(Et, i, {
                    condition: Oe(un, i, e[0] === r ? {
                        operator: "!==",
                        left: i.expression,
                        right: e[1].expression
                    } : {
                        operator: "===",
                        left: i.expression,
                        right: e[0].expression
                    }),
                    body: Oe(on, e[0], {
                        body: u
                    }),
                    alternative: g && b || null
                });
                if (!g && b) y = Oe(on, i, {
                    body: [ y, b ]
                });
                return y.optimize(t);
            }
            return i;
            function w(e, n) {
                return e instanceof xt && n.loopcontrol_target(e) === i;
            }
            function x(e) {
                var n = false;
                var t = new Yi(function(e) {
                    if (n || e instanceof Wn || e instanceof an) return true;
                    if (w(e, t)) n = true;
                });
                t.push(i);
                e.walk(t);
                return !n;
            }
            function k(e, n) {
                if (n && !F(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    z(t, e, c);
                }
            }
        });
        e(Ot, function(e, n) {
            e.body = c(e.body, n);
            if (n.option("dead_code")) {
                if (T(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof wi && !De(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        z(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof Ft)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(Oe(on, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(Oe(on, e.bfinally, e.bfinally).optimize(n));
                    }
                    return Oe(on, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && T(e.bfinally)) {
                    var t = Oe(on, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return Oe(on, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function G(r) {
            return function(n, t) {
                var i = false;
                this.definitions.forEach(function(e) {
                    if (e.value) i = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof pi) t.push(Oe(Pt, e, {
                            name: e,
                            value: r(n, e)
                        }));
                    }, true);
                });
                return i;
            };
        }
        Ct.DEFMETHOD("remove_initializers", G(function(e, n) {
            return Oe(Fi, n).optimize(e);
        }));
        Mt.DEFMETHOD("remove_initializers", G(gn));
        Ft.DEFMETHOD("remove_initializers", G(gn));
        zt.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, t) {
                var n = t.name.definition();
                var i = t.value;
                if (i) {
                    if (i instanceof sn) i = i.clone();
                    var r = Oe(ln, t.name, t.name);
                    var a = Oe(cn, t, {
                        operator: "=",
                        left: r,
                        right: i
                    });
                    e.push(a);
                    var o = function() {
                        return a.right;
                    };
                    o.assigns = [ a ];
                    o.direct_access = n.direct_access;
                    o.escaped = n.escaped;
                    r.fixed = o;
                    n.references.forEach(function(e) {
                        var n = e.fixed && e.fixed.assigns;
                        if (n && n[0] === t) n[0] = a;
                    });
                    n.references.push(r);
                }
                n.assignments++;
                n.eliminated++;
                n.single_use = false;
                return e;
            }, []);
            if (e.length == 0) return null;
            return $e(this, e);
        });
        function ne(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof bi ? 3 : 2);
        }
        function J(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var i = n.scope; i !== t; ) {
                i = i.parent_scope;
                if (i.var_names().has(n.name)) return true;
            }
        }
        function X(e) {
            return Oe(Ft, e, {
                definitions: e.definitions.map(function(e) {
                    return Oe(Pt, e, {
                        name: e.name.convert_symbol(mi, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var i = t.scope.resolve();
                            if (t.scope === i) return;
                            t.scope = i;
                            i.variables.set(t.name, t);
                            i.enclosed.push(t);
                            i.var_names().set(t.name, true);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function K(e, n) {
            if (!n.fixed_value()) return false;
            var t = n.definition();
            return ne(t) && Ve(t) && !J(e, t);
        }
        function te(e, n) {
            return n.option("varify") && tn(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof pi) return !K(n, e);
                }, true);
            }) ? X(e) : e;
        }
        e(Ct, te);
        e(Mt, te);
        function ye(e, n) {
            if (!n.option("optional_chains")) return;
            if (e.terminal) do {
                var t = e.expression;
                if (e.optional) {
                    var i = V(n, t, true);
                    if (i == null) return Oe(fn, e, {
                        operator: "void",
                        expression: t
                    }).optimize(n);
                    if (!(i instanceof rn)) e.optional = false;
                }
                e = t;
            } while ((e.TYPE == "Call" || e instanceof Ut) && !e.terminal);
        }
        function we(e, n) {
            var t = e.expression;
            if (!(t instanceof sn)) return e;
            var i = t.expressions.slice();
            var r = e.clone();
            r.expression = i.pop();
            i.push(r);
            return $e(e, i);
        }
        function xe(e, t, c) {
            var l = e.expression;
            var n = l instanceof ln ? l.fixed_value() : l;
            if (!(n instanceof Wn)) return;
            if (n.uses_arguments) return;
            if (n.pinned()) return;
            if (c && c.indexOf(n) < 0) return;
            var i = e.args;
            if (!tn(i, function(e) {
                return !(e instanceof Gt);
            })) return;
            var r = n.argnames;
            var p = n === l && !n.name;
            if (n.rest) {
                if (!(p && t.option("rests"))) return;
                var d = r.length;
                i = i.slice(0, d);
                while (i.length < d) i.push(Oe(Fi, e).optimize(t));
                i.push(Oe(ei, e, {
                    elements: e.args.slice(d)
                }));
                r = r.concat(n.rest);
                n.rest = null;
            } else {
                i = i.slice();
                r = r.slice();
            }
            var a = 0, v = 0;
            var h = p && t.option("default_values");
            var m = p && t.drop_fargs(n, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof ti) {
                    return e.elements.length == 0 && !e.rest && n instanceof ei;
                }
                if (e instanceof ri) {
                    return e.properties.length == 0 && !e.rest && n && !n.may_throw_on_access(t);
                }
                return e.unused;
            } : hn;
            var o = [];
            for (var s = 0; s < i.length; s++) {
                var f = r[s];
                if (h && f instanceof Yt && i[s].is_defined(t)) {
                    r[s] = f = f.name;
                }
                if (!f || f.unused !== undefined) {
                    var u = i[s].drop_side_effect_free(t);
                    if (m(f)) {
                        if (f) r.splice(s, 1);
                        i.splice(s, 1);
                        if (u) o.push(u);
                        s--;
                        continue;
                    } else if (u) {
                        o.push(u);
                        i[a++] = $e(e, o);
                        o = [];
                    } else if (f) {
                        if (o.length) {
                            i[a++] = $e(e, o);
                            o = [];
                        } else {
                            i[a++] = Oe($i, i[s], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (m(f, i[s])) {
                    var u = i[s].drop_side_effect_free(t);
                    r.splice(s, 1);
                    i.splice(s, 1);
                    if (u) o.push(u);
                    s--;
                    continue;
                } else {
                    o.push(i[s]);
                    i[a++] = $e(e, o);
                    o = [];
                }
                v = a;
            }
            for (;s < r.length; s++) {
                if (m(r[s])) r.splice(s--, 1);
            }
            n.argnames = r;
            i.length = v;
            e.args = i;
            if (!o.length) return;
            var _ = $e(e, o);
            i.push(i.length < r.length ? Oe(fn, e, {
                operator: "void",
                expression: _
            }) : _);
        }
        function ke(e) {
            var n = [];
            if (Kn(e)) n.push("await");
            if (Qn(e)) n.push("yield");
            return n.length && kn(n);
        }
        function Ee(t, i) {
            if (!i) return true;
            var r = true;
            var a = new Yi(function(e) {
                if (!r) return true;
                if (e instanceof Un) {
                    if (e === t) return;
                    if (Xn(e)) {
                        for (var n = 0; r && n < e.argnames.length; n++) e.argnames[n].walk(a);
                    } else if (e instanceof ot && i[e.name.name]) {
                        r = false;
                    }
                    return true;
                }
                if (e instanceof li && i[e.name] && e !== t.name) r = false;
            });
            t.walk(a);
            return r;
        }
        e(Rt, function(p, u) {
            var a = p.expression;
            var i = ye(p, u);
            if (i) return i;
            if (u.option("sequences")) {
                if (a instanceof Ut) {
                    var r = we(a, u);
                    if (r !== a) {
                        var o = p.clone();
                        o.expression = r.expressions.pop();
                        r.expressions.push(o);
                        return r.optimize(u);
                    }
                } else if (!ce(u, a.tail_node())) {
                    var r = we(p, u);
                    if (r !== p) return r.optimize(u);
                }
            }
            if (u.option("unused")) xe(p, u);
            if (u.option("unsafe")) {
                if (qe(a)) switch (a.name) {
                  case "Array":
                    if (p.args.length == 1) {
                        var s = p.args[0];
                        if (s instanceof $i) try {
                            var f = s.value;
                            if (f > 6) break;
                            var e = Array(f);
                            for (var l = 0; l < f; l++) e[l] = Oe(Pi, p);
                            return Oe(ei, p, {
                                elements: e
                            });
                        } catch (e) {
                            rn.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: f,
                                file: p.start.file,
                                line: p.start.line,
                                col: p.start.col
                            });
                            break;
                        }
                        if (!s.is_boolean(u) && !s.is_string(u)) break;
                    }
                    return Oe(ei, p, {
                        elements: p.args
                    });

                  case "Object":
                    if (p.args.length == 0) return Oe(ai, p, {
                        properties: []
                    });
                    break;

                  case "String":
                    if (p.args.length == 0) return Oe(Oi, p, {
                        value: ""
                    });
                    if (p.args.length == 1) return Oe(un, p, {
                        operator: "+",
                        left: Oe(Oi, p, {
                            value: ""
                        }),
                        right: p.args[0]
                    }).optimize(u);
                    break;

                  case "Number":
                    if (p.args.length == 0) return Oe($i, p, {
                        value: 0
                    });
                    if (p.args.length == 1) return Oe(fn, p, {
                        operator: "+",
                        expression: Oe(un, p, {
                            operator: "+",
                            left: Oe(Oi, p, {
                                value: ""
                            }),
                            right: p.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "Boolean":
                    if (p.args.length == 0) return Oe(Ii, p).optimize(u);
                    if (p.args.length == 1) return Oe(fn, p, {
                        operator: "!",
                        expression: Oe(fn, p, {
                            operator: "!",
                            expression: p.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "RegExp":
                    var m = [];
                    if (tn(p.args, function(e) {
                        var n = e.evaluate(u);
                        m.unshift(n);
                        return e !== n;
                    })) try {
                        return he(u, p, Oe(zi, p, {
                            value: RegExp.apply(RegExp, m)
                        }));
                    } catch (e) {
                        rn.warn("Error converting {expr} [{file}:{line},{col}]", {
                            expr: p,
                            file: p.start.file,
                            line: p.start.line,
                            col: p.start.col
                        });
                    }
                    break;
                } else if (a instanceof Vt) switch (a.property) {
                  case "toString":
                    var _ = a.expression;
                    if (p.args.length == 0 && !(_.may_throw_on_access(u) || _ instanceof Ei)) {
                        return Oe(un, p, {
                            operator: "+",
                            left: Oe(Oi, p, {
                                value: ""
                            }),
                            right: _
                        }).optimize(u);
                    }
                    break;

                  case "join":
                    if (a.expression instanceof ei && p.args.length < 2) e: {
                        var n = p.args[0];
                        if (a.expression.elements.length == 0 && !(n instanceof Gt)) {
                            return n ? $e(p, [ n, Oe(Oi, p, {
                                value: ""
                            }) ]).optimize(u) : Oe(Oi, p, {
                                value: ""
                            });
                        }
                        if (n) {
                            n = n.evaluate(u);
                            if (n instanceof rn) break e;
                        }
                        var e = [];
                        var g = [];
                        for (var l = 0; l < a.expression.elements.length; l++) {
                            var b = a.expression.elements[l];
                            var y = b.evaluate(u);
                            if (y !== b) {
                                g.push(y);
                            } else if (b instanceof Gt) {
                                break e;
                            } else {
                                if (g.length > 0) {
                                    e.push(Oe(Oi, p, {
                                        value: g.join(n)
                                    }));
                                    g.length = 0;
                                }
                                e.push(b);
                            }
                        }
                        if (g.length > 0) e.push(Oe(Oi, p, {
                            value: g.join(n)
                        }));
                        if (e.length == 1) {
                            if (e[0].is_string(u)) return e[0];
                            return Oe(un, e[0], {
                                operator: "+",
                                left: Oe(Oi, p, {
                                    value: ""
                                }),
                                right: e[0]
                            });
                        }
                        if (n == "") {
                            var s;
                            if (e[0].is_string(u) || e[1].is_string(u)) {
                                s = e.shift();
                            } else {
                                s = Oe(Oi, p, {
                                    value: ""
                                });
                            }
                            return e.reduce(function(e, n) {
                                return Oe(un, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, s).optimize(u);
                        }
                        var t = p.clone();
                        t.expression = t.expression.clone();
                        t.expression.expression = t.expression.expression.clone();
                        t.expression.expression.elements = e;
                        return he(u, p, t);
                    }
                    break;

                  case "charAt":
                    if (p.args.length < 2) {
                        var t = Oe(un, p, {
                            operator: "||",
                            left: Oe(Wt, p, {
                                expression: a.expression,
                                property: p.args.length ? Oe(un, p.args[0], {
                                    operator: "|",
                                    left: Oe($i, p, {
                                        value: 0
                                    }),
                                    right: p.args[0]
                                }) : Oe($i, p, {
                                    value: 0
                                })
                            }).optimize(u),
                            right: Oe(Oi, p, {
                                value: ""
                            })
                        });
                        t.is_string = mn;
                        return t.optimize(u);
                    }
                    break;

                  case "apply":
                    if (p.args.length == 2 && p.args[1] instanceof ei) {
                        var w = p.args[1].elements.slice();
                        w.unshift(p.args[0]);
                        return Oe(Rt, p, {
                            expression: Oe(Vt, a, {
                                expression: a.expression,
                                property: "call"
                            }),
                            args: w
                        }).optimize(u);
                    }
                    break;

                  case "call":
                    var x = a.expression;
                    if (x instanceof ln) {
                        x = x.fixed_value();
                    }
                    if (x instanceof Wn && !x.contains_this()) {
                        return (p.args.length ? $e(this, [ p.args[0], Oe(Rt, p, {
                            expression: a.expression,
                            args: p.args.slice(1)
                        }) ]) : Oe(Rt, p, {
                            expression: a.expression,
                            args: []
                        })).optimize(u);
                    }
                    break;
                }
            }
            if (u.option("unsafe_Function") && qe(a) && a.name == "Function") {
                if (p.args.length == 0) return Oe(rt, p, {
                    argnames: [],
                    body: []
                }).init_vars(a.scope);
                if (tn(p.args, function(e) {
                    return e instanceof Oi;
                })) {
                    try {
                        var k = "n(function(" + p.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join() + "){" + p.args[p.args.length - 1].value + "})";
                        var E = Gi(k);
                        var S = {
                            ie: u.option("ie")
                        };
                        E.figure_out_scope(S);
                        var T = new Qi(u.options);
                        E = E.transform(T);
                        E.figure_out_scope(S);
                        E.compute_char_frequency(S);
                        E.mangle_names(S);
                        var A;
                        E.walk(new Yi(function(e) {
                            if (A) return true;
                            if (e instanceof Wn) {
                                A = e;
                                return true;
                            }
                        }));
                        var k = Zi();
                        on.prototype._codegen.call(A, k);
                        p.args = [ Oe(Oi, p, {
                            value: A.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join()
                        }), Oe(Oi, p.args[p.args.length - 1], {
                            value: k.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return p;
                    } catch (e) {
                        if (e instanceof Ui) {
                            rn.warn("Error parsing code passed to new Function [{file}:{line},{col}]", p.args[p.args.length - 1].start);
                            rn.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var d = a instanceof ln ? a.fixed_value() : a;
            var D = u.parent(), O = u.self();
            var $ = d instanceof Wn && (!Kn(d) || u.option("awaits") && D instanceof Qt) && (!Qn(d) || u.option("yields") && O instanceof Zt && O.nested);
            var q = $ && d.first_statement();
            var c = 0, z = false;
            var C = !tn(p.args, function(e) {
                return !(e instanceof Gt);
            });
            var M = $ && tn(d.argnames, function(e, n) {
                if (c == 1 && p.args[n] instanceof Gt) c = 2;
                if (e instanceof Yt) {
                    if (!c) c = 1;
                    var t = c == 1 && p.args[n];
                    if (!ze(t)) c = 2;
                    if (en(d, e.value)) return false;
                    e = e.name;
                }
                if (e instanceof ni) {
                    z = true;
                    if (en(d, e)) return false;
                }
                return true;
            }) && !(d.rest instanceof ni && en(d, d.rest));
            var F = M && u.option("inline") && !p.is_expr_pure(u);
            if (F && q instanceof bt) {
                var y = q.value;
                if (a === d && !d.name && (!y || y.is_constant_expression()) && Ee(d, ke(u.find_parent(Un)))) {
                    return $e(p, W(y)).optimize(u);
                }
            }
            if ($ && !d.contains_this()) {
                var P, y, j = false;
                if (F && !d.uses_arguments && !d.pinned() && !(d.name && d instanceof Jn) && (a === d || !Ue(u, P = a.definition(), d) && d.is_constant_expression(je(u))) && (y = X(q))) {
                    var N = a === d || P.single_use && P.references.length - P.replaced == 1;
                    if (Q()) {
                        var w = p.args.slice();
                        var I = [];
                        var H = y.clone(true).transform(new Ri(function(e) {
                            if (e instanceof ln) {
                                var n = e.definition();
                                if (d.variables.get(e.name) !== n) {
                                    I.push(e);
                                    return e;
                                }
                                var t = K(n);
                                var i = w[t];
                                if (!i) return Oe(Fi, p);
                                w[t] = null;
                                var r = this.parent();
                                return r ? Ie(u, r, e, i) : i;
                            }
                        }));
                        var Y = d.inlined;
                        if (a !== d) d.inlined = true;
                        var R = [];
                        w.forEach(function(e) {
                            if (!e) return;
                            e = e.clone(true);
                            e.walk(new Yi(function(e) {
                                if (e instanceof ln) I.push(e);
                            }));
                            R.push(e);
                        }, []);
                        R.push(H);
                        var t = $e(p, R).optimize(u);
                        d.inlined = Y;
                        t = Ie(u, D, O, t);
                        if (N || ve(t, p) === t) {
                            I.forEach(function(e) {
                                e.scope = a === d ? d.parent_scope : a.scope;
                                e.reference();
                                var n = e.definition();
                                if (N) n.replaced++;
                                n.single_use = false;
                            });
                            return t;
                        } else if (!t.has_side_effects(u)) {
                            p.drop_side_effect_free = function(e, n) {
                                var t = this;
                                var i = t.args.slice();
                                i.unshift(t.expression);
                                return $e(t, i).drop_side_effect_free(e, n);
                            };
                        }
                    }
                    var L, B, v, h;
                    if (N && te()) {
                        d._squeezed = true;
                        if (a !== d) d.parent_scope = a.scope;
                        var t = $e(p, se()).optimize(u);
                        return Ie(u, D, O, t);
                    }
                }
                if (u.option("side_effects") && M && tn(d.body, le) && (d === a ? be(d, u) : !c && !z && !d.rest) && !(Xn(d) && d.value) && Ee(d, ke(u.find_parent(Un)))) {
                    return $e(p, W()).optimize(u);
                }
            }
            if (u.option("drop_console")) {
                if (a instanceof Ut) {
                    var U = a.expression;
                    while (U.expression) {
                        U = U.expression;
                    }
                    if (qe(U) && U.name == "console") {
                        return Oe(Fi, p).optimize(u);
                    }
                }
            }
            if (u.option("negate_iife") && D instanceof an && pe(O)) {
                return p.negate(u, true);
            }
            return me(u, p);
            function V(e) {
                return Oe(Vt, e, {
                    expression: Oe(ei, e, {
                        elements: []
                    }),
                    property: "e"
                });
            }
            function W(e) {
                var n = p.args.slice();
                var t = c > 1 || z || d.rest;
                if (t || C) n = [ Oe(ei, p, {
                    elements: n
                }) ];
                if (t) {
                    var o = new Ri(function(i, e) {
                        if (i instanceof Yt) return Oe(Yt, i, {
                            name: i.name.transform(o) || V(i),
                            value: i.value
                        });
                        if (i instanceof ti) {
                            var t = [];
                            i.elements.forEach(function(e, n) {
                                e = e.transform(o);
                                if (e) t[n] = e;
                            });
                            _e(i, t);
                            return Oe(ti, i, {
                                elements: t
                            });
                        }
                        if (i instanceof ri) {
                            var r = [], a = [];
                            i.properties.forEach(function(e) {
                                var n = e.key;
                                var t = e.value.transform(o);
                                if (t) {
                                    if (a.length) {
                                        if (!(n instanceof rn)) n = ue(n, e);
                                        a.push(n);
                                        n = $e(i, a);
                                        a = [];
                                    }
                                    r.push(Oe(ii, e, {
                                        key: n,
                                        value: t
                                    }));
                                } else if (n instanceof rn) {
                                    a.push(n);
                                }
                            });
                            if (a.length) r.push(Oe(ii, i, {
                                key: $e(i, a),
                                value: V(i)
                            }));
                            return Oe(ri, i, {
                                properties: r
                            });
                        }
                        if (i instanceof _i) return null;
                    });
                    var i = [];
                    d.argnames.forEach(function(e, n) {
                        e = e.transform(o);
                        if (e) i[n] = e;
                    });
                    var r = d.rest && d.rest.transform(o);
                    if (r) i.length = d.argnames.length;
                    _e(d, i);
                    n[0] = Oe(cn, p, {
                        operator: "=",
                        left: Oe(ti, d, {
                            elements: i,
                            rest: r
                        }),
                        right: n[0]
                    });
                } else d.argnames.forEach(function(e) {
                    if (e instanceof Yt) n.push(e.value);
                });
                n.push(e || Oe(Fi, p));
                return n;
            }
            function G() {
                return p.call_only ? Oe($i, p, {
                    value: 0
                }) : Oe(Fi, p);
            }
            function J(e) {
                if (!e) return G();
                if (e instanceof bt) return e.value || G();
                if (e instanceof an) {
                    return p.call_only ? e.body : Oe(fn, e, {
                        operator: "void",
                        expression: e.body
                    });
                }
            }
            function X(e) {
                var n = d.body.length;
                if (n < 2) {
                    e = J(e);
                    if (e) return e;
                }
                if (u.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = d.body[t];
                    if (i instanceof Ft) {
                        if (j) {
                            if (!e) continue;
                            if (!(e instanceof an)) return false;
                            if (!de(i)) e = null;
                        } else if (!de(i)) {
                            if (e && !(e instanceof an)) return false;
                            e = null;
                            j = true;
                        }
                    } else if (i instanceof st || i instanceof ut || i instanceof $n) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return J(e);
            }
            function K(e) {
                for (var n = d.argnames.length; --n >= 0; ) {
                    if (d.argnames[n].definition() === e) return n;
                }
            }
            function Q() {
                if (c || z || C || j || d.rest) return;
                if (u.option("inline") < 2 && d.argnames.length) return;
                if (!d.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof _i;
                })) return;
                var n = u.find_parent(Un);
                var r = false;
                var a = ke(n);
                var o;
                var s = [];
                var f = false;
                y.walk(new Yi(function(e, n) {
                    if (r) return true;
                    if (e instanceof un && Ce[e.operator] || e instanceof Kt) {
                        s = null;
                        return;
                    }
                    if (e instanceof Un) return r = true;
                    if (a && e instanceof li && a[e.name]) return r = true;
                    if (e instanceof ln) {
                        var t = e.definition();
                        if (d.variables.get(e.name) !== t) {
                            s = null;
                            return;
                        }
                        if (t.init instanceof ot) return r = true;
                        if (Ki(e, this.parent())) return r = true;
                        var i = K(t);
                        if (!(o < i)) o = i;
                        if (!s) return;
                        if (f) {
                            s = null;
                        } else {
                            s.push(d.argnames[i]);
                        }
                        return;
                    }
                    if (e.has_side_effects(u)) {
                        n();
                        f = true;
                        return true;
                    }
                }));
                if (r) return;
                var e = p.args.length;
                if (s && d.argnames.length >= e) {
                    e = d.argnames.length;
                    while (e-- > o && d.argnames[e] === s.pop());
                    e++;
                }
                return e <= o || tn(p.args.slice(o, e), f && !s ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(u);
                });
            }
            function Z(e, n) {
                return e.has(n) || fe[n] || h.var_names().has(n);
            }
            function ee(n, t) {
                var i = false;
                d.each_argname(function(e) {
                    if (i) return;
                    if (e.unused) return;
                    if (!t || Z(n, e.name)) return i = true;
                    L.set(e.name, true);
                    if (v) v.push(e.definition());
                });
                return !i;
            }
            function ne(n, e) {
                for (var t = 0; t < d.body.length; t++) {
                    var i = d.body[t];
                    if (i instanceof ot) {
                        var r = i.name;
                        if (!e) return false;
                        if (L.has(r.name)) return false;
                        if (Z(n, r.name)) return false;
                        if (!tn(i.enclosed, function(e) {
                            return e.scope === h || e.scope === i || !n.has(e.name);
                        })) return false;
                        if (v) v.push(r.definition());
                        continue;
                    }
                    if (!(i instanceof Ft)) continue;
                    if (!e) return false;
                    for (var a = i.definitions.length; --a >= 0; ) {
                        var r = i.definitions[a].name;
                        if (Z(n, r.name)) return false;
                        if (v) v.push(r.definition());
                    }
                }
                return true;
            }
            function te() {
                var n = new En();
                var e = 0, t;
                h = O;
                do {
                    if (h.variables) h.variables.each(function(e) {
                        n.set(e.name, true);
                    });
                    t = h;
                    h = u.parent(e++);
                    if (h instanceof jn) {
                        v = [];
                    } else if (h instanceof Hn) {
                        if (h.init === t) continue;
                        v = [];
                    } else if (h instanceof Yn) {
                        if (h.init === t) continue;
                        if (h.object === t) continue;
                        v = [];
                    }
                } while (!(h instanceof Un));
                B = h.body.indexOf(t) + 1;
                if (!B) return false;
                if (!Ee(d, ke(h))) return false;
                var i = a !== d || d.parent_scope.resolve() === h;
                if (h instanceof Vn) {
                    if (u.toplevel.vars) {
                        n.set("arguments", true);
                    } else {
                        i = false;
                    }
                }
                L = new En();
                var r = u.option("inline");
                if (!ee(n, r >= 2 && i)) return false;
                if (!ne(n, r >= 3 && i)) return false;
                return !v || v.length == 0 || !Ge(d, v);
            }
            function ie(e, n, t, i) {
                var r = t.definition();
                if (!h.var_names().has(t.name)) {
                    h.var_names().set(t.name, true);
                    e.push(Oe(Pt, t, {
                        name: t,
                        value: null
                    }));
                }
                h.variables.set(t.name, r);
                h.enclosed.push(r);
                if (!i) return;
                var a = Oe(ln, t, t);
                r.assignments++;
                r.references.push(a);
                n.push(Oe(cn, p, {
                    operator: "=",
                    left: a,
                    right: i
                }));
            }
            function re(e, n) {
                var t = d.argnames.length;
                for (var i = p.args.length; --i >= t; ) {
                    n.push(p.args[i]);
                }
                var r = [];
                for (i = t; --i >= 0; ) {
                    var a = d.argnames[i];
                    var o;
                    if (a instanceof Yt) {
                        r.push(a);
                        o = a.name;
                    } else {
                        o = a;
                    }
                    var s = p.args[i];
                    if (o.unused || h.var_names().has(o.name)) {
                        if (s) n.push(s);
                    } else {
                        var f = Oe(mi, o, o);
                        var c = o.definition();
                        c.orig.push(f);
                        c.eliminated++;
                        if (o.unused !== undefined) {
                            ie(e, n, f);
                            if (s) n.push(s);
                        } else {
                            if (!s && v && a === o) s = Oe(Fi, p);
                            ie(e, n, f, s);
                        }
                    }
                }
                e.reverse();
                n.reverse();
                for (i = r.length; --i >= 0; ) {
                    var u = r[i];
                    if (u.name.unused !== undefined) {
                        n.push(u.value);
                    } else {
                        var l = Oe(ln, u.name, u.name);
                        u.name.definition().references.push(l);
                        n.push(Oe(cn, u, {
                            operator: "=",
                            left: l,
                            right: u.value
                        }));
                    }
                }
            }
            function ae(r, a) {
                a.push(Oe(cn, p, {
                    operator: "=",
                    left: Oe(ti, p, {
                        elements: d.argnames.map(function(e) {
                            if (e.unused) return Oe(Pi, e);
                            return e.convert_symbol(ln, n);
                        }),
                        rest: d.rest && d.rest.convert_symbol(ln, n)
                    }),
                    right: Oe(ei, p, {
                        elements: p.args.slice()
                    })
                }));
                function n(e, n) {
                    var t = n.definition();
                    t.assignments++;
                    t.references.push(e);
                    var i = Oe(mi, n, n);
                    t.orig.push(i);
                    t.eliminated++;
                    ie(r, a, i);
                }
            }
            function oe(i, e) {
                var t = [ B, 0 ];
                var a = [], r = [], o = [], s = [], f = [];
                d.body.filter(v ? function(e) {
                    if (!(e instanceof ot)) return true;
                    var n = Oe(mi, e.name, Ze(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    ie(i, r, n, ge(e, true));
                    return false;
                } : function(e) {
                    if (!(e instanceof ot)) return true;
                    var n = e.name.definition();
                    h.functions.set(n.name, n);
                    h.variables.set(n.name, n);
                    h.enclosed.push(n);
                    h.var_names().set(n.name, true);
                    t.push(e);
                    return false;
                }).forEach(function(e) {
                    if (!(e instanceof Ft)) {
                        if (e instanceof an) f.push(e.body);
                        return;
                    }
                    for (var n = 0; n < e.definitions.length; n++) {
                        var t = e.definitions[n];
                        var i = Ze(t.name);
                        var r = t.value;
                        if (r && f.length > 0) {
                            f.push(r);
                            r = $e(t, f);
                            f = [];
                        }
                        ie(a, o, i, r);
                        if (!v) continue;
                        if (L.has(i.name)) continue;
                        if (i.definition().orig.length == 1 && d.functions.has(i.name)) continue;
                        s.push(nn(u, i));
                    }
                });
                [].push.apply(i, a);
                [].push.apply(e, s);
                [].push.apply(e, r);
                [].push.apply(e, o);
                return t;
            }
            function se() {
                var e = [];
                var n = [];
                if (c > 1 || z || C || d.rest) {
                    ae(e, n);
                } else {
                    re(e, n);
                }
                var t = oe(e, n);
                n.push(y);
                if (e.length) t.push(Oe(Ft, d, {
                    definitions: e
                }));
                [].splice.apply(h.body, t);
                d.enclosed.forEach(function(e) {
                    if (h.var_names().has(e.name)) return;
                    h.enclosed.push(e);
                    h.var_names().set(e.name, true);
                });
                return n;
            }
        });
        e(Lt, function(e, n) {
            if (n.option("sequences")) {
                var t = we(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unused")) xe(e, n);
            if (n.option("unsafe")) {
                var i = e.expression;
                if (qe(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return Oe(Rt, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function ie(t, i, e, n) {
            if (!(n instanceof un)) return;
            if (!(n.operator == "&&" || n.operator == "||")) return;
            if (!(n.right instanceof cn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof ln)) return;
            if (n.right.left.definition() !== i) return;
            if (e.has_side_effects(t)) return;
            if (!r(n.left)) return;
            if (!r(n.right.right)) return;
            i.replaced++;
            return n.operator == "&&" ? Oe(Kt, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : Oe(Kt, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function r(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Yi(function(e) {
                    if (n) return true;
                    if (e instanceof ln && e.definition() === i) return n = true;
                }));
                return !n;
            }
        }
        e(sn, function(e, a) {
            var o = n();
            var s = o.length - 1;
            i();
            t();
            if (s == 0) {
                e = Ie(a, a.parent(), a.self(), o[0]);
                if (!(e instanceof sn)) e = e.optimize(a);
                return e;
            }
            e.expressions = o;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var i = Tn(a);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(a, i);
                    if (e) {
                        E(t, e);
                        i = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (s > 0 && ze(o[s], a)) s--;
                if (s < o.length - 1) {
                    o[s] = Oe(fn, e, {
                        operator: "void",
                        expression: o[s]
                    });
                    o.length = s + 1;
                }
            }
            function f(e) {
                return e instanceof cn && e.operator == "=" && e.left instanceof ln && e.left.definition();
            }
            function i() {
                for (var e = 1; e < s; e++) {
                    var n = o[e - 1];
                    var t = f(n);
                    if (!t) continue;
                    var i = o[e];
                    if (a.option("conditionals")) {
                        var r = ie(a, t, n.right, i);
                        if (r) {
                            n.right = r;
                            o.splice(e--, 1);
                            s--;
                            continue;
                        }
                    }
                    if (a.option("dead_code") && f(i) === t && i.right.is_constant_expression(t.scope.resolve())) {
                        o[--e] = n.right;
                    }
                }
            }
        });
        e(Xt, function(e, n) {
            if (n.option("sequences")) {
                var t = we(e, n);
                if (t !== e) return t.optimize(n);
            }
            return me(n, e);
        });
        var re = kn("+ -");
        var ae = kn("* / %");
        e(fn, function(e, n) {
            var t = e.operator;
            var i = e.expression;
            if (n.option("sequences") && s()) {
                var r = we(e, n);
                if (r !== e) return r.optimize(n);
            }
            switch (t) {
              case "-":
                if (i instanceof ji) i = i.transform(n);
                if (i instanceof $i || i instanceof ji) return e;
                break;

              case "!":
                if (!n.option("booleans")) break;
                if (i.is_truthy()) return $e(e, [ i, Oe(Ii, e) ]).optimize(n);
                if (n.in_boolean_context()) {
                    if (i instanceof fn && i.operator == "!") return i.expression;
                    if (i instanceof un) {
                        e = he(n, e, i.negate(n, Tn(n)));
                    }
                }
                break;

              case "delete":
                if (!n.option("evaluate")) break;
                if (o(i)) break;
                return $e(e, [ i, Oe(Hi, e) ]).optimize(n);

              case "typeof":
                if (!n.option("booleans")) break;
                if (!n.in_boolean_context()) break;
                rn.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                var a = [ Oe(Hi, e) ];
                if (!(i instanceof ln && De(i, n))) a.unshift(i);
                return $e(e, a).optimize(n);

              case "void":
                if (!n.option("side_effects")) break;
                i = i.drop_side_effect_free(n);
                if (!i) return Oe(Fi, e).optimize(n);
                e.expression = i;
                return e;
            }
            if (n.option("evaluate") && i instanceof un && re[t] && ae[i.operator] && (i.left.is_constant() || !i.right.has_side_effects(n))) {
                return Oe(un, e, {
                    operator: i.operator,
                    left: Oe(fn, i.left, {
                        operator: t,
                        expression: i.left
                    }),
                    right: i.right
                });
            }
            return me(n, e);
            function o(e) {
                return e instanceof ji || e instanceof Mi || e instanceof Ti || e instanceof Ut || e instanceof ln || e instanceof Fi;
            }
            function s() {
                switch (t) {
                  case "delete":
                    return !o(i.tail_node());

                  case "typeof":
                    return !qe(i.tail_node());

                  default:
                    return true;
                }
            }
        });
        e(Qt, function(e, n) {
            if (!n.option("awaits")) return e;
            if (n.option("sequences")) {
                var t = we(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("side_effects")) {
                var i = e.expression;
                if (i instanceof Qt) return i.optimize(n);
                if (i instanceof fn && i.expression instanceof Qt) return i.optimize(n);
                for (var r = 0, a = e, o; o = n.parent(r++); a = o) {
                    if (Xn(o)) {
                        if (o.value === a) return i.optimize(n);
                    } else if (o instanceof bt) {
                        var s = true;
                        do {
                            a = o;
                            o = n.parent(r++);
                            if (o instanceof Ot && (o.bfinally || o.bcatch) !== a) {
                                s = false;
                                break;
                            }
                        } while (o && !(o instanceof Un));
                        if (s) return i.optimize(n);
                    } else if (o instanceof sn) {
                        if (o.tail_node() === a) continue;
                    }
                    break;
                }
            }
            return e;
        });
        e(Zt, function(e, n) {
            if (!n.option("yields")) return e;
            if (n.option("sequences")) {
                var t = we(e, n);
                if (t !== e) return t.optimize(n);
            }
            var i = e.expression;
            if (e.nested && i.TYPE == "Call") {
                var r = i.clone().optimize(n);
                if (r.TYPE != "Call") return r;
            }
            return e;
        });
        un.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof Ut) {
                if (!(this.left.expression instanceof sn)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return $e(this, n);
            }
            if (this.left instanceof sn) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return $e(this, n);
            }
            if (this.right instanceof sn) {
                if (this.left.has_side_effects(e)) return this;
                var i = this.operator == "=" && this.left instanceof ln;
                var n = this.right.expressions;
                var r = n.length - 1;
                for (var a = 0; a < r; a++) {
                    if (!i && n[a].has_side_effects(e)) break;
                }
                if (a == r) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return $e(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = $e(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return $e(this, n);
                }
            }
            return this;
        });
        var oe = kn("indexOf lastIndexOf");
        var se = kn("== === != !== * & | ^");
        function Be(e) {
            if (e instanceof cn) return e.operator == "=" && Be(e.right);
            if (e instanceof sn) return Be(e.tail_node());
            if (e instanceof ln) return Be(e.fixed_value());
            return e instanceof ei || e instanceof lt || e instanceof Wn || e instanceof Lt || e instanceof ai;
        }
        function x(e, n) {
            if (n.is_constant()) return true;
            if (n instanceof cn) return n.operator != "=" || x(e, n.right);
            if (n instanceof un) {
                return !Ce[n.operator] || x(e, n.left) && x(e, n.right);
            }
            if (n instanceof Kt) {
                return x(e, n.consequent) && x(e, n.alternative);
            }
            if (n instanceof sn) return x(e, n.tail_node());
            if (n instanceof ln) {
                var t = n.fixed_value();
                return t && x(e, t);
            }
            if (n instanceof Ai) return !n.tag || Te(e, n.tag);
            if (n instanceof Jt) return true;
        }
        function Se(e, n) {
            if (n instanceof Vt) return Se(e, n.expression);
            if (n instanceof Wt) {
                return Se(e, n.expression) && Se(e, n.property);
            }
            if (n instanceof li) return true;
            return !n.has_side_effects(e);
        }
        e(un, function(i, o) {
            if (se[i.operator] && i.right.is_constant() && !i.left.is_constant() && !(i.left instanceof un && Wi[i.left.operator] >= Wi[i.operator])) {
                D();
            }
            if (o.option("sequences")) {
                var c = i.lift_sequences(o);
                if (c !== i) return c.optimize(o);
            }
            if (o.option("assignments") && Ce[i.operator]) {
                var e = i.right;
                if (i.left instanceof ln && e instanceof cn && e.operator == "=" && i.left.equivalent_to(e.left)) {
                    i.right = e.right;
                    e.right = i;
                    return e;
                }
            }
            if (o.option("comparisons")) switch (i.operator) {
              case "===":
              case "!==":
                if (ze(i.left, o) && i.right.is_defined(o)) {
                    rn.warn("Expression always defined [{file}:{line},{col}]", i.start);
                    return $e(i, [ i.right, Oe(i.operator == "===" ? Ii : Hi, i) ]).optimize(o);
                }
                var l = true;
                if (i.left.is_string(o) && i.right.is_string(o) || i.left.is_number(o) && i.right.is_number(o) || i.left.is_boolean(o) && i.right.is_boolean(o) || Se(o, i.left) && i.left.equivalent_to(i.right)) {
                    i.operator = i.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!l && ze(i.left, o)) {
                    i.left = Oe(Ci, i.left);
                } else if (o.option("typeofs") && i.left instanceof Oi && i.left.value == "undefined" && i.right instanceof fn && i.right.operator == "typeof") {
                    var n = i.right.expression;
                    if (n instanceof ln ? n.is_declared(o) : !(n instanceof Ut && o.option("ie"))) {
                        i.right = n;
                        i.left = Oe(Fi, i.left).optimize(o);
                        if (i.operator.length == 2) i.operator += "=";
                    }
                } else if (i.left instanceof ln && i.right instanceof ln && i.left.definition() === i.right.definition() && Be(i.left)) {
                    return Oe(i.operator[0] == "=" ? Hi : Ii, i).optimize(o);
                }
                break;

              case "&&":
              case "||":
                var t = i.left;
                if (t.operator == i.operator) {
                    t = t.right;
                }
                if (t instanceof un && t.operator == (i.operator == "&&" ? "!==" : "===") && i.right instanceof un && t.operator == i.right.operator && (ze(t.left, o) && i.right.left instanceof Ci || t.left instanceof Ci && ze(i.right.left, o)) && !t.right.has_side_effects(o) && t.right.equivalent_to(i.right.right)) {
                    var p = Oe(un, i, {
                        operator: t.operator.slice(0, -1),
                        left: Oe(Ci, i),
                        right: t.right
                    });
                    if (t !== i.left) {
                        p = Oe(un, i, {
                            operator: i.operator,
                            left: i.left.left,
                            right: p
                        });
                    }
                    return p;
                }
                break;
            }
            var r = false;
            var a = o.parent();
            if (o.option("booleans")) {
                var t = i.left;
                if (Ce[i.operator] && !t.has_side_effects(o)) {
                    if (t.equivalent_to(i.right)) {
                        return Ie(o, a, o.self(), t).optimize(o);
                    }
                    W(o, t);
                }
                r = o.in_boolean_context();
            }
            if (r) switch (i.operator) {
              case "+":
                var s = i.left.evaluate(o);
                var f = i.right.evaluate(o);
                if (s && typeof s == "string") {
                    rn.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return $e(i, [ i.right, Oe(Hi, i) ]).optimize(o);
                }
                if (f && typeof f == "string") {
                    rn.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return $e(i, [ i.left, Oe(Hi, i) ]).optimize(o);
                }
                break;

              case "==":
                if (i.left instanceof Oi && i.left.value == "" && i.right.is_string(o)) {
                    return Oe(fn, i, {
                        operator: "!",
                        expression: i.right
                    }).optimize(o);
                }
                break;

              case "!=":
                if (i.left instanceof Oi && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                break;
            }
            if (o.option("comparisons") && i.is_boolean(o)) {
                if (!(a instanceof un) || a instanceof cn) {
                    var d = he(o, i, Oe(fn, i, {
                        operator: "!",
                        expression: i.negate(o, Tn(o))
                    }));
                    if (d !== i) return d;
                }
                switch (i.operator) {
                  case ">":
                    D("<");
                    break;

                  case ">=":
                    D("<=");
                    break;
                }
            }
            if (o.option("conditionals") && Ce[i.operator] && i.right instanceof un && i.operator == i.right.operator) {
                O();
            }
            if (o.option("strings") && i.operator == "+") {
                if (i.right instanceof Oi && i.right.value == "" && i.left.is_string(o)) {
                    return i.left.optimize(o);
                }
                if (i.left instanceof Oi && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                if (i.left instanceof un && i.left.operator == "+" && i.left.left instanceof Oi && i.left.left.value == "" && i.right.is_string(o) && (i.left.right.is_constant() || !i.right.has_side_effects(o))) {
                    i.left = i.left.right;
                    return i.optimize(o);
                }
                if (i.right instanceof un && i.operator == i.right.operator && (i.left.is_string(o) && i.right.is_string(o) || i.right.left.is_string(o) && (i.left.is_constant() || !i.right.right.has_side_effects(o)))) {
                    O();
                }
            }
            if (o.option("evaluate")) {
                var v = true;
                switch (i.operator) {
                  case "&&":
                    var s = V(o, i.left);
                    if (!s) {
                        rn.warn("Condition left of && always false [{file}:{line},{col}]", i.start);
                        return Ie(o, a, o.self(), i.left).optimize(o);
                    } else if (!(s instanceof rn)) {
                        rn.warn("Condition left of && always true [{file}:{line},{col}]", i.start);
                        return $e(i, [ i.left, i.right ]).optimize(o);
                    }
                    var f = i.right.evaluate(o);
                    if (!f) {
                        if (r) {
                            rn.warn("Boolean && always false [{file}:{line},{col}]", i.start);
                            return $e(i, [ i.left, Oe(Ii, i) ]).optimize(o);
                        } else i.falsy = true;
                    } else if (!(f instanceof rn)) {
                        if (r || a.operator == "&&" && a.left === o.self()) {
                            rn.warn("Dropping side-effect-free && [{file}:{line},{col}]", i.start);
                            return i.left.optimize(o);
                        }
                    }
                    if (i.left.operator == "||") {
                        var h = V(o, i.left.right);
                        if (!h) return Oe(Kt, i, {
                            condition: i.left.left,
                            consequent: i.right,
                            alternative: i.left.right
                        }).optimize(o);
                    }
                    break;

                  case "??":
                    var u = true;

                  case "||":
                    var s = V(o, i.left, u);
                    if (u ? s == null : !s) {
                        rn.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: i.operator,
                            value: u ? "nulish" : "false",
                            file: i.start.file,
                            line: i.start.line,
                            col: i.start.col
                        });
                        return $e(i, [ i.left, i.right ]).optimize(o);
                    } else if (!(s instanceof rn)) {
                        rn.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: i.operator,
                            value: u ? "defined" : "true",
                            file: i.start.file,
                            line: i.start.line,
                            col: i.start.col
                        });
                        return Ie(o, a, o.self(), i.left).optimize(o);
                    }
                    var f = i.right.evaluate(o);
                    if (!f) {
                        if (r || a.operator == "||" && a.left === o.self()) {
                            rn.warn("Dropping side-effect-free {operator} [{file}:{line},{col}]", {
                                operator: i.operator,
                                file: i.start.file,
                                line: i.start.line,
                                col: i.start.col
                            });
                            return i.left.optimize(o);
                        }
                    } else if (!u && !(f instanceof rn)) {
                        if (r) {
                            rn.warn("Boolean || always true [{file}:{line},{col}]", i.start);
                            return $e(i, [ i.left, Oe(Hi, i) ]).optimize(o);
                        } else i.truthy = true;
                    }
                    if (!u && i.left.operator == "&&") {
                        var h = V(o, i.left.right);
                        if (h && !(h instanceof rn)) return Oe(Kt, i, {
                            condition: i.left.left,
                            consequent: i.left.right,
                            alternative: i.right
                        }).optimize(o);
                    }
                    break;

                  case "+":
                    if (i.left instanceof Di && i.right instanceof un && i.right.operator == "+" && i.right.left instanceof Di && i.right.is_string(o)) {
                        i = Oe(un, i, {
                            operator: "+",
                            left: Oe(Oi, i.left, {
                                value: "" + i.left.value + i.right.left.value,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                    }
                    if (i.right instanceof Di && i.left instanceof un && i.left.operator == "+" && i.left.right instanceof Di && i.left.is_string(o)) {
                        i = Oe(un, i, {
                            operator: "+",
                            left: i.left.left,
                            right: Oe(Oi, i.right, {
                                value: "" + i.left.right.value + i.right.value,
                                start: i.left.right.start,
                                end: i.right.end
                            })
                        });
                    }
                    if (i.right instanceof fn && i.right.operator == "-" && i.left.is_number(o)) {
                        i = Oe(un, i, {
                            operator: "-",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }
                    if (i.left instanceof fn && i.left.operator == "-" && A() && i.right.is_number(o)) {
                        i = Oe(un, i, {
                            operator: "-",
                            left: i.right,
                            right: i.left.expression
                        });
                        break;
                    }
                    if (o.option("unsafe_math") && i.left instanceof un && Wi[i.left.operator] == Wi[i.operator] && i.right.is_constant() && (i.right.is_boolean(o) || i.right.is_number(o)) && i.left.is_number(o) && !i.left.right.is_constant() && (i.left.left.is_boolean(o) || i.left.left.is_number(o))) {
                        i = Oe(un, i, {
                            operator: i.left.operator,
                            left: Oe(un, i, {
                                operator: i.operator,
                                left: i.right,
                                right: i.left.left
                            }),
                            right: i.left.right
                        });
                        break;
                    }

                  case "-":
                    if (i.right instanceof fn && i.right.operator == "-" && i.left.is_number(o) && i.right.expression.is_number(o)) {
                        i = Oe(un, i, {
                            operator: "+",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    v = o.option("unsafe_math");
                    if (i.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = i[e];
                        if (n instanceof fn && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(o) || t.is_number(o) || t.is_string(o)) {
                                i[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (i.operator != "-" && i.operator != "/" && (i.left.is_boolean(o) || i.left.is_number(o)) && (i.right.is_boolean(o) || i.right.is_number(o)) && A() && !(i.left instanceof un && i.left.operator != i.operator && Wi[i.left.operator] >= Wi[i.operator])) {
                        var m = Oe(un, i, {
                            operator: i.operator,
                            left: i.right,
                            right: i.left
                        });
                        if (i.right instanceof Di && !(i.left instanceof Di)) {
                            i = he(o, m, i);
                        } else {
                            i = he(o, i, m);
                        }
                    }
                    if (!v || !i.is_number(o)) break;
                    if (i.right instanceof un && i.right.operator != "%" && Wi[i.right.operator] == Wi[i.operator] && i.right.is_number(o) && (i.operator != "+" || i.right.left.is_boolean(o) || i.right.left.is_number(o)) && (i.operator != "-" || !i.left.is_negative_zero()) && (i.right.left.is_constant_expression() || !i.right.right.has_side_effects(o)) && !x(i.right.right)) {
                        i = Oe(un, i, {
                            operator: k(i.operator, i.right.operator),
                            left: Oe(un, i.left, {
                                operator: i.operator,
                                left: i.left,
                                right: i.right.left,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                        if (i.operator == "+" && !i.right.is_boolean(o) && !i.right.is_number(o)) {
                            i.right = Oe(fn, i.right, {
                                operator: "+",
                                expression: i.right
                            });
                        }
                    }
                    if (i.right instanceof Di && i.left instanceof un && i.left.operator != "%" && Wi[i.left.operator] == Wi[i.operator] && i.left.is_number(o)) {
                        if (i.left.left instanceof Di) {
                            var t = E(i.left, i.operator, i.left.left, i.right, i.left.left.start, i.right.end);
                            i = E(i, i.left.operator, me(o, t), i.left.right);
                        } else if (i.left.right instanceof Di) {
                            var _ = k(i.left.operator, i.operator);
                            var g = me(o, E(i.left, _, i.left.right, i.right));
                            if (g.is_constant() && !(i.left.operator == "-" && i.right.value != 0 && +g.value == 0 && i.left.left.is_negative_zero())) {
                                i = E(i, i.left.operator, i.left.left, g);
                            }
                        }
                    }
                    break;
                }
                if (!(a instanceof fn && a.operator == "delete")) {
                    if (i.left instanceof $i && !i.right.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.left.value == 0) {
                            if (i.right.is_boolean(o)) return Oe(fn, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                            if (i.right.is_number(o) && !i.right.is_negative_zero()) return i.right;
                        }
                        break;

                      case "*":
                        if (i.left.value == 1) {
                            return i.right.is_number(o) ? i.right : Oe(fn, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                        }
                        break;
                    }
                    if (i.right instanceof $i && !i.left.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.right.value == 0) {
                            if (i.left.is_boolean(o)) return Oe(fn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                            if (i.left.is_number(o) && !i.left.is_negative_zero()) return i.left;
                        }
                        break;

                      case "-":
                        if (i.right.value == 0) {
                            return i.left.is_number(o) ? i.left : Oe(fn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;

                      case "/":
                        if (i.right.value == 1) {
                            return i.left.is_number(o) ? i.left : Oe(fn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;
                    }
                }
            }
            if (o.option("typeofs")) switch (i.operator) {
              case "&&":
                U(i.left, i.right, null);
                break;

              case "||":
                U(i.left, null, i.right);
                break;
            }
            if (o.option("unsafe")) {
                var b = S(i.right);
                if (r && b && (i.operator == "==" || i.operator == "!=") && i.left instanceof $i && i.left.value == 0) {
                    return (i.operator == "==" ? Oe(fn, i, {
                        operator: "!",
                        expression: i.right
                    }) : i.right).optimize(o);
                }
                var y = S(i.left);
                if (o.option("comparisons") && T()) {
                    var w = Oe(fn, i, {
                        operator: "!",
                        expression: Oe(fn, i, {
                            operator: "~",
                            expression: y ? i.left : i.right
                        })
                    });
                    switch (i.operator) {
                      case "<":
                        if (y) break;

                      case "<=":
                      case "!=":
                        w = Oe(fn, i, {
                            operator: "!",
                            expression: w
                        });
                        break;
                    }
                    return w.optimize(o);
                }
            }
            return me(o, i);
            function x(e) {
                var n = false;
                e.walk(new Yi(function(e) {
                    if (n) return true;
                    if (e instanceof cn) {
                        if (e.left instanceof Ut) return n = true;
                    } else if (e instanceof Jt) {
                        if (Xi[e.operator] && e.expression instanceof Ut) {
                            return n = true;
                        }
                    }
                }));
                return n;
            }
            function k(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function E(e, n, t, i, r, a) {
                if (n == "+") {
                    if (!t.is_boolean(o) && !t.is_number(o)) {
                        t = Oe(fn, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!i.is_boolean(o) && !i.is_number(o)) {
                        i = Oe(fn, i, {
                            operator: "+",
                            expression: i
                        });
                    }
                }
                return Oe(un, e, {
                    operator: n,
                    left: t,
                    right: i,
                    start: r,
                    end: a
                });
            }
            function S(e) {
                return e.TYPE == "Call" && e.expression instanceof Vt && oe[e.expression.property];
            }
            function T() {
                switch (i.operator) {
                  case "<=":
                    return b && i.left instanceof $i && i.left.value == 0;

                  case "<":
                    if (y && i.right instanceof $i && i.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!b) return false;
                    return i.left instanceof $i && i.left.value == -1 || i.left instanceof fn && i.left.operator == "-" && i.left.expression instanceof $i && i.left.expression.value == 1;
                }
            }
            function A() {
                return i.left.is_constant() || i.right.is_constant() || !i.left.has_side_effects(o) && !i.right.has_side_effects(o);
            }
            function D(e) {
                if (A()) {
                    if (e) i.operator = e;
                    var n = i.left;
                    i.left = i.right;
                    i.right = n;
                }
            }
            function O() {
                var e = i.right;
                i.left = Oe(un, i, {
                    operator: i.operator,
                    left: i.left,
                    right: e.left,
                    start: i.left.start,
                    end: e.left.end
                });
                i.right = e.right;
                i.left = i.left.transform(o);
            }
        });
        e(xi, function(e) {
            return e;
        });
        function Ue(e, n, t) {
            var i = 0, r = e.self();
            do {
                if (r === t) return r;
                if (O(r) && r.name && r.name.definition() === n) return r;
            } while (r = e.parent(i++));
        }
        function Ve(e) {
            var n = e.scope.resolve();
            return tn(e.references, function(e) {
                return n === e.scope.resolve();
            });
        }
        e(ln, function(t, e) {
            if (!e.option("ie") && qe(t) && !(t.scope.resolve().uses_with && e.find_parent(Bn))) {
                switch (t.name) {
                  case "undefined":
                    return Oe(Fi, t).optimize(e);

                  case "NaN":
                    return Oe(Mi, t).optimize(e);

                  case "Infinity":
                    return Oe(ji, t).optimize(e);
                }
            }
            var c = e.parent();
            if (e.option("reduce_vars") && Ki(e.self(), c) !== e.self()) {
                var n = t.definition();
                var i = t.fixed_value();
                var r = n.single_use && !(c instanceof Rt && c.is_expr_pure(e));
                if (r) {
                    if (O(i)) {
                        if ((n.scope !== t.scope.resolve() || n.in_loop) && (!e.option("reduce_funcs") || n.escaped.depth == 1 || i.inlined)) {
                            r = false;
                        } else if (Ue(e, n, i)) {
                            r = false;
                        } else if (i.name && i.name.definition() !== n) {
                            r = false;
                        } else if (i.parent_scope !== t.scope || Ji(n)) {
                            r = i.is_constant_expression(t.scope);
                            if (r == "f") {
                                var a = t.scope;
                                do {
                                    if (a instanceof ot || a instanceof Jn) {
                                        a.inlined = true;
                                    }
                                } while (a = a.parent_scope);
                            }
                        } else if (i.name && (i.name.name == "await" && Kn(i) || i.name.name == "yield" && Qn(i))) {
                            r = false;
                        } else if (i.has_side_effects(e)) {
                            r = false;
                        } else if (e.option("ie") && i instanceof lt) {
                            r = false;
                        }
                        if (r) i.parent_scope = t.scope;
                    } else if (!i || n.recursive_refs > 0 || !i.is_constant_expression() || i.drop_side_effect_free(e)) {
                        r = false;
                    }
                }
                if (r) {
                    n.single_use = false;
                    i._squeezed = true;
                    i.single_use = true;
                    if (i instanceof pt) i = ee(i);
                    if (i instanceof ot) i = ge(i);
                    if (O(i)) {
                        var a = t.scope.resolve();
                        i.enclosed.forEach(function(e) {
                            if (i.variables.has(e.name)) return;
                            if (a.var_names().has(e.name)) return;
                            a.enclosed.push(e);
                            a.var_names().set(e.name, true);
                        });
                    }
                    var o;
                    if (n.recursive_refs > 0) {
                        o = i.clone(true);
                        var l = o.name.definition();
                        var p = o.variables.get(o.name.name);
                        var s = p && p.orig[0];
                        var d, v;
                        if (o instanceof lt) {
                            d = "def_function";
                            v = yi;
                        } else {
                            d = "def_variable";
                            v = bi;
                        }
                        if (!(s instanceof v)) {
                            s = Oe(v, o.name, o.name);
                            s.scope = o;
                            o.name = s;
                            p = o[d](s);
                            p.recursive_refs = n.recursive_refs;
                        }
                        o.walk(new Yi(function(e) {
                            if (e instanceof pi) {
                                if (e !== s) {
                                    var n = e.definition();
                                    n.orig.push(e);
                                    n.eliminated++;
                                }
                                return;
                            }
                            if (!(e instanceof ln)) return;
                            var n = e.definition();
                            if (n === l) {
                                e.thedef = n = p;
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (O(t) && t.name && t.name.definition() === n && n.scope === t.name.scope && i.variables.get(t.name.name) === n) {
                                    t.name = t.name.clone();
                                    e.thedef = n = o.variables.get(t.name.name) || o[d](t.name);
                                }
                            }
                            n.references.push(e);
                        }));
                    } else {
                        if (i instanceof Un) {
                            e.push(i);
                            o = i.optimize(e);
                            e.pop();
                        } else {
                            o = i.optimize(e);
                        }
                        o = o.transform(new Ri(function(e, n) {
                            if (e instanceof Un) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    n.replaced++;
                    return o;
                }
                var h;
                if (i && (h = t.fixed || n.fixed).should_replace !== false) {
                    var f, u;
                    if (i instanceof Si) {
                        if (!Ji(n) && Ve(n) && !b(n)) u = i;
                    } else if ((f = i.evaluate(e, true)) !== i && typeof f != "function" && (f === null || typeof f != "object" || e.option("unsafe_regexp") && f instanceof RegExp && !n.cross_loop && Ve(n))) {
                        u = ue(f, i);
                    }
                    if (u) {
                        if (h.should_replace === undefined) {
                            var m = u.optimize(e).print_to_string().length;
                            if (!y(i)) {
                                m = Math.min(m, i.print_to_string().length);
                            }
                            var _ = n.name.length;
                            if (e.option("unused") && !e.exposed(n)) {
                                var g = n.references.length - n.replaced - n.assignments;
                                g = Math.min(g, n.references.filter(function(e) {
                                    return e.fixed === h;
                                }).length);
                                _ += (_ + 2 + m) / Math.max(1, g);
                            }
                            h.should_replace = m - Math.floor(_) < e.eval_threshold;
                        }
                        if (h.should_replace) {
                            var o;
                            if (y(i)) {
                                o = u.optimize(e);
                                if (o === u) o = o.clone(true);
                            } else {
                                o = ve(u.optimize(e), i);
                                if (o === u || o === i) o = o.clone(true);
                            }
                            n.replaced++;
                            return o;
                        }
                    }
                }
            }
            return t;
            function b(e) {
                var n = t.scope;
                while (n !== e.scope) {
                    if (n instanceof lt) return true;
                    n = n.parent_scope;
                }
            }
            function y(e) {
                var n;
                e.walk(new Yi(function(e) {
                    if (e instanceof ln) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function Te(e, n) {
            return e.option("unsafe") && n instanceof Vt && n.property == "raw" && qe(n.expression) && n.expression.name == "String";
        }
        function Ae(e) {
            var i = false;
            e = e.replace(/\\(u\{[^{}]*\}?|u[\s\S]{0,4}|x[\s\S]{0,2}|[0-9]+|[\s\S])/g, function(e, n) {
                var t = Bi(n);
                if (typeof t == "string") return t;
                i = true;
            });
            if (!i) return e;
        }
        e(Ai, function(e, t) {
            if (!t.option("templates")) return e;
            var i = e.tag;
            if (!i || Te(t, i)) {
                var n = [];
                var r = [];
                for (var a = 0, c; a < e.strings.length; a++) {
                    var o = e.strings[a];
                    if (!i) {
                        var s = Ae(o);
                        if (s) o = h(s);
                    }
                    if (a > 0) {
                        var l = e.expressions[a - 1];
                        var p = m(l);
                        if (p) {
                            var d = r[r.length - 1];
                            var v = d + p + o;
                            var f;
                            if (i || typeof (f = Ae(v)) == c) {
                                r[r.length - 1] = f ? h(f) : v;
                                continue;
                            }
                        }
                        n.push(l);
                    }
                    r.push(o);
                    if (!i) c = typeof s;
                }
                if (!i && r.length > 1) {
                    if (r[r.length - 1] == "") return Oe(un, e, {
                        operator: "+",
                        left: Oe(Ai, e, {
                            expressions: n.slice(0, -1),
                            strings: r.slice(0, -1),
                            tag: i
                        }).transform(t),
                        right: n[n.length - 1]
                    }).optimize(t);
                    if (r[0] == "") {
                        var u = Oe(un, e, {
                            operator: "+",
                            left: Oe(Oi, e, {
                                value: ""
                            }),
                            right: n[0]
                        });
                        for (var a = 1; r[a] == "" && a < n.length; a++) {
                            u = Oe(un, e, {
                                operator: "+",
                                left: u,
                                right: n[a]
                            });
                        }
                        return he(t, e, Oe(un, e, {
                            operator: "+",
                            left: u.transform(t),
                            right: Oe(Ai, e, {
                                expressions: n.slice(a),
                                strings: r.slice(a),
                                tag: i
                            }).transform(t)
                        }).optimize(t));
                    }
                }
                e.expressions = n;
                e.strings = r;
            }
            return me(t, e);
            function h(e) {
                return e.replace(/\r|\\|`|\${/g, function(e) {
                    return "\\" + (e == "\r" ? "r" : e);
                });
            }
            function m(e) {
                var n = e.evaluate(t);
                if (n === e) return;
                if (i && /\r|\\|`/.test(n)) return;
                n = h("" + n);
                if (n.length > e.print_to_string().length + "${}".length) return;
                return n;
            }
        });
        function We(e, n) {
            return e instanceof ln || e.TYPE === n.TYPE;
        }
        e(Fi, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = je(n).find_variable("undefined");
                if (t) {
                    var i = Oe(ln, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = Ki(n.self(), n.parent());
            if (r && We(r, e)) return e;
            return Oe(fn, e, {
                operator: "void",
                expression: Oe($i, e, {
                    value: 0
                })
            });
        });
        e(ji, function(e, n) {
            var t = Ki(n.self(), n.parent());
            if (t && We(t, e)) return e;
            if (n.option("keep_infinity") && !t && !je(n).find_variable("Infinity")) {
                return e;
            }
            return Oe(un, e, {
                operator: "/",
                left: Oe($i, e, {
                    value: 1
                }),
                right: Oe($i, e, {
                    value: 0
                })
            });
        });
        e(Mi, function(e, n) {
            var t = Ki(n.self(), n.parent());
            if (t && We(t, e)) return e;
            if (!t && !je(n).find_variable("NaN")) return e;
            return Oe(un, e, {
                operator: "/",
                left: Oe($i, e, {
                    value: 0
                }),
                right: Oe($i, e, {
                    value: 0
                })
            });
        });
        function Ge(t, n) {
            var i = false;
            var r = new Yi(function(e) {
                if (i) return true;
                if (e instanceof ln && pn(e.definition(), n)) return i = true;
            });
            var a = new Yi(function(e) {
                if (i) return true;
                if (e instanceof Wn && e !== t) {
                    if (!(e.name || Kn(e) || Qn(e))) {
                        var n = a.parent();
                        if (n instanceof Rt && n.expression === e) return;
                    }
                    e.walk(r);
                    return true;
                }
            });
            t.walk(a);
            return i;
        }
        var Je = kn("+ - * / % >> << >>> | ^ &");
        var Xe = kn("* | ^ &");
        e(cn, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof Ut) {
                    if (a.operator == "=") {
                        if (a.redundant) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof Wt) e.push(a.left.property);
                            e.push(a.right);
                            return $e(a, e).optimize(o);
                        }
                        if (a.left.equivalent_to(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof Wn || !o.has_directive("use strict") && n instanceof Di && !n.may_throw_on_access(o)) {
                            return a.left instanceof Vt ? a.right : $e(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof ln && De(a.left, o)) {
                    var t;
                    if (a.operator == "=" && a.left.equivalent_to(a.right) && !((t = o.parent()) instanceof fn && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return u();
                    var i = a.left.definition();
                    var s = i.scope.resolve();
                    var c = s === o.find_parent(Wn);
                    var r = 0, l;
                    t = o.self();
                    if (!(s.uses_arguments && Ji(i)) || o.has_directive("use strict")) do {
                        l = t;
                        t = o.parent(r++);
                        if (t instanceof cn) {
                            if (t.left instanceof ln && t.left.definition() === i) {
                                if (_(r, t)) break;
                                return u(i);
                            }
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof Ut) return true;
                            })) break;
                            continue;
                        }
                        if (t instanceof gt) {
                            if (!c) break;
                            if (_(r, t)) break;
                            if (Ge(s, [ i ])) break;
                            return u(i);
                        }
                        if (t instanceof an) {
                            if (!c) break;
                            if (Ge(s, [ i ])) break;
                            var p;
                            do {
                                p = t;
                                t = o.parent(r++);
                                if (t === s && A(t.body, p)) return u(i);
                            } while (m(p, t));
                            break;
                        }
                        if (t instanceof Pt) {
                            if (!(t.name instanceof pi)) continue;
                            if (t.name.definition() !== i) continue;
                            if (_(r, t)) break;
                            return u(i);
                        }
                    } while (h(l, t));
                }
            }
            if (o.option("sequences")) {
                var d = a.lift_sequences(o);
                if (d !== a) return d.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof ln && a.right instanceof un) {
                    var f;
                    if ((f = a.right.left) instanceof ln && f.name == a.left.name && Je[a.right.operator]) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return f;
                        };
                        return Oe(cn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        });
                    }
                    if ((f = a.right.right) instanceof ln && f.name == a.left.name && Xe[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return f;
                        };
                        return Oe(cn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        });
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof $i && a.right.value == 1) {
                    var v = a.operator.slice(0, -1);
                    return Oe(fn, a, {
                        operator: v + v,
                        expression: a.left
                    });
                }
            }
            return me(o, a);
            function h(e, n) {
                if (n instanceof un) {
                    return n.right === e || n.right.is_constant_expression(s);
                }
                if (n instanceof Kt) {
                    return n.condition !== e || n.consequent.is_constant_expression(s) && n.alternative.is_constant_expression(s);
                }
                if (n instanceof sn) {
                    var t = n.expressions;
                    var i = t.indexOf(e);
                    if (i < 0) return false;
                    for (var r = t.length; --r > i; ) {
                        if (!t[r].is_constant_expression(s)) return false;
                    }
                    return true;
                }
                if (n instanceof fn) return true;
            }
            function m(e, n) {
                if (n instanceof on) return A(n.body, e);
                if (n instanceof $t) return A(n.body, e);
                if (n instanceof qt) return A(n.body, e);
                if (n instanceof Et) return n.body === e || n.alternative === e;
                if (n instanceof Ot) return n.bfinally ? n.bfinally === e : n.bcatch === e;
            }
            function _(e, n) {
                var t = a.right;
                a.right = Oe(Ci, t);
                var i = n.may_throw(o);
                a.right = t;
                for (var r; r = o.parent(e++); n = r) {
                    if (r === s) return false;
                    if (r instanceof Ot) {
                        if (r.bfinally && r.bfinally !== n) return true;
                        if (i && r.bcatch && r.bcatch !== n) return true;
                    }
                }
            }
            function u(e) {
                if (e) e.fixed = false;
                return (a.operator != "=" ? Oe(un, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : Ie(o, o.parent(), a, a.right)).optimize(o);
            }
        });
        e(Kt, function(r, n) {
            if (n.option("sequences") && r.condition instanceof sn) {
                var e = r.condition.expressions.slice();
                r.condition = e.pop();
                e.push(r);
                return $e(r, e);
            }
            if (!n.option("conditionals")) return r;
            var a = r.condition;
            if (n.option("booleans") && !a.has_side_effects(n)) {
                W(n, a);
            }
            a = V(n, a);
            if (!a) {
                rn.warn("Condition always false [{file}:{line},{col}]", r.start);
                return $e(r, [ r.condition, r.alternative ]).optimize(n);
            } else if (!(a instanceof rn)) {
                rn.warn("Condition always true [{file}:{line},{col}]", r.start);
                return $e(r, [ r.condition, r.consequent ]).optimize(n);
            }
            var t = a.negate(n, Tn(n));
            if (he(n, a, t) === t) {
                r = Oe(Kt, r, {
                    condition: t,
                    consequent: r.alternative,
                    alternative: r.consequent
                });
                t = a;
                a = r.condition;
            }
            var i = r.consequent;
            var o = r.alternative;
            if (Se(n, a)) {
                if (a.equivalent_to(i)) return Oe(un, r, {
                    operator: "||",
                    left: a,
                    right: o
                }).optimize(n);
                if (a.equivalent_to(o)) return Oe(un, r, {
                    operator: "&&",
                    left: a,
                    right: i
                }).optimize(n);
            }
            var s = i.tail_node();
            if (s instanceof cn) {
                var c = s.operator == "=";
                var l = c ? o.tail_node() : o;
                if ((c || i === s) && l instanceof cn && s.operator == l.operator && s.left.equivalent_to(l.left) && (c && s.left instanceof ln || !a.has_side_effects(n) && w(i) && w(o))) {
                    return Oe(cn, r, {
                        operator: s.operator,
                        left: s.left,
                        right: Oe(Kt, r, {
                            condition: a,
                            consequent: x(i),
                            alternative: x(o)
                        })
                    });
                }
            }
            if (i.equivalent_to(o)) return $e(r, [ a, i ]).optimize(n);
            var p = y(i, o, true);
            if (p) return p;
            var f;
            if (i instanceof Rt && o.TYPE == i.TYPE && (f = g(i, o)) >= 0 && i.expression.equivalent_to(o.expression) && !a.has_side_effects(n) && !i.expression.has_side_effects(n)) {
                var d = i.clone();
                var v = i.args[f];
                d.args[f] = v instanceof Gt ? Oe(Gt, r, {
                    expression: Oe(Kt, r, {
                        condition: a,
                        consequent: v.expression,
                        alternative: o.args[f].expression
                    })
                }) : Oe(Kt, r, {
                    condition: a,
                    consequent: v,
                    alternative: o.args[f]
                });
                return d;
            }
            if (i instanceof Kt && i.alternative.equivalent_to(o)) {
                return Oe(Kt, r, {
                    condition: Oe(un, r, {
                        left: a,
                        operator: "&&",
                        right: i.condition
                    }),
                    consequent: i.consequent,
                    alternative: o
                });
            }
            if (i instanceof Kt && i.consequent.equivalent_to(o)) {
                return Oe(Kt, r, {
                    condition: Oe(un, r, {
                        left: t,
                        operator: "||",
                        right: i.condition
                    }),
                    consequent: o,
                    alternative: i.alternative
                });
            }
            if (o instanceof Kt && i.equivalent_to(o.consequent)) {
                return Oe(Kt, r, {
                    condition: Oe(un, r, {
                        left: a,
                        operator: "||",
                        right: o.condition
                    }),
                    consequent: i,
                    alternative: o.alternative
                });
            }
            if (o instanceof Kt && i.equivalent_to(o.alternative)) {
                return Oe(Kt, r, {
                    condition: Oe(un, r, {
                        left: t,
                        operator: "&&",
                        right: o.condition
                    }),
                    consequent: o.consequent,
                    alternative: i
                });
            }
            if ((i instanceof sn || o instanceof sn) && i.tail_node().equivalent_to(o.tail_node())) {
                return $e(r, [ Oe(Kt, r, {
                    condition: a,
                    consequent: k(i),
                    alternative: k(o)
                }), i.tail_node() ]).optimize(n);
            }
            if (i instanceof un && i.operator == "&&" && i.right.equivalent_to(o)) {
                return Oe(un, r, {
                    operator: "&&",
                    left: Oe(un, r, {
                        operator: "||",
                        left: t,
                        right: i.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (i instanceof un && i.operator == "||" && i.right.equivalent_to(o)) {
                return Oe(un, r, {
                    operator: "||",
                    left: Oe(un, r, {
                        operator: "&&",
                        left: a,
                        right: i.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (o instanceof un && o.operator == "&&" && o.right.equivalent_to(i)) {
                return Oe(un, r, {
                    operator: "&&",
                    left: Oe(un, r, {
                        operator: "||",
                        left: a,
                        right: o.left
                    }),
                    right: i
                }).optimize(n);
            }
            if (o instanceof un && o.operator == "||" && o.right.equivalent_to(i)) {
                return Oe(un, r, {
                    operator: "||",
                    left: Oe(un, r, {
                        operator: "&&",
                        left: t,
                        right: o.left
                    }),
                    right: i
                }).optimize(n);
            }
            var h = n.option("booleans") && n.in_boolean_context();
            if (m(i)) {
                if (_(o)) {
                    return u(a);
                }
                return Oe(un, r, {
                    operator: "||",
                    left: u(a),
                    right: o
                });
            }
            if (_(i)) {
                if (m(o)) {
                    return u(a.negate(n));
                }
                return Oe(un, r, {
                    operator: "&&",
                    left: u(a.negate(n)),
                    right: o
                });
            }
            if (m(o)) {
                return Oe(un, r, {
                    operator: "||",
                    left: u(a.negate(n)),
                    right: i
                });
            }
            if (_(o)) {
                return Oe(un, r, {
                    operator: "&&",
                    left: u(a),
                    right: i
                });
            }
            if (n.option("typeofs")) U(a, i, o);
            return r;
            function u(e) {
                if (e.is_boolean(n)) return e;
                return Oe(fn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function m(e) {
                return e instanceof Hi || h && e instanceof Di && e.value || e instanceof fn && e.operator == "!" && e.expression instanceof Di && !e.expression.value;
            }
            function _(e) {
                return e instanceof Ii || h && (e instanceof Di && !e.value || e instanceof fn && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof fn && e.operator == "!" && e.expression instanceof Di && e.expression.value;
            }
            function g(e, n) {
                var t = e.args;
                var i = n.args;
                var r = t.length;
                if (r != i.length) return -2;
                for (var a = 0; a < r; a++) {
                    if (!t[a].equivalent_to(i[a])) {
                        if (t[a] instanceof Gt !== i[a] instanceof Gt) return -3;
                        for (var o = a + 1; o < r; o++) {
                            if (!t[o].equivalent_to(i[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function b(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e.optional != n.optional) return;
                if (e instanceof Rt) {
                    if (g(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof Ut || n.expression instanceof Ut) || b(e.expression, n.expression);
                }
                if (!(e instanceof Ut)) return;
                var t = e.property;
                var i = n.property;
                return (t instanceof rn ? t.equivalent_to(i) : t == i) && !(e.expression instanceof Ei || n.expression instanceof Ei);
            }
            function y(e, n, t) {
                if (!b(e, n)) return !t && Oe(Kt, r, {
                    condition: a,
                    consequent: e,
                    alternative: n
                });
                var i = e.clone();
                i.expression = y(e.expression, n.expression);
                return i;
            }
            function w(e) {
                return e === e.tail_node() || tn(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function x(e) {
                if (!(e instanceof sn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return $e(e, n);
            }
            function k(e) {
                if (!(e instanceof sn)) return Oe($i, e, {
                    value: 0
                });
                return $e(e, e.expressions.slice(0, -1));
            }
        });
        e(Ni, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return Oe($i, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof un && (t.operator == "==" || t.operator == "!=")) {
                rn.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return Oe($i, e, {
                    value: +e.value
                });
            }
            return Oe(fn, e, {
                operator: "!",
                expression: Oe($i, e, {
                    value: 1 - e.value
                })
            });
        });
        e(Gt, function(e, n) {
            var t = e.expression;
            if (n.option("spreads") && t instanceof ei && !(n.parent() instanceof ai)) {
                return bn.splice(t.elements.map(function(e) {
                    return e instanceof Pi ? Oe(Fi, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function Ke(e, n) {
            if (!e) return false;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            if (e instanceof ln) {
                e = e.fixed_value();
                if (!e) return false;
            }
            return e instanceof Wn && !e.contains_this();
        }
        e(Wt, function(e, t) {
            var n = e.expression;
            var i = e.property;
            var c = ye(e, t);
            if (c) return c;
            if (t.option("properties")) {
                var r = i.evaluate(t);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var a = parseFloat(r);
                            if (a.toString() == r) {
                                r = a;
                            }
                        }
                    }
                    i = e.property = ve(i, ue(r, i).transform(t));
                    var l = "" + r;
                    if (Li(l) && l.length <= i.print_to_string().length + 1) {
                        return Oe(Vt, e, {
                            optional: e.optional,
                            expression: n,
                            property: l
                        }).optimize(t);
                    }
                }
            }
            var p = t.parent();
            var d = Ki(t.self(), p);
            var o, s, v, f;
            if (t.option("arguments") && n instanceof ln && Fe(o = n.definition()) && !n.in_arg && i instanceof $i && Math.floor(f = i.value) == f && (s = o.scope) === S() && s.uses_arguments < (d ? 2 : 3)) {
                if (p instanceof fn && p.operator == "delete") {
                    if (!o.deleted) o.deleted = [];
                    o.deleted[f] = true;
                }
                var u = s.argnames[f];
                if (o.deleted && o.deleted[f]) {
                    u = null;
                } else if (u) {
                    var h;
                    if (!(u instanceof _i) || u.name == "await" || n.scope.find_variable(u.name) !== (h = u.definition())) {
                        u = null;
                    } else if (t.has_directive("use strict") || s.name || s.rest || !(v instanceof Rt && f < v.args.length && tn(v.args.slice(0, f + 1), function(e) {
                        return !(e instanceof Gt);
                    })) || !tn(s.argnames, function(e) {
                        return e instanceof _i;
                    })) {
                        if (T() || h.assignments || h.orig.length > 1) u = null;
                    }
                } else if ((d || !T()) && f < s.argnames.length + 5 && t.drop_fargs(s, v) && !s.rest) {
                    while (f >= s.argnames.length) {
                        u = s.make_var(_i, s, "argument_" + s.argnames.length);
                        s.argnames.push(u);
                    }
                }
                if (u && dn(function(e) {
                    return e.name === u.name;
                }, s.argnames) === u) {
                    if (d) o.reassigned--;
                    var m = Oe(ln, e, u);
                    m.reference();
                    u.unused = undefined;
                    return m;
                }
            }
            if (d) return e;
            if (t.option("sequences") && p.TYPE != "Call" && !(p instanceof Yn && p.init === e)) {
                var _ = we(e, t);
                if (_ !== e) return _.optimize(t);
            }
            if (r !== i) {
                var g = e.flatten_object(l, t);
                if (g) {
                    n = e.expression = g.expression;
                    i = e.property = g.property;
                }
            }
            var b;
            if (t.option("properties") && t.option("side_effects") && i instanceof $i && n instanceof ei && tn(b = n.elements, function(e) {
                return !(e instanceof Gt);
            })) {
                var f = i.value;
                var y = b[f];
                if (Ke(y, t)) {
                    var w = y instanceof Pi;
                    var x = !w;
                    var k = [];
                    for (var E = b.length; --E > f; ) {
                        var a = b[E].drop_side_effect_free(t);
                        if (a) {
                            k.unshift(a);
                            if (x && a.has_side_effects(t)) x = false;
                        }
                    }
                    if (!x) k.unshift(y);
                    while (--E >= 0) {
                        var a = b[E].drop_side_effect_free(t);
                        if (a) {
                            k.unshift(a);
                        } else if (w) {
                            k.unshift(Oe(Pi, b[E]));
                        } else {
                            f--;
                        }
                    }
                    if (x) {
                        k.push(y);
                        return $e(e, k).optimize(t);
                    } else return Oe(Wt, e, {
                        expression: Oe(ei, n, {
                            elements: k
                        }),
                        property: Oe($i, i, {
                            value: f
                        })
                    });
                }
            }
            return me(t, e);
            function S() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof Wn) {
                        if (n instanceof Gn) return;
                        if (Xn(n)) continue;
                        v = t.parent(e);
                        return n;
                    }
                }
            }
            function T() {
                return !t.option("reduce_vars") || o.reassigned;
            }
        });
        Jn.DEFMETHOD("contains_super", function() {
            var n = false;
            var t = this;
            t.walk(new Yi(function(e) {
                if (n) return true;
                if (e instanceof Ei) return n = true;
                if (e !== t && e instanceof Un && !Xn(e)) return true;
            }));
            return n;
        });
        (function(e) {
            e(et, hn);
            e(nt, hn);
            e(rn, function() {
                var n = false;
                var t = this;
                t.walk(new Yi(function(e) {
                    if (n) return true;
                    if (e instanceof Si) return n = true;
                    if (e !== t && e instanceof Un && !Xn(e)) return true;
                }));
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("contains_this", n);
        });
        function Qe(e) {
            return e instanceof si && typeof e.key == "string" && !(e instanceof fi && e.value.contains_super());
        }
        Ut.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            if (e === "__proto__") return;
            var t = this.expression;
            if (t instanceof ai) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var c = i[r];
                    if (c.key !== e) continue;
                    if (!tn(i, Qe)) return;
                    if (!Ke(c.value, n)) return;
                    var a, l = [];
                    for (var o = 0; o < i.length; o++) {
                        var s = i[o].value;
                        if (i[o] instanceof fi) {
                            var f = !(s.uses_arguments || Qn(s) || s.contains_this());
                            if (f) {
                                if (!a) a = n.find_parent(Un);
                                var p = ke(a);
                                s.each_argname(function(e) {
                                    if (p[e.name]) f = false;
                                });
                            }
                            var u;
                            if (f) {
                                u = Kn(s) ? nt : et;
                            } else if (r === o && !(n.parent() instanceof Rt)) {
                                return;
                            } else {
                                u = s.CTOR;
                            }
                            s = Oe(u, s, s);
                        }
                        l.push(s);
                    }
                    return Oe(Wt, this, {
                        expression: Oe(ei, t, {
                            elements: l
                        }),
                        property: Oe($i, this, {
                            value: r
                        })
                    });
                }
            }
        });
        e(Vt, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                rn.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (Ki(n.self(), t)) return e;
            var i = ye(e, n);
            if (i) return i;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof Yn && t.init === e)) {
                var r = we(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof Vt && e.expression.property == "prototype") {
                var a = e.expression.expression;
                if (qe(a)) switch (a.name) {
                  case "Array":
                    e.expression = Oe(ei, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = Oe(rt, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(a.scope);
                    break;

                  case "Number":
                    e.expression = Oe($i, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = Oe(ai, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = Oe(zi, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = Oe(Oi, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var o = e.flatten_object(e.property, n);
            if (o) return o.optimize(n);
            return me(n, e);
        });
        e(ti, function(e, n) {
            if (n.option("rests") && e.rest instanceof ti) {
                return Oe(ti, e, {
                    elements: e.elements.concat(e.rest.elements),
                    rest: e.rest.rest
                });
            }
            return e;
        });
        e(ii, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof rn) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(ai, function(i, r) {
            if (!r.option("objects")) return i;
            var a = false;
            var t = false;
            var o = false;
            var l = r.has_directive("use strict");
            var s = [];
            var f = new En();
            var u = [];
            i.properties.forEach(function(e) {
                if (!(e instanceof Gt)) return p(e);
                t = true;
                var n = e.expression;
                if (r.option("spreads") && n instanceof ai && tn(n.properties, function(e) {
                    if (e instanceof ci) return false;
                    if (e instanceof Gt) return false;
                    if (e.key !== "__proto__") return true;
                    if (e instanceof ui) return true;
                    return !e.value.has_side_effects(r);
                })) {
                    a = true;
                    n.properties.forEach(function(e) {
                        var n = e.key;
                        var t = e instanceof ui;
                        if (n === "__proto__") {
                            if (!t) return;
                            n = ue(n, e);
                        }
                        p(t ? Oe(si, e, {
                            key: n,
                            value: Oe(Fi, e).optimize(r)
                        }) : e);
                    });
                } else {
                    o = true;
                    c();
                    u.push(e);
                }
            });
            c();
            if (!a) return i;
            if (t && o && u.length == 1) {
                var e = u[0];
                if (e instanceof oi && e.key instanceof $i) {
                    e.key = "" + e.key.value;
                }
            }
            return Oe(ai, i, {
                properties: u
            });
            function c() {
                s.forEach(function(e) {
                    var n = f.get(e);
                    switch (n.length) {
                      case 0:
                        return;

                      case 1:
                        return u.push(n[0]);
                    }
                    a = true;
                    var t = l && !o && n.pop();
                    u.push(n.length == 1 ? n[0] : Oe(si, i, {
                        key: n[0].key,
                        value: $e(i, n.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (t) u.push(t);
                    n.length = 0;
                });
                s = [];
                f = new En();
            }
            function p(e) {
                var n = e.key;
                if (n instanceof rn) {
                    t = true;
                    n = n.evaluate(r);
                    if (n === e.key || n === "__proto__") {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (Qe(e)) {
                    if (e.value.has_side_effects(r)) c();
                    s.push(n);
                    f.add(n, e);
                } else {
                    c();
                    u.push(e);
                }
                if (t && !o && typeof n == "string" && $.test(n)) {
                    o = true;
                    if (f.has(n)) e = f.get(n)[0];
                    e.key = Oe($i, e, {
                        value: +n
                    });
                }
            }
        });
        function Ze(e) {
            var n = e.definition().redefined();
            if (n) {
                e = e.clone();
                e.thedef = n;
            }
            return e;
        }
        function en(n, e) {
            var t = false;
            e.walk(new Yi(function(e) {
                if (t) return true;
                if (e instanceof ln && n.variables.get(e.name) === e.definition()) {
                    return t = true;
                }
            }));
            return t;
        }
        function nn(e, n) {
            var t = Oe(ln, n, n);
            var i = Oe(cn, n, {
                operator: "=",
                left: t,
                right: Oe(Fi, n).transform(e)
            });
            var r = n.definition();
            if (r.fixed) {
                t.fixed = function() {
                    return i.right;
                };
                t.fixed.assigns = [ i ];
                var a = [];
                r.references.forEach(function(e) {
                    var n = e.fixed;
                    if (!n || !yn(a, n)) return;
                    if (n.assigns) {
                        n.assigns.unshift(i);
                    } else {
                        n.assigns = [ i ];
                    }
                });
            }
            r.assignments++;
            r.references.push(t);
            return i;
        }
        (function(e) {
            e(rn, vn);
            e(cn, vn);
            e(Qt, function(t, e, i, n) {
                var r = this;
                var a = o(r.expression).try_inline(t, e, i, n);
                if (!a) return;
                if (!i) w(a, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (n instanceof Qt) return;
                    e.value = Oe(Qt, r, {
                        expression: n || Oe(Fi, e).transform(t)
                    });
                });
                return F(a) ? a : Oe(on, r, {
                    body: [ a, Oe(an, r, {
                        body: Oe(Qt, r, {
                            expression: Oe($i, r, {
                                value: 0
                            })
                        })
                    }) ]
                });
                function o(e) {
                    if (!i) return e;
                    if (e.TYPE != "Call") return e;
                    var n = e.expression;
                    switch (n.CTOR) {
                      case nt:
                        n = Oe(et, n, n);
                        break;

                      case tt:
                        n = Oe(rt, n, n);
                        break;

                      case it:
                        n = Oe(at, n, n);
                        break;

                      default:
                        return e;
                    }
                    e = e.clone();
                    e.expression = n;
                    return e;
                }
            });
            e(un, function(n, e, t, i) {
                if (t === undefined) return;
                var r = this;
                var a = r.operator;
                if (!Ce[a]) return;
                var o = r.right.try_inline(n, e, t, i);
                if (!o) return;
                return Oe(Et, r, {
                    condition: s(r.left),
                    body: o,
                    alternative: t ? null : Oe(bt, r, {
                        value: null
                    })
                });
                function s(e) {
                    switch (a) {
                      case "&&":
                        return e;

                      case "||":
                        return e.negate(n);

                      case "??":
                        return Oe(un, r, {
                            operator: "==",
                            left: Oe(Ci, r),
                            right: e
                        });
                    }
                }
            });
            e(on, function(e, n, t, i) {
                if (t) return;
                if (!this.variables) return;
                var r = this.body;
                var a = r.length - 1;
                if (a < 0) return;
                var o = r[a].try_inline(e, this, t, i);
                if (!o) return;
                r[a] = o;
                return this;
            });
            e(Rt, function(i, r, e, a) {
                if (i.option("inline") < 4) return;
                var t = this;
                if (t.is_expr_pure(i)) return;
                var o = t.expression;
                if (!(o instanceof Jn)) return;
                if (o.name) return;
                if (o.uses_arguments) return;
                if (Qn(o)) return;
                var s = Xn(o);
                if (s && o.value) return;
                if (o.body[0] instanceof On) return;
                if (o.contains_this()) return;
                if (!r) r = je(i);
                var f = new En();
                f.set("NaN", true);
                while (!(r instanceof Un)) {
                    r.variables.each(function(e) {
                        f.set(e.name, true);
                    });
                    r = r.parent_scope;
                }
                if (!pn(r, i.stack)) return;
                if (r instanceof Vn) {
                    if (o.variables.size() > (s ? 0 : 1)) {
                        if (!i.toplevel.vars) return;
                        if (o.functions.size() > 0 && !i.toplevel.funcs) return;
                    }
                    f.set("arguments", true);
                }
                var u = Kn(o);
                if (u) {
                    if (!i.option("awaits")) return;
                    if (!Kn(r)) return;
                    if (t.may_throw(i)) return;
                }
                var p = r.var_names();
                if (a) a = [];
                if (!o.variables.all(function(e, n) {
                    if (a) a.push(e);
                    if (!f.has(n) && !p.has(n)) return true;
                    return !s && n == "arguments" && e.orig.length == 1;
                })) return;
                if (a && a.length > 0 && Ge(o, a)) return;
                var c = true;
                if (!tn(o.argnames, function(e) {
                    var n = false;
                    var t = new Yi(function(e) {
                        if (n) return true;
                        if (e instanceof Yt) {
                            if (en(o, e.value)) return n = true;
                            e.name.walk(t);
                            return true;
                        }
                        if (e instanceof ii) {
                            if (e.key instanceof rn && en(o, e.key)) return n = true;
                            e.value.walk(t);
                            return true;
                        }
                        if (e instanceof _i && !tn(e.definition().orig, function(e) {
                            return !(e instanceof gi);
                        })) return n = true;
                    });
                    e.walk(t);
                    if (n) return false;
                    if (!(e instanceof _i)) c = false;
                    return true;
                })) return;
                if (o.rest) {
                    if (en(o, o.rest)) return;
                    c = false;
                }
                if (e && !tn(o.body, function(e) {
                    var n = false;
                    e.walk(new Yi(function(e) {
                        if (n) return true;
                        if (u && e instanceof Qt || e instanceof bt) return n = true;
                        if (e instanceof Un && e !== o) return true;
                    }));
                    return !n;
                })) return;
                if (!Ee(o, ke(r))) return;
                o.functions.each(function(e, n) {
                    r.functions.set(n, e);
                });
                var l = [];
                o.variables.each(function(n, e) {
                    if (e == "arguments") return;
                    p.set(e, true);
                    r.enclosed.push(n);
                    r.variables.set(e, n);
                    n.single_use = false;
                    if (!a) return;
                    if (n.references.length == n.replaced) return;
                    if (n.orig.length == 1 && o.functions.has(e)) return;
                    if (!tn(n.orig, function(e) {
                        if (e instanceof di) return false;
                        if (e instanceof _i) return n.scope.resolve() !== o;
                        if (e instanceof hi) return false;
                        return true;
                    })) return;
                    var t = n.orig[0];
                    if (t instanceof wi) return;
                    l.push(Oe(an, t, {
                        body: nn(i, Ze(t))
                    }));
                });
                var d = Object.create(null), v = new En();
                if (c && tn(t.args, function(e) {
                    return !(e instanceof Gt);
                })) {
                    var h = t.args.slice();
                    o.argnames.forEach(function(e) {
                        var n = h.shift();
                        if (e.unused) {
                            if (n) l.push(Oe(an, t, {
                                body: n
                            }));
                            return;
                        }
                        l.push(Oe(Ft, t, {
                            definitions: [ Oe(Pt, t, {
                                name: e.convert_symbol(mi, m),
                                value: n || Oe(Fi, t).transform(i)
                            }) ]
                        }));
                    });
                    if (h.length) l.push(Oe(an, t, {
                        body: $e(t, h)
                    }));
                } else {
                    l.push(Oe(Ft, t, {
                        definitions: [ Oe(Pt, t, {
                            name: Oe(ti, t, {
                                elements: o.argnames.map(function(e) {
                                    if (e.unused) return Oe(Pi, e);
                                    return e.convert_symbol(mi, m);
                                }),
                                rest: o.rest && o.rest.convert_symbol(mi, m)
                            }),
                            value: Oe(ei, t, {
                                elements: t.args.slice()
                            })
                        }) ]
                    }));
                }
                v.each(function(e, n) {
                    var t = d[n];
                    [].unshift.apply(t.orig, e);
                    t.eliminated += e.length;
                });
                [].push.apply(l, a ? o.body.filter(function(e) {
                    if (!(e instanceof ot)) return true;
                    var n = Oe(mi, e.name, Ze(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    l.push(Oe(Ft, e, {
                        definitions: [ Oe(Pt, e, {
                            name: n,
                            value: ge(e, true)
                        }) ]
                    }));
                    return false;
                }) : o.body);
                var n = Oe(on, t, {
                    body: l
                });
                if (!e) {
                    if (u) w(n, function(e) {
                        var n = e.value;
                        if (ze(n)) return;
                        e.value = Oe(Qt, t, {
                            expression: n
                        });
                    });
                    l.push(Oe(bt, t, {
                        value: null
                    }));
                }
                return n;
                function m(e, n) {
                    var t = n.definition();
                    d[t.id] = t;
                    v.add(t.id, e);
                }
            });
            e(Kt, function(e, n, t, i) {
                var r = this;
                var a = r.consequent.try_inline(e, n, t, i);
                var o = r.alternative.try_inline(e, n, t, i);
                if (!a && !o) return;
                return Oe(Et, r, {
                    condition: r.condition,
                    body: a || s(r.consequent),
                    alternative: o || s(r.alternative)
                });
                function s(e) {
                    if (t) return Oe(an, e, {
                        body: e
                    });
                    return Oe(bt, e, {
                        value: e
                    });
                }
            });
            e(Hn, function(e, n, t, i) {
                var r = this.body.try_inline(e, n, true, true);
                if (r) this.body = r;
                var a = this.init;
                if (a) {
                    a = a.try_inline(e, n, true, i);
                    if (a) {
                        this.init = null;
                        a.body.push(this);
                        return a;
                    }
                }
                return r && this;
            });
            e(Yn, function(e, n, t, i) {
                var r = this.body.try_inline(e, n, true, true);
                if (r) this.body = r;
                var a = this.object;
                if (a instanceof sn) {
                    var o = f(e, n, true, i, a, 1);
                    if (o) {
                        this.object = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return r && this;
            });
            e(Et, function(e, n, t, i) {
                var r = this.body.try_inline(e, n, t, i);
                if (r) this.body = r;
                var a = this.alternative;
                if (a) {
                    a = a.try_inline(e, n, t, i);
                    if (a) this.alternative = a;
                }
                var o = this.condition;
                if (o instanceof sn) {
                    var s = f(e, n, true, i, o, 1);
                    if (s) {
                        this.condition = o.tail_node();
                        s.body.push(this);
                        return s;
                    }
                }
                return (r || a) && this;
            });
            e(Pn, function(e, n, t, i) {
                var r = this.body.try_inline(e, n, true, true);
                if (!r) return;
                this.body = r;
                return this;
            });
            e(Fn, function(e, n, t, i) {
                var r = this.body.try_inline(e, n, t, i);
                if (!r) return;
                this.body = r;
                return this;
            });
            e(Lt, vn);
            e(bt, function(e, n, t, i) {
                var r = this.value;
                return r && r.try_inline(e, n, undefined, i === "try");
            });
            function f(e, c, n, l, t, p) {
                var i = [], r = t.expressions, a = n;
                for (var o = r.length - (p || 0), s = o; --o >= 0; a = true) {
                    var f = r[o].try_inline(e, c, a, l);
                    if (!f) continue;
                    u();
                    i.push(f);
                }
                if (i.length == 0) return;
                u();
                if (!n && i[0] instanceof an) {
                    i[0] = Oe(bt, t, {
                        value: i[0].body
                    });
                }
                return Oe(on, t, {
                    body: i.reverse()
                });
                function u() {
                    if (s > o + 1) i.push(Oe(an, t, {
                        body: $e(t, r.slice(o + 1, s))
                    }));
                    s = o;
                }
            }
            e(sn, function(e, n, t, i) {
                return f(e, n, t, i, this);
            });
            e(an, function(e, n, t, i) {
                var r = this.body;
                while (r instanceof fn) {
                    var a = r.operator;
                    if (Xi[a]) break;
                    if (a == "void") break;
                    r = r.expression;
                }
                if (!t && !ze(r)) r = Oe(fn, this, {
                    operator: "void",
                    expression: r
                });
                return r.try_inline(e, n, t || false, i);
            });
            e(fn, function(t, e, n, i) {
                var r = this;
                var a = r.operator;
                if (Xi[a]) return;
                if (!n && a == "void") n = false;
                var o = r.expression.try_inline(t, e, n, i);
                if (!o) return;
                if (!n) w(o, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (a == "void" && ze(n)) return;
                    e.value = Oe(fn, r, {
                        operator: a,
                        expression: n || Oe(Fi, e).transform(t)
                    });
                });
                return o;
            });
            e(Bn, function(e, n, t, i) {
                var r = this.body.try_inline(e, n, t, i);
                if (r) this.body = r;
                var a = this.expression;
                if (a instanceof sn) {
                    var o = f(e, n, true, i, a, 1);
                    if (o) {
                        this.expression = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return r && this;
            });
            e(Zt, function(e, n, t, i) {
                if (!e.option("yields")) return;
                if (!this.nested) return;
                var r = this.expression;
                if (r.TYPE != "Call") return;
                var a = r.expression;
                switch (a.CTOR) {
                  case it:
                    a = Oe(tt, a, a);
                    break;

                  case at:
                    a = Oe(rt, a, a);
                    break;

                  default:
                    return;
                }
                r = r.clone();
                r.expression = a;
                return r.try_inline(e, n, t, i);
            });
        })(function(e, n) {
            e.DEFMETHOD("try_inline", n);
        });
        e(bt, function(e, n) {
            var t = e.value;
            if (t && n.option("side_effects") && ze(t, n) && !k(n.find_parent(Un))) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ae(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function Zi(f) {
        f = be(f, {
            annotations: false,
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var m = hn;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var e = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, e - 1), f.comments.substr(e + 1));
            }
            if (n instanceof RegExp) {
                m = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                m = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                m = ae;
            } else {
                m = mn;
            }
        }
        function t(e) {
            if (typeof e == "number") return new Array(e + 1).join(" ");
            if (!e) return "";
            if (!/^\s*$/.test(e)) throw new Error("unsupported indentation: " + JSON.stringify("" + e));
            return e;
        }
        var u = 0;
        var c = 1;
        var i = t(f.indent_start);
        var r = t(f.indent_level);
        var a = r.length + 1 >> 1;
        var o;
        var _ = 0;
        var s = true;
        var l = f.source_map && [];
        var g;
        var b;
        var p;
        var d;
        var y = false;
        var w = false;
        var v;
        var x;
        var k = "";
        function E() {
            o = "";
            p = false;
            d = false;
            x = [];
            var e = v;
            v = "";
            return e;
        }
        E();
        var S = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = 0; t < e.length; t++) {
                var r = e.charCodeAt(t);
                if (te(r)) {
                    if (ie(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ie(r)) {
                    continue;
                }
                n += e.slice(i, t) + "\\u" + r.toString(16);
                i = t + 1;
            }
            return i == 0 ? e : n + e.slice(i);
        };
        function T(e) {
            return "'" + e.replace(/\x27/g, "\\'") + "'";
        }
        function A(e) {
            return '"' + e.replace(/\x22/g, '\\"') + '"';
        }
        var D = [ null, T, A, function(e, n) {
            return n == "'" ? T(e) : A(e);
        } ][f.quote_style] || function(e, n, t, i) {
            return t > i ? T(e) : A(e);
        };
        function O(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            return D(S(t), e, i, r);
        }
        var $ = l ? function(n, t) {
            l.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : vn;
        var q = l ? function() {
            l.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            l = [];
        } : vn;
        function z(e) {
            k += v.slice(0, _);
            v = v.slice(_);
            var n = v.length;
            $(e, n - u);
            c += e;
            u = n;
            while (e--) k += "\n";
        }
        var C = f.max_line_len ? function(e) {
            if (s) {
                if (u > f.max_line_len) {
                    rn.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (u > f.max_line_len) {
                z(1);
                s = true;
            }
            if (s || e) q();
        } : vn;
        var M = kn("( [ + * / - , .");
        var h = f.beautify || f.comments || f.max_line_len || f.preserve_line || f.shebang || !f.semicolons || f.source_map || f.width ? function(e) {
            var n = e.charAt(0);
            if (y && n) {
                y = false;
                if (n != "\n") {
                    h("\n");
                    P();
                }
            }
            if (w && n) {
                w = false;
                if (!/[\s;})]/.test(n)) {
                    F();
                }
            }
            var t = o.slice(-1);
            if (d) {
                d = false;
                if (t == ":" && n == "}" || t != ";" && (!n || ";}".indexOf(n) < 0)) {
                    var i = M[n];
                    if (i || f.semicolons) {
                        v += ";";
                        u++;
                        if (!s) {
                            C();
                            if (s && !i && v == ";") {
                                v = "";
                                u = 0;
                            }
                        }
                        if (_ == v.length - 1) _++;
                    } else {
                        C();
                        v += "\n";
                        c++;
                        u = 0;
                        if (/^\s+$/.test(e)) d = true;
                    }
                    if (!f.beautify) p = false;
                }
            }
            if (p) {
                if (re(t) && (re(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == o || e == "--" && o == "!" || e == "in" && t == "/" || o == "--" && n == ">") {
                    v += " ";
                    u++;
                }
                if (t != "<" || e != "!") p = false;
            }
            if (b) {
                l.push({
                    token: b,
                    name: g,
                    line: c,
                    col: u
                });
                b = false;
                if (s) q();
            }
            v += e;
            var r = e.split(/\r?\n/), a = r.length - 1;
            c += a;
            u += r[0].length;
            if (a > 0) {
                C();
                u = r[a].length;
            }
            o = e;
        } : function(e) {
            var n = e.charAt(0);
            var t = o.slice(-1);
            if (d) {
                d = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    v += ";";
                    p = false;
                }
            }
            if (p) {
                if (re(t) && (re(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == o || e == "--" && o == "!" || e == "in" && t == "/" || o == "--" && n == ">") {
                    v += " ";
                }
                if (t != "<" || e != "!") p = false;
            }
            v += e;
            o = e;
        };
        var F = f.beautify ? function() {
            h(" ");
        } : function() {
            p = true;
        };
        var P = f.beautify ? function(e) {
            if (y) h("\n");
            h(e ? i.slice(0, -a) : i);
        } : vn;
        var j = f.beautify ? function(e) {
            var n = i;
            i += r;
            e();
            i = n;
        } : function(e) {
            e();
        };
        var N = f.max_line_len || f.preserve_line ? function() {
            C();
            _ = v.length;
            s = false;
        } : vn;
        var I = f.beautify ? function() {
            h("\n");
            _ = v.length;
        } : N;
        var H = f.beautify ? function() {
            h(";");
        } : function() {
            d = true;
        };
        function Y() {
            if (d) h(";");
            h(";");
        }
        function R(e) {
            h("{");
            I();
            j(e);
            P();
            h("}");
        }
        function L(e) {
            h("(");
            N();
            e();
            N();
            h(")");
        }
        function B(e) {
            h("[");
            N();
            e();
            N();
            h("]");
        }
        function U() {
            N();
            h(",");
            N();
            F();
        }
        function V() {
            h(":");
            F();
        }
        var W = l ? function(e, n) {
            b = e;
            g = n;
        } : vn;
        function G() {
            if (!s) C(true);
            return k + v;
        }
        function J() {
            return /(^|\n) *$/.test(v);
        }
        function X(e, n) {
            if (y) return;
            if (e.nlb && (n || !J())) {
                y = true;
            } else if (n) {
                w = true;
            }
        }
        function K(e) {
            var n = e.value.replace(/[@#]__PURE__/g, " ");
            if (/^\s*$/.test(n) && !/^\s*$/.test(e.value)) return false;
            if (/comment[134]/.test(e.type)) {
                h("//" + n);
                y = true;
            } else if (e.type == "comment2") {
                h("/*" + n + "*/");
            }
            return true;
        }
        function Q(e, n) {
            if (n instanceof un) return n.left === e;
            if (n.TYPE == "Call") return n.expression === e;
            if (n instanceof Kt) return n.condition === e;
            if (n instanceof Vt) return n.expression === e;
            if (n instanceof gt) return true;
            if (n instanceof sn) return n.expressions[0] === e;
            if (n instanceof Wt) return n.expression === e;
            if (n instanceof Xt) return true;
            if (n instanceof Zt) return true;
        }
        function Z(e) {
            var i = this;
            var r;
            if (e instanceof gt) {
                r = e.value;
            } else if (e instanceof Zt) {
                r = e.expression;
            }
            var t = s(e);
            if (!t) t = [];
            if (r) {
                var a = new Yi(function(e) {
                    if (!Q(e, a.parent())) return true;
                    var n = s(e);
                    if (n) t = t.concat(n);
                });
                a.push(e);
                r.walk(a);
            }
            if (c == 1 && u == 0) {
                if (t.length > 0 && f.shebang && t[0].type == "comment5") {
                    h("#!" + t.shift().value + "\n");
                    P();
                }
                var n = f.preamble;
                if (n) h(n.replace(/\r\n?|\u2028|\u2029|(^|\S)\s*$/g, "$1\n"));
            }
            t = t.filter(m, e);
            var o = false;
            t.forEach(function(e, n) {
                X(e, n);
                if (K(e)) o = true;
            });
            if (o) X(e.start, true);
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new ne();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function ee(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof An || tn(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            r.filter(m, e).forEach(function(e, n) {
                X(e, n || !t);
                K(e);
            });
        }
        return {
            get: G,
            reset: E,
            indent: P,
            should_break: f.beautify && f.width ? function() {
                return u >= f.width;
            } : hn,
            has_parens: function() {
                return o.slice(-1) == "(";
            },
            newline: I,
            print: h,
            space: F,
            comma: U,
            colon: V,
            last: function() {
                return o;
            },
            semicolon: H,
            force_semicolon: Y,
            to_utf8: S,
            print_name: function(e) {
                h(S(e.toString(), true));
            },
            print_string: f.inline_script ? function(e, n) {
                e = O(e, n).replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                h(e.replace(/\x3c!--/g, "\\x3c!--").replace(/--\x3e/g, "--\\x3e"));
            } : function(e, n) {
                h(O(e, n));
            },
            with_indent: j,
            with_block: R,
            with_parens: L,
            with_square: B,
            add_mapping: W,
            option: function(e) {
                return f[e];
            },
            prepend_comments: f.comments || f.shebang ? Z : vn,
            append_comments: f.comments ? ee : vn,
            push_node: function(e) {
                x.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = x.pop();
                if (e.start && e.start.line > c) {
                    z(e.start.line - c);
                }
            } : function() {
                x.pop();
            },
            parent: function(e) {
                return x[x.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var c = false;
        rn.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(i);
            } else {
                i();
            }
            e.pop_node();
            function i() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        var l = Zi({
            inline_script: false,
            shebang: false,
            width: false
        });
        rn.DEFMETHOD("print_to_string", function(e) {
            if (e) {
                var n = Zi(e);
                this.print(n);
                return n.get();
            }
            this.print(l);
            return l.reset();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(rn, hn);
        function t(e) {
            var n = e.parent();
            if (!e.has_parens() && Tn(e, false, true)) {
                return this.name || !(n instanceof Nt);
            }
            if (e.option("webkit") && n instanceof Ut && n.expression === this) return true;
            if (e.option("wrap_iife") && n instanceof Rt && n.expression === this) return true;
        }
        n(tt, t);
        n(it, t);
        n(dt, t);
        n(rt, t);
        n(at, t);
        function p(e) {
            return !e.has_parens() && Tn(e, true);
        }
        n(ai, p);
        function d(e) {
            var n = e.parent();
            if (n instanceof un) return n.operator == "**" && n.left === this;
            if (n instanceof Rt) return n.expression === this;
            if (n instanceof lt) return true;
            if (n instanceof Ut) return n.expression === this;
            if (n instanceof Ai) return n.tag === this;
        }
        n(Qt, d);
        n(Jt, d);
        n(sn, function(e) {
            var n = e.parent();
            return n instanceof ei || Xn(n) && n.value === this || n instanceof Qt || n instanceof un || n instanceof Rt || n instanceof lt || n instanceof vt || n instanceof Kt || n instanceof Yt || n instanceof ii || n instanceof Nt || n instanceof ye || n instanceof oi || n instanceof Ut && n.expression === this || n instanceof Gt || n instanceof Ai && n.tag === this || n instanceof Jt || n instanceof Pt || n instanceof Zt;
        });
        n(un, function(e) {
            var n = e.parent();
            if (n instanceof Qt) return true;
            if (n instanceof un) {
                var t = n.operator, i = Wi[t];
                var r = this.operator, a = Wi[r];
                return i > a || t == "??" && (r == "&&" || r == "||") || i == a && this === n[t == "**" ? "left" : "right"];
            }
            if (n instanceof Rt) return n.expression === this;
            if (n instanceof lt) return true;
            if (n instanceof Ut) return n.expression === this;
            if (n instanceof Ai) return n.tag === this;
            if (n instanceof Jt) return true;
        });
        function v(e, n) {
            if (!e.terminal) return false;
            if (!(n instanceof Rt || n instanceof Ut)) return false;
            return n.expression === e;
        }
        n(Ut, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof Lt && t.expression === n && Bt(n).TYPE == "Call") return true;
            return v(n, t);
        });
        n(Rt, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof Lt) return t.expression === n;
            if (e.option("webkit") && n.expression instanceof rt && t instanceof Ut && t.expression === n) {
                var i = e.parent(1);
                if (i instanceof cn && i.left === t) return true;
            }
            return v(n, t);
        });
        n(Lt, function(e) {
            if (z(this, e)) return false;
            var n = e.parent();
            if (n instanceof Rt) return n.expression === this;
            if (n instanceof Ut) return true;
            if (n instanceof Ai) return n.tag === this;
        });
        n($i, function(e) {
            if (!e.option("galio")) return false;
            var n = e.parent();
            return n instanceof Ut && n.expression === this && /^0/.test(M(this.value));
        });
        function i(e, n) {
            var t = n.parent();
            if (t instanceof Qt) return true;
            if (t instanceof un) return !(t instanceof cn);
            if (t instanceof Rt) return t.expression === e;
            if (t instanceof lt) return true;
            if (t instanceof Kt) return t.condition === e;
            if (t instanceof Ut) return t.expression === e;
            if (t instanceof Ai) return t.tag === e;
            if (t instanceof Jt) return true;
        }
        n(et, function(e) {
            return i(this, e);
        });
        n(cn, function(e) {
            if (i(this, e)) return true;
            if (e.option("v8")) return this.left instanceof ni;
            if (this.left instanceof ri) return p(e);
        });
        n(nt, function(e) {
            return i(this, e);
        });
        n(Kt, function(e) {
            return i(this, e);
        });
        n(Zt, function(e) {
            return i(this, e);
        });
        e(On, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(Dn, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function h(e, t, i, n) {
            var r = e.length - 1;
            var a = n;
            var o = c;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof On) {
                        if (e.value == "use asm") c = true;
                    } else if (!(e instanceof $n)) {
                        if (e instanceof an && e.body instanceof Oi) {
                            i.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof $n) return;
                i.indent();
                e.print(i);
                if (n == r && t) return;
                i.newline();
                if (t) i.newline();
            });
            c = o;
        }
        e(Vn, function(e) {
            h(this.body, true, e, true);
            e.print("");
        });
        e(Fn, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(an, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function a(e, n) {
            n.print("{");
            n.with_indent(function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function r(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    h(e.body, false, n, t);
                });
            } else a(e, n);
        }
        e(on, function(e) {
            r(this, e);
        });
        e($n, function(e) {
            e.semicolon();
        });
        e(Nn, function(e) {
            var n = this;
            e.print("do");
            F(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(In, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            u(n.body, e);
        });
        e(Hn, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof zt) {
                        n.init.print(e);
                    } else {
                        A(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            u(n.body, e);
        });
        function m(t, i) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                e.with_parens(function() {
                    n.init.print(e);
                    e.space();
                    e.print(i);
                    e.space();
                    n.object.print(e);
                });
                u(n.body, e);
            };
        }
        e(Ln, m("for await", "of"));
        e(Rn, m("for", "in"));
        e(ye, m("for", "of"));
        e(Bn, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            u(n.body, e);
        });
        e(jt, function(e) {
            e.print("export");
            e.space();
            this.body.print(e);
        });
        e(Nt, function(e) {
            e.print("export");
            e.space();
            e.print("default");
            e.space();
            var n = this.body;
            n.print(e);
            if (n instanceof dt) {
                if (!n.name) return;
            }
            if (n instanceof pt) return;
            if (n instanceof ot) return;
            if (n instanceof Jn) {
                if (!n.name && !Xn(n)) return;
            }
            e.semicolon();
        });
        e(ke, function(i) {
            var r = this;
            i.print("export");
            i.space();
            var n = r.keys.length;
            if (n == 0) {
                a(r, i);
            } else if (r.keys[0] == "*") {
                t(0);
            } else i.with_block(function() {
                i.indent();
                t(0);
                for (var e = 1; e < n; e++) {
                    i.print(",");
                    i.newline();
                    i.indent();
                    t(e);
                }
                i.newline();
            });
            i.space();
            i.print("from");
            i.space();
            i.print_string(r.path, r.quote);
            i.semicolon();
            function t(e) {
                var n = r.aliases[e];
                var t = r.keys[e];
                i.print_name(t);
                if (n != t) {
                    i.space();
                    i.print("as");
                    i.space();
                    i.print_name(n);
                }
            }
        });
        e(It, function(e) {
            var n = this;
            e.print("export");
            e.space();
            $(n, e);
            e.semicolon();
        });
        e(Ht, function(e) {
            var n = this;
            e.print("import");
            e.space();
            if (n.default) n.default.print(e);
            if (n.all) {
                if (n.default) e.comma();
                n.all.print(e);
            }
            if (n.properties) {
                if (n.default) e.comma();
                $(n, e);
            }
            if (n.all || n.default || n.properties) {
                e.space();
                e.print("from");
                e.space();
            }
            e.print_string(n.path, n.quote);
            e.semicolon();
        });
        function _(e, t) {
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (e.rest) {
                    if (e.argnames.length) t.comma();
                    t.print("...");
                    e.rest.print(t);
                }
            });
        }
        function g(e, n) {
            var t = e.argnames.length == 1 && !e.rest && e.argnames[0];
            if (t instanceof _i && t.name != "yield") {
                t.print(n);
            } else {
                _(e, n);
            }
            n.space();
            n.print("=>");
            n.space();
            if (e.value) {
                e.value.print(n);
            } else {
                r(e, n, true);
            }
        }
        e(et, function(e) {
            g(this, e);
        });
        e(nt, function(e) {
            e.print("async");
            e.space();
            g(this, e);
        });
        function o(e, n) {
            if (e.name) {
                n.space();
                e.name.print(n);
            }
            _(e, n);
            n.space();
            r(e, n, true);
        }
        e(Wn, function(e) {
            e.print("function");
            o(this, e);
        });
        function b(e) {
            e.print("async");
            e.space();
            e.print("function");
            o(this, e);
        }
        e(st, b);
        e(tt, b);
        function y(e) {
            e.print("async");
            e.space();
            e.print("function*");
            o(this, e);
        }
        e(ft, y);
        e(it, y);
        function w(e) {
            e.print("function*");
            o(this, e);
        }
        e(ct, w);
        e(at, w);
        e(lt, function(e) {
            var n = this;
            e.print("class");
            if (n.name) {
                e.space();
                n.name.print(e);
            }
            if (n.extends) {
                e.space();
                e.print("extends");
                e.space();
                n.extends.print(e);
            }
            e.space();
            $(n, e, true);
        });
        e(ht, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            s(n, e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                n.value.print(e);
            }
            e.semicolon();
        });
        e(we, q("get"));
        e(xe, q("set"));
        function x(e, n) {
            var t = e.value;
            if (Kn(t)) {
                n.print("async");
                n.space();
            }
            if (Qn(t)) n.print("*");
            s(e, n);
            o(e.value, n);
        }
        e(mt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            x(n, e);
        });
        function k(t, i) {
            return function(e) {
                e.print(t);
                var n = this[i];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(bt, k("return", "value"));
        e(yt, k("throw", "value"));
        e(xt, k("break", "label"));
        e(kt, k("continue", "label"));
        function E(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof Ct || t instanceof Mt) || n.option("ie") && t instanceof Nn) return F(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof Et) {
                    if (!t.alternative) {
                        F(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof j) {
                    t = t.body;
                } else break;
            }
            u(e.body, n);
        }
        e(Et, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            if (n.alternative) {
                E(n, e);
                e.space();
                e.print("else");
                if (n.alternative instanceof Et) {
                    e.space();
                    n.alternative.print(e);
                } else {
                    u(n.alternative, e);
                }
            } else {
                u(n.body, e);
            }
        });
        e(St, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) a(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        function S(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(At, function(e) {
            e.print("default:");
            S(this, e);
        });
        e(Dt, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            S(n, e);
        });
        e(Ot, function(e) {
            var n = this;
            e.print("try");
            e.space();
            r(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e($t, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            r(n, e);
        });
        e(qt, function(e) {
            e.print("finally");
            e.space();
            r(this, e);
        });
        function T(i) {
            return function(t) {
                var e = this;
                t.print(i);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (!(n instanceof Pn && n.init === e)) t.semicolon();
            };
        }
        e(Ct, T("const"));
        e(Mt, T("let"));
        e(Ft, T("var"));
        function A(e, n, t) {
            var i = false;
            if (t) e.walk(new Yi(function(e) {
                if (i) return true;
                if (e instanceof un && e.operator == "in") return i = true;
                if (e instanceof Un && !(Xn(e) && e.value)) return true;
            }));
            e.print(n, i);
        }
        e(Pt, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var i = t instanceof Hn || t instanceof Yn;
                A(n.value, e, i);
            }
        });
        e(Yt, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function D(e, n) {
            if (!n.option("annotations")) return;
            if (!e.pure) return;
            var t = 0, i = e, r;
            do {
                r = i;
                i = n.parent(t++);
                if (i instanceof Rt && i.expression === r) return;
            } while (i instanceof Ut && i.expression === r);
            n.print("/*@__PURE__*/");
        }
        function O(e, t) {
            if (e.expression instanceof Rt || e.expression instanceof Wn) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(Rt, function(e) {
            var n = this;
            D(n, e);
            n.expression.print(e);
            if (n.optional) e.print("?.");
            O(n, e);
        });
        e(Lt, function(e) {
            var n = this;
            D(n, e);
            e.print("new");
            e.space();
            n.expression.print(e);
            if (z(n, e)) O(n, e);
        });
        e(sn, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(Vt, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var i = n.property;
            if (e.option("ie") && N[i]) {
                e.print(n.optional ? "?.[" : "[");
                e.add_mapping(n.end);
                e.print_string(i);
                e.print("]");
            } else {
                if (t instanceof $i && !/[ex.)]/i.test(e.last())) e.print(".");
                e.print(n.optional ? "?." : ".");
                e.add_mapping(n.end);
                e.print_name(i);
            }
        });
        e(Wt, function(e) {
            var n = this;
            n.expression.print(e);
            e.print(n.optional ? "?.[" : "[");
            n.property.print(e);
            e.print("]");
        });
        e(Gt, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e(fn, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof fn && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(Xt, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(un, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(Kt, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(Qt, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(Zt, function(e) {
            e.print(this.nested ? "yield*" : "yield");
            if (this.expression) {
                e.space();
                this.expression.print(e);
            }
        });
        e(ei, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof Pi) t.comma();
                });
                t.space();
            } : vn);
        });
        e(ti, function(t) {
            var e = this.elements, n = e.length, i = this.rest;
            t.with_square(n || i ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (i) {
                    if (n) t.comma();
                    t.print("...");
                    i.print(t);
                } else if (e[n - 1] instanceof Pi) {
                    t.comma();
                }
                t.space();
            } : vn);
        });
        e(ii, function(e) {
            var n = this;
            var t = s(n, e);
            var i = n.value;
            if (t) {
                if (i instanceof Yt) {
                    if (i.name instanceof li && t == f(i.name)) {
                        e.space();
                        e.print("=");
                        e.space();
                        i.value.print(e);
                        return;
                    }
                } else if (i instanceof li) {
                    if (t == f(i)) return;
                }
            }
            e.colon();
            i.print(e);
        });
        e(ri, function(t) {
            var e = this.properties, n = e.length, i = this.rest;
            if (n || i) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                if (i) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    t.print("...");
                    i.print(t);
                }
                t.newline();
            }); else a(this, t);
        });
        function $(e, t, i) {
            var n = e.properties;
            if (n.length > 0) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        if (!i) t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else a(e, t);
        }
        e(ai, function(e) {
            $(this, e);
        });
        function s(e, n) {
            var t = e.key;
            if (t instanceof rn) return n.with_square(function() {
                t.print(n);
            });
            var i = e.start && e.start.quote;
            if (n.option("quote_keys") || i && n.option("keep_quoted_props")) {
                n.print_string(t, i);
            } else if ("" + +t == t && t >= 0) {
                n.print(M(t));
            } else if (e.private) {
                n.print_name(t);
            } else if (N[t] ? !n.option("ie") : Li(t)) {
                n.print_name(t);
                return t;
            } else {
                n.print_string(t, i);
            }
        }
        e(si, function(e) {
            var n = this;
            s(n, e);
            e.colon();
            n.value.print(e);
        });
        e(fi, function(e) {
            x(this, e);
        });
        function q(t) {
            return function(e) {
                var n = this;
                if (n.static) {
                    e.print("static");
                    e.space();
                }
                e.print(t);
                e.space();
                s(n, e);
                o(n.value, e);
            };
        }
        e(ci, q("get"));
        e(ui, q("set"));
        function f(e) {
            var n = e.definition();
            return n && n.mangled_name || e.name;
        }
        e(li, function(e) {
            e.print_name(f(this));
        });
        e(xi, function(e) {
            var n = this;
            var t = f(n);
            e.print_name(t);
            var i = n.alias;
            if (i != t) {
                e.space();
                e.print("as");
                e.space();
                e.print_name(i);
            }
        });
        e(vi, function(e) {
            var n = this;
            var t = f(n);
            var i = n.key;
            if (i && i != t) {
                e.print_name(i);
                e.space();
                e.print("as");
                e.space();
            }
            e.print_name(t);
        });
        e(Pi, vn);
        e(Ai, function(e) {
            var n = this;
            if (n.tag) n.tag.print(e);
            e.print("`");
            for (var t = 0; t < n.expressions.length; t++) {
                e.print(n.strings[t]);
                e.print("${");
                n.expressions[t].print(e);
                e.print("}");
            }
            e.print(n.strings[t]);
            e.print("`");
        });
        e(Di, function(e) {
            e.print("" + this.value);
        });
        e(Oi, function(e) {
            e.print_string(this.value, this.quote);
        });
        e($i, function(e) {
            var n = this.start;
            if (c && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(M(this.value));
            }
        });
        e(zi, function(e) {
            var n = this.value;
            var t = n.toString();
            var i = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(i);
            } else if (i == 1) {
                t = "/(?:)" + t.slice(i);
            } else if (t.indexOf("/", 1) < i) {
                t = "/" + t.slice(1, i).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(i);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var r = e.parent();
            if (r instanceof un && /^in/.test(r.operator) && r.left === this) e.print(" ");
        });
        function u(e, n) {
            if (n.option("braces") && !(e instanceof Ct || e instanceof Mt)) {
                F(e, n);
            } else if (e instanceof $n) {
                n.force_semicolon();
            } else {
                n.space();
                e.print(n);
            }
        }
        function z(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function C(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function M(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, a;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                a = n.slice(r);
                t.push(a + "e-" + (a.length + r - 1));
            } else if (i = /[^0]0+$/.exec(n)) {
                r = i[0].length - 1;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return C(t);
        }
        function F(e, n) {
            n.space();
            if (e instanceof $n) {
                a(e, n);
            } else if (e instanceof on) {
                e.print(n);
            } else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function P(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        P([ rn, Fn ], vn);
        P([ ei, on, $t, Di, Dn, zt, ni, qt, _t, Wn, Lt, ai, j, li, St, Tt, Ot ], function(e) {
            e.add_mapping(this.start);
        });
        P([ vt, ii, oi ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var S = n("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var T = S.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function A(e, n) {
        var t = 0;
        var i = 0;
        for (var r = 0, a = 0; r < n.length; r++) {
            var o = T[n[r]];
            t += (o & 31) << i;
            if (o & 32) {
                i += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = i = 0;
            }
        }
        return a;
    }
    function D(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += S[t];
        } while (e);
        return n;
    }
    function O() {
        var t = new En();
        var i = [];
        i.index = function(e) {
            var n = t.get(e);
            if (!(n >= 0)) {
                n = i.length;
                i.push(e);
                t.set(e, n);
            }
            return n;
        };
        return i;
    }
    function $(l) {
        var f = O();
        var a = l.includeSources && new En();
        var u = O();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, A(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var i = 0; i < n.sources.length; i++) {
                var r = n.sourcesContent[i];
                if (r) a.set(n.sources[i], r);
            }
        });
        var p;
        var d = 1;
        var v = 0;
        var h = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, c, t, i, r) {
                var a = l.orig[e];
                if (a) {
                    var o = a.mappings[t - 1];
                    if (!o) return;
                    var s;
                    for (var f = 0; f < o.length; f++) {
                        var u = o[f][0];
                        if (i >= u) s = o[f];
                        if (i <= u) break;
                    }
                    if (!s || s.length < 4) {
                        e = null;
                    } else {
                        e = a.sources[s[1]];
                        t = s[2];
                        i = s[3];
                        if (s.length > 4) r = a.names[s[4]];
                    }
                }
                b(e, n, c, t, i, r);
            } : b,
            setSourceContent: a ? function(e, n) {
                if (!a.has(e)) {
                    a.set(e, n);
                }
            } : vn,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a.get(e) || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, i, r, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                v = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += D(t - v);
            v = t;
            if (e == null) return;
            var o = f.index(e);
            c += D(o - h);
            h = o;
            c += D(i - m);
            m = i;
            c += D(r - _);
            _ = r;
            if (l.names && a != null) {
                var s = u.index(a);
                c += D(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        var i = {
            Program: function(e) {
                return new Vn({
                    start: s(e),
                    end: f(e),
                    body: d(e.body.map(u))
                });
            },
            ArrowFunctionExpression: function(e) {
                var n = [], t = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = u(e.argument);
                    } else {
                        n.push(u(e));
                    }
                });
                var i = new (e.async ? nt : et)({
                    start: s(e),
                    end: f(e),
                    argnames: n,
                    rest: t
                });
                var r = u(e.body);
                if (r instanceof on) {
                    i.body = d(r.body);
                    i.value = null;
                } else {
                    i.body = [];
                    i.value = r;
                }
                return i;
            },
            FunctionDeclaration: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? ft : st;
                } else {
                    n = e.generator ? ct : ut;
                }
                var t = [], i = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        i = u(e.argument);
                    } else {
                        t.push(u(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: t,
                    rest: i,
                    body: d(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? it : tt;
                } else {
                    n = e.generator ? at : rt;
                }
                var t = [], i = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        i = u(e.argument);
                    } else {
                        t.push(u(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: t,
                    rest: i,
                    body: d(u(e.body).body)
                });
            },
            ClassDeclaration: function(e) {
                return new pt({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    extends: u(e.superClass),
                    properties: e.body.body.map(u)
                });
            },
            ClassExpression: function(e) {
                return new dt({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    extends: u(e.superClass),
                    properties: e.body.body.map(u)
                });
            },
            MethodDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = u(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = a(n);
                }
                var i = mt, r = u(e.value);
                switch (e.kind) {
                  case "get":
                    i = we;
                    r = new Gn(r);
                    break;

                  case "set":
                    i = xe;
                    r = new Gn(r);
                    break;
                }
                return new i({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: r
                });
            },
            PropertyDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = u(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = a(n);
                }
                return new ht({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: u(e.value)
                });
            },
            ForOfStatement: function(e) {
                return new (e.await ? Ln : ye)({
                    start: s(e),
                    end: f(e),
                    init: u(e.left),
                    object: u(e.right),
                    body: u(e.body)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new Ot({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new qt(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.computed ? u(e.key) : a(e.key);
                var t = {
                    start: s(e),
                    end: f(e),
                    key: n,
                    value: u(e.value)
                };
                if (e.kind == "init") return new (e.method ? fi : si)(t);
                t.value = new Gn(t.value);
                if (e.kind == "get") return new ci(t);
                if (e.kind == "set") return new ui(t);
            },
            ArrayExpression: function(e) {
                return new ei({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Pi() : u(e);
                    })
                });
            },
            ArrayPattern: function(e) {
                var n = [], t = null;
                e.elements.forEach(function(e) {
                    if (e === null) {
                        n.push(new Pi());
                    } else if (e.type == "RestElement") {
                        t = u(e.argument);
                    } else {
                        n.push(u(e));
                    }
                });
                return new ti({
                    start: s(e),
                    end: f(e),
                    elements: n,
                    rest: t
                });
            },
            ObjectPattern: function(e) {
                var n = [], t = null;
                e.properties.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = u(e.argument);
                    } else {
                        n.push(new ii(u(e)));
                    }
                });
                return new ri({
                    start: s(e),
                    end: f(e),
                    properties: n,
                    rest: t
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? Wt : Vt)({
                    start: s(e),
                    end: f(e),
                    optional: e.optional,
                    expression: u(e.object),
                    property: e.computed ? u(e.property) : e.property.name
                });
            },
            MetaProperty: function(e) {
                var n = u(e.meta);
                var t = a(e.property);
                if (n.name == "new" && t == "target") return new Ti({
                    start: s(e),
                    end: f(e),
                    name: "new.target"
                });
                return new Vt({
                    start: s(e),
                    end: f(e),
                    expression: n,
                    property: t
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? Dt : At)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            ExportAllDeclaration: function(e) {
                var n = e.exported ? a(e.exported) : "*";
                return new ke({
                    start: s(e),
                    end: f(e),
                    aliases: [ n ],
                    keys: [ "*" ],
                    path: e.source.value
                });
            },
            ExportDefaultDeclaration: function(e) {
                var n = u(e.declaration);
                if (!n.name) switch (n.CTOR) {
                  case st:
                    n = new tt(n);
                    break;

                  case ft:
                    n = new it(n);
                    break;

                  case pt:
                    n = new dt(n);
                    break;

                  case ut:
                    n = new rt(n);
                    break;

                  case ct:
                    n = new at(n);
                    break;
                }
                return new Nt({
                    start: s(e),
                    end: f(e),
                    body: n
                });
            },
            ExportNamedDeclaration: function(e) {
                if (e.declaration) return new jt({
                    start: s(e),
                    end: f(e),
                    body: u(e.declaration)
                });
                if (e.source) {
                    var n = [], t = [];
                    e.specifiers.forEach(function(e) {
                        n.push(a(e.exported));
                        t.push(a(e.local));
                    });
                    return new ke({
                        start: s(e),
                        end: f(e),
                        aliases: n,
                        keys: t,
                        path: e.source.value
                    });
                }
                return new It({
                    start: s(e),
                    end: f(e),
                    properties: e.specifiers.map(function(e) {
                        var n = new xi(u(e.local));
                        n.alias = a(e.exported);
                        return n;
                    })
                });
            },
            ImportDeclaration: function(e) {
                var t = null, i = null, r = null;
                e.specifiers.forEach(function(e) {
                    var n = new vi(u(e.local));
                    switch (e.type) {
                      case "ImportDefaultSpecifier":
                        i = n;
                        i.key = "";
                        break;

                      case "ImportNamespaceSpecifier":
                        t = n;
                        t.key = "*";
                        break;

                      default:
                        n.key = e.imported.name || syn.name;
                        if (!r) r = [];
                        r.push(n);
                        break;
                    }
                });
                return new Ht({
                    start: s(e),
                    end: f(e),
                    all: t,
                    default: i,
                    properties: r,
                    path: e.source.value
                });
            },
            ImportExpression: function(e) {
                var n = s(e);
                var t = u(e.source);
                return new Rt({
                    start: n,
                    end: f(e),
                    expression: new ln({
                        start: n,
                        end: t.start,
                        name: "import"
                    }),
                    args: [ t ]
                });
            },
            VariableDeclaration: function(e) {
                return new ({
                    const: Ct,
                    let: Mt
                }[e.kind] || Ft)({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = {
                    start: s(e),
                    end: f(e)
                };
                if (e.bigint) {
                    n.value = e.bigint.toLowerCase() + "n";
                    return new qi(n);
                }
                var t = e.value;
                if (t === null) return new Ci(n);
                var i = e.regex;
                if (i && i.pattern) {
                    n.value = new RegExp(i.pattern, i.flags);
                    n.value.raw_source = i.pattern;
                    return new zi(n);
                } else if (i) {
                    n.value = e.regex && e.raw ? e.raw : t;
                    return new zi(n);
                }
                switch (typeof t) {
                  case "string":
                    n.value = t;
                    return new Oi(n);

                  case "number":
                    if (isNaN(t)) return new Mi(n);
                    var r, a;
                    if (isFinite(t)) {
                        r = 1 / t < 0;
                        n.value = r ? -t : t;
                        a = new $i(n);
                    } else {
                        r = t < 0;
                        a = new ji(n);
                    }
                    return r ? new fn({
                        start: n.start,
                        end: n.end,
                        operator: "-",
                        expression: a
                    }) : a;

                  case "boolean":
                    return new (t ? Hi : Ii)(n);
                }
            },
            TemplateLiteral: function(e) {
                return new Ai({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u),
                    strings: e.quasis.map(function(e) {
                        return e.value.raw;
                    })
                });
            },
            TaggedTemplateExpression: function(e) {
                var n = u(e.quasi);
                n.start = s(e);
                n.end = f(e);
                n.tag = u(e.tag);
                return n;
            },
            Identifier: function(e) {
                var n, t = r.length - 1;
                do {
                    n = r[--t];
                } while (n.type == "ArrayPattern" || n.type == "AssignmentPattern" && n.left === r[t + 1] || n.type == "ObjectPattern" || n.type == "Property" && n.value === r[t + 1] || n.type == "VariableDeclarator" && n.id === r[t + 1]);
                var i = ln;
                switch (n.type) {
                  case "ArrowFunctionExpression":
                    if (n.body !== r[t + 1]) i = _i;
                    break;

                  case "BreakStatement":
                  case "ContinueStatement":
                    i = Te;
                    break;

                  case "CatchClause":
                    i = wi;
                    break;

                  case "ClassDeclaration":
                    if (n.id === r[t + 1]) i = Ee;
                    break;

                  case "ClassExpression":
                    if (n.id === r[t + 1]) i = yi;
                    break;

                  case "FunctionDeclaration":
                    i = n.id === r[t + 1] ? gi : _i;
                    break;

                  case "FunctionExpression":
                    i = n.id === r[t + 1] ? bi : _i;
                    break;

                  case "LabeledStatement":
                    i = Se;
                    break;

                  case "VariableDeclaration":
                    i = {
                        const: di,
                        let: hi
                    }[n.kind] || mi;
                    break;
                }
                return new i({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            Super: function(e) {
                return new Ei({
                    start: s(e),
                    end: f(e),
                    name: "super"
                });
            },
            ThisExpression: function(e) {
                return new Si({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            },
            ParenthesizedExpression: function(e) {
                var n = u(e.expression);
                if (!n.start.parens) n.start.parens = [];
                n.start.parens.push(s(e));
                if (!n.end.parens) n.end.parens = [];
                n.end.parens.push(f(e));
                return n;
            },
            ChainExpression: function(e) {
                var n = u(e.expression);
                n.terminal = true;
                return n;
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? fn : Xt)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", $n);
        e("ExpressionStatement", an, "expression>body");
        e("BlockStatement", on, "body@body");
        e("IfStatement", Et, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", Fn, "label>label, body>body");
        e("BreakStatement", xt, "label>label");
        e("ContinueStatement", kt, "label>label");
        e("WithStatement", Bn, "object>expression, body>body");
        e("SwitchStatement", St, "discriminant>expression, cases@body");
        e("ReturnStatement", bt, "argument>value");
        e("ThrowStatement", yt, "argument>value");
        e("WhileStatement", In, "test>condition, body>body");
        e("DoWhileStatement", Nn, "test>condition, body>body");
        e("ForStatement", Hn, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", Rn, "left>init, right>object, body>body");
        e("DebuggerStatement", Dn);
        e("VariableDeclarator", Pt, "id>name, init>value");
        e("CatchClause", $t, "param>argname, body%body");
        e("BinaryExpression", un, "operator=operator, left>left, right>right");
        e("LogicalExpression", un, "operator=operator, left>left, right>right");
        e("AssignmentExpression", cn, "operator=operator, left>left, right>right");
        e("AssignmentPattern", Yt, "left>name, right>value");
        e("ConditionalExpression", Kt, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", Lt, "callee>expression, arguments@args, pure=pure");
        e("CallExpression", Rt, "callee>expression, arguments@args, optional=optional, pure=pure");
        e("SequenceExpression", sn, "expressions@expressions");
        e("SpreadElement", Gt, "argument>expression");
        e("ObjectExpression", ai, "properties@properties");
        e("AwaitExpression", Qt, "argument>expression");
        e("YieldExpression", Zt, "argument>expression, delegate=nested");
        c(Vn, function e(n) {
            return p("Program", n);
        });
        c(ot, function e(n) {
            var t = n.argnames.map(l);
            if (n.rest) t.push({
                type: "RestElement",
                argument: l(n.rest)
            });
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                async: Kn(n),
                generator: Qn(n),
                params: t,
                body: p("BlockStatement", n)
            };
        });
        c(Wn, function e(n) {
            var t = n.argnames.map(l);
            if (n.rest) t.push({
                type: "RestElement",
                argument: l(n.rest)
            });
            if (Xn(n)) return {
                type: "ArrowFunctionExpression",
                async: Kn(n),
                params: t,
                body: n.value ? l(n.value) : p("BlockStatement", n)
            };
            return {
                type: "FunctionExpression",
                id: l(n.name),
                async: Kn(n),
                generator: Qn(n),
                params: t,
                body: p("BlockStatement", n)
            };
        });
        c(pt, function e(n) {
            return {
                type: "ClassDeclaration",
                id: l(n.name),
                superClass: l(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(l)
                }
            };
        });
        c(dt, function e(n) {
            return {
                type: "ClassExpression",
                id: l(n.name),
                superClass: l(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(l)
                }
            };
        });
        function n(i) {
            return function(e) {
                var n = e.key instanceof rn;
                var t = n ? l(e.key) : e.private ? {
                    type: "PrivateIdentifier",
                    name: e.key.slice(1)
                } : {
                    type: "Literal",
                    value: e.key
                };
                return {
                    type: "MethodDefinition",
                    kind: i,
                    computed: n,
                    key: t,
                    static: e.static,
                    value: l(e.value)
                };
            };
        }
        c(we, n("get"));
        c(xe, n("set"));
        c(mt, n("method"));
        c(ht, function e(n) {
            var t = n.key instanceof rn;
            var i = t ? l(n.key) : n.private ? {
                type: "PrivateIdentifier",
                name: n.key.slice(1)
            } : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "PropertyDefinition",
                computed: t,
                key: i,
                static: n.static,
                value: l(n.value)
            };
        });
        function t(n) {
            return function(e) {
                return {
                    type: "ForOfStatement",
                    await: n,
                    left: l(e.init),
                    right: l(e.object),
                    body: l(e.body)
                };
            };
        }
        c(Ln, t(true));
        c(ye, t(false));
        c(On, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: h(n, {
                    type: "Literal",
                    value: n.value
                })
            };
        });
        c(Tt, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(Ot, function e(n) {
            return {
                type: "TryStatement",
                block: m(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c($t, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: m(n)
            };
        });
        c(jt, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                declaration: l(n.body)
            };
        });
        c(Nt, function e(n) {
            return {
                type: "ExportDefaultDeclaration",
                declaration: l(n.body)
            };
        });
        c(ke, function e(n) {
            if (n.keys[0] == "*") return {
                type: "ExportAllDeclaration",
                exported: n.aliases[0] == "*" ? null : {
                    type: "Identifier",
                    name: n.aliases[0]
                },
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
            var t = [];
            for (var i = 0; i < n.aliases.length; i++) {
                t.push({
                    type: "ExportSpecifier",
                    exported: {
                        type: "Identifier",
                        name: n.aliases[i]
                    },
                    local: {
                        type: "Identifier",
                        name: n.keys[i]
                    }
                });
            }
            return {
                type: "ExportNamedDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        c(It, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                specifiers: n.properties.map(function(e) {
                    return {
                        type: "ExportSpecifier",
                        local: l(e),
                        exported: {
                            type: "Identifier",
                            name: e.alias
                        }
                    };
                })
            };
        });
        c(Ht, function e(n) {
            var t = n.properties ? n.properties.map(function(e) {
                return {
                    type: "ImportSpecifier",
                    local: l(e),
                    imported: {
                        type: "Identifier",
                        name: e.key
                    }
                };
            }) : [];
            if (n.all) t.unshift({
                type: "ImportNamespaceSpecifier",
                local: l(n.all)
            });
            if (n.default) t.unshift({
                type: "ImportDefaultSpecifier",
                local: l(n.default)
            });
            return {
                type: "ImportDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        c(zt, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: n.TYPE.toLowerCase(),
                declarations: n.definitions.map(l)
            };
        });
        c(Ut, function e(n) {
            var t = n instanceof Wt;
            var i = {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                optional: n.optional,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
            return n.terminal ? {
                type: "ChainExpression",
                expression: i
            } : i;
        });
        c(Jt, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof fn,
                argument: l(n.expression)
            };
        });
        c(un, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(ei, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(ti, function e(n) {
            var t = n.elements.map(l);
            if (n.rest) t.push({
                type: "RestElement",
                argument: l(n.rest)
            });
            return {
                type: "ArrayPattern",
                elements: t
            };
        });
        c(ii, function e(n) {
            var t = n.key instanceof rn;
            var i = t ? l(n.key) : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "Property",
                kind: "init",
                computed: t,
                key: i,
                value: l(n.value)
            };
        });
        c(ri, function e(n) {
            var t = n.properties.map(l);
            if (n.rest) t.push({
                type: "RestElement",
                argument: l(n.rest)
            });
            return {
                type: "ObjectPattern",
                properties: t
            };
        });
        c(oi, function e(n) {
            var t = n.key instanceof rn;
            var i = t ? l(n.key) : {
                type: "Literal",
                value: n.key
            };
            var r;
            if (n instanceof si) {
                r = "init";
            } else if (n instanceof ci) {
                r = "get";
            } else if (n instanceof ui) {
                r = "set";
            }
            return {
                type: "Property",
                kind: r,
                computed: t,
                method: n instanceof fi,
                key: i,
                value: l(n.value)
            };
        });
        c(li, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(Ei, function e() {
            return {
                type: "Super"
            };
        });
        c(Si, function e() {
            return {
                type: "ThisExpression"
            };
        });
        c(Ti, function e() {
            return {
                type: "MetaProperty",
                meta: {
                    type: "Identifier",
                    name: "new"
                },
                property: {
                    type: "Identifier",
                    name: "target"
                }
            };
        });
        c(zi, function e(n) {
            var t = n.value.toString().match(/\/([gimuy]*)$/)[1];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(qi, function e(n) {
            var t = n.value;
            return {
                type: "Literal",
                bigint: t.slice(0, -1),
                raw: t
            };
        });
        function o(e) {
            var n = e.value;
            if (typeof n === "number" && (n < 0 || n === 0 && 1 / n < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -n,
                        raw: e.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: n,
                raw: e.start.raw
            };
        }
        c(Ni, o);
        c(Di, o);
        c(Ci, o);
        c(g, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        c(Ai, function e(n) {
            var t = n.strings.length - 1;
            var i = {
                type: "TemplateLiteral",
                expressions: n.expressions.map(l),
                quasis: n.strings.map(function(e, n) {
                    return {
                        type: "TemplateElement",
                        tail: n == t,
                        value: {
                            raw: e
                        }
                    };
                })
            };
            if (!n.tag) return i;
            return {
                type: "TaggedTemplateExpression",
                tag: l(n.tag),
                quasi: i
            };
        });
        Mn.DEFMETHOD("to_mozilla_ast", on.prototype.to_mozilla_ast);
        Pi.DEFMETHOD("to_mozilla_ast", gn);
        rn.DEFMETHOD("to_mozilla_ast", function() {
            throw new Error("Cannot convert AST_" + this.TYPE);
        });
        function d(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof an)) break;
                var i = t.body;
                if (!(i instanceof Oi)) break;
                if (t.start.pos !== i.start.pos) break;
                e[n] = new On(i);
            }
            return e;
        }
        function v(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new ne({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: v(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new ne({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: v(e)
            });
        }
        function a(e) {
            return "" + e[e.type == "Identifier" ? "name" : "value"];
        }
        function e(e, n, t) {
            var a = [ "start: my_start_token(M)", "end: my_end_token(M)" ];
            var o = [ "type: " + JSON.stringify(e) ];
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                switch (i) {
                  case "@":
                    a.push(r + ": M." + t + ".map(from_moz)");
                    o.push(t + ": M." + r + ".map(to_moz)");
                    break;

                  case ">":
                    a.push(r + ": from_moz(M." + t + ")");
                    o.push(t + ": to_moz(M." + r + ")");
                    break;

                  case "=":
                    a.push(r + ": M." + t);
                    o.push(t + ": M." + r);
                    break;

                  case "%":
                    a.push(r + ": from_moz(M." + t + ").body");
                    o.push(t + ": to_moz_block(M)");
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            i[e] = new Function("U2", "my_start_token", "my_end_token", "from_moz", [ "return function From_Moz_" + e + "(M) {", "    return new U2.AST_" + n.TYPE + "({", a.join(",\n"), "    });", "};" ].join("\n"))(_, s, f, u);
            c(n, new Function("to_moz", "to_moz_block", "to_moz_scope", [ "return function To_Moz_" + e + "(M) {", "    return {", o.join(",\n"), "    };", "};" ].join("\n"))(l, m, p));
        }
        var r = null;
        function u(e) {
            r.push(e);
            var n = null;
            if (e) {
                if (!Sn(i, e.type)) throw new Error("Unsupported type: " + e.type);
                n = i[e.type](e);
            }
            r.pop();
            return n;
        }
        rn.from_mozilla_ast = function(e) {
            var n = r;
            r = [];
            var t = u(e);
            r = n;
            t.walk(new Yi(function(e) {
                if (e instanceof Te) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof Un) break;
                        if (t instanceof Fn && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        Oe("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function h(e, n) {
            var t = e.start;
            var i = e.end;
            if (t.pos != null && i.endpos != null) {
                n.range = [ t.pos, i.endpos ];
            }
            if (t.line) {
                n.loc = {
                    start: {
                        line: t.line,
                        column: t.col
                    },
                    end: i.endline ? {
                        line: i.endline,
                        column: i.endcol
                    } : null
                };
                if (t.file) {
                    n.loc.source = t.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return h(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function m(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function p(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof an && n.body[0].body instanceof Oi) {
                t.unshift(l(new $n(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var q = function() {
        var n = new En();
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return n;
        function t(e) {
            n.set(e, true);
        }
    }();
    function z(e, n) {
        e.walk(new Yi(function(e) {
            if (e instanceof vt) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof oi) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof Wt) {
                W(e.property, t);
            }
        }));
        function t(e) {
            yn(n, e);
        }
    }
    function W(e, n) {
        if (e instanceof Kt) {
            W(e.consequent, n);
            W(e.alternative, n);
        } else if (e instanceof sn) {
            W(e.tail_node(), n);
        } else if (e instanceof Oi) {
            n(e.value);
        }
    }
    function G(e, t) {
        t = be(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = t.builtins ? new En() : q.clone();
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n.set(e, true);
        });
        var c = -1;
        var i;
        if (t.cache) {
            i = t.cache.props;
            i.each(function(e) {
                n.set(e, true);
            });
        } else {
            i = new En();
        }
        var r = t.regex;
        var a = t.debug !== false;
        var l;
        if (a) l = t.debug === true ? "" : t.debug;
        var p = new En();
        var d = n.clone();
        e.walk(new Yi(function(e) {
            if (e instanceof un) {
                if (e.operator == "in") W(e.left, s);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Vt) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof ln)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    W(e.args[1], s);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    W(e.args[0], s);
                    break;
                }
            } else if (e instanceof vt) {
                if (typeof e.key == "string") s(e.key);
            } else if (e instanceof Vt) {
                s(e.property);
            } else if (e instanceof oi) {
                if (typeof e.key == "string") s(e.key);
            } else if (e instanceof Wt) {
                W(e.property, s);
            }
        }));
        e.walk(new Yi(function(e) {
            if (e instanceof un) {
                if (e.operator == "in") u(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Vt) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof ln)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    u(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    u(e.args[0]);
                    break;
                }
            } else if (e instanceof vt) {
                if (typeof e.key == "string") e.key = f(e.key);
            } else if (e instanceof Vt) {
                e.property = f(e.property);
            } else if (e instanceof oi) {
                if (typeof e.key == "string") e.key = f(e.key);
            } else if (e instanceof Wt) {
                if (!t.keep_quoted) u(e.property);
            }
        }));
        function o(e) {
            if (d.has(e)) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function v(e) {
            if (n.has(e)) return false;
            if (r && !r.test(e)) return false;
            return i.has(e) || p.has(e);
        }
        function s(e) {
            if (o(e)) p.set(e, true);
            if (!v(e)) d.set(e, true);
        }
        function f(e) {
            if (!v(e)) return e;
            var n = i.get(e);
            if (!n) {
                if (a) {
                    var t = "_$" + e + "$" + l + "_";
                    if (o(t)) n = t;
                }
                if (!n) do {
                    n = E(++c);
                } while (!o(n));
                if (/^#/.test(e)) n = "#" + n;
                i.set(e, n);
            }
            return n;
        }
        function u(e) {
            if (e instanceof sn) {
                u(e.expressions.tail_node());
            } else if (e instanceof Oi) {
                e.value = f(e.value);
            } else if (e instanceof Kt) {
                u(e.consequent);
                u(e.alternative);
            }
        }
    }
    "use strict";
    var J, X;
    if (typeof Buffer == "undefined") {
        J = atob;
        X = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        J = function(e) {
            return new Buffer(e, "base64").toString();
        };
        X = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        J = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        X = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function K(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,([^,]+)$/.exec(a[2]);
                if (!a) break;
                return J(a[2]);
            }
        }
        rn.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function Q(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function Z(n, t, e) {
        e.forEach(function(e) {
            if (t[e]) {
                if (typeof t[e] != "object") t[e] = {};
                if (!(n in t[e])) t[e][n] = t[n];
            }
        });
    }
    function ee(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new En();
        } else if (!(e.props instanceof En)) {
            e.props = En.fromObject(e.props);
        }
    }
    function oe(e) {
        return {
            props: e.props.toObject()
        };
    }
    function se(i, r) {
        try {
            r = be(r, {
                annotations: undefined,
                compress: {},
                enclose: false,
                ie: false,
                ie8: false,
                keep_fargs: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (r.validate) rn.enable_validation();
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) r.rename = r.compress && r.mangle;
            if (r.annotations !== undefined) Z("annotations", r, [ "compress", "output" ]);
            if (r.ie8) r.ie = r.ie || r.ie8;
            if (r.ie) Z("ie", r, [ "compress", "mangle", "output" ]);
            if (r.keep_fargs) Z("keep_fargs", r, [ "compress", "mangle" ]);
            if (r.keep_fnames) Z("keep_fnames", r, [ "compress", "mangle" ]);
            if (r.toplevel) Z("toplevel", r, [ "compress", "mangle" ]);
            if (r.v8) Z("v8", r, [ "mangle", "output" ]);
            if (r.webkit) Z("webkit", r, [ "compress", "mangle", "output" ]);
            var n;
            if (r.mangle) {
                r.mangle = be(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie: false,
                    keep_fargs: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                ee(r.mangle.cache);
                ee(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = be(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) rn.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            if (i instanceof Vn) {
                a = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var o = r.sourceMap && r.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = Q(o);
                }
                if (o) r.sourceMap.orig = Object.create(null);
                for (var s in i) if (Sn(i, s)) {
                    r.parse.filename = s;
                    r.parse.toplevel = a = Gi(i[s], r.parse);
                    if (o == "inline") {
                        var c = K(s, a);
                        if (c) {
                            r.sourceMap.orig[s] = Q(c);
                        }
                    } else if (o) {
                        r.sourceMap.orig[s] = o;
                    }
                }
            }
            if (n) {
                z(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                i[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (r.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (r.rename) {
                a.figure_out_scope(r.mangle);
                a.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) {
                a = new Qi(r.compress).compress(a);
                if (r.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (r.mangle) a.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                a.compute_char_frequency(r.mangle);
                a.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) G(a, r.mangle.properties);
            if (e) e.output = Date.now();
            var f = {};
            var u = be(r.output, {
                ast: false,
                code: true
            });
            if (u.ast) f.ast = a;
            if (u.code) {
                if (r.sourceMap) {
                    u.source_map = $(r.sourceMap);
                    if (r.sourceMap.includeSources) {
                        if (i instanceof Vn) {
                            throw new Error("original source content unavailable");
                        } else for (var s in i) if (Sn(i, s)) {
                            u.source_map.setSourceContent(s, i[s]);
                        }
                    }
                }
                delete u.ast;
                delete u.code;
                var l = Zi(u);
                a.print(l);
                f.code = l.get();
                if (r.sourceMap) {
                    f.map = u.source_map.toString();
                    var p = r.sourceMap.url;
                    if (p) {
                        f.code = f.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (p == "inline") {
                            f.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + X(f.map);
                        } else {
                            f.code += "\n//# sourceMappingURL=" + p;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = oe(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = oe(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                f.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                f.warnings = t;
            }
            return f;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            rn.log_function();
            rn.disable_validation();
        }
    }
    _["Dictionary"] = En;
    _["is_statement"] = qn;
    _["List"] = bn;
    _["minify"] = se;
    _["parse"] = Gi;
    _["push_uniq"] = yn;
    _["TreeTransformer"] = Ri;
    _["TreeWalker"] = Yi;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
